/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Q=["require","exports","vs/base/common/lifecycle","vs/base/common/platform","vs/base/common/event","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/base/common/path","vs/base/common/async","vs/base/common/network","vs/nls!vs/code/electron-main/main","vs/nls","electron","vs/base/common/types","vs/base/common/resources","vs/base/common/buffer","vs/platform/configuration/common/configuration","vs/base/common/errors","vs/base/node/pfs","vs/platform/files/common/files","vs/platform/product/common/productService","vs/platform/lifecycle/electron-main/lifecycleMainService","vs/base/common/cancellation","vs/platform/environment/electron-main/environmentMainService","os","vs/platform/workspaces/common/workspaces","vs/base/common/strings","vs/base/common/uuid","vs/platform/telemetry/common/telemetry","vs/base/common/arrays","fs","vs/base/common/process","vs/base/common/extpath","vs/base/common/labels","vs/base/parts/ipc/common/ipc","vs/platform/windows/electron-main/windows","vs/platform/registry/common/platform","vs/platform/state/electron-main/state","vs/base/common/json","vs/base/common/map","vs/platform/update/common/update","vs/base/common/functional","vs/base/common/objects","child_process","vs/platform/product/common/product","vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/base/common/decorators","vs/platform/environment/common/environment","vs/platform/configuration/common/configurationRegistry","vs/platform/request/common/request","vs/platform/backup/electron-main/backup","vs/platform/dialogs/electron-main/dialogMainService","vs/platform/native/electron-main/nativeHostMainService","vs/platform/environment/node/argvHelper","vs/platform/files/common/watcher","vs/platform/protocol/electron-main/protocol","vs/base/parts/ipc/node/ipc.net","vs/base/common/keybindings","vs/base/common/stream","crypto","net","vs/base/common/errorMessage","vs/platform/remote/common/remoteHosts","vs/platform/telemetry/common/telemetryUtils","vs/platform/theme/electron-main/themeMainService","vs/platform/windows/common/windows","vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/base/common/iterator","vs/base/common/normalization","vs/base/node/id","vs/base/node/processes","vs/base/parts/ipc/node/ipc.cp","vs/platform/instantiation/common/descriptors","vs/platform/diagnostics/common/diagnostics","vs/platform/instantiation/common/serviceCollection","vs/base/common/performance","vs/platform/sign/common/sign","vs/platform/update/electron-main/abstractUpdateService","vs/base/common/jsonEdit","vs/base/common/keyCodes","vs/base/common/processes","vs/base/common/hash","vs/base/node/extpath","vs/base/node/ps","vs/base/parts/ipc/common/ipc.net","vs/base/parts/ipc/electron-main/ipc.mp","vs/base/parts/storage/common/storage","vs/platform/environment/node/argv","vs/platform/encryption/electron-main/encryptionMainService","vs/platform/externalTerminal/common/externalTerminal","vs/platform/environment/node/shellEnv","vs/platform/log/common/bufferLog","vs/platform/log/node/spdlogLog","vs/platform/files/common/io","vs/platform/files/node/diskFileSystemProvider","vs/platform/remote/common/tunnel","vs/platform/storage/common/storage","vs/platform/url/common/url","vs/platform/storage/electron-main/storageMainService","vs/platform/windows/electron-main/windowsFinder","vs/platform/workspaces/electron-main/workspaces","vs/platform/launch/electron-main/launchMainService","vs/base/common/assert","vs/base/common/jsonFormatter","vs/base/common/keybindingParser","vs/base/common/linkedList","vs/base/common/stopwatch","vs/base/common/codicons","vs/base/common/console","vs/base/common/marshalling","vs/base/node/crypto","vs/base/node/decoder","vs/base/node/macAddress","util","vs/base/node/ports","vs/base/node/powershell","vs/base/node/watcher","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/contextmenu/electron-main/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-main/ipc.electron","vs/base/parts/storage/node/storage","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/keybindingLabels","vs/base/common/keybindingLabels","vs/nls!vs/base/node/processes","vs/base/node/shell","vs/nls!vs/code/electron-main/app","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/dialogs/electron-main/dialogMainService","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/environment/node/shellEnv","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/externalTerminal/node/externalTerminalService","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/electron-main/diskFileSystemProviderChannel","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/issue/electron-main/issueMainService","vs/nls!vs/platform/menubar/electron-main/menubar","vs/nls!vs/platform/native/electron-main/nativeHostMainService","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/update/common/update.config.contribution","vs/nls!vs/platform/windows/electron-main/window","vs/nls!vs/platform/windows/electron-main/windowsMainService","vs/nls!vs/platform/workspaces/common/workspaces","vs/nls!vs/platform/workspaces/electron-main/workspacesHistoryMainService","vs/nls!vs/platform/workspaces/electron-main/workspacesManagementMainService","vs/platform/debug/common/extensionHostDebugIpc","vs/platform/driver/common/driverIpc","vs/platform/environment/common/environmentService","vs/platform/debug/electron-main/extensionHostDebugIpc","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/environment/node/wait","vs/platform/extensions/common/extensionValidator","vs/platform/files/electron-main/diskFileSystemProviderChannel","vs/platform/instantiation/common/graph","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionUrlTrust","vs/platform/externalTerminal/node/externalTerminalService","vs/platform/files/node/watcher/nodejs/watcherService","vs/platform/files/node/watcher/nsfw/watcherService","vs/platform/files/node/watcher/parcel/watcherService","vs/platform/files/node/watcher/unix/watcherService","vs/platform/instantiation/common/instantiationService","vs/platform/keybinding/common/baseResolvedKeybinding","vs/platform/keybinding/common/resolvedKeybindingItem","vs/platform/keybinding/common/usLayoutResolvedKeybinding","vs/platform/lifecycle/common/lifecycle","vs/platform/configuration/common/userConfigurationFileService","vs/platform/log/common/fileLog","vs/platform/log/common/logIpc","vs/platform/log/node/loggerService","vs/platform/menubar/common/menubar","vs/platform/files/common/fileService","vs/platform/extensionManagement/node/extensionUrlTrustService","vs/platform/protocol/electron-main/protocolMainService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationModels","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteAgentConnection","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/request/node/proxy","url","vs/platform/serviceMachineId/common/serviceMachineId","vs/platform/sign/node/signService","vs/platform/keyboardLayout/electron-main/keyboardLayoutMainService","vs/platform/telemetry/common/commonProperties","vs/platform/diagnostics/node/diagnosticsService","vs/platform/telemetry/common/telemetryIpc","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/telemetry/common/telemetryService","vs/platform/theme/common/theme","vs/platform/theme/common/themeService","vs/platform/update/common/update.config.contribution","vs/platform/update/common/updateIpc","vs/platform/url/common/urlIpc","vs/platform/url/common/urlService","vs/platform/url/electron-main/electronUrlListener","vs/platform/webview/common/webviewManagerService","vs/platform/webview/electron-main/webviewProtocolProvider","vs/platform/webview/electron-main/webviewMainService","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/storage/electron-main/storageIpc","vs/platform/storage/electron-main/storageMain","vs/platform/windows/electron-main/windowsStateHandler","zlib","vs/platform/driver/node/driver","vs/platform/driver/electron-main/driver","vs/platform/backup/electron-main/backupMainService","vs/platform/remote/node/nodeSocketFactory","vs/platform/remote/node/tunnelService","vs/platform/request/node/requestService","vs/platform/request/electron-main/requestMainService","vs/platform/sharedProcess/electron-main/sharedProcess","vs/platform/state/electron-main/stateMainService","vs/platform/update/electron-main/updateService.darwin","vs/platform/update/electron-main/updateService.snap","vs/code/electron-main/auth","vs/platform/issue/electron-main/issueMainService","vs/platform/update/electron-main/updateService.linux","vs/platform/update/electron-main/updateService.win32","vs/platform/windows/electron-main/window","vs/platform/menubar/electron-main/menubar","vs/platform/menubar/electron-main/menubarMainService","vs/platform/windows/electron-main/windowsMainService","vs/platform/workspaces/electron-main/workspacesMainService","vs/code/electron-main/app","string_decoder","minimist","path","assert","vs/code/electron-main/main"],J=function(j){for(var e=[],p=0,L=j.length;p<L;p++)e[p]=Q[j[p]];return e};define(Q[103],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ok=void 0;function p(L,D){if(!L)throw new Error(D?`Assertion failed (${D})`:"Assertion Failed")}e.ok=p}),define(Q[47],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function p(P){return(b,d,g)=>{let i=null,I=null;if(typeof g.value=="function"?(i="value",I=g.value):typeof g.get=="function"&&(i="get",I=g.get),!I)throw new Error("not supported");g[i]=P(I,d)}}e.createDecorator=p;function L(P,b,d){let g=null,i=null;if(typeof d.value=="function"?(g="value",i=d.value,i.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof d.get=="function"&&(g="get",i=d.get),!i)throw new Error("not supported");const I=`$memoize$${b}`;d[g]=function(...S){return this.hasOwnProperty(I)||Object.defineProperty(this,I,{configurable:!1,enumerable:!1,writable:!1,value:i.apply(this,S)}),this[I]}}e.memoize=L;function D(P,b,d){return p((g,i)=>{const I=`$debounce$${i}`,S=`$debounce$result$${i}`;return function(...m){this[S]||(this[S]=d?d():void 0),clearTimeout(this[I]),b&&(this[S]=b(this[S],...m),m=[this[S]]),this[I]=setTimeout(()=>{g.apply(this,m),this[S]=d?d():void 0},P)}})}e.debounce=D;function M(P,b,d){return p((g,i)=>{const I=`$throttle$timer$${i}`,S=`$throttle$result$${i}`,m=`$throttle$lastRun$${i}`,t=`$throttle$pending$${i}`;return function(...h){if(this[S]||(this[S]=d?d():void 0),(this[m]===null||this[m]===void 0)&&(this[m]=-Number.MAX_VALUE),b&&(this[S]=b(this[S],...h)),this[t])return;const E=this[m]+P;E<=Date.now()?(this[m]=Date.now(),g.apply(this,[this[S]]),this[S]=d?d():void 0):(this[t]=!0,this[I]=setTimeout(()=>{this[t]=!1,this[m]=Date.now(),g.apply(this,[this[S]]),this[S]=d?d():void 0},E-Date.now()))}})}e.throttle=M}),define(Q[18],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isPromiseCanceledError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class p{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(n){setTimeout(()=>{throw n.stack?new Error(n.message+`

`+n.stack):n},0)}}addListener(n){return this.listeners.push(n),()=>{this._removeListener(n)}}emit(n){this.listeners.forEach(o=>{o(n)})}_removeListener(n){this.listeners.splice(this.listeners.indexOf(n),1)}setUnexpectedErrorHandler(n){this.unexpectedErrorHandler=n}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(n){this.unexpectedErrorHandler(n),this.emit(n)}onUnexpectedExternalError(n){this.unexpectedErrorHandler(n)}}e.ErrorHandler=p,e.errorHandler=new p;function L(c){e.errorHandler.setUnexpectedErrorHandler(c)}e.setUnexpectedErrorHandler=L;function D(c){d(c)||e.errorHandler.onUnexpectedError(c)}e.onUnexpectedError=D;function M(c){d(c)||e.errorHandler.onUnexpectedExternalError(c)}e.onUnexpectedExternalError=M;function P(c){if(c instanceof Error){let{name:n,message:o}=c;const s=c.stacktrace||c.stack;return{$isError:!0,name:n,message:o,stack:s}}return c}e.transformErrorForSerialization=P;const b="Canceled";function d(c){return c instanceof Error&&c.name===b&&c.message===b}e.isPromiseCanceledError=d;class g extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=g;function i(){const c=new Error(b);return c.name=c.message,c}e.canceled=i;function I(c){return c?new Error(`Illegal argument: ${c}`):new Error("Illegal argument")}e.illegalArgument=I;function S(c){return c?new Error(`Illegal state: ${c}`):new Error("Illegal state")}e.illegalState=S;function m(c){return c?new Error(`readonly property '${c} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=m;function t(c){const n=new Error(`${c} has been disposed`);return n.name="DISPOSED",n}e.disposed=t;function h(c){return c?c.message?c.message:c.stack?c.stack.split(`
`)[0]:String(c):"Error"}e.getErrorMessage=h;class E extends Error{constructor(n){super("NotImplemented");n&&(this.message=n)}}e.NotImplementedError=E;class v extends Error{constructor(n){super("NotSupported");n&&(this.message=n)}}e.NotSupportedError=v;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=y;function u(c){const n=c;return n instanceof Error&&Array.isArray(n.actions)}e.isErrorWithActions=u;function l(c,n=Object.create(null)){const o=new Error(c);return n.actions&&(o.actions=n.actions),o}e.createErrorWithActions=l}),define(Q[30],J([0,1,18]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ArrayQueue=e.maxIndex=e.minIndex=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch=e.equals=e.tail2=e.tail=void 0;function L(W,T=0){return W[W.length-(1+T)]}e.tail=L;function D(W){if(W.length===0)throw new Error("Invalid tail call");return[W.slice(0,W.length-1),W[W.length-1]]}e.tail2=D;function M(W,T,_=(q,Y)=>q===Y){if(W===T)return!0;if(!W||!T||W.length!==T.length)return!1;for(let q=0,Y=W.length;q<Y;q++)if(!_(W[q],T[q]))return!1;return!0}e.equals=M;function P(W,T,_){let q=0,Y=W.length-1;for(;q<=Y;){const $=(q+Y)/2|0,N=_(W[$],T);if(N<0)q=$+1;else if(N>0)Y=$-1;else return $}return-(q+1)}e.binarySearch=P;function b(W,T){let _=0,q=W.length;if(q===0)return 0;for(;_<q;){const Y=Math.floor((_+q)/2);T(W[Y])?q=Y:_=Y+1}return _}e.findFirstInSorted=b;function d(W,T,_){if(W=W|0,W>=T.length)throw new TypeError("invalid index");let q=T[Math.floor(T.length*Math.random())],Y=[],$=[],N=[];for(let Z of T){const ie=_(Z,q);ie<0?Y.push(Z):ie>0?$.push(Z):N.push(Z)}return W<Y.length?d(W,Y,_):W<Y.length+N.length?N[0]:d(W-(Y.length+N.length),$,_)}e.quickSelect=d;function g(W,T){const _=[];let q;for(const Y of W.slice(0).sort(T))!q||T(q[0],Y)!==0?(q=[Y],_.push(q)):q.push(Y);return _}e.groupBy=g;function i(W,T,_){const q=[];function Y(Z,ie,oe){if(ie===0&&oe.length===0)return;const le=q[q.length-1];le&&le.start+le.deleteCount===Z?(le.deleteCount+=ie,le.toInsert.push(...oe)):q.push({start:Z,deleteCount:ie,toInsert:oe})}let $=0,N=0;for(;;){if($===W.length){Y($,0,T.slice(N));break}if(N===T.length){Y($,W.length-$,[]);break}const Z=W[$],ie=T[N],oe=_(Z,ie);oe===0?($+=1,N+=1):oe<0?(Y($,1,[]),$+=1):oe>0&&(Y($,0,[ie]),N+=1)}return q}e.sortedDiff=i;function I(W,T,_){const q=i(W,T,_),Y=[],$=[];for(const N of q)Y.push(...W.slice(N.start,N.start+N.deleteCount)),$.push(...N.toInsert);return{removed:Y,added:$}}e.delta=I;function S(W,T,_){if(_===0)return[];const q=W.slice(0,_).sort(T);return t(W,T,q,_,W.length),q}e.top=S;function m(W,T,_,q,Y){return _===0?Promise.resolve([]):new Promise(($,N)=>{(async()=>{const Z=W.length,ie=W.slice(0,_).sort(T);for(let oe=_,le=Math.min(_+q,Z);oe<Z;oe=le,le=Math.min(le+q,Z)){if(oe>_&&await new Promise(ne=>setTimeout(ne)),Y&&Y.isCancellationRequested)throw(0,p.canceled)();t(W,T,ie,oe,le)}return ie})().then($,N)})}e.topAsync=m;function t(W,T,_,q,Y){for(const $=_.length;q<Y;q++){const N=W[q];if(T(N,_[$-1])<0){_.pop();const Z=b(_,ie=>T(N,ie)<0);_.splice(Z,0,N)}}}function h(W){return W.filter(T=>!!T)}e.coalesce=h;function E(W){let T=0;for(let _=0;_<W.length;_++)W[_]&&(W[T]=W[_],T+=1);W.length=T}e.coalesceInPlace=E;function v(W,T,_){W.splice(_,0,W.splice(T,1)[0])}e.move=v;function y(W){return!Array.isArray(W)||W.length===0}e.isFalsyOrEmpty=y;function u(W){return Array.isArray(W)&&W.length>0}e.isNonEmptyArray=u;function l(W,T=_=>_){const _=new Set;return W.filter(q=>{const Y=T(q);return _.has(Y)?!1:(_.add(Y),!0)})}e.distinct=l;function c(W){const T=Object.create(null);return _=>{const q=W(_);return T[q]?!1:(T[q]=!0,!0)}}e.uniqueFilter=c;function n(W,T){const _=o(W,T);if(_!==-1)return W[_]}e.findLast=n;function o(W,T){for(let _=W.length-1;_>=0;_--){const q=W[_];if(T(q))return _}return-1}e.lastIndex=o;function s(W,T){return W.length>0?W[0]:T}e.firstOrDefault=s;function r(W,T,_=(q,Y)=>q===Y){let q=0;for(let Y=0,$=Math.min(W.length,T.length);Y<$&&_(W[Y],T[Y]);Y++)q++;return q}e.commonPrefixLength=r;function a(W){return[].concat(...W)}e.flatten=a;function f(W,T){let _=typeof T=="number"?W:0;typeof T=="number"?_=W:(_=0,T=W);const q=[];if(_<=T)for(let Y=_;Y<T;Y++)q.push(Y);else for(let Y=_;Y>T;Y--)q.push(Y);return q}e.range=f;function w(W,T,_){return W.reduce((q,Y)=>(q[T(Y)]=_?_(Y):Y,q),Object.create(null))}e.index=w;function k(W,T){return W.push(T),()=>R(W,T)}e.insert=k;function R(W,T){const _=W.indexOf(T);if(_>-1)return W.splice(_,1),T}e.remove=R;function A(W,T,_){const q=W.slice(0,T),Y=W.slice(T);return q.concat(_,Y)}e.arrayInsert=A;function O(W,T){let _;if(typeof T=="number"){let q=T;_=()=>{const Y=Math.sin(q++)*179426549;return Y-Math.floor(Y)}}else _=Math.random;for(let q=W.length-1;q>0;q-=1){const Y=Math.floor(_()*(q+1)),$=W[q];W[q]=W[Y],W[Y]=$}}e.shuffle=O;function H(W,T){const _=W.indexOf(T);_>-1&&(W.splice(_,1),W.unshift(T))}e.pushToStart=H;function x(W,T){const _=W.indexOf(T);_>-1&&(W.splice(_,1),W.push(T))}e.pushToEnd=x;function re(W,T){return Array.isArray(W)?W.map(T):T(W)}e.mapArrayOrNot=re;function K(W){return Array.isArray(W)?W:[W]}e.asArray=K;function ee(W){return W[Math.floor(Math.random()*W.length)]}e.getRandomElement=ee;function F(W,T){for(const _ of W){const q=T(_);if(q!==void 0)return q}}e.mapFind=F;function V(W,T,_){const q=B(W,T),Y=W.length,$=_.length;W.length=Y+$;for(let N=Y-1;N>=q;N--)W[N+$]=W[N];for(let N=0;N<$;N++)W[N+q]=_[N]}e.insertInto=V;function z(W,T,_,q){const Y=B(W,T),$=W.splice(Y,_);return V(W,Y,q),$}e.splice=z;function B(W,T){return T<0?Math.max(T+W.length,0):Math.min(T,W.length)}function U(W,T){let _=Number.MAX_SAFE_INTEGER,q=0;return W.forEach((Y,$)=>{const N=T(Y);N<_&&(_=N,q=$)}),q}e.minIndex=U;function C(W,T){let _=Number.MIN_SAFE_INTEGER,q=0;return W.forEach((Y,$)=>{const N=T(Y);N>_&&(_=N,q=$)}),q}e.maxIndex=C;class X{constructor(T){this.items=T,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(T){let _=this.firstIdx;for(;_<this.items.length&&T(this.items[_]);)_++;const q=_===this.firstIdx?null:this.items.slice(this.firstIdx,_);return this.firstIdx=_,q}takeFromEndWhile(T){let _=this.lastIdx;for(;_>=0&&T(this.items[_]);)_--;const q=_===this.lastIdx?null:this.items.slice(_+1,this.lastIdx+1);return this.lastIdx=_,q}peek(){return this.items[this.firstIdx]}}e.ArrayQueue=X}),define(Q[42],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function p(L){const D=this;let M=!1,P;return function(){return M||(M=!0,P=L.apply(D,arguments)),P}}e.once=p}),define(Q[68],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var p;(function(L){function D(c){return c&&typeof c=="object"&&typeof c[Symbol.iterator]=="function"}L.is=D;const M=Object.freeze([]);function P(){return M}L.empty=P;function*b(c){yield c}L.single=b;function d(c){return c||M}L.from=d;function g(c){return!c||c[Symbol.iterator]().next().done===!0}L.isEmpty=g;function i(c){return c[Symbol.iterator]().next().value}L.first=i;function I(c,n){for(const o of c)if(n(o))return!0;return!1}L.some=I;function S(c,n){for(const o of c)if(n(o))return o}L.find=S;function*m(c,n){for(const o of c)n(o)&&(yield o)}L.filter=m;function*t(c,n){let o=0;for(const s of c)yield n(s,o++)}L.map=t;function*h(...c){for(const n of c)for(const o of n)yield o}L.concat=h;function*E(c){for(const n of c)for(const o of n)yield o}L.concatNested=E;function v(c,n,o){let s=o;for(const r of c)s=n(s,r);return s}L.reduce=v;function*y(c,n,o=c.length){for(n<0&&(n+=c.length),o<0?o+=c.length:o>c.length&&(o=c.length);n<o;n++)yield c[n]}L.slice=y;function u(c,n=Number.POSITIVE_INFINITY){const o=[];if(n===0)return[o,c];const s=c[Symbol.iterator]();for(let r=0;r<n;r++){const a=s.next();if(a.done)return[o,L.empty()];o.push(a.value)}return[o,{[Symbol.iterator](){return s}}]}L.consume=u;function l(c,n,o=(s,r)=>s===r){const s=c[Symbol.iterator](),r=n[Symbol.iterator]();for(;;){const a=s.next(),f=r.next();if(a.done!==f.done)return!1;if(a.done)return!0;if(!o(a.value,f.value))return!1}}L.equals=l})(p=e.Iterable||(e.Iterable={}))}),define(Q[39],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var p;(function(n){n[n.None=0]="None",n[n.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=2]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",n[n.InvalidUnicode=4]="InvalidUnicode",n[n.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",n[n.InvalidCharacter=6]="InvalidCharacter"})(p=e.ScanError||(e.ScanError={}));var L;(function(n){n[n.OpenBraceToken=1]="OpenBraceToken",n[n.CloseBraceToken=2]="CloseBraceToken",n[n.OpenBracketToken=3]="OpenBracketToken",n[n.CloseBracketToken=4]="CloseBracketToken",n[n.CommaToken=5]="CommaToken",n[n.ColonToken=6]="ColonToken",n[n.NullKeyword=7]="NullKeyword",n[n.TrueKeyword=8]="TrueKeyword",n[n.FalseKeyword=9]="FalseKeyword",n[n.StringLiteral=10]="StringLiteral",n[n.NumericLiteral=11]="NumericLiteral",n[n.LineCommentTrivia=12]="LineCommentTrivia",n[n.BlockCommentTrivia=13]="BlockCommentTrivia",n[n.LineBreakTrivia=14]="LineBreakTrivia",n[n.Trivia=15]="Trivia",n[n.Unknown=16]="Unknown",n[n.EOF=17]="EOF"})(L=e.SyntaxKind||(e.SyntaxKind={}));var D;(function(n){n[n.InvalidSymbol=1]="InvalidSymbol",n[n.InvalidNumberFormat=2]="InvalidNumberFormat",n[n.PropertyNameExpected=3]="PropertyNameExpected",n[n.ValueExpected=4]="ValueExpected",n[n.ColonExpected=5]="ColonExpected",n[n.CommaExpected=6]="CommaExpected",n[n.CloseBraceExpected=7]="CloseBraceExpected",n[n.CloseBracketExpected=8]="CloseBracketExpected",n[n.EndOfFileExpected=9]="EndOfFileExpected",n[n.InvalidCommentToken=10]="InvalidCommentToken",n[n.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",n[n.UnexpectedEndOfString=12]="UnexpectedEndOfString",n[n.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",n[n.InvalidUnicode=14]="InvalidUnicode",n[n.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",n[n.InvalidCharacter=16]="InvalidCharacter"})(D=e.ParseErrorCode||(e.ParseErrorCode={}));var M;(function(n){n.DEFAULT={allowTrailingComma:!0}})(M=e.ParseOptions||(e.ParseOptions={}));function P(n,o=!1){let s=0,r=n.length,a="",f=0,w=16,k=0;function R(ee){let F=0,V=0;for(;F<ee;){const z=n.charCodeAt(s);if(z>=48&&z<=57)V=V*16+z-48;else if(z>=65&&z<=70)V=V*16+z-65+10;else if(z>=97&&z<=102)V=V*16+z-97+10;else break;s++,F++}return F<ee&&(V=-1),V}function A(ee){s=ee,a="",f=0,w=16,k=0}function O(){const ee=s;if(n.charCodeAt(s)===48)s++;else for(s++;s<n.length&&g(n.charCodeAt(s));)s++;if(s<n.length&&n.charCodeAt(s)===46)if(s++,s<n.length&&g(n.charCodeAt(s)))for(s++;s<n.length&&g(n.charCodeAt(s));)s++;else return k=3,n.substring(ee,s);let F=s;if(s<n.length&&(n.charCodeAt(s)===69||n.charCodeAt(s)===101))if(s++,(s<n.length&&n.charCodeAt(s)===43||n.charCodeAt(s)===45)&&s++,s<n.length&&g(n.charCodeAt(s))){for(s++;s<n.length&&g(n.charCodeAt(s));)s++;F=s}else k=3;return n.substring(ee,F)}function H(){let ee="",F=s;for(;;){if(s>=r){ee+=n.substring(F,s),k=2;break}const V=n.charCodeAt(s);if(V===34){ee+=n.substring(F,s),s++;break}if(V===92){if(ee+=n.substring(F,s),s++,s>=r){k=2;break}switch(n.charCodeAt(s++)){case 34:ee+='"';break;case 92:ee+="\\";break;case 47:ee+="/";break;case 98:ee+="\b";break;case 102:ee+="\f";break;case 110:ee+=`
`;break;case 114:ee+="\r";break;case 116:ee+="	";break;case 117:const B=R(4);B>=0?ee+=String.fromCharCode(B):k=4;break;default:k=5}F=s;continue}if(V>=0&&V<=31)if(d(V)){ee+=n.substring(F,s),k=2;break}else k=6;s++}return ee}function x(){if(a="",k=0,f=s,s>=r)return f=r,w=17;let ee=n.charCodeAt(s);if(b(ee)){do s++,a+=String.fromCharCode(ee),ee=n.charCodeAt(s);while(b(ee));return w=15}if(d(ee))return s++,a+=String.fromCharCode(ee),ee===13&&n.charCodeAt(s)===10&&(s++,a+=`
`),w=14;switch(ee){case 123:return s++,w=1;case 125:return s++,w=2;case 91:return s++,w=3;case 93:return s++,w=4;case 58:return s++,w=6;case 44:return s++,w=5;case 34:return s++,a=H(),w=10;case 47:const F=s-1;if(n.charCodeAt(s+1)===47){for(s+=2;s<r&&!d(n.charCodeAt(s));)s++;return a=n.substring(F,s),w=12}if(n.charCodeAt(s+1)===42){s+=2;const V=r-1;let z=!1;for(;s<V;){if(n.charCodeAt(s)===42&&n.charCodeAt(s+1)===47){s+=2,z=!0;break}s++}return z||(s++,k=1),a=n.substring(F,s),w=13}return a+=String.fromCharCode(ee),s++,w=16;case 45:if(a+=String.fromCharCode(ee),s++,s===r||!g(n.charCodeAt(s)))return w=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return a+=O(),w=11;default:for(;s<r&&re(ee);)s++,ee=n.charCodeAt(s);if(f!==s){switch(a=n.substring(f,s),a){case"true":return w=8;case"false":return w=9;case"null":return w=7}return w=16}return a+=String.fromCharCode(ee),s++,w=16}}function re(ee){if(b(ee)||d(ee))return!1;switch(ee){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function K(){let ee;do ee=x();while(ee>=12&&ee<=15);return ee}return{setPosition:A,getPosition:()=>s,scan:o?K:x,getToken:()=>w,getTokenValue:()=>a,getTokenOffset:()=>f,getTokenLength:()=>s-f,getTokenError:()=>k}}e.createScanner=P;function b(n){return n===32||n===9||n===11||n===12||n===160||n===5760||n>=8192&&n<=8203||n===8239||n===8287||n===12288||n===65279}function d(n){return n===10||n===13||n===8232||n===8233}function g(n){return n>=48&&n<=57}var i;(function(n){n[n.nullCharacter=0]="nullCharacter",n[n.maxAsciiCharacter=127]="maxAsciiCharacter",n[n.lineFeed=10]="lineFeed",n[n.carriageReturn=13]="carriageReturn",n[n.lineSeparator=8232]="lineSeparator",n[n.paragraphSeparator=8233]="paragraphSeparator",n[n.nextLine=133]="nextLine",n[n.space=32]="space",n[n.nonBreakingSpace=160]="nonBreakingSpace",n[n.enQuad=8192]="enQuad",n[n.emQuad=8193]="emQuad",n[n.enSpace=8194]="enSpace",n[n.emSpace=8195]="emSpace",n[n.threePerEmSpace=8196]="threePerEmSpace",n[n.fourPerEmSpace=8197]="fourPerEmSpace",n[n.sixPerEmSpace=8198]="sixPerEmSpace",n[n.figureSpace=8199]="figureSpace",n[n.punctuationSpace=8200]="punctuationSpace",n[n.thinSpace=8201]="thinSpace",n[n.hairSpace=8202]="hairSpace",n[n.zeroWidthSpace=8203]="zeroWidthSpace",n[n.narrowNoBreakSpace=8239]="narrowNoBreakSpace",n[n.ideographicSpace=12288]="ideographicSpace",n[n.mathematicalSpace=8287]="mathematicalSpace",n[n.ogham=5760]="ogham",n[n._=95]="_",n[n.$=36]="$",n[n._0=48]="_0",n[n._1=49]="_1",n[n._2=50]="_2",n[n._3=51]="_3",n[n._4=52]="_4",n[n._5=53]="_5",n[n._6=54]="_6",n[n._7=55]="_7",n[n._8=56]="_8",n[n._9=57]="_9",n[n.a=97]="a",n[n.b=98]="b",n[n.c=99]="c",n[n.d=100]="d",n[n.e=101]="e",n[n.f=102]="f",n[n.g=103]="g",n[n.h=104]="h",n[n.i=105]="i",n[n.j=106]="j",n[n.k=107]="k",n[n.l=108]="l",n[n.m=109]="m",n[n.n=110]="n",n[n.o=111]="o",n[n.p=112]="p",n[n.q=113]="q",n[n.r=114]="r",n[n.s=115]="s",n[n.t=116]="t",n[n.u=117]="u",n[n.v=118]="v",n[n.w=119]="w",n[n.x=120]="x",n[n.y=121]="y",n[n.z=122]="z",n[n.A=65]="A",n[n.B=66]="B",n[n.C=67]="C",n[n.D=68]="D",n[n.E=69]="E",n[n.F=70]="F",n[n.G=71]="G",n[n.H=72]="H",n[n.I=73]="I",n[n.J=74]="J",n[n.K=75]="K",n[n.L=76]="L",n[n.M=77]="M",n[n.N=78]="N",n[n.O=79]="O",n[n.P=80]="P",n[n.Q=81]="Q",n[n.R=82]="R",n[n.S=83]="S",n[n.T=84]="T",n[n.U=85]="U",n[n.V=86]="V",n[n.W=87]="W",n[n.X=88]="X",n[n.Y=89]="Y",n[n.Z=90]="Z",n[n.ampersand=38]="ampersand",n[n.asterisk=42]="asterisk",n[n.at=64]="at",n[n.backslash=92]="backslash",n[n.bar=124]="bar",n[n.caret=94]="caret",n[n.closeBrace=125]="closeBrace",n[n.closeBracket=93]="closeBracket",n[n.closeParen=41]="closeParen",n[n.colon=58]="colon",n[n.comma=44]="comma",n[n.dot=46]="dot",n[n.doubleQuote=34]="doubleQuote",n[n.equals=61]="equals",n[n.exclamation=33]="exclamation",n[n.greaterThan=62]="greaterThan",n[n.lessThan=60]="lessThan",n[n.minus=45]="minus",n[n.openBrace=123]="openBrace",n[n.openBracket=91]="openBracket",n[n.openParen=40]="openParen",n[n.percent=37]="percent",n[n.plus=43]="plus",n[n.question=63]="question",n[n.semicolon=59]="semicolon",n[n.singleQuote=39]="singleQuote",n[n.slash=47]="slash",n[n.tilde=126]="tilde",n[n.backspace=8]="backspace",n[n.formFeed=12]="formFeed",n[n.byteOrderMark=65279]="byteOrderMark",n[n.tab=9]="tab",n[n.verticalTab=11]="verticalTab"})(i||(i={}));function I(n,o){const s=[],r=new Object;let a;const f={value:{},offset:0,length:0,type:"object",parent:void 0};let w=!1;function k(R,A,O,H){f.value=R,f.offset=A,f.length=O,f.type=H,f.colonOffset=void 0,a=f}try{u(n,{onObjectBegin:(R,A)=>{if(o<=R)throw r;a=void 0,w=o>R,s.push("")},onObjectProperty:(R,A,O)=>{if(o<A||(k(R,A,O,"property"),s[s.length-1]=R,o<=A+O))throw r},onObjectEnd:(R,A)=>{if(o<=R)throw r;a=void 0,s.pop()},onArrayBegin:(R,A)=>{if(o<=R)throw r;a=void 0,s.push(0)},onArrayEnd:(R,A)=>{if(o<=R)throw r;a=void 0,s.pop()},onLiteralValue:(R,A,O)=>{if(o<A||(k(R,A,O,c(R)),o<=A+O))throw r},onSeparator:(R,A,O)=>{if(o<=A)throw r;if(R===":"&&a&&a.type==="property")a.colonOffset=A,w=!1,a=void 0;else if(R===","){const H=s[s.length-1];typeof H=="number"?s[s.length-1]=H+1:(w=!0,s[s.length-1]=""),a=void 0}}})}catch(R){if(R!==r)throw R}return{path:s,previousNode:a,isAtPropertyKey:w,matches:R=>{let A=0;for(let O=0;A<R.length&&O<s.length;O++)if(R[A]===s[O]||R[A]==="*")A++;else if(R[A]!=="**")return!1;return A===R.length}}}e.getLocation=I;function S(n,o=[],s=M.DEFAULT){let r=null,a=[];const f=[];function w(R){Array.isArray(a)?a.push(R):r!==null&&(a[r]=R)}return u(n,{onObjectBegin:()=>{const R={};w(R),f.push(a),a=R,r=null},onObjectProperty:R=>{r=R},onObjectEnd:()=>{a=f.pop()},onArrayBegin:()=>{const R=[];w(R),f.push(a),a=R,r=null},onArrayEnd:()=>{a=f.pop()},onLiteralValue:w,onError:(R,A,O)=>{o.push({error:R,offset:A,length:O})}},s),a[0]}e.parse=S;function m(n,o=[],s=M.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function a(R){r.type==="property"&&(r.length=R-r.offset,r=r.parent)}function f(R){return r.children.push(R),R}u(n,{onObjectBegin:R=>{r=f({type:"object",offset:R,length:-1,parent:r,children:[]})},onObjectProperty:(R,A,O)=>{r=f({type:"property",offset:A,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:R,offset:A,length:O,parent:r})},onObjectEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,a(R+A)},onArrayBegin:(R,A)=>{r=f({type:"array",offset:R,length:-1,parent:r,children:[]})},onArrayEnd:(R,A)=>{r.length=R+A-r.offset,r=r.parent,a(R+A)},onLiteralValue:(R,A,O)=>{f({type:c(R),offset:A,length:O,parent:r,value:R}),a(A+O)},onSeparator:(R,A,O)=>{r.type==="property"&&(R===":"?r.colonOffset=A:R===","&&a(A))},onError:(R,A,O)=>{o.push({error:R,offset:A,length:O})}},s);const k=r.children[0];return k&&delete k.parent,k}e.parseTree=m;function t(n,o){if(!n)return;let s=n;for(let r of o)if(typeof r=="string"){if(s.type!=="object"||!Array.isArray(s.children))return;let a=!1;for(const f of s.children)if(Array.isArray(f.children)&&f.children[0].value===r){s=f.children[1],a=!0;break}if(!a)return}else{const a=r;if(s.type!=="array"||a<0||!Array.isArray(s.children)||a>=s.children.length)return;s=s.children[a]}return s}e.findNodeAtLocation=t;function h(n){if(!n.parent||!n.parent.children)return[];const o=h(n.parent);if(n.parent.type==="property"){const s=n.parent.children[0].value;o.push(s)}else if(n.parent.type==="array"){const s=n.parent.children.indexOf(n);s!==-1&&o.push(s)}return o}e.getNodePath=h;function E(n){switch(n.type){case"array":return n.children.map(E);case"object":const o=Object.create(null);for(let s of n.children){const r=s.children[1];r&&(o[s.children[0].value]=E(r))}return o;case"null":case"string":case"number":case"boolean":return n.value;default:return}}e.getNodeValue=E;function v(n,o,s=!1){return o>=n.offset&&o<n.offset+n.length||s&&o===n.offset+n.length}e.contains=v;function y(n,o,s=!1){if(v(n,o,s)){const r=n.children;if(Array.isArray(r))for(let a=0;a<r.length&&r[a].offset<=o;a++){const f=y(r[a],o,s);if(f)return f}return n}}e.findNodeAtOffset=y;function u(n,o,s=M.DEFAULT){const r=P(n,!1);function a(_){return _?()=>_(r.getTokenOffset(),r.getTokenLength()):()=>!0}function f(_){return _?q=>_(q,r.getTokenOffset(),r.getTokenLength()):()=>!0}const w=a(o.onObjectBegin),k=f(o.onObjectProperty),R=a(o.onObjectEnd),A=a(o.onArrayBegin),O=a(o.onArrayEnd),H=f(o.onLiteralValue),x=f(o.onSeparator),re=a(o.onComment),K=f(o.onError),ee=s&&s.disallowComments,F=s&&s.allowTrailingComma;function V(){for(;;){const _=r.scan();switch(r.getTokenError()){case 4:z(14);break;case 5:z(15);break;case 3:z(13);break;case 1:ee||z(11);break;case 2:z(12);break;case 6:z(16);break}switch(_){case 12:case 13:ee?z(10):re();break;case 16:z(1);break;case 15:case 14:break;default:return _}}}function z(_,q=[],Y=[]){if(K(_),q.length+Y.length>0){let $=r.getToken();for(;$!==17;){if(q.indexOf($)!==-1){V();break}else if(Y.indexOf($)!==-1)break;$=V()}}}function B(_){const q=r.getTokenValue();return _?H(q):k(q),V(),!0}function U(){switch(r.getToken()){case 11:let _=0;try{_=JSON.parse(r.getTokenValue()),typeof _!="number"&&(z(2),_=0)}catch(q){z(2)}H(_);break;case 7:H(null);break;case 8:H(!0);break;case 9:H(!1);break;default:return!1}return V(),!0}function C(){return r.getToken()!==10?(z(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(x(":"),V(),T()||z(4,[],[2,5])):z(5,[],[2,5]),!0)}function X(){w(),V();let _=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(_||z(4,[],[]),x(","),V(),r.getToken()===2&&F)break}else _&&z(6,[],[]);C()||z(4,[],[2,5]),_=!0}return R(),r.getToken()!==2?z(7,[2],[]):V(),!0}function W(){A(),V();let _=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(_||z(4,[],[]),x(","),V(),r.getToken()===4&&F)break}else _&&z(6,[],[]);T()||z(4,[],[4,5]),_=!0}return O(),r.getToken()!==4?z(8,[4],[]):V(),!0}function T(){switch(r.getToken()){case 3:return W();case 1:return X();case 10:return B(!0);default:return U()}}return V(),r.getToken()===17?s.allowEmptyContent?!0:(z(4,[],[]),!1):T()?(r.getToken()!==17&&z(9,[],[]),!0):(z(4,[],[]),!1)}e.visit=u;function l(n,o){let s=P(n),r=[],a,f=0,w;do switch(w=s.getPosition(),a=s.scan(),a){case 12:case 13:case 17:f!==w&&r.push(n.substring(f,w)),o!==void 0&&r.push(s.getTokenValue().replace(/[^\r\n]/g,o)),f=s.getPosition();break}while(a!==17);return r.join("")}e.stripComments=l;function c(n){switch(typeof n){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(n){if(Array.isArray(n))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=c}),define(Q[104],J([0,1,39]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.format=void 0;function L(d,g,i){let I,S,m,t,h;if(g){for(t=g.offset,h=t+g.length,m=t;m>0&&!b(d,m-1);)m--;let f=h;for(;f<d.length&&!b(d,f);)f++;S=d.substring(m,f),I=M(S,i)}else S=d,I=0,m=0,t=0,h=d.length;const E=P(i,d);let v=!1,y=0,u;i.insertSpaces?u=D(" ",i.tabSize||4):u="	";const l=(0,p.createScanner)(S,!1);let c=!1;function n(){return E+D(u,I+y)}function o(){let f=l.scan();for(v=!1;f===15||f===14;)v=v||f===14,f=l.scan();return c=f===16||l.getTokenError()!==0,f}const s=[];function r(f,w,k){!c&&w<h&&k>t&&d.substring(w,k)!==f&&s.push({offset:w,length:k-w,content:f})}let a=o();if(a!==17){const f=l.getTokenOffset()+m,w=D(u,I);r(w,m,f)}for(;a!==17;){let f=l.getTokenOffset()+l.getTokenLength()+m,w=o(),k="";for(;!v&&(w===12||w===13);){const A=l.getTokenOffset()+m;r(" ",f,A),f=l.getTokenOffset()+l.getTokenLength()+m,k=w===12?n():"",w=o()}if(w===2)a!==1&&(y--,k=n());else if(w===4)a!==3&&(y--,k=n());else{switch(a){case 3:case 1:y++,k=n();break;case 5:case 12:k=n();break;case 13:v?k=n():k=" ";break;case 6:k=" ";break;case 10:if(w===6){k="";break}case 7:case 8:case 9:case 11:case 2:case 4:w===12||w===13?k=" ":w!==5&&w!==17&&(c=!0);break;case 16:c=!0;break}v&&(w===12||w===13)&&(k=n())}const R=l.getTokenOffset()+m;r(k,f,R),a=w}return s}e.format=L;function D(d,g){let i="";for(let I=0;I<g;I++)i+=d;return i}function M(d,g){let i=0,I=0;const S=g.tabSize||4;for(;i<d.length;){const m=d.charAt(i);if(m===" ")I++;else if(m==="	")I+=S;else break;i++}return Math.floor(I/S)}function P(d,g){for(let i=0;i<g.length;i++){const I=g.charAt(i);if(I==="\r")return i+1<g.length&&g.charAt(i+1)===`
`?`\r
`:"\r";if(I===`
`)return`
`}return d&&d.eol||`
`}e.getEOL=P;function b(d,g){return`\r
`.indexOf(d.charAt(g))!==-1}e.isEOL=b}),define(Q[79],J([0,1,39,104]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function D(g,i,I){return M(g,i,void 0,I)}e.removeProperty=D;function M(g,i,I,S,m){const t=i.slice(),h=[],E=(0,p.parseTree)(g,h);let v,y;for(;t.length>0&&(y=t.pop(),v=(0,p.findNodeAtLocation)(E,t),v===void 0&&I!==void 0);)typeof y=="string"?I={[y]:I}:I=[I];if(v)if(v.type==="object"&&typeof y=="string"&&Array.isArray(v.children)){const u=(0,p.findNodeAtLocation)(v,[y]);if(u!==void 0)if(I===void 0){if(!u.parent)throw new Error("Malformed AST");const l=v.children.indexOf(u.parent);let c,n=u.parent.offset+u.parent.length;if(l>0){const o=v.children[l-1];c=o.offset+o.length}else c=v.offset+1,v.children.length>1&&(n=v.children[1].offset);return P(g,{offset:c,length:n-c,content:""},S)}else return P(g,{offset:u.offset,length:u.length,content:JSON.stringify(I)},S);else{if(I===void 0)return[];const l=`${JSON.stringify(y)}: ${JSON.stringify(I)}`,c=m?m(v.children.map(o=>o.children[0].value)):v.children.length;let n;if(c>0){const o=v.children[c-1];n={offset:o.offset+o.length,length:0,content:","+l}}else v.children.length===0?n={offset:v.offset+1,length:0,content:l}:n={offset:v.offset+1,length:0,content:l+","};return P(g,n,S)}}else if(v.type==="array"&&typeof y=="number"&&Array.isArray(v.children))if(I!==void 0){const u=`${JSON.stringify(I)}`;let l;if(v.children.length===0||y===0)l={offset:v.offset+1,length:0,content:v.children.length===0?u:u+","};else{const c=y===-1||y>v.children.length?v.children.length:y,n=v.children[c-1];l={offset:n.offset+n.length,length:0,content:","+u}}return P(g,l,S)}else{const u=y,l=v.children[u];let c;if(v.children.length===1)c={offset:v.offset+1,length:v.length-2,content:""};else if(v.children.length-1===u){const n=v.children[u-1],o=n.offset+n.length,s=v.offset+v.length;c={offset:o,length:s-2-o,content:""}}else c={offset:l.offset,length:v.children[u+1].offset-l.offset,content:""};return P(g,c,S)}else throw new Error(`Can not add ${typeof y!="number"?"index":"property"} to parent of type ${v.type}`);else{if(I===void 0)throw new Error("Can not delete in empty document");return P(g,{offset:E?E.offset:0,length:E?E.length:0,content:JSON.stringify(I)},S)}}e.setProperty=M;function P(g,i,I){let S=b(g,i),m=i.offset,t=i.offset+i.content.length;if(i.length===0||i.content.length===0){for(;m>0&&!(0,L.isEOL)(S,m-1);)m--;for(;t<S.length&&!(0,L.isEOL)(S,t);)t++}const h=(0,L.format)(S,{offset:m,length:t-m},I);for(let v=h.length-1;v>=0;v--){const y=h[v];S=b(S,y),m=Math.min(m,y.offset),t=Math.max(t,y.offset+y.length),t+=y.content.length-y.length}const E=g.length-(S.length-t)-m;return[{offset:m,length:E,content:S.substring(m,t)}]}e.withFormatting=P;function b(g,i){return g.substring(0,i.offset)+i.content+g.substring(i.offset+i.length)}e.applyEdit=b;function d(g,i){let I=i.slice(0).sort((m,t)=>{const h=m.offset-t.offset;return h===0?m.length-t.length:h}),S=g.length;for(let m=I.length-1;m>=0;m--){let t=I[m];if(t.offset+t.length<=S)g=b(g,t);else throw new Error("Overlapping edit");S=t.offset}return g}e.applyEdits=d}),define(Q[80],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyChord=e.KeyMod=e.KeyCodeUtils=e.IMMUTABLE_KEY_CODE_TO_CODE=e.IMMUTABLE_CODE_TO_KEY_CODE=e.ScanCodeUtils=e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=e.EVENT_KEY_CODE_MAP=e.ScanCode=e.KeyCode=void 0;var p;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.Unknown=0]="Unknown",t[t.Backspace=1]="Backspace",t[t.Tab=2]="Tab",t[t.Enter=3]="Enter",t[t.Shift=4]="Shift",t[t.Ctrl=5]="Ctrl",t[t.Alt=6]="Alt",t[t.PauseBreak=7]="PauseBreak",t[t.CapsLock=8]="CapsLock",t[t.Escape=9]="Escape",t[t.Space=10]="Space",t[t.PageUp=11]="PageUp",t[t.PageDown=12]="PageDown",t[t.End=13]="End",t[t.Home=14]="Home",t[t.LeftArrow=15]="LeftArrow",t[t.UpArrow=16]="UpArrow",t[t.RightArrow=17]="RightArrow",t[t.DownArrow=18]="DownArrow",t[t.Insert=19]="Insert",t[t.Delete=20]="Delete",t[t.Digit0=21]="Digit0",t[t.Digit1=22]="Digit1",t[t.Digit2=23]="Digit2",t[t.Digit3=24]="Digit3",t[t.Digit4=25]="Digit4",t[t.Digit5=26]="Digit5",t[t.Digit6=27]="Digit6",t[t.Digit7=28]="Digit7",t[t.Digit8=29]="Digit8",t[t.Digit9=30]="Digit9",t[t.KeyA=31]="KeyA",t[t.KeyB=32]="KeyB",t[t.KeyC=33]="KeyC",t[t.KeyD=34]="KeyD",t[t.KeyE=35]="KeyE",t[t.KeyF=36]="KeyF",t[t.KeyG=37]="KeyG",t[t.KeyH=38]="KeyH",t[t.KeyI=39]="KeyI",t[t.KeyJ=40]="KeyJ",t[t.KeyK=41]="KeyK",t[t.KeyL=42]="KeyL",t[t.KeyM=43]="KeyM",t[t.KeyN=44]="KeyN",t[t.KeyO=45]="KeyO",t[t.KeyP=46]="KeyP",t[t.KeyQ=47]="KeyQ",t[t.KeyR=48]="KeyR",t[t.KeyS=49]="KeyS",t[t.KeyT=50]="KeyT",t[t.KeyU=51]="KeyU",t[t.KeyV=52]="KeyV",t[t.KeyW=53]="KeyW",t[t.KeyX=54]="KeyX",t[t.KeyY=55]="KeyY",t[t.KeyZ=56]="KeyZ",t[t.Meta=57]="Meta",t[t.ContextMenu=58]="ContextMenu",t[t.F1=59]="F1",t[t.F2=60]="F2",t[t.F3=61]="F3",t[t.F4=62]="F4",t[t.F5=63]="F5",t[t.F6=64]="F6",t[t.F7=65]="F7",t[t.F8=66]="F8",t[t.F9=67]="F9",t[t.F10=68]="F10",t[t.F11=69]="F11",t[t.F12=70]="F12",t[t.F13=71]="F13",t[t.F14=72]="F14",t[t.F15=73]="F15",t[t.F16=74]="F16",t[t.F17=75]="F17",t[t.F18=76]="F18",t[t.F19=77]="F19",t[t.NumLock=78]="NumLock",t[t.ScrollLock=79]="ScrollLock",t[t.Semicolon=80]="Semicolon",t[t.Equal=81]="Equal",t[t.Comma=82]="Comma",t[t.Minus=83]="Minus",t[t.Period=84]="Period",t[t.Slash=85]="Slash",t[t.Backquote=86]="Backquote",t[t.BracketLeft=87]="BracketLeft",t[t.Backslash=88]="Backslash",t[t.BracketRight=89]="BracketRight",t[t.Quote=90]="Quote",t[t.OEM_8=91]="OEM_8",t[t.IntlBackslash=92]="IntlBackslash",t[t.Numpad0=93]="Numpad0",t[t.Numpad1=94]="Numpad1",t[t.Numpad2=95]="Numpad2",t[t.Numpad3=96]="Numpad3",t[t.Numpad4=97]="Numpad4",t[t.Numpad5=98]="Numpad5",t[t.Numpad6=99]="Numpad6",t[t.Numpad7=100]="Numpad7",t[t.Numpad8=101]="Numpad8",t[t.Numpad9=102]="Numpad9",t[t.NumpadMultiply=103]="NumpadMultiply",t[t.NumpadAdd=104]="NumpadAdd",t[t.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",t[t.NumpadSubtract=106]="NumpadSubtract",t[t.NumpadDecimal=107]="NumpadDecimal",t[t.NumpadDivide=108]="NumpadDivide",t[t.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",t[t.ABNT_C1=110]="ABNT_C1",t[t.ABNT_C2=111]="ABNT_C2",t[t.AudioVolumeMute=112]="AudioVolumeMute",t[t.AudioVolumeUp=113]="AudioVolumeUp",t[t.AudioVolumeDown=114]="AudioVolumeDown",t[t.BrowserSearch=115]="BrowserSearch",t[t.BrowserHome=116]="BrowserHome",t[t.BrowserBack=117]="BrowserBack",t[t.BrowserForward=118]="BrowserForward",t[t.MediaTrackNext=119]="MediaTrackNext",t[t.MediaTrackPrevious=120]="MediaTrackPrevious",t[t.MediaStop=121]="MediaStop",t[t.MediaPlayPause=122]="MediaPlayPause",t[t.LaunchMediaPlayer=123]="LaunchMediaPlayer",t[t.LaunchMail=124]="LaunchMail",t[t.LaunchApp2=125]="LaunchApp2",t[t.MAX_VALUE=126]="MAX_VALUE"})(p=e.KeyCode||(e.KeyCode={}));var L;(function(t){t[t.DependsOnKbLayout=-1]="DependsOnKbLayout",t[t.None=0]="None",t[t.Hyper=1]="Hyper",t[t.Super=2]="Super",t[t.Fn=3]="Fn",t[t.FnLock=4]="FnLock",t[t.Suspend=5]="Suspend",t[t.Resume=6]="Resume",t[t.Turbo=7]="Turbo",t[t.Sleep=8]="Sleep",t[t.WakeUp=9]="WakeUp",t[t.KeyA=10]="KeyA",t[t.KeyB=11]="KeyB",t[t.KeyC=12]="KeyC",t[t.KeyD=13]="KeyD",t[t.KeyE=14]="KeyE",t[t.KeyF=15]="KeyF",t[t.KeyG=16]="KeyG",t[t.KeyH=17]="KeyH",t[t.KeyI=18]="KeyI",t[t.KeyJ=19]="KeyJ",t[t.KeyK=20]="KeyK",t[t.KeyL=21]="KeyL",t[t.KeyM=22]="KeyM",t[t.KeyN=23]="KeyN",t[t.KeyO=24]="KeyO",t[t.KeyP=25]="KeyP",t[t.KeyQ=26]="KeyQ",t[t.KeyR=27]="KeyR",t[t.KeyS=28]="KeyS",t[t.KeyT=29]="KeyT",t[t.KeyU=30]="KeyU",t[t.KeyV=31]="KeyV",t[t.KeyW=32]="KeyW",t[t.KeyX=33]="KeyX",t[t.KeyY=34]="KeyY",t[t.KeyZ=35]="KeyZ",t[t.Digit1=36]="Digit1",t[t.Digit2=37]="Digit2",t[t.Digit3=38]="Digit3",t[t.Digit4=39]="Digit4",t[t.Digit5=40]="Digit5",t[t.Digit6=41]="Digit6",t[t.Digit7=42]="Digit7",t[t.Digit8=43]="Digit8",t[t.Digit9=44]="Digit9",t[t.Digit0=45]="Digit0",t[t.Enter=46]="Enter",t[t.Escape=47]="Escape",t[t.Backspace=48]="Backspace",t[t.Tab=49]="Tab",t[t.Space=50]="Space",t[t.Minus=51]="Minus",t[t.Equal=52]="Equal",t[t.BracketLeft=53]="BracketLeft",t[t.BracketRight=54]="BracketRight",t[t.Backslash=55]="Backslash",t[t.IntlHash=56]="IntlHash",t[t.Semicolon=57]="Semicolon",t[t.Quote=58]="Quote",t[t.Backquote=59]="Backquote",t[t.Comma=60]="Comma",t[t.Period=61]="Period",t[t.Slash=62]="Slash",t[t.CapsLock=63]="CapsLock",t[t.F1=64]="F1",t[t.F2=65]="F2",t[t.F3=66]="F3",t[t.F4=67]="F4",t[t.F5=68]="F5",t[t.F6=69]="F6",t[t.F7=70]="F7",t[t.F8=71]="F8",t[t.F9=72]="F9",t[t.F10=73]="F10",t[t.F11=74]="F11",t[t.F12=75]="F12",t[t.PrintScreen=76]="PrintScreen",t[t.ScrollLock=77]="ScrollLock",t[t.Pause=78]="Pause",t[t.Insert=79]="Insert",t[t.Home=80]="Home",t[t.PageUp=81]="PageUp",t[t.Delete=82]="Delete",t[t.End=83]="End",t[t.PageDown=84]="PageDown",t[t.ArrowRight=85]="ArrowRight",t[t.ArrowLeft=86]="ArrowLeft",t[t.ArrowDown=87]="ArrowDown",t[t.ArrowUp=88]="ArrowUp",t[t.NumLock=89]="NumLock",t[t.NumpadDivide=90]="NumpadDivide",t[t.NumpadMultiply=91]="NumpadMultiply",t[t.NumpadSubtract=92]="NumpadSubtract",t[t.NumpadAdd=93]="NumpadAdd",t[t.NumpadEnter=94]="NumpadEnter",t[t.Numpad1=95]="Numpad1",t[t.Numpad2=96]="Numpad2",t[t.Numpad3=97]="Numpad3",t[t.Numpad4=98]="Numpad4",t[t.Numpad5=99]="Numpad5",t[t.Numpad6=100]="Numpad6",t[t.Numpad7=101]="Numpad7",t[t.Numpad8=102]="Numpad8",t[t.Numpad9=103]="Numpad9",t[t.Numpad0=104]="Numpad0",t[t.NumpadDecimal=105]="NumpadDecimal",t[t.IntlBackslash=106]="IntlBackslash",t[t.ContextMenu=107]="ContextMenu",t[t.Power=108]="Power",t[t.NumpadEqual=109]="NumpadEqual",t[t.F13=110]="F13",t[t.F14=111]="F14",t[t.F15=112]="F15",t[t.F16=113]="F16",t[t.F17=114]="F17",t[t.F18=115]="F18",t[t.F19=116]="F19",t[t.F20=117]="F20",t[t.F21=118]="F21",t[t.F22=119]="F22",t[t.F23=120]="F23",t[t.F24=121]="F24",t[t.Open=122]="Open",t[t.Help=123]="Help",t[t.Select=124]="Select",t[t.Again=125]="Again",t[t.Undo=126]="Undo",t[t.Cut=127]="Cut",t[t.Copy=128]="Copy",t[t.Paste=129]="Paste",t[t.Find=130]="Find",t[t.AudioVolumeMute=131]="AudioVolumeMute",t[t.AudioVolumeUp=132]="AudioVolumeUp",t[t.AudioVolumeDown=133]="AudioVolumeDown",t[t.NumpadComma=134]="NumpadComma",t[t.IntlRo=135]="IntlRo",t[t.KanaMode=136]="KanaMode",t[t.IntlYen=137]="IntlYen",t[t.Convert=138]="Convert",t[t.NonConvert=139]="NonConvert",t[t.Lang1=140]="Lang1",t[t.Lang2=141]="Lang2",t[t.Lang3=142]="Lang3",t[t.Lang4=143]="Lang4",t[t.Lang5=144]="Lang5",t[t.Abort=145]="Abort",t[t.Props=146]="Props",t[t.NumpadParenLeft=147]="NumpadParenLeft",t[t.NumpadParenRight=148]="NumpadParenRight",t[t.NumpadBackspace=149]="NumpadBackspace",t[t.NumpadMemoryStore=150]="NumpadMemoryStore",t[t.NumpadMemoryRecall=151]="NumpadMemoryRecall",t[t.NumpadMemoryClear=152]="NumpadMemoryClear",t[t.NumpadMemoryAdd=153]="NumpadMemoryAdd",t[t.NumpadMemorySubtract=154]="NumpadMemorySubtract",t[t.NumpadClear=155]="NumpadClear",t[t.NumpadClearEntry=156]="NumpadClearEntry",t[t.ControlLeft=157]="ControlLeft",t[t.ShiftLeft=158]="ShiftLeft",t[t.AltLeft=159]="AltLeft",t[t.MetaLeft=160]="MetaLeft",t[t.ControlRight=161]="ControlRight",t[t.ShiftRight=162]="ShiftRight",t[t.AltRight=163]="AltRight",t[t.MetaRight=164]="MetaRight",t[t.BrightnessUp=165]="BrightnessUp",t[t.BrightnessDown=166]="BrightnessDown",t[t.MediaPlay=167]="MediaPlay",t[t.MediaRecord=168]="MediaRecord",t[t.MediaFastForward=169]="MediaFastForward",t[t.MediaRewind=170]="MediaRewind",t[t.MediaTrackNext=171]="MediaTrackNext",t[t.MediaTrackPrevious=172]="MediaTrackPrevious",t[t.MediaStop=173]="MediaStop",t[t.Eject=174]="Eject",t[t.MediaPlayPause=175]="MediaPlayPause",t[t.MediaSelect=176]="MediaSelect",t[t.LaunchMail=177]="LaunchMail",t[t.LaunchApp2=178]="LaunchApp2",t[t.LaunchApp1=179]="LaunchApp1",t[t.SelectTask=180]="SelectTask",t[t.LaunchScreenSaver=181]="LaunchScreenSaver",t[t.BrowserSearch=182]="BrowserSearch",t[t.BrowserHome=183]="BrowserHome",t[t.BrowserBack=184]="BrowserBack",t[t.BrowserForward=185]="BrowserForward",t[t.BrowserStop=186]="BrowserStop",t[t.BrowserRefresh=187]="BrowserRefresh",t[t.BrowserFavorites=188]="BrowserFavorites",t[t.ZoomToggle=189]="ZoomToggle",t[t.MailReply=190]="MailReply",t[t.MailForward=191]="MailForward",t[t.MailSend=192]="MailSend",t[t.MAX_VALUE=193]="MAX_VALUE"})(L=e.ScanCode||(e.ScanCode={}));class D{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(h,E){this._keyCodeToStr[h]=E,this._strToKeyCode[E.toLowerCase()]=h}keyCodeToStr(h){return this._keyCodeToStr[h]}strToKeyCode(h){return this._strToKeyCode[h.toLowerCase()]||0}}const M=new D,P=new D,b=new D;e.EVENT_KEY_CODE_MAP=new Array(230),e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const d=[],g=Object.create(null),i=Object.create(null);e.ScanCodeUtils={lowerCaseToEnum:t=>i[t]||0,toEnum:t=>g[t]||0,toString:t=>d[t]||"None"},e.IMMUTABLE_CODE_TO_KEY_CODE=[],e.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let t=0;t<=193;t++)e.IMMUTABLE_CODE_TO_KEY_CODE[t]=-1;for(let t=0;t<=126;t++)e.IMMUTABLE_KEY_CODE_TO_CODE[t]=-1;(function(){const t="",h=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",t,t],[0,1,1,"Hyper",0,t,0,t,t,t],[0,1,2,"Super",0,t,0,t,t,t],[0,1,3,"Fn",0,t,0,t,t,t],[0,1,4,"FnLock",0,t,0,t,t,t],[0,1,5,"Suspend",0,t,0,t,t,t],[0,1,6,"Resume",0,t,0,t,t,t],[0,1,7,"Turbo",0,t,0,t,t,t],[0,1,8,"Sleep",0,t,0,"VK_SLEEP",t,t],[0,1,9,"WakeUp",0,t,0,t,t,t],[31,0,10,"KeyA",31,"A",65,"VK_A",t,t],[32,0,11,"KeyB",32,"B",66,"VK_B",t,t],[33,0,12,"KeyC",33,"C",67,"VK_C",t,t],[34,0,13,"KeyD",34,"D",68,"VK_D",t,t],[35,0,14,"KeyE",35,"E",69,"VK_E",t,t],[36,0,15,"KeyF",36,"F",70,"VK_F",t,t],[37,0,16,"KeyG",37,"G",71,"VK_G",t,t],[38,0,17,"KeyH",38,"H",72,"VK_H",t,t],[39,0,18,"KeyI",39,"I",73,"VK_I",t,t],[40,0,19,"KeyJ",40,"J",74,"VK_J",t,t],[41,0,20,"KeyK",41,"K",75,"VK_K",t,t],[42,0,21,"KeyL",42,"L",76,"VK_L",t,t],[43,0,22,"KeyM",43,"M",77,"VK_M",t,t],[44,0,23,"KeyN",44,"N",78,"VK_N",t,t],[45,0,24,"KeyO",45,"O",79,"VK_O",t,t],[46,0,25,"KeyP",46,"P",80,"VK_P",t,t],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",t,t],[48,0,27,"KeyR",48,"R",82,"VK_R",t,t],[49,0,28,"KeyS",49,"S",83,"VK_S",t,t],[50,0,29,"KeyT",50,"T",84,"VK_T",t,t],[51,0,30,"KeyU",51,"U",85,"VK_U",t,t],[52,0,31,"KeyV",52,"V",86,"VK_V",t,t],[53,0,32,"KeyW",53,"W",87,"VK_W",t,t],[54,0,33,"KeyX",54,"X",88,"VK_X",t,t],[55,0,34,"KeyY",55,"Y",89,"VK_Y",t,t],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",t,t],[22,0,36,"Digit1",22,"1",49,"VK_1",t,t],[23,0,37,"Digit2",23,"2",50,"VK_2",t,t],[24,0,38,"Digit3",24,"3",51,"VK_3",t,t],[25,0,39,"Digit4",25,"4",52,"VK_4",t,t],[26,0,40,"Digit5",26,"5",53,"VK_5",t,t],[27,0,41,"Digit6",27,"6",54,"VK_6",t,t],[28,0,42,"Digit7",28,"7",55,"VK_7",t,t],[29,0,43,"Digit8",29,"8",56,"VK_8",t,t],[30,0,44,"Digit9",30,"9",57,"VK_9",t,t],[21,0,45,"Digit0",21,"0",48,"VK_0",t,t],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",t,t],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",t,t],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",t,t],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",t,t],[10,1,50,"Space",10,"Space",32,"VK_SPACE",t,t],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,t,0,t,t,t],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",t,t],[59,1,64,"F1",59,"F1",112,"VK_F1",t,t],[60,1,65,"F2",60,"F2",113,"VK_F2",t,t],[61,1,66,"F3",61,"F3",114,"VK_F3",t,t],[62,1,67,"F4",62,"F4",115,"VK_F4",t,t],[63,1,68,"F5",63,"F5",116,"VK_F5",t,t],[64,1,69,"F6",64,"F6",117,"VK_F6",t,t],[65,1,70,"F7",65,"F7",118,"VK_F7",t,t],[66,1,71,"F8",66,"F8",119,"VK_F8",t,t],[67,1,72,"F9",67,"F9",120,"VK_F9",t,t],[68,1,73,"F10",68,"F10",121,"VK_F10",t,t],[69,1,74,"F11",69,"F11",122,"VK_F11",t,t],[70,1,75,"F12",70,"F12",123,"VK_F12",t,t],[0,1,76,"PrintScreen",0,t,0,t,t,t],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",t,t],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",t,t],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",t,t],[14,1,80,"Home",14,"Home",36,"VK_HOME",t,t],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",t,t],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",t,t],[13,1,83,"End",13,"End",35,"VK_END",t,t],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",t,t],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",t],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",t],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",t],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",t],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",t,t],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",t,t],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",t,t],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",t,t],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",t,t],[3,1,94,"NumpadEnter",3,t,0,t,t,t],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",t,t],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",t,t],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",t,t],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",t,t],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",t,t],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",t,t],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",t,t],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",t,t],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",t,t],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",t,t],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",t,t],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",t,t],[58,1,107,"ContextMenu",58,"ContextMenu",93,t,t,t],[0,1,108,"Power",0,t,0,t,t,t],[0,1,109,"NumpadEqual",0,t,0,t,t,t],[71,1,110,"F13",71,"F13",124,"VK_F13",t,t],[72,1,111,"F14",72,"F14",125,"VK_F14",t,t],[73,1,112,"F15",73,"F15",126,"VK_F15",t,t],[74,1,113,"F16",74,"F16",127,"VK_F16",t,t],[75,1,114,"F17",75,"F17",128,"VK_F17",t,t],[76,1,115,"F18",76,"F18",129,"VK_F18",t,t],[77,1,116,"F19",77,"F19",130,"VK_F19",t,t],[0,1,117,"F20",0,t,0,"VK_F20",t,t],[0,1,118,"F21",0,t,0,"VK_F21",t,t],[0,1,119,"F22",0,t,0,"VK_F22",t,t],[0,1,120,"F23",0,t,0,"VK_F23",t,t],[0,1,121,"F24",0,t,0,"VK_F24",t,t],[0,1,122,"Open",0,t,0,t,t,t],[0,1,123,"Help",0,t,0,t,t,t],[0,1,124,"Select",0,t,0,t,t,t],[0,1,125,"Again",0,t,0,t,t,t],[0,1,126,"Undo",0,t,0,t,t,t],[0,1,127,"Cut",0,t,0,t,t,t],[0,1,128,"Copy",0,t,0,t,t,t],[0,1,129,"Paste",0,t,0,t,t,t],[0,1,130,"Find",0,t,0,t,t,t],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",t,t],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",t,t],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",t,t],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",t,t],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",t,t],[0,1,136,"KanaMode",0,t,0,t,t,t],[0,0,137,"IntlYen",0,t,0,t,t,t],[0,1,138,"Convert",0,t,0,t,t,t],[0,1,139,"NonConvert",0,t,0,t,t,t],[0,1,140,"Lang1",0,t,0,t,t,t],[0,1,141,"Lang2",0,t,0,t,t,t],[0,1,142,"Lang3",0,t,0,t,t,t],[0,1,143,"Lang4",0,t,0,t,t,t],[0,1,144,"Lang5",0,t,0,t,t,t],[0,1,145,"Abort",0,t,0,t,t,t],[0,1,146,"Props",0,t,0,t,t,t],[0,1,147,"NumpadParenLeft",0,t,0,t,t,t],[0,1,148,"NumpadParenRight",0,t,0,t,t,t],[0,1,149,"NumpadBackspace",0,t,0,t,t,t],[0,1,150,"NumpadMemoryStore",0,t,0,t,t,t],[0,1,151,"NumpadMemoryRecall",0,t,0,t,t,t],[0,1,152,"NumpadMemoryClear",0,t,0,t,t,t],[0,1,153,"NumpadMemoryAdd",0,t,0,t,t,t],[0,1,154,"NumpadMemorySubtract",0,t,0,t,t,t],[0,1,155,"NumpadClear",0,t,0,t,t,t],[0,1,156,"NumpadClearEntry",0,t,0,t,t,t],[5,1,0,t,5,"Ctrl",17,"VK_CONTROL",t,t],[4,1,0,t,4,"Shift",16,"VK_SHIFT",t,t],[6,1,0,t,6,"Alt",18,"VK_MENU",t,t],[57,1,0,t,57,"Meta",0,"VK_COMMAND",t,t],[5,1,157,"ControlLeft",5,t,0,"VK_LCONTROL",t,t],[4,1,158,"ShiftLeft",4,t,0,"VK_LSHIFT",t,t],[6,1,159,"AltLeft",6,t,0,"VK_LMENU",t,t],[57,1,160,"MetaLeft",57,t,0,"VK_LWIN",t,t],[5,1,161,"ControlRight",5,t,0,"VK_RCONTROL",t,t],[4,1,162,"ShiftRight",4,t,0,"VK_RSHIFT",t,t],[6,1,163,"AltRight",6,t,0,"VK_RMENU",t,t],[57,1,164,"MetaRight",57,t,0,"VK_RWIN",t,t],[0,1,165,"BrightnessUp",0,t,0,t,t,t],[0,1,166,"BrightnessDown",0,t,0,t,t,t],[0,1,167,"MediaPlay",0,t,0,t,t,t],[0,1,168,"MediaRecord",0,t,0,t,t,t],[0,1,169,"MediaFastForward",0,t,0,t,t,t],[0,1,170,"MediaRewind",0,t,0,t,t,t],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",t,t],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",t,t],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",t,t],[0,1,174,"Eject",0,t,0,t,t,t],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",t,t],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",t,t],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",t,t],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",t,t],[0,1,179,"LaunchApp1",0,t,0,"VK_MEDIA_LAUNCH_APP1",t,t],[0,1,180,"SelectTask",0,t,0,t,t,t],[0,1,181,"LaunchScreenSaver",0,t,0,t,t,t],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",t,t],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",t,t],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",t,t],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",t,t],[0,1,186,"BrowserStop",0,t,0,"VK_BROWSER_STOP",t,t],[0,1,187,"BrowserRefresh",0,t,0,"VK_BROWSER_REFRESH",t,t],[0,1,188,"BrowserFavorites",0,t,0,"VK_BROWSER_FAVORITES",t,t],[0,1,189,"ZoomToggle",0,t,0,t,t,t],[0,1,190,"MailReply",0,t,0,t,t,t],[0,1,191,"MailForward",0,t,0,t,t,t],[0,1,192,"MailSend",0,t,0,t,t,t],[109,1,0,t,109,"KeyInComposition",229,t,t,t],[111,1,0,t,111,"ABNT_C2",194,"VK_ABNT_C2",t,t],[91,1,0,t,91,"OEM_8",223,"VK_OEM_8",t,t],[0,1,0,t,0,t,0,"VK_CLEAR",t,t],[0,1,0,t,0,t,0,"VK_KANA",t,t],[0,1,0,t,0,t,0,"VK_HANGUL",t,t],[0,1,0,t,0,t,0,"VK_JUNJA",t,t],[0,1,0,t,0,t,0,"VK_FINAL",t,t],[0,1,0,t,0,t,0,"VK_HANJA",t,t],[0,1,0,t,0,t,0,"VK_KANJI",t,t],[0,1,0,t,0,t,0,"VK_CONVERT",t,t],[0,1,0,t,0,t,0,"VK_NONCONVERT",t,t],[0,1,0,t,0,t,0,"VK_ACCEPT",t,t],[0,1,0,t,0,t,0,"VK_MODECHANGE",t,t],[0,1,0,t,0,t,0,"VK_SELECT",t,t],[0,1,0,t,0,t,0,"VK_PRINT",t,t],[0,1,0,t,0,t,0,"VK_EXECUTE",t,t],[0,1,0,t,0,t,0,"VK_SNAPSHOT",t,t],[0,1,0,t,0,t,0,"VK_HELP",t,t],[0,1,0,t,0,t,0,"VK_APPS",t,t],[0,1,0,t,0,t,0,"VK_PROCESSKEY",t,t],[0,1,0,t,0,t,0,"VK_PACKET",t,t],[0,1,0,t,0,t,0,"VK_DBE_SBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_DBE_DBCSCHAR",t,t],[0,1,0,t,0,t,0,"VK_ATTN",t,t],[0,1,0,t,0,t,0,"VK_CRSEL",t,t],[0,1,0,t,0,t,0,"VK_EXSEL",t,t],[0,1,0,t,0,t,0,"VK_EREOF",t,t],[0,1,0,t,0,t,0,"VK_PLAY",t,t],[0,1,0,t,0,t,0,"VK_ZOOM",t,t],[0,1,0,t,0,t,0,"VK_NONAME",t,t],[0,1,0,t,0,t,0,"VK_PA1",t,t],[0,1,0,t,0,t,0,"VK_OEM_CLEAR",t,t]];let E=[],v=[];for(const y of h){const[u,l,c,n,o,s,r,a,f,w]=y;if(v[c]||(v[c]=!0,d[c]=n,g[n]=c,i[n.toLowerCase()]=c,l&&(e.IMMUTABLE_CODE_TO_KEY_CODE[c]=o,o!==0&&o!==3&&o!==5&&o!==4&&o!==6&&o!==57&&(e.IMMUTABLE_KEY_CODE_TO_CODE[o]=c))),!E[o]){if(E[o]=!0,!s)throw new Error(`String representation missing for key code ${o} around scan code ${n}`);M.define(o,s),P.define(o,f||s),b.define(o,w||f||s)}r&&(e.EVENT_KEY_CODE_MAP[r]=o),a&&(e.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[a]=o)}e.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var I;(function(t){function h(c){return M.keyCodeToStr(c)}t.toString=h;function E(c){return M.strToKeyCode(c)}t.fromString=E;function v(c){return P.keyCodeToStr(c)}t.toUserSettingsUS=v;function y(c){return b.keyCodeToStr(c)}t.toUserSettingsGeneral=y;function u(c){return P.strToKeyCode(c)||b.strToKeyCode(c)}t.fromUserSettings=u;function l(c){if(c>=93&&c<=108)return null;switch(c){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return M.keyCodeToStr(c)}t.toElectronAccelerator=l})(I=e.KeyCodeUtils||(e.KeyCodeUtils={}));var S;(function(t){t[t.CtrlCmd=2048]="CtrlCmd",t[t.Shift=1024]="Shift",t[t.Alt=512]="Alt",t[t.WinCtrl=256]="WinCtrl"})(S=e.KeyMod||(e.KeyMod={}));function m(t,h){const E=(h&65535)<<16>>>0;return(t|E)>>>0}e.KeyChord=m}),define(Q[58],J([0,1,18]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ResolvedKeybinding=e.ResolvedKeybindingPart=e.ScanCodeBinding=e.ChordKeybinding=e.SimpleKeybinding=e.createSimpleKeybinding=e.createKeybinding=void 0;var L;(function(I){I[I.CtrlCmd=2048]="CtrlCmd",I[I.Shift=1024]="Shift",I[I.Alt=512]="Alt",I[I.WinCtrl=256]="WinCtrl",I[I.KeyCode=255]="KeyCode"})(L||(L={}));function D(I,S){if(I===0)return null;const m=(I&65535)>>>0,t=(I&4294901760)>>>16;return t!==0?new b([M(m,S),M(t,S)]):new b([M(m,S)])}e.createKeybinding=D;function M(I,S){const m=!!(I&2048),t=!!(I&256),h=S===2?t:m,E=!!(I&1024),v=!!(I&512),y=S===2?m:t,u=I&255;return new P(h,E,v,y,u)}e.createSimpleKeybinding=M;class P{constructor(S,m,t,h,E){this.ctrlKey=S,this.shiftKey=m,this.altKey=t,this.metaKey=h,this.keyCode=E}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.keyCode===S.keyCode}getHashCode(){const S=this.ctrlKey?"1":"0",m=this.shiftKey?"1":"0",t=this.altKey?"1":"0",h=this.metaKey?"1":"0";return`${S}${m}${t}${h}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new b([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}e.SimpleKeybinding=P;class b{constructor(S){if(S.length===0)throw(0,p.illegalArgument)("parts");this.parts=S}getHashCode(){let S="";for(let m=0,t=this.parts.length;m<t;m++)m!==0&&(S+=";"),S+=this.parts[m].getHashCode();return S}equals(S){if(S===null||this.parts.length!==S.parts.length)return!1;for(let m=0;m<this.parts.length;m++)if(!this.parts[m].equals(S.parts[m]))return!1;return!0}}e.ChordKeybinding=b;class d{constructor(S,m,t,h,E){this.ctrlKey=S,this.shiftKey=m,this.altKey=t,this.metaKey=h,this.scanCode=E}equals(S){return this.ctrlKey===S.ctrlKey&&this.shiftKey===S.shiftKey&&this.altKey===S.altKey&&this.metaKey===S.metaKey&&this.scanCode===S.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}e.ScanCodeBinding=d;class g{constructor(S,m,t,h,E,v){this.ctrlKey=S,this.shiftKey=m,this.altKey=t,this.metaKey=h,this.keyLabel=E,this.keyAriaLabel=v}}e.ResolvedKeybindingPart=g;class i{}e.ResolvedKeybinding=i}),define(Q[105],J([0,1,80,58]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingParser=void 0;class D{static _readModifiers(P){P=P.toLowerCase().trim();let b=!1,d=!1,g=!1,i=!1,I;do I=!1,/^ctrl(\+|\-)/.test(P)&&(b=!0,P=P.substr("ctrl-".length),I=!0),/^shift(\+|\-)/.test(P)&&(d=!0,P=P.substr("shift-".length),I=!0),/^alt(\+|\-)/.test(P)&&(g=!0,P=P.substr("alt-".length),I=!0),/^meta(\+|\-)/.test(P)&&(i=!0,P=P.substr("meta-".length),I=!0),/^win(\+|\-)/.test(P)&&(i=!0,P=P.substr("win-".length),I=!0),/^cmd(\+|\-)/.test(P)&&(i=!0,P=P.substr("cmd-".length),I=!0);while(I);let S;const m=P.indexOf(" ");return m>0?(S=P.substring(0,m),P=P.substring(m)):(S=P,P=""),{remains:P,ctrl:b,shift:d,alt:g,meta:i,key:S}}static parseSimpleKeybinding(P){const b=this._readModifiers(P),d=p.KeyCodeUtils.fromUserSettings(b.key);return[new L.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,d),b.remains]}static parseKeybinding(P,b){if(!P)return null;const d=[];let g;do[g,P]=this.parseSimpleKeybinding(P),d.push(g);while(P.length>0);return new L.ChordKeybinding(d)}static parseSimpleUserBinding(P){const b=this._readModifiers(P),d=b.key.match(/^\[([^\]]+)\]$/);if(d){const i=d[1],I=p.ScanCodeUtils.lowerCaseToEnum(i);return[new L.ScanCodeBinding(b.ctrl,b.shift,b.alt,b.meta,I),b.remains]}const g=p.KeyCodeUtils.fromUserSettings(b.key);return[new L.SimpleKeybinding(b.ctrl,b.shift,b.alt,b.meta,g),b.remains]}static parseUserBinding(P){if(!P)return[];const b=[];let d;for(;P.length>0;)[d,P]=this.parseSimpleUserBinding(P),b.push(d);return b}}e.KeybindingParser=D}),define(Q[2],J([0,1,42,68]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const D=!1;let M=null;function P(r){M=r}if(e.setDisposableTracker=P,D){const r="__is_disposable_tracked__";P(new class{trackDisposable(a){const f=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[r]||console.log(f)},3e3)}setParent(a,f){if(a&&a!==y.None)try{a[r]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[r]=!0}catch{}}markAsSingleton(a){}})}function b(r){return M?.trackDisposable(r),r}function d(r){M?.markAsDisposed(r)}function g(r,a){M?.setParent(r,a)}function i(r,a){if(!!M)for(const f of r)M.setParent(f,a)}function I(r){return M?.markAsSingleton(r),r}e.markAsSingleton=I;class S extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}e.MultiDisposeError=S;function m(r){return typeof r.dispose=="function"&&r.dispose.length===0}e.isDisposable=m;function t(r){if(L.Iterable.is(r)){let a=[];for(const f of r)if(f)try{f.dispose()}catch(w){a.push(w)}if(a.length===1)throw a[0];if(a.length>1)throw new S(a);return Array.isArray(r)?[]:r}else if(r)return r.dispose(),r}e.dispose=t;function h(...r){const a=E(()=>t(r));return i(r,a),a}e.combinedDisposable=h;function E(r){const a=b({dispose:(0,p.once)(()=>{d(a),r()})});return a}e.toDisposable=E;class v{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(d(this),this._isDisposed=!0,this.clear())}clear(){try{t(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return g(a,this),this._isDisposed?v.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}e.DisposableStore=v,v.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new v,b(this),g(this._store,this)}dispose(){d(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}e.Disposable=y,y.None=Object.freeze({dispose(){}});class u{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&g(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,d(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&g(a,null),a}}e.MutableDisposable=u;class l{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=l;class c{constructor(){this.references=new Map}acquire(a,...f){let w=this.references.get(a);w||(w={counter:0,object:this.createReferencedObject(a,...f)},this.references.set(a,w));const{object:k}=w,R=(0,p.once)(()=>{--w.counter==0&&(this.destroyReferencedObject(a,w.object),this.references.delete(a))});return w.counter++,{object:k,dispose:R}}}e.ReferenceCollection=c;class n{constructor(a){this.referenceCollection=a}async acquire(a,...f){const w=this.referenceCollection.acquire(a,...f);try{return{object:await w.object,dispose:()=>w.dispose()}}catch(k){throw w.dispose(),k}}}e.AsyncReferenceCollection=n;class o{constructor(a){this.object=a}dispose(){}}e.ImmortalReference=o;function s(r){const a=new v;try{r(a)}finally{a.dispose()}}e.disposeOnReturn=s}),define(Q[106],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class p{constructor(M){this.element=M,this.next=p.Undefined,this.prev=p.Undefined}}p.Undefined=new p(void 0);class L{constructor(){this._first=p.Undefined,this._last=p.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===p.Undefined}clear(){let M=this._first;for(;M!==p.Undefined;){const P=M.next;M.prev=p.Undefined,M.next=p.Undefined,M=P}this._first=p.Undefined,this._last=p.Undefined,this._size=0}unshift(M){return this._insert(M,!1)}push(M){return this._insert(M,!0)}_insert(M,P){const b=new p(M);if(this._first===p.Undefined)this._first=b,this._last=b;else if(P){const g=this._last;this._last=b,b.prev=g,g.next=b}else{const g=this._first;this._first=b,b.next=g,g.prev=b}this._size+=1;let d=!1;return()=>{d||(d=!0,this._remove(b))}}shift(){if(this._first!==p.Undefined){const M=this._first.element;return this._remove(this._first),M}}pop(){if(this._last!==p.Undefined){const M=this._last.element;return this._remove(this._last),M}}_remove(M){if(M.prev!==p.Undefined&&M.next!==p.Undefined){const P=M.prev;P.next=M.next,M.next.prev=P}else M.prev===p.Undefined&&M.next===p.Undefined?(this._first=p.Undefined,this._last=p.Undefined):M.next===p.Undefined?(this._last=this._last.prev,this._last.next=p.Undefined):M.prev===p.Undefined&&(this._first=this._first.next,this._first.prev=p.Undefined);this._size-=1}*[Symbol.iterator](){let M=this._first;for(;M!==p.Undefined;)yield M.element,M=M.next}}e.LinkedList=L}),function(){function j(D){const M=[];typeof D=="number"&&M.push("code/timeOrigin",D);function P(d){M.push(d,Date.now())}function b(){const d=[];for(let g=0;g<M.length;g+=2)d.push({name:M[g],startTime:M[g+1]});return d}return{mark:P,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function")return typeof performance.timeOrigin!="number"&&!performance.timing?j():{mark(D){performance.mark(D)},getMarks(){let D=performance.timeOrigin;typeof D!="number"&&(D=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const M=[{name:"code/timeOrigin",startTime:Math.round(D)}];for(const P of performance.getEntriesByType("mark"))M.push({name:P.name,startTime:Math.round(D+P.startTime)});return M}};if(typeof process=="object"){const D=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return j(D)}else return console.trace("perf-util loaded in UNKNOWN environment"),j()}function p(D){return D.MonacoPerformanceMarks||(D.MonacoPerformanceMarks=e()),D.MonacoPerformanceMarks}var L;typeof global=="object"?L=global:typeof self=="object"?L=self:L={},typeof define=="function"?define("vs/base/common/performance",[],function(){return p(L)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=p(L):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),L.perf=p(L))}(),define(Q[3],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLittleEndian=e.OS=e.OperatingSystem=e.setImmediate=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isIOS=e.isWeb=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.isElectronSandboxed=e.globals=void 0;const p="en";let L=!1,D=!1,M=!1,P=!1,b=!1,d=!1,g=!1,i,I=p,S,m;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let t;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?t=e.globals.vscode.process:typeof process!="undefined"&&(t=process);const h=typeof t?.versions?.electron=="string"&&t.type==="renderer";if(e.isElectronSandboxed=h&&t?.sandboxed,typeof navigator=="object"&&!h)m=navigator.userAgent,L=m.indexOf("Windows")>=0,D=m.indexOf("Macintosh")>=0,g=(m.indexOf("Macintosh")>=0||m.indexOf("iPad")>=0||m.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,M=m.indexOf("Linux")>=0,d=!0,i=navigator.language,I=i;else if(typeof t=="object"){L=t.platform==="win32",D=t.platform==="darwin",M=t.platform==="linux",P=M&&!!t.env.SNAP&&!!t.env.SNAP_REVISION,i=p,I=p;const s=t.env.VSCODE_NLS_CONFIG;if(s)try{const r=JSON.parse(s),a=r.availableLanguages["*"];i=r.locale,I=a||p,S=r._translationsConfigFile}catch(r){}b=!0}else console.error("Unable to resolve platform.");var E;(function(s){s[s.Web=0]="Web",s[s.Mac=1]="Mac",s[s.Linux=2]="Linux",s[s.Windows=3]="Windows"})(E=e.Platform||(e.Platform={}));function v(s){switch(s){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=v;let y=0;D?y=1:L?y=3:M&&(y=2),e.isWindows=L,e.isMacintosh=D,e.isLinux=M,e.isLinuxSnap=P,e.isNative=b,e.isWeb=d,e.isIOS=g,e.platform=y,e.userAgent=m,e.language=I;var u;(function(s){function r(){return e.language}s.value=r;function a(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}s.isDefaultVariant=a;function f(){return e.language==="en"}s.isDefault=f})(u=e.Language||(e.Language={})),e.locale=i,e.translationsConfigFile=S,e.setImmediate=function(){if(e.globals.setImmediate)return e.globals.setImmediate.bind(e.globals);if(typeof e.globals.postMessage=="function"&&!e.globals.importScripts){let a=[];e.globals.addEventListener("message",w=>{if(w.data&&w.data.vscodeSetImmediateId)for(let k=0,R=a.length;k<R;k++){const A=a[k];if(A.id===w.data.vscodeSetImmediateId){a.splice(k,1),A.callback();return}}});let f=0;return w=>{const k=++f;a.push({id:k,callback:w}),e.globals.postMessage({vscodeSetImmediateId:k},"*")}}if(typeof t?.nextTick=="function")return t.nextTick.bind(t);const r=Promise.resolve();return a=>r.then(a)}();var l;(function(s){s[s.Windows=1]="Windows",s[s.Macintosh=2]="Macintosh",s[s.Linux=3]="Linux"})(l=e.OperatingSystem||(e.OperatingSystem={})),e.OS=D||g?2:L?1:3;let c=!0,n=!1;function o(){if(!n){n=!0;const s=new Uint8Array(2);s[0]=1,s[1]=2,c=new Uint16Array(s.buffer)[0]===(2<<8)+1}return c}e.isLittleEndian=o}),define(Q[32],J([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.nextTick=e.platform=e.env=e.cwd=void 0;let L;if(typeof p.globals.vscode!="undefined"&&typeof p.globals.vscode.process!="undefined"){const D=p.globals.vscode.process;L={get platform(){return D.platform},get arch(){return D.arch},get env(){return D.env},cwd(){return D.cwd()},nextTick(M){return(0,p.setImmediate)(M)}}}else typeof process!="undefined"?L={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()},nextTick(D){return process.nextTick(D)}}:L={get platform(){return p.isWindows?"win32":p.isMacintosh?"darwin":"linux"},get arch(){},nextTick(D){return(0,p.setImmediate)(D)},get env(){return{}},cwd(){return"/"}};e.cwd=L.cwd,e.env=L.env,e.platform=L.platform,e.nextTick=L.nextTick,e.arch=L.arch}),define(Q[8],J([0,1,32]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const L=65,D=97,M=90,P=122,b=46,d=47,g=92,i=58,I=63;class S extends Error{constructor(l,c,n){let o;typeof c=="string"&&c.indexOf("not ")===0?(o="must not be",c=c.replace(/^not /,"")):o="must be";const s=l.indexOf(".")!==-1?"property":"argument";let r=`The "${l}" ${s} ${o} of type ${c}`;r+=`. Received type ${typeof n}`,super(r),this.code="ERR_INVALID_ARG_TYPE"}}function m(u,l){if(typeof u!="string")throw new S(l,"string",u)}function t(u){return u===d||u===g}function h(u){return u===d}function E(u){return u>=L&&u<=M||u>=D&&u<=P}function v(u,l,c,n){let o="",s=0,r=-1,a=0,f=0;for(let w=0;w<=u.length;++w){if(w<u.length)f=u.charCodeAt(w);else{if(n(f))break;f=d}if(n(f)){if(!(r===w-1||a===1))if(a===2){if(o.length<2||s!==2||o.charCodeAt(o.length-1)!==b||o.charCodeAt(o.length-2)!==b){if(o.length>2){const k=o.lastIndexOf(c);k===-1?(o="",s=0):(o=o.slice(0,k),s=o.length-1-o.lastIndexOf(c)),r=w,a=0;continue}else if(o.length!==0){o="",s=0,r=w,a=0;continue}}l&&(o+=o.length>0?`${c}..`:"..",s=2)}else o.length>0?o+=`${c}${u.slice(r+1,w)}`:o=u.slice(r+1,w),s=w-r-1;r=w,a=0}else f===b&&a!==-1?++a:a=-1}return o}function y(u,l){if(l===null||typeof l!="object")throw new S("pathObject","Object",l);const c=l.dir||l.root,n=l.base||`${l.name||""}${l.ext||""}`;return c?c===l.root?`${c}${n}`:`${c}${u}${n}`:n}e.win32={resolve(...u){let l="",c="",n=!1;for(let o=u.length-1;o>=-1;o--){let s;if(o>=0){if(s=u[o],m(s,"path"),s.length===0)continue}else l.length===0?s=p.cwd():(s=p.env[`=${l}`]||p.cwd(),(s===void 0||s.slice(0,2).toLowerCase()!==l.toLowerCase()&&s.charCodeAt(2)===g)&&(s=`${l}\\`));const r=s.length;let a=0,f="",w=!1;const k=s.charCodeAt(0);if(r===1)t(k)&&(a=1,w=!0);else if(t(k))if(w=!0,t(s.charCodeAt(1))){let R=2,A=R;for(;R<r&&!t(s.charCodeAt(R));)R++;if(R<r&&R!==A){const O=s.slice(A,R);for(A=R;R<r&&t(s.charCodeAt(R));)R++;if(R<r&&R!==A){for(A=R;R<r&&!t(s.charCodeAt(R));)R++;(R===r||R!==A)&&(f=`\\\\${O}\\${s.slice(A,R)}`,a=R)}}}else a=1;else E(k)&&s.charCodeAt(1)===i&&(f=s.slice(0,2),a=2,r>2&&t(s.charCodeAt(2))&&(w=!0,a=3));if(f.length>0)if(l.length>0){if(f.toLowerCase()!==l.toLowerCase())continue}else l=f;if(n){if(l.length>0)break}else if(c=`${s.slice(a)}\\${c}`,n=w,w&&l.length>0)break}return c=v(c,!n,"\\",t),n?`${l}\\${c}`:`${l}${c}`||"."},normalize(u){m(u,"path");const l=u.length;if(l===0)return".";let c=0,n,o=!1;const s=u.charCodeAt(0);if(l===1)return h(s)?"\\":u;if(t(s))if(o=!0,t(u.charCodeAt(1))){let a=2,f=a;for(;a<l&&!t(u.charCodeAt(a));)a++;if(a<l&&a!==f){const w=u.slice(f,a);for(f=a;a<l&&t(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!t(u.charCodeAt(a));)a++;if(a===l)return`\\\\${w}\\${u.slice(f)}\\`;a!==f&&(n=`\\\\${w}\\${u.slice(f,a)}`,c=a)}}}else c=1;else E(s)&&u.charCodeAt(1)===i&&(n=u.slice(0,2),c=2,l>2&&t(u.charCodeAt(2))&&(o=!0,c=3));let r=c<l?v(u.slice(c),!o,"\\",t):"";return r.length===0&&!o&&(r="."),r.length>0&&t(u.charCodeAt(l-1))&&(r+="\\"),n===void 0?o?`\\${r}`:r:o?`${n}\\${r}`:`${n}${r}`},isAbsolute(u){m(u,"path");const l=u.length;if(l===0)return!1;const c=u.charCodeAt(0);return t(c)||l>2&&E(c)&&u.charCodeAt(1)===i&&t(u.charCodeAt(2))},join(...u){if(u.length===0)return".";let l,c;for(let s=0;s<u.length;++s){const r=u[s];m(r,"path"),r.length>0&&(l===void 0?l=c=r:l+=`\\${r}`)}if(l===void 0)return".";let n=!0,o=0;if(typeof c=="string"&&t(c.charCodeAt(0))){++o;const s=c.length;s>1&&t(c.charCodeAt(1))&&(++o,s>2&&(t(c.charCodeAt(2))?++o:n=!1))}if(n){for(;o<l.length&&t(l.charCodeAt(o));)o++;o>=2&&(l=`\\${l.slice(o)}`)}return e.win32.normalize(l)},relative(u,l){if(m(u,"from"),m(l,"to"),u===l)return"";const c=e.win32.resolve(u),n=e.win32.resolve(l);if(c===n||(u=c.toLowerCase(),l=n.toLowerCase(),u===l))return"";let o=0;for(;o<u.length&&u.charCodeAt(o)===g;)o++;let s=u.length;for(;s-1>o&&u.charCodeAt(s-1)===g;)s--;const r=s-o;let a=0;for(;a<l.length&&l.charCodeAt(a)===g;)a++;let f=l.length;for(;f-1>a&&l.charCodeAt(f-1)===g;)f--;const w=f-a,k=r<w?r:w;let R=-1,A=0;for(;A<k;A++){const H=u.charCodeAt(o+A);if(H!==l.charCodeAt(a+A))break;H===g&&(R=A)}if(A!==k){if(R===-1)return n}else{if(w>k){if(l.charCodeAt(a+A)===g)return n.slice(a+A+1);if(A===2)return n.slice(a+A)}r>k&&(u.charCodeAt(o+A)===g?R=A:A===2&&(R=3)),R===-1&&(R=0)}let O="";for(A=o+R+1;A<=s;++A)(A===s||u.charCodeAt(A)===g)&&(O+=O.length===0?"..":"\\..");return a+=R,O.length>0?`${O}${n.slice(a,f)}`:(n.charCodeAt(a)===g&&++a,n.slice(a,f))},toNamespacedPath(u){if(typeof u!="string")return u;if(u.length===0)return"";const l=e.win32.resolve(u);if(l.length<=2)return u;if(l.charCodeAt(0)===g){if(l.charCodeAt(1)===g){const c=l.charCodeAt(2);if(c!==I&&c!==b)return`\\\\?\\UNC\\${l.slice(2)}`}}else if(E(l.charCodeAt(0))&&l.charCodeAt(1)===i&&l.charCodeAt(2)===g)return`\\\\?\\${l}`;return u},dirname(u){m(u,"path");const l=u.length;if(l===0)return".";let c=-1,n=0;const o=u.charCodeAt(0);if(l===1)return t(o)?u:".";if(t(o)){if(c=n=1,t(u.charCodeAt(1))){let a=2,f=a;for(;a<l&&!t(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&t(u.charCodeAt(a));)a++;if(a<l&&a!==f){for(f=a;a<l&&!t(u.charCodeAt(a));)a++;if(a===l)return u;a!==f&&(c=n=a+1)}}}}else E(o)&&u.charCodeAt(1)===i&&(c=l>2&&t(u.charCodeAt(2))?3:2,n=c);let s=-1,r=!0;for(let a=l-1;a>=n;--a)if(t(u.charCodeAt(a))){if(!r){s=a;break}}else r=!1;if(s===-1){if(c===-1)return".";s=c}return u.slice(0,s)},basename(u,l){l!==void 0&&m(l,"ext"),m(u,"path");let c=0,n=-1,o=!0,s;if(u.length>=2&&E(u.charCodeAt(0))&&u.charCodeAt(1)===i&&(c=2),l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let r=l.length-1,a=-1;for(s=u.length-1;s>=c;--s){const f=u.charCodeAt(s);if(t(f)){if(!o){c=s+1;break}}else a===-1&&(o=!1,a=s+1),r>=0&&(f===l.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=a))}return c===n?n=a:n===-1&&(n=u.length),u.slice(c,n)}for(s=u.length-1;s>=c;--s)if(t(u.charCodeAt(s))){if(!o){c=s+1;break}}else n===-1&&(o=!1,n=s+1);return n===-1?"":u.slice(c,n)},extname(u){m(u,"path");let l=0,c=-1,n=0,o=-1,s=!0,r=0;u.length>=2&&u.charCodeAt(1)===i&&E(u.charCodeAt(0))&&(l=n=2);for(let a=u.length-1;a>=l;--a){const f=u.charCodeAt(a);if(t(f)){if(!s){n=a+1;break}continue}o===-1&&(s=!1,o=a+1),f===b?c===-1?c=a:r!==1&&(r=1):c!==-1&&(r=-1)}return c===-1||o===-1||r===0||r===1&&c===o-1&&c===n+1?"":u.slice(c,o)},format:y.bind(null,"\\"),parse(u){m(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const c=u.length;let n=0,o=u.charCodeAt(0);if(c===1)return t(o)?(l.root=l.dir=u,l):(l.base=l.name=u,l);if(t(o)){if(n=1,t(u.charCodeAt(1))){let R=2,A=R;for(;R<c&&!t(u.charCodeAt(R));)R++;if(R<c&&R!==A){for(A=R;R<c&&t(u.charCodeAt(R));)R++;if(R<c&&R!==A){for(A=R;R<c&&!t(u.charCodeAt(R));)R++;R===c?n=R:R!==A&&(n=R+1)}}}}else if(E(o)&&u.charCodeAt(1)===i){if(c<=2)return l.root=l.dir=u,l;if(n=2,t(u.charCodeAt(2))){if(c===3)return l.root=l.dir=u,l;n=3}}n>0&&(l.root=u.slice(0,n));let s=-1,r=n,a=-1,f=!0,w=u.length-1,k=0;for(;w>=n;--w){if(o=u.charCodeAt(w),t(o)){if(!f){r=w+1;break}continue}a===-1&&(f=!1,a=w+1),o===b?s===-1?s=w:k!==1&&(k=1):s!==-1&&(k=-1)}return a!==-1&&(s===-1||k===0||k===1&&s===a-1&&s===r+1?l.base=l.name=u.slice(r,a):(l.name=u.slice(r,s),l.base=u.slice(r,a),l.ext=u.slice(s,a))),r>0&&r!==n?l.dir=u.slice(0,r-1):l.dir=l.root,l},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...u){let l="",c=!1;for(let n=u.length-1;n>=-1&&!c;n--){const o=n>=0?u[n]:p.cwd();m(o,"path"),o.length!==0&&(l=`${o}/${l}`,c=o.charCodeAt(0)===d)}return l=v(l,!c,"/",h),c?`/${l}`:l.length>0?l:"."},normalize(u){if(m(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===d,c=u.charCodeAt(u.length-1)===d;return u=v(u,!l,"/",h),u.length===0?l?"/":c?"./":".":(c&&(u+="/"),l?`/${u}`:u)},isAbsolute(u){return m(u,"path"),u.length>0&&u.charCodeAt(0)===d},join(...u){if(u.length===0)return".";let l;for(let c=0;c<u.length;++c){const n=u[c];m(n,"path"),n.length>0&&(l===void 0?l=n:l+=`/${n}`)}return l===void 0?".":e.posix.normalize(l)},relative(u,l){if(m(u,"from"),m(l,"to"),u===l||(u=e.posix.resolve(u),l=e.posix.resolve(l),u===l))return"";const c=1,n=u.length,o=n-c,s=1,r=l.length-s,a=o<r?o:r;let f=-1,w=0;for(;w<a;w++){const R=u.charCodeAt(c+w);if(R!==l.charCodeAt(s+w))break;R===d&&(f=w)}if(w===a)if(r>a){if(l.charCodeAt(s+w)===d)return l.slice(s+w+1);if(w===0)return l.slice(s+w)}else o>a&&(u.charCodeAt(c+w)===d?f=w:w===0&&(f=0));let k="";for(w=c+f+1;w<=n;++w)(w===n||u.charCodeAt(w)===d)&&(k+=k.length===0?"..":"/..");return`${k}${l.slice(s+f)}`},toNamespacedPath(u){return u},dirname(u){if(m(u,"path"),u.length===0)return".";const l=u.charCodeAt(0)===d;let c=-1,n=!0;for(let o=u.length-1;o>=1;--o)if(u.charCodeAt(o)===d){if(!n){c=o;break}}else n=!1;return c===-1?l?"/":".":l&&c===1?"//":u.slice(0,c)},basename(u,l){l!==void 0&&m(l,"ext"),m(u,"path");let c=0,n=-1,o=!0,s;if(l!==void 0&&l.length>0&&l.length<=u.length){if(l===u)return"";let r=l.length-1,a=-1;for(s=u.length-1;s>=0;--s){const f=u.charCodeAt(s);if(f===d){if(!o){c=s+1;break}}else a===-1&&(o=!1,a=s+1),r>=0&&(f===l.charCodeAt(r)?--r==-1&&(n=s):(r=-1,n=a))}return c===n?n=a:n===-1&&(n=u.length),u.slice(c,n)}for(s=u.length-1;s>=0;--s)if(u.charCodeAt(s)===d){if(!o){c=s+1;break}}else n===-1&&(o=!1,n=s+1);return n===-1?"":u.slice(c,n)},extname(u){m(u,"path");let l=-1,c=0,n=-1,o=!0,s=0;for(let r=u.length-1;r>=0;--r){const a=u.charCodeAt(r);if(a===d){if(!o){c=r+1;break}continue}n===-1&&(o=!1,n=r+1),a===b?l===-1?l=r:s!==1&&(s=1):l!==-1&&(s=-1)}return l===-1||n===-1||s===0||s===1&&l===n-1&&l===c+1?"":u.slice(l,n)},format:y.bind(null,"/"),parse(u){m(u,"path");const l={root:"",dir:"",base:"",ext:"",name:""};if(u.length===0)return l;const c=u.charCodeAt(0)===d;let n;c?(l.root="/",n=1):n=0;let o=-1,s=0,r=-1,a=!0,f=u.length-1,w=0;for(;f>=n;--f){const k=u.charCodeAt(f);if(k===d){if(!a){s=f+1;break}continue}r===-1&&(a=!1,r=f+1),k===b?o===-1?o=f:w!==1&&(w=1):o!==-1&&(w=-1)}if(r!==-1){const k=s===0&&c?1:s;o===-1||w===0||w===1&&o===r-1&&o===s+1?l.base=l.name=u.slice(k,r):(l.name=u.slice(k,o),l.base=u.slice(k,r),l.ext=u.slice(o,r))}return s>0?l.dir=u.slice(0,s-1):c&&(l.dir="/"),l},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=p.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=p.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=p.platform==="win32"?e.win32.join:e.posix.join,e.resolve=p.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=p.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=p.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=p.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=p.platform==="win32"?e.win32.extname:e.posix.extname,e.format=p.platform==="win32"?e.win32.format:e.posix.format,e.parse=p.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=p.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=p.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=p.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(Q[81],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var p;(function(M){M[M.stdout=0]="stdout",M[M.stderr=1]="stderr"})(p=e.Source||(e.Source={}));var L;(function(M){M[M.Success=0]="Success",M[M.Unknown=1]="Unknown",M[M.AccessDenied=2]="AccessDenied",M[M.ProcessNotFound=3]="ProcessNotFound"})(L=e.TerminateResponseCode||(e.TerminateResponseCode={}));function D(M,...P){const b=P.reduce((i,I)=>(i[I]=!0,i),{}),d=[/^ELECTRON_.+$/,/^VSCODE_.+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(M).filter(i=>!b[i]).forEach(i=>{for(let I=0;I<d.length;I++)if(i.search(d[I])!==-1){delete M[i];break}})}e.sanitizeProcessEnvironment=D}),define(Q[107],J([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const L=p.globals.performance&&typeof p.globals.performance.now=="function";class D{constructor(P){this._highResolution=L&&P,this._startTime=this._now(),this._stopTime=-1}static create(P=!0){return new D(P)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?p.globals.performance.now():Date.now()}}e.StopWatch=D}),define(Q[4],J([0,1,18,42,2,106,107]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;var b;(function(l){l.None=()=>D.Disposable.None;function c(F){return(V,z=null,B)=>{let U=!1,C;return C=F(X=>{if(!U)return C?C.dispose():U=!0,V.call(z,X)},null,B),U&&C.dispose(),C}}l.once=c;function n(F,V){return w((z,B=null,U)=>F(C=>z.call(B,V(C)),null,U))}l.map=n;function o(F,V){return w((z,B=null,U)=>F(C=>{V(C),z.call(B,C)},null,U))}l.forEach=o;function s(F,V){return w((z,B=null,U)=>F(C=>V(C)&&z.call(B,C),null,U))}l.filter=s;function r(F){return F}l.signal=r;function a(...F){return(V,z=null,B)=>(0,D.combinedDisposable)(...F.map(U=>U(C=>V.call(z,C),null,B)))}l.any=a;function f(F,V,z){let B=z;return n(F,U=>(B=V(B,U),B))}l.reduce=f;function w(F){let V;const z=new S({onFirstListenerAdd(){V=F(z.fire,z)},onLastListenerRemove(){V.dispose()}});return z.event}function k(F,V,z=100,B=!1,U){let C,X,W,T=0;const _=new S({leakWarningThreshold:U,onFirstListenerAdd(){C=F(q=>{T++,X=V(X,q),B&&!W&&(_.fire(X),X=void 0),clearTimeout(W),W=setTimeout(()=>{const Y=X;X=void 0,W=void 0,(!B||T>1)&&_.fire(Y),T=0},z)})},onLastListenerRemove(){C.dispose()}});return _.event}l.debounce=k;function R(F,V=(z,B)=>z===B){let z=!0,B;return s(F,U=>{const C=z||!V(U,B);return z=!1,B=U,C})}l.latch=R;function A(F,V){return[l.filter(F,V),l.filter(F,z=>!V(z))]}l.split=A;function O(F,V=!1,z=[]){let B=z.slice(),U=F(W=>{B?B.push(W):X.fire(W)});const C=()=>{B&&B.forEach(W=>X.fire(W)),B=null},X=new S({onFirstListenerAdd(){U||(U=F(W=>X.fire(W)))},onFirstListenerDidAdd(){B&&(V?setTimeout(C):C())},onLastListenerRemove(){U&&U.dispose(),U=null}});return X.event}l.buffer=O;class H{constructor(V){this.event=V}map(V){return new H(n(this.event,V))}forEach(V){return new H(o(this.event,V))}filter(V){return new H(s(this.event,V))}reduce(V,z){return new H(f(this.event,V,z))}latch(){return new H(R(this.event))}debounce(V,z=100,B=!1,U){return new H(k(this.event,V,z,B,U))}on(V,z,B){return this.event(V,z,B)}once(V,z,B){return c(this.event)(V,z,B)}}function x(F){return new H(F)}l.chain=x;function re(F,V,z=B=>B){const B=(...W)=>X.fire(z(...W)),U=()=>F.on(V,B),C=()=>F.removeListener(V,B),X=new S({onFirstListenerAdd:U,onLastListenerRemove:C});return X.event}l.fromNodeEventEmitter=re;function K(F,V,z=B=>B){const B=(...W)=>X.fire(z(...W)),U=()=>F.addEventListener(V,B),C=()=>F.removeEventListener(V,B),X=new S({onFirstListenerAdd:U,onLastListenerRemove:C});return X.event}l.fromDOMEventEmitter=K;function ee(F){return new Promise(V=>c(F)(V))}l.toPromise=ee})(b=e.Event||(e.Event={}));class d{constructor(c){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${c}_${d._idPool++}`}start(c){this._stopWatch=new P.StopWatch(!0),this._listenerCount=c}stop(){if(this._stopWatch){const c=this._stopWatch.elapsed();this._elapsedOverall+=c,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${c.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}d._idPool=0;let g=-1;function i(l){const c=g;return g=l,{dispose(){g=c}}}e.setGlobalLeakWarningThreshold=i;class I{constructor(c,n=Math.random().toString(18).slice(2,5)){this.customThreshold=c,this.name=n,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(c){let n=g;if(typeof this.customThreshold=="number"&&(n=this.customThreshold),n<=0||c<n)return;this._stacks||(this._stacks=new Map);const o=new Error().stack.split(`
`).slice(3).join(`
`),s=this._stacks.get(o)||0;if(this._stacks.set(o,s+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=n*.5;let r,a=0;for(const[f,w]of this._stacks)(!r||a<w)&&(r=f,a=w);console.warn(`[${this.name}] potential listener LEAK detected, having ${c} listeners already. MOST frequent listener (${a}):`),console.warn(r)}return()=>{const r=this._stacks.get(o)||0;this._stacks.set(o,r-1)}}}class S{constructor(c){this._disposed=!1,this._options=c,this._leakageMon=g>0?new I(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new d(this._options._profName):void 0}get event(){return this._event||(this._event=(c,n,o)=>{this._listeners||(this._listeners=new M.LinkedList);const s=this._listeners.isEmpty();s&&this._options&&this._options.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);const r=this._listeners.push(n?[c,n]:c);s&&this._options&&this._options.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options&&this._options.onListenerDidAdd&&this._options.onListenerDidAdd(this,c,n);const a=this._leakageMon?.check(this._listeners.size),f=(0,D.toDisposable)(()=>{a&&a(),this._disposed||(r(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return o instanceof D.DisposableStore?o.add(f):Array.isArray(o)&&o.push(f),f}),this._event}fire(c){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new M.LinkedList);for(let n of this._listeners)this._deliveryQueue.push([n,c]);for(this._perfMon?.start(this._deliveryQueue.size);this._deliveryQueue.size>0;){const[n,o]=this._deliveryQueue.shift();try{typeof n=="function"?n.call(void 0,o):n[0].call(n[1],o)}catch(s){(0,p.onUnexpectedError)(s)}}this._perfMon?.stop()}}dispose(){this._disposed||(this._disposed=!0,this._listeners?.clear(),this._deliveryQueue?.clear(),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose())}}e.Emitter=S;class m extends S{async fireAsync(c,n,o){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new M.LinkedList);for(const s of this._listeners)this._asyncDeliveryQueue.push([s,c]);for(;this._asyncDeliveryQueue.size>0&&!n.isCancellationRequested;){const[s,r]=this._asyncDeliveryQueue.shift(),a=[],f={...r,waitUntil:w=>{if(Object.isFrozen(a))throw new Error("waitUntil can NOT be called asynchronous");o&&(w=o(w,typeof s=="function"?s:s[0])),a.push(w)}};try{typeof s=="function"?s.call(void 0,f):s[0].call(s[1],f)}catch(w){(0,p.onUnexpectedError)(w);continue}Object.freeze(a),await Promise.allSettled(a).then(w=>{for(const k of w)k.status==="rejected"&&(0,p.onUnexpectedError)(k.reason)})}}}}e.AsyncEmitter=m;class t extends S{constructor(c){super(c);this._isPaused=0,this._eventQueue=new M.LinkedList,this._mergeFn=c?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const c=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(c))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(c){this._listeners&&(this._isPaused!==0?this._eventQueue.push(c):super.fire(c))}}e.PauseableEmitter=t;class h extends t{constructor(c){super(c);this._delay=c.delay??100}fire(c){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(c)}}e.DebounceEmitter=h;class E extends S{constructor(c){super(c);this._queuedEvents=[],this._mergeFn=c?.merge}fire(c){this._queuedEvents.push(c),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(n=>super.fire(n)),this._queuedEvents=[]})}}e.MicrotaskEmitter=E;class v{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new S({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(c){const n={event:c,listener:null};this.events.push(n),this.hasListeners&&this.hook(n);const o=()=>{this.hasListeners&&this.unhook(n);const s=this.events.indexOf(n);this.events.splice(s,1)};return(0,D.toDisposable)((0,L.once)(o))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(c=>this.hook(c))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(c=>this.unhook(c))}hook(c){c.listener=c.event(n=>this.emitter.fire(n))}unhook(c){c.listener&&c.listener.dispose(),c.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=v;class y{constructor(){this.buffers=[]}wrapEvent(c){return(n,o,s)=>c(r=>{const a=this.buffers[this.buffers.length-1];a?a.push(()=>n.call(o,r)):n.call(o,r)},void 0,s)}bufferEvents(c){const n=[];this.buffers.push(n);const o=c();return this.buffers.pop(),n.forEach(s=>s()),o}}e.EventBufferer=y;class u{constructor(){this.listening=!1,this.inputEvent=b.None,this.inputEventListener=D.Disposable.None,this.emitter=new S({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(c){this.inputEvent=c,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=c(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=u}),define(Q[23],J([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const L=Object.freeze(function(b,d){const g=setTimeout(b.bind(d),0);return{dispose(){clearTimeout(g)}}});var D;(function(b){function d(g){return g===b.None||g===b.Cancelled||g instanceof M?!0:!g||typeof g!="object"?!1:typeof g.isCancellationRequested=="boolean"&&typeof g.onCancellationRequested=="function"}b.isCancellationToken=d,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:p.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:L})})(D=e.CancellationToken||(e.CancellationToken={}));class M{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?L:(this._emitter||(this._emitter=new p.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class P{constructor(d){this._token=void 0,this._parentListener=void 0,this._parentListener=d&&d.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new M),this._token}cancel(){this._token?this._token instanceof M&&this._token.cancel():this._token=D.Cancelled}dispose(d=!1){d&&this.cancel(),this._parentListener&&this._parentListener.dispose(),this._token?this._token instanceof M&&this._token.dispose():this._token=D.None}}e.CancellationTokenSource=P}),define(Q[108],J([0,1,4]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=e.registerCodicon=e.iconRegistry=void 0;class L{constructor(){this._icons=new Map,this._onDidRegister=new p.Emitter}add(I){const S=this._icons.get(I.id);S?I.description?S.description=I.description:console.error(`Duplicate registration of codicon ${I.id}`):(this._icons.set(I.id,I),this._onDidRegister.fire(I))}get(I){return this._icons.get(I)}get all(){return this._icons.values()}get onDidRegister(){return this._onDidRegister.event}}const D=new L;e.iconRegistry=D;function M(i,I){return new b(i,I)}e.registerCodicon=M;function P(i){return i?i.replace(/\$\((.*?)\)/g,(I,S)=>` ${S} `).trim():""}e.getCodiconAriaLabel=P;class b{constructor(I,S,m){this.id=I,this.definition=S,this.description=m,D.add(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}}e.Codicon=b;function d(i,I){const S=["codicon","codicon-"+i];return I&&S.push("codicon-modifier-"+I),S}e.getClassNamesArray=d;var g;(function(i){i.iconNameSegment="[A-Za-z0-9]+",i.iconNameExpression="[A-Za-z0-9\\-]+",i.iconModifierExpression="~[A-Za-z]+";const I=new RegExp(`^(${i.iconNameExpression})(${i.iconModifierExpression})?$`);function S(h){if(h instanceof b)return["codicon","codicon-"+h.id];const E=I.exec(h.id);if(!E)return S(b.error);let[,v,y]=E;const u=["codicon","codicon-"+v];return y&&u.push("codicon-modifier-"+y.substr(1)),u}i.asClassNameArray=S;function m(h){return S(h).join(" ")}i.asClassName=m;function t(h){return"."+S(h).join(".")}i.asCSSSelector=t})(g=e.CSSIcon||(e.CSSIcon={})),function(i){i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",{fontCharacter:"\\ea71"}),i.closeDirty=new i("close-dirty",{fontCharacter:"\\ea71"}),i.debugBreakpoint=new i("debug-breakpoint",{fontCharacter:"\\ea71"}),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",{fontCharacter:"\\ea71"}),i.debugHint=new i("debug-hint",{fontCharacter:"\\ea71"}),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circleOutline=new i("circle-outline",{fontCharacter:"\\eabc"}),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",{fontCharacter:"\\eabc"}),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.debugStackframeDot=new i("debug-stackframe-dot",{fontCharacter:"\\eb8a"}),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLargeOutline=new i("circle-large-outline",{fontCharacter:"\\ebb5"}),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"})}(b=e.Codicon||(e.Codicon={}))}),define(Q[59],J([0,1,18,2]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=void 0;function D(u){const l=u;return l?[l.on,l.pause,l.resume,l.destroy].every(c=>typeof c=="function"):!1}e.isReadableStream=D;function M(u){const l=u;return l?D(l.stream)&&Array.isArray(l.buffer)&&typeof l.ended=="boolean":!1}e.isReadableBufferedStream=M;function P(u,l){return new b(u,l)}e.newWriteableStream=P;class b{constructor(l,c){this.reducer=l,this.options=c,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(l){if(!this.state.destroyed){if(this.state.flowing)this.emitData(l);else if(this.buffer.data.push(l),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(c=>this.pendingWritePromises.push(c))}}error(l){this.state.destroyed||(this.state.flowing?this.emitError(l):this.buffer.error.push(l))}end(l){this.state.destroyed||(typeof l!="undefined"&&this.write(l),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(l){this.listeners.data.slice(0).forEach(c=>c(l))}emitError(l){this.listeners.error.length===0?(0,p.onUnexpectedError)(l):this.listeners.error.slice(0).forEach(c=>c(l))}emitEnd(){this.listeners.end.slice(0).forEach(l=>l())}on(l,c){if(!this.state.destroyed)switch(l){case"data":this.listeners.data.push(c),this.resume();break;case"end":this.listeners.end.push(c),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(c),this.state.flowing&&this.flowErrors();break}}removeListener(l,c){if(this.state.destroyed)return;let n;switch(l){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const o=n.indexOf(c);o>=0&&n.splice(o,1)}}flowData(){if(this.buffer.data.length>0){const l=this.reducer(this.buffer.data);this.emitData(l),this.buffer.data.length=0;const c=[...this.pendingWritePromises];this.pendingWritePromises.length=0,c.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const l of this.buffer.error)this.emitError(l);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(u,l){const c=[];let n;for(;(n=u.read())!==null;)c.push(n);return l(c)}e.consumeReadable=d;function g(u,l,c){const n=[];let o;for(;(o=u.read())!==null&&n.length<c;)n.push(o);return o===null&&n.length>0?l(n):{read:()=>{if(n.length>0)return n.shift();if(typeof o!="undefined"){const s=o;return o=void 0,s}return u.read()}}}e.peekReadable=g;function i(u,l){return new Promise((c,n)=>{const o=[];I(u,{onData:s=>{l&&o.push(s)},onError:s=>{l?n(s):c(void 0)},onEnd:()=>{c(l?l(o):void 0)}})})}e.consumeStream=i;function I(u,l){u.on("error",c=>l.onError(c)),u.on("end",()=>l.onEnd()),u.on("data",c=>l.onData(c))}e.listenStream=I;function S(u,l){return new Promise((c,n)=>{const o=new L.DisposableStore,s=[],r=w=>{if(s.push(w),s.length>l)return o.dispose(),u.pause(),c({stream:u,buffer:s,ended:!1})},a=w=>n(w),f=()=>c({stream:u,buffer:s,ended:!0});o.add((0,L.toDisposable)(()=>u.removeListener("error",a))),u.on("error",a),o.add((0,L.toDisposable)(()=>u.removeListener("end",f))),u.on("end",f),o.add((0,L.toDisposable)(()=>u.removeListener("data",r))),u.on("data",r)})}e.peekStream=S;function m(u,l){const c=P(l);return c.end(u),c}e.toStream=m;function t(){const u=P(()=>{throw new Error("not supported")});return u.end(),u}e.emptyStream=t;function h(u){let l=!1;return{read:()=>l?null:(l=!0,u)}}e.toReadable=h;function E(u,l,c){const n=P(c);return I(u,{onData:o=>n.write(l.data(o)),onError:o=>n.error(l.error?l.error(o):o),onEnd:()=>n.end()}),n}e.transform=E;function v(u,l,c){let n=!1;return{read:()=>{const o=l.read();return n?o:(n=!0,o!==null?c([u,o]):u)}}}e.prefixedReadable=v;function y(u,l,c){let n=!1;const o=P(c);return I(l,{onData:s=>n?o.write(s):(n=!0,o.write(c([u,s]))),onError:s=>o.error(s),onEnd:()=>{n||(n=!0,o.write(u)),o.end()}}),o}e.prefixedStream=y}),define(Q[16],J([0,1,59]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const L=typeof Buffer!="undefined";let D,M;class P{constructor(r){this.buffer=r,this.byteLength=this.buffer.byteLength}static alloc(r){return L?new P(Buffer.allocUnsafe(r)):new P(new Uint8Array(r))}static wrap(r){return L&&!Buffer.isBuffer(r)&&(r=Buffer.from(r.buffer,r.byteOffset,r.byteLength)),new P(r)}static fromString(r,a){return!(a?.dontUseNodeBuffer||!1)&&L?new P(Buffer.from(r)):(D||(D=new TextEncoder),new P(D.encode(r)))}static concat(r,a){if(typeof a=="undefined"){a=0;for(let k=0,R=r.length;k<R;k++)a+=r[k].byteLength}const f=P.alloc(a);let w=0;for(let k=0,R=r.length;k<R;k++){const A=r[k];f.set(A,w),w+=A.byteLength}return f}toString(){return L?this.buffer.toString():(M||(M=new TextDecoder),M.decode(this.buffer))}slice(r,a){return new P(this.buffer.subarray(r,a))}set(r,a){r instanceof P?this.buffer.set(r.buffer,a):this.buffer.set(r,a)}readUInt32BE(r){return g(this.buffer,r)}writeUInt32BE(r,a){i(this.buffer,r,a)}readUInt32LE(r){return I(this.buffer,r)}writeUInt32LE(r,a){S(this.buffer,r,a)}readUInt8(r){return m(this.buffer,r)}writeUInt8(r,a){t(this.buffer,r,a)}}e.VSBuffer=P;function b(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0}e.readUInt16LE=b;function d(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255}e.writeUInt16LE=d;function g(s,r){return s[r]*2**24+s[r+1]*2**16+s[r+2]*2**8+s[r+3]}e.readUInt32BE=g;function i(s,r,a){s[a+3]=r,r=r>>>8,s[a+2]=r,r=r>>>8,s[a+1]=r,r=r>>>8,s[a]=r}e.writeUInt32BE=i;function I(s,r){return s[r+0]<<0>>>0|s[r+1]<<8>>>0|s[r+2]<<16>>>0|s[r+3]<<24>>>0}e.readUInt32LE=I;function S(s,r,a){s[a+0]=r&255,r=r>>>8,s[a+1]=r&255,r=r>>>8,s[a+2]=r&255,r=r>>>8,s[a+3]=r&255}e.writeUInt32LE=S;function m(s,r){return s[r]}e.readUInt8=m;function t(s,r,a){s[a]=r}e.writeUInt8=t;function h(s){return p.consumeReadable(s,r=>P.concat(r))}e.readableToBuffer=h;function E(s){return p.toReadable(s)}e.bufferToReadable=E;function v(s){return p.consumeStream(s,r=>P.concat(r))}e.streamToBuffer=v;async function y(s){return s.ended?P.concat(s.buffer):P.concat([...s.buffer,await v(s.stream)])}e.bufferedStreamToBuffer=y;function u(s){return p.toStream(s,r=>P.concat(r))}e.bufferToStream=u;function l(s){return p.transform(s,{data:r=>typeof r=="string"?P.fromString(r):P.wrap(r)},r=>P.concat(r))}e.streamToBufferReadableStream=l;function c(s){return p.newWriteableStream(r=>P.concat(r),s)}e.newWriteableBufferStream=c;function n(s,r){return p.prefixedReadable(s,r,a=>P.concat(a))}e.prefixedBufferReadable=n;function o(s,r){return p.prefixedStream(s,r,a=>P.concat(a))}e.prefixedBufferStream=o}),define(Q[27],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLeftDeleteOffset=e.GraphemeBreakType=e.breakBetweenGraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsEmoji=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function p(G){return!G||typeof G!="string"?!0:G.trim().length===0}e.isFalsyOrWhitespace=p;const L=/{(\d+)}/g;function D(G,...se){return se.length===0?G:G.replace(L,function(ce,we){const Ee=parseInt(we,10);return isNaN(Ee)||Ee<0||Ee>=se.length?ce:se[Ee]})}e.format=D;const M=/{([^}]+)}/g;function P(G,se){return G.replace(M,(ce,we)=>se[we]??ce)}e.format2=P;function b(G){return G.replace(/[<>&]/g,function(se){switch(se){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return se}})}e.escape=b;function d(G){return G.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=d;function g(G,se){let ce=0;const we=se.charCodeAt(0);for(let Ee=G.length-1;Ee>=0;Ee--)G.charCodeAt(Ee)===we&&ce++;return ce}e.count=g;function i(G,se,ce="\u2026"){return G.length<=se?G:`${G.substr(0,se)}${ce}`}e.truncate=i;function I(G,se=" "){const ce=S(G,se);return m(ce,se)}e.trim=I;function S(G,se){if(!G||!se)return G;const ce=se.length;if(ce===0||G.length===0)return G;let we=0;for(;G.indexOf(se,we)===we;)we=we+ce;return G.substring(we)}e.ltrim=S;function m(G,se){if(!G||!se)return G;const ce=se.length,we=G.length;if(ce===0||we===0)return G;let Ee=we,Le=-1;for(;Le=G.lastIndexOf(se,Ee-1),!(Le===-1||Le+ce!==Ee);){if(Le===0)return"";Ee=Le}return G.substring(0,Ee)}e.rtrim=m;function t(G){return G.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=t;function h(G){return G.replace(/\*/g,"")}e.stripWildcards=h;function E(G,se,ce={}){if(!G)throw new Error("Cannot create regex from empty string");se||(G=d(G)),ce.wholeWord&&(/\B/.test(G.charAt(0))||(G="\\b"+G),/\B/.test(G.charAt(G.length-1))||(G=G+"\\b"));let we="";return ce.global&&(we+="g"),ce.matchCase||(we+="i"),ce.multiline&&(we+="m"),ce.unicode&&(we+="u"),new RegExp(G,we)}e.createRegExp=E;function v(G){return G.source==="^"||G.source==="^$"||G.source==="$"||G.source==="^\\s*$"?!1:!!(G.exec("")&&G.lastIndex===0)}e.regExpLeadsToEndlessLoop=v;function y(G){return!!G.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=y;function u(G){return(G.global?"g":"")+(G.ignoreCase?"i":"")+(G.multiline?"m":"")+(G.unicode?"u":"")}e.regExpFlags=u;function l(G){return G.split(/\r\n|\r|\n/)}e.splitLines=l;function c(G){for(let se=0,ce=G.length;se<ce;se++){const we=G.charCodeAt(se);if(we!==32&&we!==9)return se}return-1}e.firstNonWhitespaceIndex=c;function n(G,se=0,ce=G.length){for(let we=se;we<ce;we++){const Ee=G.charCodeAt(we);if(Ee!==32&&Ee!==9)return G.substring(se,we)}return G.substring(se,ce)}e.getLeadingWhitespace=n;function o(G,se=G.length-1){for(let ce=se;ce>=0;ce--){const we=G.charCodeAt(ce);if(we!==32&&we!==9)return ce}return-1}e.lastNonWhitespaceIndex=o;function s(G,se){return G<se?-1:G>se?1:0}e.compare=s;function r(G,se,ce=0,we=G.length,Ee=0,Le=se.length){for(;ce<we&&Ee<Le;ce++,Ee++){let Be=G.charCodeAt(ce),We=se.charCodeAt(Ee);if(Be<We)return-1;if(Be>We)return 1}const Oe=we-ce,Ce=Le-Ee;return Oe<Ce?-1:Oe>Ce?1:0}e.compareSubstring=r;function a(G,se){return f(G,se,0,G.length,0,se.length)}e.compareIgnoreCase=a;function f(G,se,ce=0,we=G.length,Ee=0,Le=se.length){for(;ce<we&&Ee<Le;ce++,Ee++){let Be=G.charCodeAt(ce),We=se.charCodeAt(Ee);if(Be===We)continue;if(Be>=128||We>=128)return r(G.toLowerCase(),se.toLowerCase(),ce,we,Ee,Le);w(Be)&&(Be-=32),w(We)&&(We-=32);const ze=Be-We;if(ze!==0)return ze}const Oe=we-ce,Ce=Le-Ee;return Oe<Ce?-1:Oe>Ce?1:0}e.compareSubstringIgnoreCase=f;function w(G){return G>=97&&G<=122}e.isLowerAsciiLetter=w;function k(G){return G>=65&&G<=90}e.isUpperAsciiLetter=k;function R(G,se){return G.length===se.length&&f(G,se)===0}e.equalsIgnoreCase=R;function A(G,se){const ce=se.length;return se.length>G.length?!1:f(G,se,0,ce)===0}e.startsWithIgnoreCase=A;function O(G,se){let ce,we=Math.min(G.length,se.length);for(ce=0;ce<we;ce++)if(G.charCodeAt(ce)!==se.charCodeAt(ce))return ce;return we}e.commonPrefixLength=O;function H(G,se){let ce,we=Math.min(G.length,se.length);const Ee=G.length-1,Le=se.length-1;for(ce=0;ce<we;ce++)if(G.charCodeAt(Ee-ce)!==se.charCodeAt(Le-ce))return ce;return we}e.commonSuffixLength=H;function x(G){return 55296<=G&&G<=56319}e.isHighSurrogate=x;function re(G){return 56320<=G&&G<=57343}e.isLowSurrogate=re;function K(G,se){return(G-55296<<10)+(se-56320)+65536}e.computeCodePoint=K;function ee(G,se,ce){const we=G.charCodeAt(ce);if(x(we)&&ce+1<se){const Ee=G.charCodeAt(ce+1);if(re(Ee))return K(we,Ee)}return we}e.getNextCodePoint=ee;function F(G,se){const ce=G.charCodeAt(se-1);if(re(ce)&&se>1){const we=G.charCodeAt(se-2);if(x(we))return K(we,ce)}return ce}function V(G,se){const ce=Fe.getInstance(),we=se,Ee=G.length,Le=ee(G,Ee,se);se+=Le>=65536?2:1;let Oe=ce.getGraphemeBreakType(Le);for(;se<Ee;){const Ce=ee(G,Ee,se),Be=ce.getGraphemeBreakType(Ce);if(Te(Oe,Be))break;se+=Ce>=65536?2:1,Oe=Be}return se-we}e.nextCharLength=V;function z(G,se){const ce=Fe.getInstance(),we=se,Ee=F(G,se);se-=Ee>=65536?2:1;let Le=ce.getGraphemeBreakType(Ee);for(;se>0;){const Oe=F(G,se),Ce=ce.getGraphemeBreakType(Oe);if(Te(Ce,Le))break;se-=Oe>=65536?2:1,Le=Ce}return we-se}e.prevCharLength=z;function B(G,se){const ce=Fe.getInstance(),we=G.length,Ee=se,Le=ee(G,we,se),Oe=ce.getGraphemeBreakType(Le);se+=Le>=65536?2:1;let Ce=Oe;for(;se<we;){const We=ee(G,we,se),ze=ce.getGraphemeBreakType(We);if(Te(Ce,ze))break;se+=We>=65536?2:1,Ce=ze}const Be=se;for(se=Ee,Ce=Oe;se>0;){const We=F(G,se),ze=ce.getGraphemeBreakType(We);if(Te(ze,Ce))break;se-=We>=65536?2:1,Ce=ze}return[se,Be]}function U(G,se){return se>0&&re(G.charCodeAt(se))?B(G,se-1):B(G,se)}e.getCharContainingOffset=U;const C=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u08BD\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE33\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDCFF]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD50-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function X(G){return C.test(G)}e.containsRTL=X;const W=/(?:[\u231A\u231B\u23F0\u23F3\u2600-\u27BF\u2B50\u2B55]|\uD83C[\uDDE6-\uDDFF\uDF00-\uDFFF]|\uD83D[\uDC00-\uDE4F\uDE80-\uDEFC\uDFE0-\uDFEB]|\uD83E[\uDD00-\uDDFF\uDE70-\uDED6])/;function T(G){return W.test(G)}e.containsEmoji=T;const _=/^[\t\n\r\x20-\x7E]*$/;function q(G){return _.test(G)}e.isBasicASCII=q,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Y(G){return e.UNUSUAL_LINE_TERMINATORS.test(G)}e.containsUnusualLineTerminators=Y;function $(G){for(let se=0,ce=G.length;se<ce;se++)if(N(G.charCodeAt(se)))return!0;return!1}e.containsFullWidthCharacter=$;function N(G){return G=+G,G>=11904&&G<=55215||G>=63744&&G<=64255||G>=65281&&G<=65374}e.isFullWidthCharacter=N;function Z(G){return G>=127462&&G<=127487||G===8986||G===8987||G===9200||G===9203||G>=9728&&G<=10175||G===11088||G===11093||G>=127744&&G<=128591||G>=128640&&G<=128764||G>=128992&&G<=129003||G>=129280&&G<=129535||G>=129648&&G<=129750}e.isEmojiImprecise=Z;function ie(G,se){if(G.length<se)return G;const ce=/\b/g;let we=0;for(;ce.test(G)&&!(G.length-ce.lastIndex<se);)we=ce.lastIndex,ce.lastIndex+=1;return G.substring(we).replace(/^\s/,"")}e.lcut=ie;const oe=/\x1B\x5B[12]?K/g,le=/\x1b\[\d+m/g,ne=/\x1b\[0?m/g;function ae(G){return G&&(G=G.replace(oe,""),G=G.replace(le,""),G=G.replace(ne,"")),G}e.removeAnsiEscapeCodes=ae,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function ue(G){return!!(G&&G.length>0&&G.charCodeAt(0)===65279)}e.startsWithUTF8BOM=ue;function de(G){return ue(G)?G.substr(1):G}e.stripUTF8BOM=de;function ve(G,se){if(!G||!se||G.length<se.length)return!1;const ce=se.length,we=G.toLowerCase();let Ee=0,Le=-1;for(;Ee<ce;){const Oe=we.indexOf(se[Ee],Le+1);if(Oe<0)return!1;Le=Oe,Ee++}return!0}e.fuzzyContains=ve;function Ie(G,se=!1){return G?(se&&(G=G.replace(/\\./g,"")),G.toLowerCase()!==G):!1}e.containsUppercaseCharacter=Ie;function me(G){return G.charAt(0).toUpperCase()+G.slice(1)}e.uppercaseFirstLetter=me;function ge(G,se=1){if(se===0)return"";let ce=-1;do ce=G.indexOf(`
`,ce+1),se--;while(se>0&&ce>=0);return ce===-1?G:(G[ce-1]==="\r"&&ce--,G.substr(0,ce))}e.getNLines=ge;function be(G){const se=90-65+1;return G=G%(2*se),G<se?String.fromCharCode(97+G):String.fromCharCode(65+G-se)}e.singleLetterHash=be;function ke(G){return Fe.getInstance().getGraphemeBreakType(G)}e.getGraphemeBreakType=ke;function Te(G,se){return G===0?se!==5&&se!==7:G===2&&se===3?!1:G===4||G===2||G===3||se===4||se===2||se===3?!0:!(G===8&&(se===8||se===9||se===11||se===12)||(G===11||G===9)&&(se===9||se===10)||(G===12||G===10)&&se===10||se===5||se===13||se===7||G===1||G===13&&se===14||G===6&&se===6)}e.breakBetweenGraphemeBreakType=Te;var Ne;(function(G){G[G.Other=0]="Other",G[G.Prepend=1]="Prepend",G[G.CR=2]="CR",G[G.LF=3]="LF",G[G.Control=4]="Control",G[G.Extend=5]="Extend",G[G.Regional_Indicator=6]="Regional_Indicator",G[G.SpacingMark=7]="SpacingMark",G[G.L=8]="L",G[G.V=9]="V",G[G.T=10]="T",G[G.LV=11]="LV",G[G.LVT=12]="LVT",G[G.ZWJ=13]="ZWJ",G[G.Extended_Pictographic=14]="Extended_Pictographic"})(Ne=e.GraphemeBreakType||(e.GraphemeBreakType={}));class Fe{constructor(){this._data=Ve()}static getInstance(){return Fe._INSTANCE||(Fe._INSTANCE=new Fe),Fe._INSTANCE}getGraphemeBreakType(se){if(se<32)return se===10?3:se===13?2:4;if(se<127)return 0;const ce=this._data,we=ce.length/3;let Ee=1;for(;Ee<=we;)if(se<ce[3*Ee])Ee=2*Ee;else if(se>ce[3*Ee+1])Ee=2*Ee+1;else return ce[3*Ee+2];return 0}}Fe._INSTANCE=null;function Ve(){return JSON.parse("[0,0,0,51592,51592,11,44424,44424,11,72251,72254,5,7150,7150,7,48008,48008,11,55176,55176,11,128420,128420,14,3276,3277,5,9979,9980,14,46216,46216,11,49800,49800,11,53384,53384,11,70726,70726,5,122915,122916,5,129320,129327,14,2558,2558,5,5906,5908,5,9762,9763,14,43360,43388,8,45320,45320,11,47112,47112,11,48904,48904,11,50696,50696,11,52488,52488,11,54280,54280,11,70082,70083,1,71350,71350,7,73111,73111,5,127892,127893,14,128726,128727,14,129473,129474,14,2027,2035,5,2901,2902,5,3784,3789,5,6754,6754,5,8418,8420,5,9877,9877,14,11088,11088,14,44008,44008,5,44872,44872,11,45768,45768,11,46664,46664,11,47560,47560,11,48456,48456,11,49352,49352,11,50248,50248,11,51144,51144,11,52040,52040,11,52936,52936,11,53832,53832,11,54728,54728,11,69811,69814,5,70459,70460,5,71096,71099,7,71998,71998,5,72874,72880,5,119149,119149,7,127374,127374,14,128335,128335,14,128482,128482,14,128765,128767,14,129399,129400,14,129680,129685,14,1476,1477,5,2377,2380,7,2759,2760,5,3137,3140,7,3458,3459,7,4153,4154,5,6432,6434,5,6978,6978,5,7675,7679,5,9723,9726,14,9823,9823,14,9919,9923,14,10035,10036,14,42736,42737,5,43596,43596,5,44200,44200,11,44648,44648,11,45096,45096,11,45544,45544,11,45992,45992,11,46440,46440,11,46888,46888,11,47336,47336,11,47784,47784,11,48232,48232,11,48680,48680,11,49128,49128,11,49576,49576,11,50024,50024,11,50472,50472,11,50920,50920,11,51368,51368,11,51816,51816,11,52264,52264,11,52712,52712,11,53160,53160,11,53608,53608,11,54056,54056,11,54504,54504,11,54952,54952,11,68108,68111,5,69933,69940,5,70197,70197,7,70498,70499,7,70845,70845,5,71229,71229,5,71727,71735,5,72154,72155,5,72344,72345,5,73023,73029,5,94095,94098,5,121403,121452,5,126981,127182,14,127538,127546,14,127990,127990,14,128391,128391,14,128445,128449,14,128500,128505,14,128752,128752,14,129160,129167,14,129356,129356,14,129432,129442,14,129648,129651,14,129751,131069,14,173,173,4,1757,1757,1,2274,2274,1,2494,2494,5,2641,2641,5,2876,2876,5,3014,3016,7,3262,3262,7,3393,3396,5,3570,3571,7,3968,3972,5,4228,4228,7,6086,6086,5,6679,6680,5,6912,6915,5,7080,7081,5,7380,7392,5,8252,8252,14,9096,9096,14,9748,9749,14,9784,9786,14,9833,9850,14,9890,9894,14,9938,9938,14,9999,9999,14,10085,10087,14,12349,12349,14,43136,43137,7,43454,43456,7,43755,43755,7,44088,44088,11,44312,44312,11,44536,44536,11,44760,44760,11,44984,44984,11,45208,45208,11,45432,45432,11,45656,45656,11,45880,45880,11,46104,46104,11,46328,46328,11,46552,46552,11,46776,46776,11,47000,47000,11,47224,47224,11,47448,47448,11,47672,47672,11,47896,47896,11,48120,48120,11,48344,48344,11,48568,48568,11,48792,48792,11,49016,49016,11,49240,49240,11,49464,49464,11,49688,49688,11,49912,49912,11,50136,50136,11,50360,50360,11,50584,50584,11,50808,50808,11,51032,51032,11,51256,51256,11,51480,51480,11,51704,51704,11,51928,51928,11,52152,52152,11,52376,52376,11,52600,52600,11,52824,52824,11,53048,53048,11,53272,53272,11,53496,53496,11,53720,53720,11,53944,53944,11,54168,54168,11,54392,54392,11,54616,54616,11,54840,54840,11,55064,55064,11,65438,65439,5,69633,69633,5,69837,69837,1,70018,70018,7,70188,70190,7,70368,70370,7,70465,70468,7,70712,70719,5,70835,70840,5,70850,70851,5,71132,71133,5,71340,71340,7,71458,71461,5,71985,71989,7,72002,72002,7,72193,72202,5,72281,72283,5,72766,72766,7,72885,72886,5,73104,73105,5,92912,92916,5,113824,113827,4,119173,119179,5,121505,121519,5,125136,125142,5,127279,127279,14,127489,127490,14,127570,127743,14,127900,127901,14,128254,128254,14,128369,128370,14,128400,128400,14,128425,128432,14,128468,128475,14,128489,128494,14,128715,128720,14,128745,128745,14,128759,128760,14,129004,129023,14,129296,129304,14,129340,129342,14,129388,129392,14,129404,129407,14,129454,129455,14,129485,129487,14,129659,129663,14,129719,129727,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2363,2363,7,2402,2403,5,2507,2508,7,2622,2624,7,2691,2691,7,2786,2787,5,2881,2884,5,3006,3006,5,3072,3072,5,3170,3171,5,3267,3268,7,3330,3331,7,3406,3406,1,3538,3540,5,3655,3662,5,3897,3897,5,4038,4038,5,4184,4185,5,4352,4447,8,6068,6069,5,6155,6157,5,6448,6449,7,6742,6742,5,6783,6783,5,6966,6970,5,7042,7042,7,7143,7143,7,7212,7219,5,7412,7412,5,8206,8207,4,8294,8303,4,8596,8601,14,9410,9410,14,9742,9742,14,9757,9757,14,9770,9770,14,9794,9794,14,9828,9828,14,9855,9855,14,9882,9882,14,9900,9903,14,9929,9933,14,9963,9967,14,9987,9988,14,10006,10006,14,10062,10062,14,10175,10175,14,11744,11775,5,42607,42607,5,43043,43044,7,43263,43263,5,43444,43445,7,43569,43570,5,43698,43700,5,43766,43766,5,44032,44032,11,44144,44144,11,44256,44256,11,44368,44368,11,44480,44480,11,44592,44592,11,44704,44704,11,44816,44816,11,44928,44928,11,45040,45040,11,45152,45152,11,45264,45264,11,45376,45376,11,45488,45488,11,45600,45600,11,45712,45712,11,45824,45824,11,45936,45936,11,46048,46048,11,46160,46160,11,46272,46272,11,46384,46384,11,46496,46496,11,46608,46608,11,46720,46720,11,46832,46832,11,46944,46944,11,47056,47056,11,47168,47168,11,47280,47280,11,47392,47392,11,47504,47504,11,47616,47616,11,47728,47728,11,47840,47840,11,47952,47952,11,48064,48064,11,48176,48176,11,48288,48288,11,48400,48400,11,48512,48512,11,48624,48624,11,48736,48736,11,48848,48848,11,48960,48960,11,49072,49072,11,49184,49184,11,49296,49296,11,49408,49408,11,49520,49520,11,49632,49632,11,49744,49744,11,49856,49856,11,49968,49968,11,50080,50080,11,50192,50192,11,50304,50304,11,50416,50416,11,50528,50528,11,50640,50640,11,50752,50752,11,50864,50864,11,50976,50976,11,51088,51088,11,51200,51200,11,51312,51312,11,51424,51424,11,51536,51536,11,51648,51648,11,51760,51760,11,51872,51872,11,51984,51984,11,52096,52096,11,52208,52208,11,52320,52320,11,52432,52432,11,52544,52544,11,52656,52656,11,52768,52768,11,52880,52880,11,52992,52992,11,53104,53104,11,53216,53216,11,53328,53328,11,53440,53440,11,53552,53552,11,53664,53664,11,53776,53776,11,53888,53888,11,54000,54000,11,54112,54112,11,54224,54224,11,54336,54336,11,54448,54448,11,54560,54560,11,54672,54672,11,54784,54784,11,54896,54896,11,55008,55008,11,55120,55120,11,64286,64286,5,66272,66272,5,68900,68903,5,69762,69762,7,69817,69818,5,69927,69931,5,70003,70003,5,70070,70078,5,70094,70094,7,70194,70195,7,70206,70206,5,70400,70401,5,70463,70463,7,70475,70477,7,70512,70516,5,70722,70724,5,70832,70832,5,70842,70842,5,70847,70848,5,71088,71089,7,71102,71102,7,71219,71226,5,71231,71232,5,71342,71343,7,71453,71455,5,71463,71467,5,71737,71738,5,71995,71996,5,72000,72000,7,72145,72147,7,72160,72160,5,72249,72249,7,72273,72278,5,72330,72342,5,72752,72758,5,72850,72871,5,72882,72883,5,73018,73018,5,73031,73031,5,73109,73109,5,73461,73462,7,94031,94031,5,94192,94193,7,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,126976,126979,14,127184,127231,14,127344,127345,14,127405,127461,14,127514,127514,14,127561,127567,14,127778,127779,14,127896,127896,14,127985,127986,14,127995,127999,5,128326,128328,14,128360,128366,14,128378,128378,14,128394,128397,14,128405,128406,14,128422,128423,14,128435,128443,14,128453,128464,14,128479,128480,14,128484,128487,14,128496,128498,14,128640,128709,14,128723,128724,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129096,129103,14,129292,129292,14,129311,129311,14,129329,129330,14,129344,129349,14,129360,129374,14,129394,129394,14,129402,129402,14,129413,129425,14,129445,129450,14,129466,129471,14,129483,129483,14,129511,129535,14,129653,129655,14,129667,129670,14,129705,129711,14,129731,129743,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2307,2307,7,2366,2368,7,2382,2383,7,2434,2435,7,2497,2500,5,2519,2519,5,2563,2563,7,2631,2632,5,2677,2677,5,2750,2752,7,2763,2764,7,2817,2817,5,2879,2879,5,2891,2892,7,2914,2915,5,3008,3008,5,3021,3021,5,3076,3076,5,3146,3149,5,3202,3203,7,3264,3265,7,3271,3272,7,3298,3299,5,3390,3390,5,3402,3404,7,3426,3427,5,3535,3535,5,3544,3550,7,3635,3635,7,3763,3763,7,3893,3893,5,3953,3966,5,3981,3991,5,4145,4145,7,4157,4158,5,4209,4212,5,4237,4237,5,4520,4607,10,5970,5971,5,6071,6077,5,6089,6099,5,6277,6278,5,6439,6440,5,6451,6456,7,6683,6683,5,6744,6750,5,6765,6770,7,6846,6846,5,6964,6964,5,6972,6972,5,7019,7027,5,7074,7077,5,7083,7085,5,7146,7148,7,7154,7155,7,7222,7223,5,7394,7400,5,7416,7417,5,8204,8204,5,8233,8233,4,8288,8292,4,8413,8416,5,8482,8482,14,8986,8987,14,9193,9203,14,9654,9654,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9775,14,9792,9792,14,9800,9811,14,9825,9826,14,9831,9831,14,9852,9853,14,9872,9873,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9936,9936,14,9941,9960,14,9974,9974,14,9982,9985,14,9992,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10145,10145,14,11013,11015,14,11503,11505,5,12334,12335,5,12951,12951,14,42612,42621,5,43014,43014,5,43047,43047,7,43204,43205,5,43335,43345,5,43395,43395,7,43450,43451,7,43561,43566,5,43573,43574,5,43644,43644,5,43710,43711,5,43758,43759,7,44005,44005,5,44012,44012,7,44060,44060,11,44116,44116,11,44172,44172,11,44228,44228,11,44284,44284,11,44340,44340,11,44396,44396,11,44452,44452,11,44508,44508,11,44564,44564,11,44620,44620,11,44676,44676,11,44732,44732,11,44788,44788,11,44844,44844,11,44900,44900,11,44956,44956,11,45012,45012,11,45068,45068,11,45124,45124,11,45180,45180,11,45236,45236,11,45292,45292,11,45348,45348,11,45404,45404,11,45460,45460,11,45516,45516,11,45572,45572,11,45628,45628,11,45684,45684,11,45740,45740,11,45796,45796,11,45852,45852,11,45908,45908,11,45964,45964,11,46020,46020,11,46076,46076,11,46132,46132,11,46188,46188,11,46244,46244,11,46300,46300,11,46356,46356,11,46412,46412,11,46468,46468,11,46524,46524,11,46580,46580,11,46636,46636,11,46692,46692,11,46748,46748,11,46804,46804,11,46860,46860,11,46916,46916,11,46972,46972,11,47028,47028,11,47084,47084,11,47140,47140,11,47196,47196,11,47252,47252,11,47308,47308,11,47364,47364,11,47420,47420,11,47476,47476,11,47532,47532,11,47588,47588,11,47644,47644,11,47700,47700,11,47756,47756,11,47812,47812,11,47868,47868,11,47924,47924,11,47980,47980,11,48036,48036,11,48092,48092,11,48148,48148,11,48204,48204,11,48260,48260,11,48316,48316,11,48372,48372,11,48428,48428,11,48484,48484,11,48540,48540,11,48596,48596,11,48652,48652,11,48708,48708,11,48764,48764,11,48820,48820,11,48876,48876,11,48932,48932,11,48988,48988,11,49044,49044,11,49100,49100,11,49156,49156,11,49212,49212,11,49268,49268,11,49324,49324,11,49380,49380,11,49436,49436,11,49492,49492,11,49548,49548,11,49604,49604,11,49660,49660,11,49716,49716,11,49772,49772,11,49828,49828,11,49884,49884,11,49940,49940,11,49996,49996,11,50052,50052,11,50108,50108,11,50164,50164,11,50220,50220,11,50276,50276,11,50332,50332,11,50388,50388,11,50444,50444,11,50500,50500,11,50556,50556,11,50612,50612,11,50668,50668,11,50724,50724,11,50780,50780,11,50836,50836,11,50892,50892,11,50948,50948,11,51004,51004,11,51060,51060,11,51116,51116,11,51172,51172,11,51228,51228,11,51284,51284,11,51340,51340,11,51396,51396,11,51452,51452,11,51508,51508,11,51564,51564,11,51620,51620,11,51676,51676,11,51732,51732,11,51788,51788,11,51844,51844,11,51900,51900,11,51956,51956,11,52012,52012,11,52068,52068,11,52124,52124,11,52180,52180,11,52236,52236,11,52292,52292,11,52348,52348,11,52404,52404,11,52460,52460,11,52516,52516,11,52572,52572,11,52628,52628,11,52684,52684,11,52740,52740,11,52796,52796,11,52852,52852,11,52908,52908,11,52964,52964,11,53020,53020,11,53076,53076,11,53132,53132,11,53188,53188,11,53244,53244,11,53300,53300,11,53356,53356,11,53412,53412,11,53468,53468,11,53524,53524,11,53580,53580,11,53636,53636,11,53692,53692,11,53748,53748,11,53804,53804,11,53860,53860,11,53916,53916,11,53972,53972,11,54028,54028,11,54084,54084,11,54140,54140,11,54196,54196,11,54252,54252,11,54308,54308,11,54364,54364,11,54420,54420,11,54476,54476,11,54532,54532,11,54588,54588,11,54644,54644,11,54700,54700,11,54756,54756,11,54812,54812,11,54868,54868,11,54924,54924,11,54980,54980,11,55036,55036,11,55092,55092,11,55148,55148,11,55216,55238,9,65056,65071,5,65529,65531,4,68097,68099,5,68159,68159,5,69446,69456,5,69688,69702,5,69808,69810,7,69815,69816,7,69821,69821,1,69888,69890,5,69932,69932,7,69957,69958,7,70016,70017,5,70067,70069,7,70079,70080,7,70089,70092,5,70095,70095,5,70191,70193,5,70196,70196,5,70198,70199,5,70367,70367,5,70371,70378,5,70402,70403,7,70462,70462,5,70464,70464,5,70471,70472,7,70487,70487,5,70502,70508,5,70709,70711,7,70720,70721,7,70725,70725,7,70750,70750,5,70833,70834,7,70841,70841,7,70843,70844,7,70846,70846,7,70849,70849,7,71087,71087,5,71090,71093,5,71100,71101,5,71103,71104,5,71216,71218,7,71227,71228,7,71230,71230,7,71339,71339,5,71341,71341,5,71344,71349,5,71351,71351,5,71456,71457,7,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123628,123631,5,125252,125258,5,126980,126980,14,127183,127183,14,127245,127247,14,127340,127343,14,127358,127359,14,127377,127386,14,127462,127487,6,127491,127503,14,127535,127535,14,127548,127551,14,127568,127569,14,127744,127777,14,127780,127891,14,127894,127895,14,127897,127899,14,127902,127984,14,127987,127989,14,127991,127994,14,128000,128253,14,128255,128317,14,128329,128334,14,128336,128359,14,128367,128368,14,128371,128377,14,128379,128390,14,128392,128393,14,128398,128399,14,128401,128404,14,128407,128419,14,128421,128421,14,128424,128424,14,128433,128434,14,128444,128444,14,128450,128452,14,128465,128467,14,128476,128478,14,128481,128481,14,128483,128483,14,128488,128488,14,128495,128495,14,128499,128499,14,128506,128591,14,128710,128714,14,128721,128722,14,128725,128725,14,128728,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129664,129666,14,129671,129679,14,129686,129704,14,129712,129718,14,129728,129730,14,129744,129750,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2259,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3134,3136,5,3142,3144,5,3157,3158,5,3201,3201,5,3260,3260,5,3263,3263,5,3266,3266,5,3270,3270,5,3274,3275,7,3285,3286,5,3328,3329,5,3387,3388,5,3391,3392,7,3398,3400,7,3405,3405,5,3415,3415,5,3457,3457,5,3530,3530,5,3536,3537,7,3542,3542,5,3551,3551,5,3633,3633,5,3636,3642,5,3761,3761,5,3764,3772,5,3864,3865,5,3895,3895,5,3902,3903,7,3967,3967,7,3974,3975,5,3993,4028,5,4141,4144,5,4146,4151,5,4155,4156,7,4182,4183,7,4190,4192,5,4226,4226,5,4229,4230,5,4253,4253,5,4448,4519,9,4957,4959,5,5938,5940,5,6002,6003,5,6070,6070,7,6078,6085,7,6087,6088,7,6109,6109,5,6158,6158,4,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6848,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7673,5,8203,8203,4,8205,8205,13,8232,8232,4,8234,8238,4,8265,8265,14,8293,8293,4,8400,8412,5,8417,8417,5,8421,8432,5,8505,8505,14,8617,8618,14,9000,9000,14,9167,9167,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9776,9783,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9935,14,9937,9937,14,9939,9940,14,9961,9962,14,9968,9973,14,9975,9978,14,9981,9981,14,9986,9986,14,9989,9989,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10084,14,10133,10135,14,10160,10160,14,10548,10549,14,11035,11036,14,11093,11093,14,11647,11647,5,12330,12333,5,12336,12336,14,12441,12442,5,12953,12953,14,42608,42610,5,42654,42655,5,43010,43010,5,43019,43019,5,43045,43046,5,43052,43052,5,43188,43203,7,43232,43249,5,43302,43309,5,43346,43347,7,43392,43394,5,43443,43443,5,43446,43449,5,43452,43453,5,43493,43493,5,43567,43568,7,43571,43572,7,43587,43587,5,43597,43597,7,43696,43696,5,43703,43704,5,43713,43713,5,43756,43757,5,43765,43765,7,44003,44004,7,44006,44007,7,44009,44010,7,44013,44013,5,44033,44059,12,44061,44087,12,44089,44115,12,44117,44143,12,44145,44171,12,44173,44199,12,44201,44227,12,44229,44255,12,44257,44283,12,44285,44311,12,44313,44339,12,44341,44367,12,44369,44395,12,44397,44423,12,44425,44451,12,44453,44479,12,44481,44507,12,44509,44535,12,44537,44563,12,44565,44591,12,44593,44619,12,44621,44647,12,44649,44675,12,44677,44703,12,44705,44731,12,44733,44759,12,44761,44787,12,44789,44815,12,44817,44843,12,44845,44871,12,44873,44899,12,44901,44927,12,44929,44955,12,44957,44983,12,44985,45011,12,45013,45039,12,45041,45067,12,45069,45095,12,45097,45123,12,45125,45151,12,45153,45179,12,45181,45207,12,45209,45235,12,45237,45263,12,45265,45291,12,45293,45319,12,45321,45347,12,45349,45375,12,45377,45403,12,45405,45431,12,45433,45459,12,45461,45487,12,45489,45515,12,45517,45543,12,45545,45571,12,45573,45599,12,45601,45627,12,45629,45655,12,45657,45683,12,45685,45711,12,45713,45739,12,45741,45767,12,45769,45795,12,45797,45823,12,45825,45851,12,45853,45879,12,45881,45907,12,45909,45935,12,45937,45963,12,45965,45991,12,45993,46019,12,46021,46047,12,46049,46075,12,46077,46103,12,46105,46131,12,46133,46159,12,46161,46187,12,46189,46215,12,46217,46243,12,46245,46271,12,46273,46299,12,46301,46327,12,46329,46355,12,46357,46383,12,46385,46411,12,46413,46439,12,46441,46467,12,46469,46495,12,46497,46523,12,46525,46551,12,46553,46579,12,46581,46607,12,46609,46635,12,46637,46663,12,46665,46691,12,46693,46719,12,46721,46747,12,46749,46775,12,46777,46803,12,46805,46831,12,46833,46859,12,46861,46887,12,46889,46915,12,46917,46943,12,46945,46971,12,46973,46999,12,47001,47027,12,47029,47055,12,47057,47083,12,47085,47111,12,47113,47139,12,47141,47167,12,47169,47195,12,47197,47223,12,47225,47251,12,47253,47279,12,47281,47307,12,47309,47335,12,47337,47363,12,47365,47391,12,47393,47419,12,47421,47447,12,47449,47475,12,47477,47503,12,47505,47531,12,47533,47559,12,47561,47587,12,47589,47615,12,47617,47643,12,47645,47671,12,47673,47699,12,47701,47727,12,47729,47755,12,47757,47783,12,47785,47811,12,47813,47839,12,47841,47867,12,47869,47895,12,47897,47923,12,47925,47951,12,47953,47979,12,47981,48007,12,48009,48035,12,48037,48063,12,48065,48091,12,48093,48119,12,48121,48147,12,48149,48175,12,48177,48203,12,48205,48231,12,48233,48259,12,48261,48287,12,48289,48315,12,48317,48343,12,48345,48371,12,48373,48399,12,48401,48427,12,48429,48455,12,48457,48483,12,48485,48511,12,48513,48539,12,48541,48567,12,48569,48595,12,48597,48623,12,48625,48651,12,48653,48679,12,48681,48707,12,48709,48735,12,48737,48763,12,48765,48791,12,48793,48819,12,48821,48847,12,48849,48875,12,48877,48903,12,48905,48931,12,48933,48959,12,48961,48987,12,48989,49015,12,49017,49043,12,49045,49071,12,49073,49099,12,49101,49127,12,49129,49155,12,49157,49183,12,49185,49211,12,49213,49239,12,49241,49267,12,49269,49295,12,49297,49323,12,49325,49351,12,49353,49379,12,49381,49407,12,49409,49435,12,49437,49463,12,49465,49491,12,49493,49519,12,49521,49547,12,49549,49575,12,49577,49603,12,49605,49631,12,49633,49659,12,49661,49687,12,49689,49715,12,49717,49743,12,49745,49771,12,49773,49799,12,49801,49827,12,49829,49855,12,49857,49883,12,49885,49911,12,49913,49939,12,49941,49967,12,49969,49995,12,49997,50023,12,50025,50051,12,50053,50079,12,50081,50107,12,50109,50135,12,50137,50163,12,50165,50191,12,50193,50219,12,50221,50247,12,50249,50275,12,50277,50303,12,50305,50331,12,50333,50359,12,50361,50387,12,50389,50415,12,50417,50443,12,50445,50471,12,50473,50499,12,50501,50527,12,50529,50555,12,50557,50583,12,50585,50611,12,50613,50639,12,50641,50667,12,50669,50695,12,50697,50723,12,50725,50751,12,50753,50779,12,50781,50807,12,50809,50835,12,50837,50863,12,50865,50891,12,50893,50919,12,50921,50947,12,50949,50975,12,50977,51003,12,51005,51031,12,51033,51059,12,51061,51087,12,51089,51115,12,51117,51143,12,51145,51171,12,51173,51199,12,51201,51227,12,51229,51255,12,51257,51283,12,51285,51311,12,51313,51339,12,51341,51367,12,51369,51395,12,51397,51423,12,51425,51451,12,51453,51479,12,51481,51507,12,51509,51535,12,51537,51563,12,51565,51591,12,51593,51619,12,51621,51647,12,51649,51675,12,51677,51703,12,51705,51731,12,51733,51759,12,51761,51787,12,51789,51815,12,51817,51843,12,51845,51871,12,51873,51899,12,51901,51927,12,51929,51955,12,51957,51983,12,51985,52011,12,52013,52039,12,52041,52067,12,52069,52095,12,52097,52123,12,52125,52151,12,52153,52179,12,52181,52207,12,52209,52235,12,52237,52263,12,52265,52291,12,52293,52319,12,52321,52347,12,52349,52375,12,52377,52403,12,52405,52431,12,52433,52459,12,52461,52487,12,52489,52515,12,52517,52543,12,52545,52571,12,52573,52599,12,52601,52627,12,52629,52655,12,52657,52683,12,52685,52711,12,52713,52739,12,52741,52767,12,52769,52795,12,52797,52823,12,52825,52851,12,52853,52879,12,52881,52907,12,52909,52935,12,52937,52963,12,52965,52991,12,52993,53019,12,53021,53047,12,53049,53075,12,53077,53103,12,53105,53131,12,53133,53159,12,53161,53187,12,53189,53215,12,53217,53243,12,53245,53271,12,53273,53299,12,53301,53327,12,53329,53355,12,53357,53383,12,53385,53411,12,53413,53439,12,53441,53467,12,53469,53495,12,53497,53523,12,53525,53551,12,53553,53579,12,53581,53607,12,53609,53635,12,53637,53663,12,53665,53691,12,53693,53719,12,53721,53747,12,53749,53775,12,53777,53803,12,53805,53831,12,53833,53859,12,53861,53887,12,53889,53915,12,53917,53943,12,53945,53971,12,53973,53999,12,54001,54027,12,54029,54055,12,54057,54083,12,54085,54111,12,54113,54139,12,54141,54167,12,54169,54195,12,54197,54223,12,54225,54251,12,54253,54279,12,54281,54307,12,54309,54335,12,54337,54363,12,54365,54391,12,54393,54419,12,54421,54447,12,54449,54475,12,54477,54503,12,54505,54531,12,54533,54559,12,54561,54587,12,54589,54615,12,54617,54643,12,54645,54671,12,54673,54699,12,54701,54727,12,54729,54755,12,54757,54783,12,54785,54811,12,54813,54839,12,54841,54867,12,54869,54895,12,54897,54923,12,54925,54951,12,54953,54979,12,54981,55007,12,55009,55035,12,55037,55063,12,55065,55091,12,55093,55119,12,55121,55147,12,55149,55175,12,55177,55203,12,55243,55291,10,65024,65039,5,65279,65279,4,65520,65528,4,66045,66045,5,66422,66426,5,68101,68102,5,68152,68154,5,68325,68326,5,69291,69292,5,69632,69632,7,69634,69634,7,69759,69761,5]")}function et(G,se){if(G===0)return 0;const ce=ot(G,se);if(ce!==void 0)return ce;const we=F(se,G);return G-=Ge(we),G}e.getLeftDeleteOffset=et;function ot(G,se){let ce=F(se,G);for(G-=Ge(ce);ht(ce)||ce===65039||ce===8419;){if(G===0)return;ce=F(se,G),G-=Ge(ce)}if(!!Z(ce)){if(G>=0){const we=F(se,G);we===8205&&(G-=Ge(we))}return G}}function Ge(G){return G>=65536?2:1}function ht(G){return 127995<=G&&G<=127999}var tt;(function(G){G[G.zwj=8205]="zwj",G[G.emojiVariantSelector=65039]="emojiVariantSelector",G[G.enclosingKeyCap=8419]="enclosingKeyCap"})(tt||(tt={}))}),define(Q[82],J([0,1,27]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function L(v){return D(v,0)}e.hash=L;function D(v,y){switch(typeof v){case"object":return v===null?M(349,y):Array.isArray(v)?d(v,y):g(v,y);case"string":return b(v,y);case"boolean":return P(v,y);case"number":return M(v,y);case"undefined":return M(937,y);default:return M(617,y)}}e.doHash=D;function M(v,y){return(y<<5)-y+v|0}e.numberHash=M;function P(v,y){return M(v?433:863,y)}function b(v,y){y=M(149417,y);for(let u=0,l=v.length;u<l;u++)y=M(v.charCodeAt(u),y);return y}e.stringHash=b;function d(v,y){return y=M(104579,y),v.reduce((u,l)=>D(l,u),y)}function g(v,y){return y=M(181387,y),Object.keys(v).sort().reduce((u,l)=>(u=b(l,u),D(v[l],u)),y)}class i{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=D(y,this._value),this._value}}e.Hasher=i;var I;(function(v){v[v.BLOCK_SIZE=64]="BLOCK_SIZE",v[v.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(I||(I={}));function S(v,y,u=32){const l=u-y,c=~((1<<l)-1);return(v<<y|(c&v)>>>l)>>>0}function m(v,y=0,u=v.byteLength,l=0){for(let c=0;c<u;c++)v[y+c]=l}function t(v,y,u="0"){for(;v.length<y;)v=u+v;return v}function h(v,y=32){return v instanceof ArrayBuffer?Array.from(new Uint8Array(v)).map(u=>u.toString(16).padStart(2,"0")).join(""):t((v>>>0).toString(16),y/4)}e.toHexString=h;class E{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const u=y.length;if(u===0)return;const l=this._buff;let c=this._buffLen,n=this._leftoverHighSurrogate,o,s;for(n!==0?(o=n,s=-1,n=0):(o=y.charCodeAt(0),s=0);;){let r=o;if(p.isHighSurrogate(o))if(s+1<u){const a=y.charCodeAt(s+1);p.isLowSurrogate(a)?(s++,r=p.computeCodePoint(o,a)):r=65533}else{n=o;break}else p.isLowSurrogate(o)&&(r=65533);if(c=this._push(l,c,r),s++,s<u)o=y.charCodeAt(s);else break}this._buffLen=c,this._leftoverHighSurrogate=n}_push(y,u,l){return l<128?y[u++]=l:l<2048?(y[u++]=192|(l&1984)>>>6,y[u++]=128|(l&63)>>>0):l<65536?(y[u++]=224|(l&61440)>>>12,y[u++]=128|(l&4032)>>>6,y[u++]=128|(l&63)>>>0):(y[u++]=240|(l&1835008)>>>18,y[u++]=128|(l&258048)>>>12,y[u++]=128|(l&4032)>>>6,y[u++]=128|(l&63)>>>0),u>=64&&(this._step(),u-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),u}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),h(this._h0)+h(this._h1)+h(this._h2)+h(this._h3)+h(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,m(this._buff,this._buffLen),this._buffLen>56&&(this._step(),m(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=E._bigBlock32,u=this._buffDV;for(let w=0;w<64;w+=4)y.setUint32(w,u.getUint32(w,!1),!1);for(let w=64;w<320;w+=4)y.setUint32(w,S(y.getUint32(w-12,!1)^y.getUint32(w-32,!1)^y.getUint32(w-56,!1)^y.getUint32(w-64,!1),1),!1);let l=this._h0,c=this._h1,n=this._h2,o=this._h3,s=this._h4,r,a,f;for(let w=0;w<80;w++)w<20?(r=c&n|~c&o,a=1518500249):w<40?(r=c^n^o,a=1859775393):w<60?(r=c&n|c&o|n&o,a=2400959708):(r=c^n^o,a=3395469782),f=S(l,5)+r+s+a+y.getUint32(w*4,!1)&4294967295,s=o,o=n,n=S(c,30),c=l,l=f;this._h0=this._h0+l&4294967295,this._h1=this._h1+c&4294967295,this._h2=this._h2+n&4294967295,this._h3=this._h3+o&4294967295,this._h4=this._h4+s&4294967295}}e.StringSHA1=E,E._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Q[14],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPromise=e.assertNever=e.NotImplementedProxy=e.withUndefinedAsNull=e.withNullAsUndefined=e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isObject=e.isStringArray=e.isString=e.isArray=void 0;function p(k){return Array.isArray(k)}e.isArray=p;function L(k){return typeof k=="string"}e.isString=L;function D(k){return Array.isArray(k)&&k.every(R=>L(R))}e.isStringArray=D;function M(k){return typeof k=="object"&&k!==null&&!Array.isArray(k)&&!(k instanceof RegExp)&&!(k instanceof Date)}e.isObject=M;function P(k){return typeof k=="number"&&!isNaN(k)}e.isNumber=P;function b(k){return!!k&&typeof k[Symbol.iterator]=="function"}e.isIterable=b;function d(k){return k===!0||k===!1}e.isBoolean=d;function g(k){return typeof k=="undefined"}e.isUndefined=g;function i(k){return!I(k)}e.isDefined=i;function I(k){return g(k)||k===null}e.isUndefinedOrNull=I;function S(k,R){if(!k)throw new Error(R?`Unexpected type, expected '${R}'`:"Unexpected type")}e.assertType=S;function m(k){if(I(k))throw new Error("Assertion Failed: argument is undefined or null");return k}e.assertIsDefined=m;function t(...k){const R=[];for(let A=0;A<k.length;A++){const O=k[A];if(I(O))throw new Error(`Assertion Failed: argument at index ${A} is undefined or null`);R.push(O)}return R}e.assertAllDefined=t;const h=Object.prototype.hasOwnProperty;function E(k){if(!M(k))return!1;for(let R in k)if(h.call(k,R))return!1;return!0}e.isEmptyObject=E;function v(k){return typeof k=="function"}e.isFunction=v;function y(...k){return k.length>0&&k.every(v)}e.areFunctions=y;function u(k,R){const A=Math.min(k.length,R.length);for(let O=0;O<A;O++)l(k[O],R[O])}e.validateConstraints=u;function l(k,R){if(L(R)){if(typeof k!==R)throw new Error(`argument does not match constraint: typeof ${R}`)}else if(v(R)){try{if(k instanceof R)return}catch{}if(!I(k)&&k.constructor===R||R.length===1&&R.call(void 0,k)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=l;function c(k){let R=[],A=Object.getPrototypeOf(k);for(;Object.prototype!==A;)R=R.concat(Object.getOwnPropertyNames(A)),A=Object.getPrototypeOf(A);return R}e.getAllPropertyNames=c;function n(k){const R=[];for(const A of c(k))typeof k[A]=="function"&&R.push(A);return R}e.getAllMethodNames=n;function o(k,R){const A=H=>function(){const x=Array.prototype.slice.call(arguments,0);return R(H,x)};let O={};for(const H of k)O[H]=A(H);return O}e.createProxyObject=o;function s(k){return k===null?void 0:k}e.withNullAsUndefined=s;function r(k){return typeof k=="undefined"?null:k}e.withUndefinedAsNull=r;function a(k){return class{constructor(){return new Proxy({},{get(R,A){if(R[A])return R[A];throw new Error(`Not Implemented: ${k}->${String(A)}`)}})}}}e.NotImplementedProxy=a;function f(k,R="Unreachable"){throw new Error(R)}e.assertNever=f;function w(k){return!!k&&typeof k.then=="function"&&typeof k.catch=="function"}e.isPromise=w}),define(Q[33],J([0,1,8,3,27,14]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function P(s){return s===47||s===92}e.isPathSeparator=P;function b(s){return s.replace(/[\\/]/g,p.posix.sep)}e.toSlashes=b;function d(s){return s.indexOf("/")===-1&&(s=b(s)),/^[a-zA-Z]:(\/|$)/.test(s)&&(s="/"+s),s}e.toPosixPath=d;function g(s,r=p.posix.sep){if(!s)return"";const a=s.length,f=s.charCodeAt(0);if(P(f)){if(P(s.charCodeAt(1))&&!P(s.charCodeAt(2))){let k=3;const R=k;for(;k<a&&!P(s.charCodeAt(k));k++);if(R!==k&&!P(s.charCodeAt(k+1))){for(k+=1;k<a;k++)if(P(s.charCodeAt(k)))return s.slice(0,k+1).replace(/[\\/]/g,r)}}return r}else if(v(f)&&s.charCodeAt(1)===58)return P(s.charCodeAt(2))?s.slice(0,2)+r:s.slice(0,2);let w=s.indexOf("://");if(w!==-1){for(w+=3;w<a;w++)if(P(s.charCodeAt(w)))return s.slice(0,w+1)}return""}e.getRoot=g;function i(s){if(!L.isWindows||!s||s.length<5)return!1;let r=s.charCodeAt(0);if(r!==92||(r=s.charCodeAt(1),r!==92))return!1;let a=2;const f=a;for(;a<s.length&&(r=s.charCodeAt(a),r!==92);a++);return!(f===a||(r=s.charCodeAt(a+1),isNaN(r)||r===92))}e.isUNC=i;const I=/[\\/:\*\?"<>\|]/g,S=/[\\/]/g,m=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function t(s,r=L.isWindows){const a=r?I:S;return!(!s||s.length===0||/^\s+$/.test(s)||(a.lastIndex=0,a.test(s))||r&&m.test(s)||s==="."||s===".."||r&&s[s.length-1]==="."||r&&s.length!==s.trim().length||s.length>255)}e.isValidBasename=t;function h(s,r,a){const f=s===r;return!a||f?f:!s||!r?!1:(0,D.equalsIgnoreCase)(s,r)}e.isEqual=h;function E(s,r,a,f=p.sep){if(s===r)return!0;if(!s||!r||r.length>s.length)return!1;if(a){if(!(0,D.startsWithIgnoreCase)(s,r))return!1;if(r.length===s.length)return!0;let k=r.length;return r.charAt(r.length-1)===f&&k--,s.charAt(k)===f}return r.charAt(r.length-1)!==f&&(r+=f),s.indexOf(r)===0}e.isEqualOrParent=E;function v(s){return s>=65&&s<=90||s>=97&&s<=122}e.isWindowsDriveLetter=v;function y(s,r){return L.isWindows&&s.endsWith(":")&&(s+=p.sep),(0,p.isAbsolute)(s)||(s=(0,p.join)(r,s)),s=(0,p.normalize)(s),L.isWindows?(s=(0,D.rtrim)(s,p.sep),s.endsWith(":")&&(s+=p.sep)):(s=(0,D.rtrim)(s,p.sep),s||(s=p.sep)),s}e.sanitizeFilePath=y;function u(s){const r=(0,p.normalize)(s);return L.isWindows?s.length>3?!1:l(r)&&(s.length===2||r.charCodeAt(2)===92):r===p.posix.sep}e.isRootOrDriveLetter=u;function l(s){return L.isWindows?v(s.charCodeAt(0))&&s.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function c(s){return l(s)?s[0]:void 0}e.getDriveLetter=c;function n(s,r,a){return r.length>s.length?-1:s===r?0:(a&&(s=s.toLowerCase(),r=r.toLowerCase()),s.indexOf(r))}e.indexOfPath=n;function o(s){const r=s.split(":");let a,f,w;if(r.forEach(k=>{const R=Number(k);(0,M.isNumber)(R)?f===void 0?f=R:w===void 0&&(w=R):a=a?[a,k].join(":"):k}),!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:f!==void 0?f:void 0,column:w!==void 0?w:f!==void 0?1:void 0}}e.parseLineAndColumnAware=o}),define(Q[43],J([0,1,14]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.filter=e.getCaseInsensitive=e.distinct=e.getOrDefault=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function L(h){if(!h||typeof h!="object"||h instanceof RegExp)return h;const E=Array.isArray(h)?[]:{};return Object.keys(h).forEach(v=>{h[v]&&typeof h[v]=="object"?E[v]=L(h[v]):E[v]=h[v]}),E}e.deepClone=L;function D(h){if(!h||typeof h!="object")return h;const E=[h];for(;E.length>0;){const v=E.shift();Object.freeze(v);for(const y in v)if(M.call(v,y)){const u=v[y];typeof u=="object"&&!Object.isFrozen(u)&&E.push(u)}}return h}e.deepFreeze=D;const M=Object.prototype.hasOwnProperty;function P(h,E){return b(h,E,new Set)}e.cloneAndChange=P;function b(h,E,v){if((0,p.isUndefinedOrNull)(h))return h;const y=E(h);if(typeof y!="undefined")return y;if((0,p.isArray)(h)){const u=[];for(const l of h)u.push(b(l,E,v));return u}if((0,p.isObject)(h)){if(v.has(h))throw new Error("Cannot clone recursive data-structure");v.add(h);const u={};for(let l in h)M.call(h,l)&&(u[l]=b(h[l],E,v));return v.delete(h),u}return h}function d(h,E,v=!0){return(0,p.isObject)(h)?((0,p.isObject)(E)&&Object.keys(E).forEach(y=>{y in h?v&&((0,p.isObject)(h[y])&&(0,p.isObject)(E[y])?d(h[y],E[y],v):h[y]=E[y]):h[y]=E[y]}),h):E}e.mixin=d;function g(h,E){if(h===E)return!0;if(h==null||E===null||E===void 0||typeof h!=typeof E||typeof h!="object"||Array.isArray(h)!==Array.isArray(E))return!1;let v,y;if(Array.isArray(h)){if(h.length!==E.length)return!1;for(v=0;v<h.length;v++)if(!g(h[v],E[v]))return!1}else{const u=[];for(y in h)u.push(y);u.sort();const l=[];for(y in E)l.push(y);if(l.sort(),!g(u,l))return!1;for(v=0;v<u.length;v++)if(!g(h[u[v]],E[u[v]]))return!1}return!0}e.equals=g;function i(h){const E=new Set;return JSON.stringify(h,(v,y)=>{if((0,p.isObject)(y)||Array.isArray(y)){if(E.has(y))return"[Circular]";E.add(y)}return y})}e.safeStringify=i;function I(h,E,v){const y=E(h);return typeof y=="undefined"?v:y}e.getOrDefault=I;function S(h,E){const v=Object.create(null);return!h||!E||Object.keys(E).forEach(u=>{const l=h[u],c=E[u];g(l,c)||(v[u]=c)}),v}e.distinct=S;function m(h,E){const v=E.toLowerCase(),y=Object.keys(h).find(u=>u.toLowerCase()===v);return y?h[y]:h[E]}e.getCaseInsensitive=m;function t(h,E){const v=Object.create(null);for(const y of Object.keys(h))E(y,h[y])&&(v[y]=h[y]);return v}e.filter=t}),define(Q[7],J([0,1,8,3]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const D=/^\w[\w\d+.-]*$/,M=/^\//,P=/^\/\//;function b(s,r){if(!s.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${s.authority}", path: "${s.path}", query: "${s.query}", fragment: "${s.fragment}"}`);if(s.scheme&&!D.test(s.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(s.path){if(s.authority){if(!M.test(s.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(P.test(s.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function d(s,r){return!s&&!r?"file":s}function g(s,r){switch(s){case"https":case"http":case"file":r?r[0]!==I&&(r=I+r):r=I;break}return r}const i="",I="/",S=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class m{constructor(r,a,f,w,k,R=!1){typeof r=="object"?(this.scheme=r.scheme||i,this.authority=r.authority||i,this.path=r.path||i,this.query=r.query||i,this.fragment=r.fragment||i):(this.scheme=d(r,R),this.authority=a||i,this.path=g(this.scheme,f||i),this.query=w||i,this.fragment=k||i,b(this,R))}static isUri(r){return r instanceof m?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return u(this,!1)}with(r){if(!r)return this;let{scheme:a,authority:f,path:w,query:k,fragment:R}=r;return a===void 0?a=this.scheme:a===null&&(a=i),f===void 0?f=this.authority:f===null&&(f=i),w===void 0?w=this.path:w===null&&(w=i),k===void 0?k=this.query:k===null&&(k=i),R===void 0?R=this.fragment:R===null&&(R=i),a===this.scheme&&f===this.authority&&w===this.path&&k===this.query&&R===this.fragment?this:new h(a,f,w,k,R)}static parse(r,a=!1){const f=S.exec(r);return f?new h(f[2]||i,o(f[4]||i),o(f[5]||i),o(f[7]||i),o(f[9]||i),a):new h(i,i,i,i,i)}static file(r){let a=i;if(L.isWindows&&(r=r.replace(/\\/g,I)),r[0]===I&&r[1]===I){const f=r.indexOf(I,2);f===-1?(a=r.substring(2),r=I):(a=r.substring(2,f),r=r.substring(f)||I)}return new h("file",a,r,i,i)}static from(r){const a=new h(r.scheme,r.authority,r.path,r.query,r.fragment);return b(a,!0),a}static joinPath(r,...a){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let f;return L.isWindows&&r.scheme==="file"?f=m.file(p.win32.join(u(r,!0),...a)).path:f=p.posix.join(r.path,...a),r.with({path:f})}toString(r=!1){return l(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof m)return r;{const a=new h(r);return a._formatted=r.external,a._fsPath=r._sep===t?r.fsPath:null,a}}else return r}}e.URI=m;const t=L.isWindows?1:void 0;class h extends m{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=u(this,!1)),this._fsPath}toString(r=!1){return r?l(this,!0):(this._formatted||(this._formatted=l(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=t),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const E={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function v(s,r){let a,f=-1;for(let w=0;w<s.length;w++){const k=s.charCodeAt(w);if(k>=97&&k<=122||k>=65&&k<=90||k>=48&&k<=57||k===45||k===46||k===95||k===126||r&&k===47)f!==-1&&(a+=encodeURIComponent(s.substring(f,w)),f=-1),a!==void 0&&(a+=s.charAt(w));else{a===void 0&&(a=s.substr(0,w));const R=E[k];R!==void 0?(f!==-1&&(a+=encodeURIComponent(s.substring(f,w)),f=-1),a+=R):f===-1&&(f=w)}}return f!==-1&&(a+=encodeURIComponent(s.substring(f))),a!==void 0?a:s}function y(s){let r;for(let a=0;a<s.length;a++){const f=s.charCodeAt(a);f===35||f===63?(r===void 0&&(r=s.substr(0,a)),r+=E[f]):r!==void 0&&(r+=s[a])}return r!==void 0?r:s}function u(s,r){let a;return s.authority&&s.path.length>1&&s.scheme==="file"?a=`//${s.authority}${s.path}`:s.path.charCodeAt(0)===47&&(s.path.charCodeAt(1)>=65&&s.path.charCodeAt(1)<=90||s.path.charCodeAt(1)>=97&&s.path.charCodeAt(1)<=122)&&s.path.charCodeAt(2)===58?r?a=s.path.substr(1):a=s.path[1].toLowerCase()+s.path.substr(2):a=s.path,L.isWindows&&(a=a.replace(/\//g,"\\")),a}e.uriToFsPath=u;function l(s,r){const a=r?y:v;let f="",{scheme:w,authority:k,path:R,query:A,fragment:O}=s;if(w&&(f+=w,f+=":"),(k||w==="file")&&(f+=I,f+=I),k){let H=k.indexOf("@");if(H!==-1){const x=k.substr(0,H);k=k.substr(H+1),H=x.indexOf(":"),H===-1?f+=a(x,!1):(f+=a(x.substr(0,H),!1),f+=":",f+=a(x.substr(H+1),!1)),f+="@"}k=k.toLowerCase(),H=k.indexOf(":"),H===-1?f+=a(k,!1):(f+=a(k.substr(0,H),!1),f+=k.substr(H))}if(R){if(R.length>=3&&R.charCodeAt(0)===47&&R.charCodeAt(2)===58){const H=R.charCodeAt(1);H>=65&&H<=90&&(R=`/${String.fromCharCode(H+32)}:${R.substr(3)}`)}else if(R.length>=2&&R.charCodeAt(1)===58){const H=R.charCodeAt(0);H>=65&&H<=90&&(R=`${String.fromCharCode(H+32)}:${R.substr(2)}`)}f+=a(R,!0)}return A&&(f+="?",f+=a(A,!1)),O&&(f+="#",f+=r?O:v(O,!1)),f}function c(s){try{return decodeURIComponent(s)}catch{return s.length>3?s.substr(0,3)+c(s.substr(3)):s}}const n=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function o(s){return s.match(n)?s.replace(n,r=>c(r)):s}}),define(Q[109],J([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function L(g){const i=g;return i&&typeof i.type=="string"&&typeof i.severity=="string"}e.isRemoteConsoleLog=L;function D(g){const i=[];let I;try{const S=JSON.parse(g.arguments),m=S[S.length-1];m&&m.__$stack&&(S.pop(),I=m.__$stack),i.push(...S)}catch(S){i.push("Unable to log remote console arguments",g.arguments)}return{args:i,stack:I}}e.parse=D;function M(g){if(typeof g!="string")return M(D(g).stack);const i=g;if(i){const I=P(i),S=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(I||"");if(S&&S.length===4)return{uri:p.URI.file(S[1]),line:Number(S[2]),column:Number(S[3])}}}e.getFirstFrame=M;function P(g){if(!g)return g;const i=g.indexOf(`
`);return i===-1?g:g.substring(0,i)}function b(g,i){const{args:I,stack:S}=D(g),m=typeof I[0]=="string"&&I.length===1;let t=P(S);t&&(t=`(${t.trim()})`);let h=[];if(typeof I[0]=="string"?t&&m?h=[`%c[${i}] %c${I[0]} %c${t}`,d("blue"),d(""),d("grey")]:h=[`%c[${i}] %c${I[0]}`,d("blue"),d(""),...I.slice(1)]:h=[`%c[${i}]%`,d("blue"),...I],t&&!m&&h.push(t),typeof console[g.severity]!="function")throw new Error("Unknown console method");console[g.severity].apply(console,h)}e.log=b;function d(g){return`color: ${g}`}});var Et=this&&this.__classPrivateFieldSet||function(j,e,p,L,D){if(L==="m")throw new TypeError("Private method is not writable");if(L==="a"&&!D)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?j!==e||!D:!e.has(j))throw new TypeError("Cannot write private member to an object whose class did not declare it");return L==="a"?D.call(j,p):D?D.value=p:e.set(j,p),p},qe=this&&this.__classPrivateFieldGet||function(j,e,p,L){if(p==="a"&&!L)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?j!==e||!L:!e.has(j))throw new TypeError("Cannot read private member from an object whose class did not declare it");return p==="m"?L:p==="a"?L.call(j):L?L.value:e.get(j)};define(Q[40],J([0,1,30,27,7]),function(j,e,p,L,D){"use strict";var M,P,b;Object.defineProperty(e,"__esModule",{value:!0}),e.ReadonlyMapView=e.LRUCache=e.LinkedMap=e.Touch=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function d(s,r,a){let f=s.get(r);return f===void 0&&(f=a,s.set(r,f)),f}e.getOrSet=d;function g(s){const r=[];return s.forEach((a,f)=>{r.push(`${f} => ${a}`)}),`Map(${s.size}) {${r.join(", ")}}`}e.mapToString=g;function i(s){const r=[];return s.forEach(a=>{r.push(a)}),`Set(${s.size}) {${r.join(", ")}}`}e.setToString=i;class I{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const a=r.charCodeAt(0),f=this._value.charCodeAt(this._pos);return a-f}value(){return this._value[this._pos]}}e.StringIterator=I;class S{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=S;class m{constructor(r=!0,a=!0){this._splitOnBackslash=r,this._caseSensitive=a}reset(r){return this._value=r.replace(/\\$|\/$/,""),this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++){const a=this._value.charCodeAt(this._to);if(a===47||this._splitOnBackslash&&a===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,L.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,L.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var t;(function(s){s[s.Scheme=1]="Scheme",s[s.Authority=2]="Authority",s[s.Path=3]="Path",s[s.Query=4]="Query",s[s.Fragment=5]="Fragment"})(t||(t={}));class h{constructor(r){this._ignorePathCasing=r,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,L.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,L.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,L.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,L.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=h;class E{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(s){s[s.Left=-1]="Left",s[s.Mid=0]="Mid",s[s.Right=1]="Right"})(v||(v={}));class y{constructor(r){this._iter=r}static forUris(r=()=>!1){return new y(new h(r))}static forPaths(){return new y(new m)}static forStrings(){return new y(new I)}static forConfigKeys(){return new y(new S)}clear(){this._root=void 0}fill(r,a){if(a){const f=a.slice(0);(0,p.shuffle)(f);for(let w of f)this.set(w,r)}else{const f=r.slice(0);(0,p.shuffle)(f);for(let w of f)this.set(w[0],w[1])}}set(r,a){const f=this._iter.reset(r);let w;this._root||(this._root=new E,this._root.segment=f.value());const k=[];for(w=this._root;;){const A=f.cmp(w.segment);if(A>0)w.left||(w.left=new E,w.left.segment=f.value()),k.push([-1,w]),w=w.left;else if(A<0)w.right||(w.right=new E,w.right.segment=f.value()),k.push([1,w]),w=w.right;else if(f.hasNext())f.next(),w.mid||(w.mid=new E,w.mid.segment=f.value()),k.push([0,w]),w=w.mid;else break}const R=w.value;w.value=a,w.key=r;for(let A=k.length-1;A>=0;A--){const O=k[A][1];O.updateHeight();const H=O.balanceFactor();if(H<-1||H>1){const x=k[A][0],re=k[A+1][0];if(x===1&&re===1)k[A][1]=O.rotateLeft();else if(x===-1&&re===-1)k[A][1]=O.rotateRight();else if(x===1&&re===-1)O.right=k[A+1][1]=k[A+1][1].rotateRight(),k[A][1]=O.rotateLeft();else if(x===-1&&re===1)O.left=k[A+1][1]=k[A+1][1].rotateLeft(),k[A][1]=O.rotateRight();else throw new Error;if(A>0)switch(k[A-1][0]){case-1:k[A-1][1].left=k[A][1];break;case 1:k[A-1][1].right=k[A][1];break;case 0:k[A-1][1].mid=k[A][1];break}else this._root=k[0][1]}}return R}get(r){return this._getNode(r)?.value}_getNode(r){const a=this._iter.reset(r);let f=this._root;for(;f;){const w=a.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else break}return f}has(r){const a=this._getNode(r);return!(a?.value===void 0&&a?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,a){const f=this._iter.reset(r),w=[];let k=this._root;for(;k;){const R=f.cmp(k.segment);if(R>0)w.push([-1,k]),k=k.left;else if(R<0)w.push([1,k]),k=k.right;else if(f.hasNext())f.next(),w.push([0,k]),k=k.mid;else break}if(!!k){if(a?(k.left=void 0,k.mid=void 0,k.right=void 0,k.height=1):(k.key=void 0,k.value=void 0),!k.mid&&!k.value)if(k.left&&k.right){const R=this._min(k.right),{key:A,value:O,segment:H}=R;this._delete(R.key,!1),k.key=A,k.value=O,k.segment=H}else{const R=k.left??k.right;if(w.length>0){const[A,O]=w[w.length-1];switch(A){case-1:O.left=R;break;case 0:O.mid=R;break;case 1:O.right=R;break}}else this._root=R}for(let R=w.length-1;R>=0;R--){const A=w[R][1];A.updateHeight();const O=A.balanceFactor();if(O>1?(A.right.balanceFactor()>=0||(A.right=w[R+1][1]=w[R+1][1].rotateRight()),w[R][1]=A.rotateLeft()):O<-1&&(A.left.balanceFactor()<=0||(A.left=w[R+1][1]=w[R+1][1].rotateLeft()),w[R][1]=A.rotateRight()),R>0)switch(w[R-1][0]){case-1:w[R-1][1].left=w[R][1];break;case 1:w[R-1][1].right=w[R][1];break;case 0:w[R-1][1].mid=w[R][1];break}else this._root=w[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const a=this._iter.reset(r);let f=this._root,w;for(;f;){const k=a.cmp(f.segment);if(k>0)f=f.left;else if(k<0)f=f.right;else if(a.hasNext())a.next(),w=f.value||w,f=f.mid;else break}return f&&f.value||w}findSuperstr(r){const a=this._iter.reset(r);let f=this._root;for(;f;){const w=a.cmp(f.segment);if(w>0)f=f.left;else if(w<0)f=f.right;else if(a.hasNext())a.next(),f=f.mid;else return f.mid?this._entries(f.mid):void 0}}forEach(r){for(const[a,f]of this)r(f,a)}*[Symbol.iterator](){yield*this._entries(this._root)}*_entries(r){!r||(r.left&&(yield*this._entries(r.left)),r.value&&(yield[r.key,r.value]),r.mid&&(yield*this._entries(r.mid)),r.right&&(yield*this._entries(r.right)))}_isBalanced(){const r=a=>{if(!a)return!0;const f=a.balanceFactor();return f<-1||f>1?!1:r(a.left)&&r(a.right)};return r(this._root)}}e.TernarySearchTree=y;class u{constructor(r,a){this[M]="ResourceMap",r instanceof u?(this.map=new Map(r.map),this.toKey=a??u.defaultToKey):(this.map=new Map,this.toKey=r??u.defaultToKey)}set(r,a){return this.map.set(this.toKey(r),a),this}get(r){return this.map.get(this.toKey(r))}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,a){typeof a!="undefined"&&(r=r.bind(a));for(let[f,w]of this.map)r(w,D.URI.parse(f),this)}values(){return this.map.values()}*keys(){for(let r of this.map.keys())yield D.URI.parse(r)}*entries(){for(let r of this.map.entries())yield[D.URI.parse(r[0]),r[1]]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(let r of this.map)yield[D.URI.parse(r[0]),r[1]]}}e.ResourceMap=u,u.defaultToKey=s=>s.toString();var l;(function(s){s[s.None=0]="None",s[s.AsOld=1]="AsOld",s[s.AsNew=2]="AsNew"})(l=e.Touch||(e.Touch={}));class c{constructor(){this[P]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,a=0){const f=this._map.get(r);if(!!f)return a!==0&&this.touch(f,a),f.value}set(r,a,f=0){let w=this._map.get(r);if(w)w.value=a,f!==0&&this.touch(w,f);else{switch(w={key:r,value:a,next:void 0,previous:void 0},f){case 0:this.addItemLast(w);break;case 1:this.addItemFirst(w);break;case 2:this.addItemLast(w);break;default:this.addItemLast(w);break}this._map.set(r,w),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const a=this._map.get(r);if(!!a)return this._map.delete(r),this.removeItem(a),this._size--,a.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,a){const f=this._state;let w=this._head;for(;w;){if(a?r.bind(a)(w.value,w.key,this):r(w.value,w.key,this),this._state!==f)throw new Error("LinkedMap got modified during iteration.");w=w.next}}keys(){const r=this,a=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.key,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}values(){const r=this,a=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:f.value,done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}entries(){const r=this,a=this._state;let f=this._head;const w={[Symbol.iterator](){return w},next(){if(r._state!==a)throw new Error("LinkedMap got modified during iteration.");if(f){const k={value:[f.key,f.value],done:!1};return f=f.next,k}else return{value:void 0,done:!0}}};return w}[(P=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let a=this._head,f=this.size;for(;a&&f>r;)this._map.delete(a.key),a=a.next,f--;this._head=a,this._size=f,a&&(a.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const a=r.next,f=r.previous;if(!a||!f)throw new Error("Invalid list");a.previous=f,f.next=a}r.next=void 0,r.previous=void 0,this._state++}touch(r,a){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(a!==1&&a!==2)){if(a===1){if(r===this._head)return;const f=r.next,w=r.previous;r===this._tail?(w.next=void 0,this._tail=w):(f.previous=w,w.next=f),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(a===2){if(r===this._tail)return;const f=r.next,w=r.previous;r===this._head?(f.previous=void 0,this._head=f):(f.previous=w,w.next=f),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((a,f)=>{r.push([f,a])}),r}fromJSON(r){this.clear();for(const[a,f]of r)this.set(a,f)}}e.LinkedMap=c;class n extends c{constructor(r,a=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,a),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,a=2){return super.get(r,a)}peek(r){return super.get(r,0)}set(r,a){return super.set(r,a,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=n;class o{constructor(r){b.set(this,void 0),Et(this,b,r,"f")}get size(){return qe(this,b,"f").size}forEach(r,a){qe(this,b,"f").forEach(r,a)}get(r){return qe(this,b,"f").get(r)}has(r){return qe(this,b,"f").has(r)}entries(){return qe(this,b,"f").entries()}keys(){return qe(this,b,"f").keys()}values(){return qe(this,b,"f").values()}[(b=new WeakMap,Symbol.iterator)](){return qe(this,b,"f").entries()}}e.ReadonlyMapView=o}),define(Q[110],J([0,1,16,27,7]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.MarshalledId=e.parse=e.stringify=void 0;function M(i){return JSON.stringify(i,d)}e.stringify=M;function P(i){let I=JSON.parse(i);return I=g(I),I}e.parse=P;var b;(function(i){i[i.Uri=1]="Uri",i[i.Regexp=2]="Regexp",i[i.ScmResource=3]="ScmResource",i[i.ScmResourceGroup=4]="ScmResourceGroup",i[i.ScmProvider=5]="ScmProvider",i[i.CommentController=6]="CommentController",i[i.CommentThread=7]="CommentThread",i[i.CommentThreadReply=8]="CommentThreadReply",i[i.CommentNode=9]="CommentNode",i[i.CommentThreadNode=10]="CommentThreadNode",i[i.TimelineActionContext=11]="TimelineActionContext",i[i.NotebookCellActionContext=12]="NotebookCellActionContext",i[i.TestItemContext=13]="TestItemContext"})(b=e.MarshalledId||(e.MarshalledId={}));function d(i,I){return I instanceof RegExp?{$mid:2,source:I.source,flags:(0,L.regExpFlags)(I)}:I}function g(i,I=0){if(!i||I>200)return i;if(typeof i=="object"){switch(i.$mid){case 1:return D.URI.revive(i);case 2:return new RegExp(i.source,i.flags)}if(i instanceof p.VSBuffer||i instanceof Uint8Array)return i;if(Array.isArray(i))for(let S=0;S<i.length;++S)i[S]=g(i[S],I+1);else for(const S in i)Object.hasOwnProperty.call(i,S)&&(i[S]=g(i[S],I+1))}return i}e.revive=g}),define(Q[10],J([0,1,3,7]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.Schemas=void 0;var D;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.userData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp"})(D=e.Schemas||(e.Schemas={}));class M{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null}setPreferredWebSchema(d){this._preferredWebSchema=d}setDelegate(d){this._delegate=d}set(d,g,i){this._hosts[d]=g,this._ports[d]=i}setConnectionToken(d,g){this._connectionTokens[d]=g}rewrite(d){if(this._delegate)return this._delegate(d);const g=d.authority;let i=this._hosts[g];i&&i.indexOf(":")!==-1&&(i=`[${i}]`);const I=this._ports[g],S=this._connectionTokens[g];let m=`path=${encodeURIComponent(d.path)}`;return typeof S=="string"&&(m+=`&tkn=${encodeURIComponent(S)}`),L.URI.from({scheme:p.isWeb?this._preferredWebSchema:D.vscodeRemoteResource,authority:`${i}:${I}`,path:"/vscode-remote-resource",query:m})}}e.RemoteAuthorities=new M;class P{asBrowserUri(d,g){const i=this.toUri(d,g);return i.scheme===D.vscodeRemote?e.RemoteAuthorities.rewrite(i):i.scheme===D.file&&(p.isNative||typeof p.globals.importScripts=="function"&&p.globals.origin===`${D.vscodeFileResource}://${P.FALLBACK_AUTHORITY}`)?i.with({scheme:D.vscodeFileResource,authority:i.authority||P.FALLBACK_AUTHORITY,query:null,fragment:null}):i}asFileUri(d,g){const i=this.toUri(d,g);return i.scheme===D.vscodeFileResource?i.with({scheme:D.file,authority:i.authority!==P.FALLBACK_AUTHORITY?i.authority:null,query:null,fragment:null}):i}toUri(d,g){return L.URI.isUri(d)?d:L.URI.parse(g.toUrl(d))}}P.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new P}),define(Q[69],J([0,1,40]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const L=new p.LRUCache(1e4);function D(g){return d(g,"NFC",L)}e.normalizeNFC=D;const M=new p.LRUCache(1e4);function P(g){return d(g,"NFD",M)}e.normalizeNFD=P;const b=/[^\u0000-\u0080]/;function d(g,i,I){if(!g)return g;const S=I.get(g);if(S)return S;let m;return b.test(g)?m=g.normalize(i):m=g,I.set(g,m),m}e.removeAccents=function(){const g=/[\u0300-\u036f]/g;return function(i){return P(i).replace(g,"")}}()}),define(Q[15],J([0,1,33,10,8,3,27,7]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function d(m){return(0,b.uriToFsPath)(m,!0)}e.originalFSPath=d;class g{constructor(t){this._ignorePathCasing=t}compare(t,h,E=!1){return t===h?0:(0,P.compare)(this.getComparisonKey(t,E),this.getComparisonKey(h,E))}isEqual(t,h,E=!1){return t===h?!0:!t||!h?!1:this.getComparisonKey(t,E)===this.getComparisonKey(h,E)}getComparisonKey(t,h=!1){return t.with({path:this._ignorePathCasing(t)?t.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(t){return this._ignorePathCasing(t)}isEqualOrParent(t,h,E=!1){if(t.scheme===h.scheme){if(t.scheme===L.Schemas.file)return p.isEqualOrParent(d(t),d(h),this._ignorePathCasing(t))&&t.query===h.query&&(E||t.fragment===h.fragment);if((0,e.isEqualAuthority)(t.authority,h.authority))return p.isEqualOrParent(t.path,h.path,this._ignorePathCasing(t),"/")&&t.query===h.query&&(E||t.fragment===h.fragment)}return!1}joinPath(t,...h){return b.URI.joinPath(t,...h)}basenameOrAuthority(t){return(0,e.basename)(t)||t.authority}basename(t){return D.posix.basename(t.path)}extname(t){return D.posix.extname(t.path)}dirname(t){if(t.path.length===0)return t;let h;return t.scheme===L.Schemas.file?h=b.URI.file(D.dirname(d(t))).path:(h=D.posix.dirname(t.path),t.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${t.toString})) resulted in a relative path`),h="/")),t.with({path:h})}normalizePath(t){if(!t.path.length)return t;let h;return t.scheme===L.Schemas.file?h=b.URI.file(D.normalize(d(t))).path:h=D.posix.normalize(t.path),t.with({path:h})}relativePath(t,h){if(t.scheme!==h.scheme||!(0,e.isEqualAuthority)(t.authority,h.authority))return;if(t.scheme===L.Schemas.file){const y=D.relative(d(t),d(h));return M.isWindows?p.toSlashes(y):y}let E=t.path||"/",v=h.path||"/";if(this._ignorePathCasing(t)){let y=0;for(const u=Math.min(E.length,v.length);y<u&&!(E.charCodeAt(y)!==v.charCodeAt(y)&&E.charAt(y).toLowerCase()!==v.charAt(y).toLowerCase());y++);E=v.substr(0,y)+E.substr(y)}return D.posix.relative(E,v)}resolvePath(t,h){if(t.scheme===L.Schemas.file){const E=b.URI.file(D.resolve(d(t),h));return t.with({authority:E.authority,path:E.path})}return h=p.toPosixPath(h),t.with({path:D.posix.resolve(t.path,h)})}isAbsolutePath(t){return!!t.path&&t.path[0]==="/"}isEqualAuthority(t,h){return t===h||(0,P.equalsIgnoreCase)(t,h)}hasTrailingPathSeparator(t,h=D.sep){if(t.scheme===L.Schemas.file){const E=d(t);return E.length>p.getRoot(E).length&&E[E.length-1]===h}else{const E=t.path;return E.length>1&&E.charCodeAt(E.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(t.fsPath)}}removeTrailingPathSeparator(t,h=D.sep){return(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path.substr(0,t.path.length-1)}):t}addTrailingPathSeparator(t,h=D.sep){let E=!1;if(t.scheme===L.Schemas.file){const v=d(t);E=v!==void 0&&v.length===p.getRoot(v).length&&v[v.length-1]===h}else{h="/";const v=t.path;E=v.length===1&&v.charCodeAt(v.length-1)===47}return!E&&!(0,e.hasTrailingPathSeparator)(t,h)?t.with({path:t.path+"/"}):t}}e.ExtUri=g,e.extUri=new g(()=>!1),e.extUriBiasedIgnorePathCase=new g(m=>m.scheme===L.Schemas.file?!M.isLinux:!0),e.extUriIgnorePathCase=new g(m=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function i(m,t){const h=[];for(let E=0;E<m.length;E++){const v=t(m[E]);m.some((y,u)=>u===E?!1:(0,e.isEqualOrParent)(v,t(y)))||h.push(m[E])}return h}e.distinctParents=i;var I;(function(m){m.META_DATA_LABEL="label",m.META_DATA_DESCRIPTION="description",m.META_DATA_SIZE="size",m.META_DATA_MIME="mime";function t(h){const E=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(u=>{const[l,c]=u.split(":");l&&c&&E.set(l,c)});const y=h.path.substring(0,h.path.indexOf(";"));return y&&E.set(m.META_DATA_MIME,y),E}m.parseMetaData=t})(I=e.DataUri||(e.DataUri={}));function S(m,t,h){if(t){let E=m.path;return E&&E[0]!==D.posix.sep&&(E=D.posix.sep+E),m.with({scheme:h,authority:t,path:E})}return m.with({scheme:h})}e.toLocalResource=S}),define(Q[9],J([0,1,23,18,4,2,15]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function b(z){return!!z&&typeof z.then=="function"}e.isThenable=b;function d(z){const B=new p.CancellationTokenSource,U=z(B.token),C=new Promise((X,W)=>{const T=B.token.onCancellationRequested(()=>{T.dispose(),B.dispose(),W((0,L.canceled)())});Promise.resolve(U).then(_=>{T.dispose(),B.dispose(),X(_)},_=>{T.dispose(),B.dispose(),W(_)})});return new class{cancel(){B.cancel()}then(X,W){return C.then(X,W)}catch(X){return this.then(void 0,X)}finally(X){return C.finally(X)}}}e.createCancelablePromise=d;function g(z,B,U){return Promise.race([z,new Promise(C=>B.onCancellationRequested(()=>C(U)))])}e.raceCancellation=g;async function i(z){let B=-1;const U=z.map((X,W)=>X.then(T=>(B=W,T))),C=await Promise.race(U);return z.forEach((X,W)=>{W!==B&&X.cancel()}),C}e.raceCancellablePromises=i;function I(z,B,U){let C;const X=setTimeout(()=>{C?.(void 0),U?.()},B);return Promise.race([z.finally(()=>clearTimeout(X)),new Promise(W=>C=W)])}e.raceTimeout=I;function S(z){return new Promise((B,U)=>{const C=z();b(C)?C.then(B,U):B(C)})}e.asPromise=S;class m{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const C=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,C};this.queuedPromise=new Promise(C=>{this.activePromise.then(U,U).then(C)})}return new Promise((U,C)=>{this.queuedPromise.then(U,C)})}return this.activePromise=B(),new Promise((U,C)=>{this.activePromise.then(X=>{this.activePromise=null,U(X)},X=>{this.activePromise=null,C(X)})})}}e.Throttler=m;class t{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}e.Sequencer=t;class h{constructor(){this.promiseMap=new Map}queue(B,U){const X=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(B)===X&&this.promiseMap.delete(B)});return this.promiseMap.set(B,X),X}}e.SequencerByKey=h;class E{constructor(B){this.defaultDelay=B,this.timeout=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,U=this.defaultDelay){return this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((C,X)=>{this.doResolve=C,this.doReject=X}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const C=this.task;return this.task=null,C()}})),this.timeout=setTimeout(()=>{this.timeout=null,this.doResolve&&this.doResolve(null)},U),this.completionPromise}isTriggered(){return this.timeout!==null}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject&&this.doReject((0,L.canceled)()),this.completionPromise=null)}cancelTimeout(){this.timeout!==null&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){this.cancel()}}e.Delayer=E;class v{constructor(B){this.delayer=new E(B),this.throttler=new m}trigger(B,U){return this.delayer.trigger(()=>this.throttler.queue(B),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=v;class y{constructor(){this._isOpen=!1,this._promise=new Promise((B,U)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=y;class u extends y{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function l(z,B){return B?new Promise((U,C)=>{const X=setTimeout(()=>{W.dispose(),U()},z),W=B.onCancellationRequested(()=>{clearTimeout(X),W.dispose(),C((0,L.canceled)())})}):d(U=>l(z,U))}e.timeout=l;function c(z,B=0){const U=setTimeout(z,B);return(0,M.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=c;function n(z){const B=[];let U=0;const C=z.length;function X(){return U<C?z[U++]():null}function W(T){T!=null&&B.push(T);const _=X();return _?_.then(W):Promise.resolve(B)}return Promise.resolve(null).then(W)}e.sequence=n;function o(z,B=C=>!!C,U=null){let C=0;const X=z.length,W=()=>{if(C>=X)return Promise.resolve(U);const T=z[C++];return Promise.resolve(T()).then(q=>B(q)?Promise.resolve(q):W())};return W()}e.first=o;function s(z,B=C=>!!C,U=null){if(z.length===0)return Promise.resolve(U);let C=z.length;const X=()=>{C=-1;for(const W of z)W.cancel?.()};return new Promise((W,T)=>{for(const _ of z)_.then(q=>{--C>=0&&B(q)?(X(),W(q)):C===0&&W(U)}).catch(q=>{--C>=0&&(X(),T(q))})})}e.firstParallel=s;class r{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onFinished=new D.Emitter}get onFinished(){return this._onFinished.event}get size(){return this._size}queue(B){return this._size++,new Promise((U,C)=>{this.outstandingPromises.push({factory:B,c:U,e:C}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const U=B.factory();U.then(B.c,B.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onFinished.fire()}dispose(){this._onFinished.dispose()}}e.Limiter=r;class a extends r{constructor(){super(1)}}e.Queue=a;class f{constructor(){this.queues=new Map}queueFor(B,U=P.extUri){const C=U.getComparisonKey(B);let X=this.queues.get(C);return X||(X=new a,D.Event.once(X.onFinished)(()=>{X?.dispose(),this.queues.delete(C)}),this.queues.set(C,X)),X}dispose(){this.queues.forEach(B=>B.dispose()),this.queues.clear()}}e.ResourceQueue=f;class w{constructor(B,U){this._token=-1,typeof B=="function"&&typeof U=="number"&&this.setIfNotSet(B,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},U)}setIfNotSet(B,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},U))}}e.TimeoutTimer=w;class k{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,U){this.cancel(),this._token=setInterval(()=>{B()},U)}}e.IntervalTimer=k;class R{constructor(B,U){this.timeoutToken=-1,this.runner=B,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner&&this.runner()}}e.RunOnceScheduler=R;class A{constructor(B,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner&&this.runner())}}e.ProcessTimeRunOnceScheduler=A;class O extends R{constructor(B,U){super(B,U);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner&&this.runner(B)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=O;class H extends M.Disposable{constructor(B,U,C,X){super();this.maxWorkChunkSize=B,this.maxPendingWork=U,this.throttleDelay=C,this.handler=X,this.pendingWork=[],this.throttler=this._register(new M.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.maxPendingWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.maxPendingWork)return!1}else if(this.pending+B.length-this.maxWorkChunkSize>this.maxPendingWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new R(()=>{this.throttler.clear(),this.doWork()},this.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=H,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=z=>{const B=setTimeout(()=>{const C=Date.now()+15;z(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,C-Date.now())}}))});let U=!1;return{dispose(){U||(U=!0,clearTimeout(B))}}}:e.runWhenIdle=(z,B)=>{const U=requestIdleCallback(z,typeof B=="number"?{timeout:B}:void 0);let C=!1;return{dispose(){C||(C=!0,cancelIdleCallback(U))}}}}();class x{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=x;async function re(z,B,U){let C;for(let X=0;X<U;X++)try{return await z()}catch(W){C=W,await l(B)}throw C}e.retry=re;class K{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,U,C){return this._pending={taskId:B,cancel:()=>C?.(),promise:U},U.then(()=>this.donePending(B),()=>this.donePending(B)),U}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let U,C;const X=new Promise((W,T)=>{U=W,C=T});this._next={run:B,promise:X,promiseResolve:U,promiseReject:C}}return this._next.promise}}e.TaskSequentializer=K;class ee{constructor(B){this.interval=B,this.lastIncrementTime=0,this.value=0}increment(){const B=Date.now();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}e.IntervalCounter=ee;class F{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,U)=>{this.completeCallback=B,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(U=>{this.completeCallback(B),this.resolved=!0,U()})}error(B){return new Promise(U=>{this.errorCallback(B),this.rejected=!0,U()})}cancel(){new Promise(B=>{this.errorCallback((0,L.canceled)()),this.rejected=!0,B()})}}e.DeferredPromise=F;var V;(function(z){async function B(C){let X;const W=await Promise.all(C.map(T=>T.then(_=>_,_=>{X||(X=_)})));if(typeof X!="undefined")throw X;return W}z.settled=B;function U(C){return new Promise(async(X,W)=>{try{await C(X,W)}catch(T){W(T)}})}z.withAsyncBody=U})(V=e.Promises||(e.Promises={}))}),define(Q[34],J([0,1,33,10,8,3,15,27,7]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getBaseLabel=e.getPathLabel=void 0;function g(r,a,f){if(typeof r=="string"&&(r=d.URI.file(r)),f){const k=f.getWorkspaceFolder(r);if(k){const R=f.getWorkspace().folders.length>1;let A;if((0,P.isEqual)(k.uri,r)?A="":A=(0,P.relativePath)(k.uri,r),R){const O=k.name?k.name:(0,P.basename)(k.uri);A=A?O+" \u2022 "+A:O}return A}}if(r.scheme!==L.Schemas.file&&r.scheme!==L.Schemas.untitled)return r.with({query:null,fragment:null}).toString(!0);if((0,p.hasDriveLetter)(r.fsPath))return(0,D.normalize)(I(r.fsPath));let w=(0,D.normalize)(r.fsPath);return!M.isWindows&&a?.userHome&&(w=m(w,a.userHome.fsPath)),w}e.getPathLabel=g;function i(r){if(!r)return;typeof r=="string"&&(r=d.URI.file(r));const a=(0,P.basename)(r)||(r.scheme===L.Schemas.file?r.fsPath:r.path);return M.isWindows&&(0,p.isRootOrDriveLetter)(a)?I(a):a}e.getBaseLabel=i;function I(r){return(0,p.hasDriveLetter)(r)?r.charAt(0).toUpperCase()+r.slice(1):r}e.normalizeDriveLetter=I;let S=Object.create(null);function m(r,a){if(M.isWindows||!r||!a)return r;let f=S.original===a?S.normalized:void 0;return f||(f=`${(0,b.rtrim)(a,D.posix.sep)}${D.posix.sep}`,S={original:a,normalized:f}),(M.isLinux?r.startsWith(f):(0,b.startsWithIgnoreCase)(r,f))&&(r=`~/${r.substr(f.length)}`),r}e.tildify=m;function t(r,a){return r.replace(/^~($|\/|\\)/,`${a}$1`)}e.untildify=t;const h="\u2026",E="\\\\",v="~";function y(r,a=D.sep){const f=new Array(r.length);let w=!1;for(let k=0;k<r.length;k++){let R=r[k];if(R===""){f[k]=`.${a}`;continue}if(!R){f[k]=R;continue}w=!0;let A="";R.indexOf(E)===0?(A=R.substr(0,R.indexOf(E)+E.length),R=R.substr(R.indexOf(E)+E.length)):R.indexOf(a)===0?(A=R.substr(0,R.indexOf(a)+a.length),R=R.substr(R.indexOf(a)+a.length)):R.indexOf(v)===0&&(A=R.substr(0,R.indexOf(v)+v.length),R=R.substr(R.indexOf(v)+v.length));const O=R.split(a);for(let H=1;w&&H<=O.length;H++)for(let x=O.length-H;w&&x>=0;x--){w=!1;let re=O.slice(x,x+H).join(a);for(let K=0;!w&&K<r.length;K++)if(K!==k&&r[K]&&r[K].indexOf(re)>-1){const ee=x+H===O.length,F=x>0&&r[K].indexOf(a)>-1?a+re:re,V=r[K].endsWith(F);w=!ee||V}if(!w){let K="";(O[0].endsWith(":")||A!=="")&&(x===1&&(x=0,H++,re=O[0]+a+re),x>0&&(K=O[0]+a),K=A+K),x>0&&(K=K+h+a),K=K+re,x+H<O.length&&(K=K+a+h),f[k]=K}}w&&(f[k]=R)}return f}e.shorten=y;var u;(function(r){r[r.TEXT=0]="TEXT",r[r.VARIABLE=1]="VARIABLE",r[r.SEPARATOR=2]="SEPARATOR"})(u||(u={}));function l(r,a=Object.create(null)){const f=[];let w=!1,k="";for(const R of r)if(R==="$"||w&&R==="{")k&&f.push({value:k,type:u.TEXT}),k="",w=!0;else if(R==="}"&&w){const A=a[k];if(typeof A=="string")A.length&&f.push({value:A,type:u.VARIABLE});else if(A){const O=f[f.length-1];(!O||O.type!==u.SEPARATOR)&&f.push({value:A.label,type:u.SEPARATOR})}k="",w=!1}else k+=R;return k&&!w&&f.push({value:k,type:u.TEXT}),f.filter((R,A)=>{if(R.type===u.SEPARATOR){const O=f[A-1],H=f[A+1];return[O,H].every(x=>x&&(x.type===u.VARIABLE||x.type===u.TEXT)&&x.value.length>0)}return!0}).map(R=>R.value).join("")}e.template=l;function c(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,"").replace(/&/g,M.isMacintosh?"&":"&&"):r.replace(/&&|&/g,f=>f==="&"?"&&":"&")}e.mnemonicMenuLabel=c;function n(r,a){return M.isMacintosh||a?r.replace(/\(&&\w\)|&&/g,""):M.isWindows?r.replace(/&&|&/g,f=>f==="&"?"&&":"&"):r.replace(/&&/g,"_")}e.mnemonicButtonLabel=n;function o(r){return r.replace(/&/g,"&&")}e.unmnemonicLabel=o;function s(r){const a=r.indexOf("/")!==-1?D.posix:D.win32,f=a.basename(r),w=a.dirname(r);return f.length?{name:f,parentPath:w}:{name:w,parentPath:""}}e.splitName=s}),define(Q[28],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const p=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function L(d){return p.test(d)}e.isUUID=L;const D=new Uint8Array(16),M=[];for(let d=0;d<256;d++)M.push(d.toString(16).padStart(2,"0"));let P;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?P=crypto.getRandomValues.bind(crypto):P=function(d){for(let g=0;g<d.length;g++)d[g]=Math.floor(Math.random()*256);return d};function b(){P(D),D[6]=D[6]&15|64,D[8]=D[8]&63|128;let d=0,g="";return g+=M[D[d++]],g+=M[D[d++]],g+=M[D[d++]],g+=M[D[d++]],g+="-",g+=M[D[d++]],g+=M[D[d++]],g+="-",g+=M[D[d++]],g+=M[D[d++]],g+="-",g+=M[D[d++]],g+=M[D[d++]],g+="-",g+=M[D[d++]],g+=M[D[d++]],g+=M[D[d++]],g+=M[D[d++]],g+=M[D[d++]],g+=M[D[d++]],g}e.generateUuid=b}),define(Q[111],J([0,1,60,31,42]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checksum=void 0;async function M(P,b){if(await new Promise((i,I)=>{const S=L.createReadStream(P),m=p.createHash("sha1");S.pipe(m);const t=(0,D.once)((h,E)=>{S.removeAllListeners(),m.removeAllListeners(),h?I(h):i(E)});S.once("error",t),S.once("end",t),m.once("error",t),m.once("data",h=>t(void 0,h.toString("hex")))})!==b)throw new Error("Hash mismatch")}e.checksum=M}),define(Q[112],J([0,1,240]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LineDecoder=void 0;class L{constructor(M="utf8"){this.stringDecoder=new p.StringDecoder(M),this.remaining=null}write(M){const P=[],b=this.remaining?this.remaining+this.stringDecoder.write(M):this.stringDecoder.write(M);if(b.length<1)return P;let d=0,g,i=d;for(;i<b.length;)if(g=b.charCodeAt(i),g===13||g===10){if(P.push(b.substring(d,i)),i++,i<b.length){const I=g;g=b.charCodeAt(i),(I===13&&g===10||I===10&&g===13)&&i++}d=i}else i++;return this.remaining=d<b.length?b.substr(d):null,P}end(){return this.remaining}}e.LineDecoder=L}),define(Q[113],J([0,1,25]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const L=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function D(b){const d=b.replace(/\-/g,":").toLowerCase();return!L.has(d)}function M(){return new Promise(async(b,d)=>{const g=setTimeout(()=>d("Unable to retrieve mac address (timeout after 10s)"),1e4);try{b(await P())}catch(i){d(i)}finally{clearTimeout(g)}})}e.getMac=M;function P(){return new Promise((b,d)=>{try{const g=(0,p.networkInterfaces)();for(let i in g){const I=g[i];if(I){for(const{mac:S}of I)if(D(S))return b(S)}}d("Unable to retrieve mac address (unexpected format)")}catch(g){d(g)}})}}),define(Q[70],J([0,1,25,18,40,28,113]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(i){return this._virtualMachineOUIs||(this._virtualMachineOUIs=D.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(i)}value(){if(this._value===void 0){let i=0,I=0;const S=(0,p.networkInterfaces)();for(let m in S){const t=S[m];if(t)for(const{mac:h,internal:E}of t)E||(I+=1,this._isVirtualMachineMacAddress(h.toUpperCase())&&(i+=1))}this._value=I>0?i/I:0}return this._value}};let b;async function d(){return b||(b=(async()=>await g()||M.generateUuid())()),b}e.getMachineId=d;async function g(){try{const i=await new Promise((S,m)=>{j(["crypto"],S,m)}),I=await(0,P.getMac)();return i.createHash("sha256").update(I,"utf8").digest("hex")}catch(i){L.onUnexpectedError(i);return}}}),define(Q[19],J([0,1,31,25,114,9,33,69,8,3,15,7,28]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var m;(function(F){F[F.UNLINK=0]="UNLINK",F[F.MOVE=1]="MOVE"})(m=e.RimRafMode||(e.RimRafMode={}));async function t(F,V=m.UNLINK){if((0,P.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");return V===m.UNLINK?E(F):h(F)}async function h(F){try{const V=(0,d.join)((0,L.tmpdir)(),(0,S.generateUuid)());try{await e.Promises.rename(F,V)}catch(z){return E(F)}E(V).catch(z=>{})}catch(V){if(V.code!=="ENOENT")throw V}}async function E(F){return e.Promises.rmdir(F,{recursive:!0,maxRetries:3})}function v(F){if((0,P.isRootOrDriveLetter)(F))throw new Error("rimraf - will refuse to recursively delete root");p.rmdirSync(F,{recursive:!0})}e.rimrafSync=v;async function y(F,V){return c(await(V?u(F):(0,D.promisify)(p.readdir)(F)))}async function u(F){try{return await(0,D.promisify)(p.readdir)(F,{withFileTypes:!0})}catch(B){console.warn("[node.js fs] readdir with filetypes failed with error: ",B)}const V=[],z=await y(F);for(const B of z){let U=!1,C=!1,X=!1;try{const W=await e.Promises.lstat((0,d.join)(F,B));U=W.isFile(),C=W.isDirectory(),X=W.isSymbolicLink()}catch(W){console.warn("[node.js fs] unexpected error from lstat after readdir: ",W)}V.push({name:B,isFile:()=>U,isDirectory:()=>C,isSymbolicLink:()=>X})}return V}function l(F){return c(p.readdirSync(F))}e.readdirSync=l;function c(F){return F.map(V=>typeof V=="string"?g.isMacintosh?(0,b.normalizeNFC)(V):V:(V.name=g.isMacintosh?(0,b.normalizeNFC)(V.name):V.name,V))}async function n(F){const V=await y(F),z=[];for(const B of V)await s.existsDirectory((0,d.join)(F,B))&&z.push(B);return z}function o(F,V=1e3){return new Promise(z=>{let B=!1;const U=setInterval(()=>{B||(B=!0,p.access(F,C=>{B=!1,C&&(clearInterval(U),z(void 0))}))},V)})}e.whenDeleted=o;var s;(function(F){async function V(U){let C;try{if(C=await e.Promises.lstat(U),!C.isSymbolicLink())return{stat:C}}catch(X){}try{return{stat:await e.Promises.stat(U),symbolicLink:C?.isSymbolicLink()?{dangling:!1}:void 0}}catch(X){if(X.code==="ENOENT"&&C)return{stat:C,symbolicLink:{dangling:!0}};if(g.isWindows&&X.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(U)),symbolicLink:{dangling:!1}}}catch(W){if(W.code==="ENOENT"&&C)return{stat:C,symbolicLink:{dangling:!0}};throw W}throw X}}F.stat=V;async function z(U){try{const{stat:C,symbolicLink:X}=await F.stat(U);return C.isFile()&&X?.dangling!==!0}catch(C){}return!1}F.existsFile=z;async function B(U){try{const{stat:C,symbolicLink:X}=await F.stat(U);return C.isDirectory()&&X?.dangling!==!0}catch(C){}return!1}F.existsDirectory=B})(s=e.SymlinkSupport||(e.SymlinkSupport={}));const r=new M.ResourceQueue;function a(F,V,z){return r.queueFor(I.URI.file(F),i.extUriBiasedIgnorePathCase).queue(()=>{const B=R(z);return new Promise((U,C)=>w(F,V,B,X=>X?C(X):U()))})}let f=!0;function w(F,V,z,B){if(!f)return p.writeFile(F,V,{mode:z.mode,flag:z.flag},B);p.open(F,z.flag,z.mode,(U,C)=>{if(U)return B(U);p.writeFile(C,V,X=>{if(X)return p.close(C,()=>B(X));p.fdatasync(C,W=>(W&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",W),f=!1),p.close(C,T=>B(T))))})})}function k(F,V,z){const B=R(z);if(!f)return p.writeFileSync(F,V,{mode:B.mode,flag:B.flag});const U=p.openSync(F,B.flag,B.mode);try{p.writeFileSync(U,V);try{p.fdatasyncSync(U)}catch(C){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",C),f=!1}}finally{p.closeSync(U)}}e.writeFileSync=k;function R(F){return F?{mode:typeof F.mode=="number"?F.mode:438,flag:typeof F.flag=="string"?F.flag:"w"}:{mode:438,flag:"w"}}async function A(F,V){if(F===V)return;async function z(B){try{const U=await e.Promises.lstat(B);if(U.isDirectory()||U.isSymbolicLink())return;await e.Promises.utimes(B,U.atime,new Date)}catch(U){}}try{await e.Promises.rename(F,V),await z(V)}catch(B){if(F.toLowerCase()!==V.toLowerCase()&&B.code==="EXDEV"||F.endsWith("."))await O(F,V,{preserveSymlinks:!1}),await t(F,m.MOVE),await z(V);else throw B}}async function O(F,V,z){return x(F,V,{root:{source:F,target:V},options:z,handledSourcePaths:new Set})}const H=511;async function x(F,V,z){if(z.handledSourcePaths.has(F))return;z.handledSourcePaths.add(F);const{stat:B,symbolicLink:U}=await s.stat(F);if(U){if(z.options.preserveSymlinks)try{return await ee(F,V,z)}catch(C){console.warn("[node.js fs] copy of symlink failed: ",C)}if(U.dangling)return}return B.isDirectory()?re(F,V,B.mode&H,z):K(F,V,B.mode&H)}async function re(F,V,z,B){await e.Promises.mkdir(V,{recursive:!0,mode:z});const U=await y(F);for(const C of U)await x((0,d.join)(F,C),(0,d.join)(V,C),B)}async function K(F,V,z){await e.Promises.copyFile(F,V),await e.Promises.chmod(V,z)}async function ee(F,V,z){let B=await e.Promises.readlink(F);(0,P.isEqualOrParent)(B,z.root.source,!g.isLinux)&&(B=(0,d.join)(z.root.target,B.substr(z.root.source.length+1))),await e.Promises.symlink(B,V)}e.Promises=new class{get access(){return(0,D.promisify)(p.access)}get stat(){return(0,D.promisify)(p.stat)}get lstat(){return(0,D.promisify)(p.lstat)}get utimes(){return(0,D.promisify)(p.utimes)}get read(){return(0,D.promisify)(p.read)}get readFile(){return(0,D.promisify)(p.readFile)}get write(){return(0,D.promisify)(p.write)}get appendFile(){return(0,D.promisify)(p.appendFile)}get fdatasync(){return(0,D.promisify)(p.fdatasync)}get truncate(){return(0,D.promisify)(p.truncate)}get rename(){return(0,D.promisify)(p.rename)}get copyFile(){return(0,D.promisify)(p.copyFile)}get open(){return(0,D.promisify)(p.open)}get close(){return(0,D.promisify)(p.close)}get symlink(){return(0,D.promisify)(p.symlink)}get readlink(){return(0,D.promisify)(p.readlink)}get chmod(){return(0,D.promisify)(p.chmod)}get mkdir(){return(0,D.promisify)(p.mkdir)}get unlink(){return(0,D.promisify)(p.unlink)}get rmdir(){return(0,D.promisify)(p.rmdir)}get realpath(){return(0,D.promisify)(p.realpath)}async exists(F){try{return await e.Promises.access(F),!0}catch{return!1}}get readdir(){return y}get readDirsInDir(){return n}get writeFile(){return a}get rm(){return t}get move(){return A}get copy(){return O}}}),define(Q[83],J([0,1,31,8,27,19]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcaseSync=void 0;function P(i){const I=(0,L.dirname)(i);if(i===I)return i;const S=((0,L.basename)(i)||i).toLowerCase();try{const t=(0,M.readdirSync)(I).filter(h=>h.toLowerCase()===S);if(t.length===1){const h=P(I);if(h)return(0,L.join)(h,t[0])}else if(t.length>1){const h=t.indexOf(S);if(h>=0){const E=P(I);if(E)return(0,L.join)(E,t[h])}}}catch(m){}return null}e.realcaseSync=P;async function b(i){try{return await M.Promises.realpath(i)}catch(I){const S=g(i);return await M.Promises.access(S,p.constants.R_OK),S}}e.realpath=b;function d(i){try{return p.realpathSync(i)}catch(I){const S=g(i);return p.accessSync(S,p.constants.R_OK),S}}e.realpathSync=d;function g(i){return(0,D.rtrim)((0,L.normalize)(i),L.sep)}}),define(Q[115],J([0,1,61]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.findFreePort=void 0;function L(b,d,g,i=1){let I=!1;return new Promise(S=>{const m=setTimeout(()=>{if(!I)return I=!0,S(0)},g);D(b,d,i,t=>{if(!I)return I=!0,clearTimeout(m),S(t)})})}e.findFreePort=L;function D(b,d,g,i){if(d===0)return i(0);const I=new p.Socket;I.once("connect",()=>(P(I),D(b+g,d-1,g,i))),I.once("data",()=>{}),I.once("error",S=>(P(I),S.code!=="ECONNREFUSED"?D(b+g,d-1,g,i):i(b))),I.connect(b,"127.0.0.1")}function M(b,d,g){let i=!1,I,S=1;const m=p.createServer({pauseOnConnect:!0});function t(h,E){i||(i=!0,m.removeAllListeners(),m.close(),I&&clearTimeout(I),E(h))}return new Promise(h=>{I=setTimeout(()=>{t(0,h)},g),m.on("listening",()=>{t(b,h)}),m.on("error",E=>{E&&(E.code==="EADDRINUSE"||E.code==="EACCES")&&S<d?(b++,S++,m.listen(b,"127.0.0.1")):t(0,h)}),m.on("close",()=>{t(0,h)}),m.listen(b,"127.0.0.1")})}e.findFreePortFaster=M;function P(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(d){console.error(d)}}}),define(Q[116],J([0,1,25,8,19]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const M=/^\d+$/,P=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var d;(function(l){l[l.x64=0]="x64",l[l.x86=1]="x86",l[l.ARM=2]="ARM"})(d||(d={}));let g;switch(process.arch){case"ia32":case"x32":g=1;break;case"arm":case"arm64":g=2;break;default:g=0;break}let i;process.env.PROCESSOR_ARCHITEW6432?i=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?i=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?i=1:i=0;class I{constructor(c,n,o){this.exePath=c,this.displayName=n,this.knownToExist=o}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await D.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function S({useAlternateBitness:l=!1}={}){return l?g===0?process.env["ProgramFiles(x86)"]||null:i===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function m({useAlternateBitness:l=!1,findPreview:c=!1}={}){const n=S({useAlternateBitness:l});if(!n)return null;const o=L.join(n,"PowerShell");if(!await D.SymlinkSupport.existsDirectory(o))return null;let s=-1,r=null;for(const w of await D.Promises.readdir(o)){let k=-1;if(c){const A=w.indexOf("-");if(A<0)continue;const O=w.substring(0,A);if(!M.test(O)||w.substring(A+1)!=="preview")continue;k=parseInt(O,10)}else{if(!M.test(w))continue;k=parseInt(w,10)}if(k<=s)continue;const R=L.join(o,w,"pwsh.exe");!await D.SymlinkSupport.existsFile(R)||(r=R,s=k)}if(!r)return null;const a=n.includes("x86")?" (x86)":"",f=c?" Preview":"";return new I(r,`PowerShell${f}${a}`,!0)}async function t({findPreview:l}={}){if(!process.env.LOCALAPPDATA)return null;const c=L.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await D.SymlinkSupport.existsDirectory(c))return null;const{pwshMsixDirRegex:n,pwshMsixName:o}=l?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:P,pwshMsixName:"PowerShell (Store)"};for(const s of await D.Promises.readdir(c))if(n.test(s)){const r=L.join(c,s,"pwsh.exe");return new I(r,o)}return null}function h(){const l=L.join(p.homedir(),".dotnet","tools","pwsh.exe");return new I(l,".NET Core PowerShell Global Tool")}function E(){const l=L.join(process.env.windir,g===1&&i!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new I(l,"Windows PowerShell",!0)}async function*v(){let l=await m();l&&(yield l),l=await m({useAlternateBitness:!0}),l&&(yield l),l=await t(),l&&(yield l),l=h(),l&&(yield l),l=await m({findPreview:!0}),l&&(yield l),l=await t({findPreview:!0}),l&&(yield l),l=await m({useAlternateBitness:!0,findPreview:!0}),l&&(yield l),l=E(),l&&(yield l)}async function*y(){for await(const l of v())await l.exists()&&(yield l)}e.enumeratePowerShellInstallations=y;async function u(){for await(const l of y())return l;return null}e.getFirstAvailablePowerShellInstallation=u}),define(Q[84],J([0,1,44,10]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function D(P){return new Promise((b,d)=>{let g;const i=new Map;function I(m,t,h,E,v){const y=i.get(t);if(m===P||y){const u={name:S(h),cmd:h,pid:m,ppid:t,load:E,mem:v};i.set(m,u),m===P&&(g=u),y&&(y.children||(y.children=[]),y.children.push(u),y.children.length>1&&(y.children=y.children.sort((l,c)=>l.pid-c.pid)))}}function S(m){const t=/--disable-blink-features=Auxclick/,h=/\\watcher\\win32\\CodeHelper\.exe/,E=/--crashes-directory/,v=/\\pipe\\winpty-control/,y=/conhost\.exe/,u=/--type=([a-zA-Z-]+)/;if(h.exec(m))return"watcherService ";if(E.exec(m))return"electron-crash-reporter";if(v.exec(m))return"winpty-process";if(y.exec(m))return"console-window-host (Windows internal process)";let l=u.exec(m);if(l&&l.length===2)return l[1]==="renderer"?t.exec(m)?"shared-process":"window":l[1];const c=/[a-zA-Z-]+\.js/g;let n="";do l=c.exec(m),l&&(n+=l+" ");while(l);return n&&m.indexOf("node ")<0&&m.indexOf("node.exe")<0?`electron_node ${n}`:m}if(process.platform==="win32"){const m=t=>t.indexOf("\\\\?\\")===0||t.indexOf("\\??\\")===0?t.substr(4):t.indexOf('"\\\\?\\')===0||t.indexOf('"\\??\\')===0?'"'+t.substr(5):t;new Promise((t,h)=>{j(["windows-process-tree"],t,h)}).then(t=>{t.getProcessList(P,h=>{t.getProcessCpuUsage(h,E=>{const v=new Map;E.forEach(y=>{const u=m(y.commandLine||"");v.set(y.pid,{name:S(u),cmd:u,pid:y.pid,ppid:y.ppid,load:y.cpu||0,mem:y.memory||0})}),g=v.get(P),g?(v.forEach(y=>{const u=v.get(y.ppid);u&&(u.children||(u.children=[]),u.children.push(y))}),v.forEach(y=>{y.children&&(y.children=y.children.sort((u,l)=>u.pid-l.pid))}),b(g)):d(new Error(`Root process ${P} not found`))})},t.ProcessDataFlag.CommandLine|t.ProcessDataFlag.Memory)})}else{let m=function(){let t=[g];const h=[];for(;t.length;){const v=t.shift();v&&(h.push(v.pid),v.children&&(t=t.concat(v.children)))}let E=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",j).fsPath);E+=" "+h.join(" "),(0,p.exec)(E,{},(v,y,u)=>{if(v||u)d(v||new Error(u.toString()));else{const l=y.toString().split(`
`);for(let c=0;c<h.length;c++){const n=i.get(h[c]);n.load=parseFloat(l[c])}if(!g){d(new Error(`Root process ${P} not found`));return}b(g)}})};(0,p.exec)("which ps",{},(t,h,E)=>{if(t||E)if(process.platform!=="linux")d(t||new Error(E.toString()));else{const v=JSON.stringify(L.FileAccess.asFileUri("vs/base/node/ps.sh",j).fsPath);(0,p.exec)(v,{},(y,u,l)=>{y||l?d(y||new Error(l.toString())):(M(u,I),m())})}else{const v=h.toString().trim(),y="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,p.exec)(`${v} ${y}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(u,l,c)=>{u||c&&!c.includes("screen size is bogus")?d(u||new Error(c.toString())):(M(l,I),process.platform==="linux"?m():g?b(g):d(new Error(`Root process ${P} not found`)))})}})}})}e.listProcesses=D;function M(P,b){const d=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,g=P.toString().split(`
`);for(const i of g){const I=d.exec(i.trim());I&&I.length===6&&b(parseInt(I[1]),parseInt(I[2]),I[5],parseFloat(I[3]),parseFloat(I[4]))}}}),define(Q[117],J([0,1,31,23,33,2,69,8,3,19]),function(j,e,p,L,D,M,P,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.CHANGE_BUFFER_DELAY=e.watchFolder=e.watchFile=void 0;function i(t,h,E){return S({path:t,isDirectory:!1},h,E)}e.watchFile=i;function I(t,h,E){return S({path:t,isDirectory:!0},h,E)}e.watchFolder=I,e.CHANGE_BUFFER_DELAY=100;function S(t,h,E){if(d.isMacintosh&&(0,D.isEqualOrParent)(t.path,"/Volumes/"))return E(`Refusing to watch ${t.path} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),M.Disposable.None;const v=(0,b.basename)(t.path),y=new Map;let u=!1,l=[(0,M.toDisposable)(()=>{y.forEach(c=>(0,M.dispose)(c)),y.clear()})];try{const c=(0,p.watch)(t.path);l.push((0,M.toDisposable)(()=>{c.removeAllListeners(),c.close()}));const n=new Set;t.isDirectory&&g.Promises.readdir(t.path).then(o=>o.forEach(s=>n.add(s))),c.on("error",(o,s)=>{u||E(`Failed to watch ${t.path} for changes using fs.watch() (${o}, ${s})`)}),c.on("change",(o,s)=>{if(u)return;let r="";if(s&&(r=s.toString(),d.isMacintosh&&(r=(0,P.normalizeNFC)(r))),!r||o!=="change"&&o!=="rename")return;const a=t.isDirectory?(0,b.join)(t.path,r):t.path;if(t.isDirectory)if(o==="rename"){const f=y.get(a);f&&(0,M.dispose)(f);const w=setTimeout(async()=>{y.delete(a);const k=await g.Promises.exists(a);if(u)return;let R;k?n.has(r)?R="changed":(R="added",n.add(r)):(n.delete(r),R="deleted"),h(R,a)},e.CHANGE_BUFFER_DELAY);y.set(a,(0,M.toDisposable)(()=>clearTimeout(w)))}else{let f;n.has(r)?f="changed":(f="added",n.add(r)),h(f,a)}else if(o==="rename"||r!==v){const f=setTimeout(async()=>{const w=await g.Promises.exists(a);u||(w?(h("changed",a),l=[S(t,h,E)]):h("deleted",a))},e.CHANGE_BUFFER_DELAY);(0,M.dispose)(l),l=[(0,M.toDisposable)(()=>clearTimeout(f))]}else h("changed",a)})}catch(c){g.Promises.exists(t.path).then(n=>{n&&!u&&E(`Failed to watch ${t.path} for changes using fs.watch() (${c.toString()})`)})}return(0,M.toDisposable)(()=>{u=!0,l=(0,M.dispose)(l)})}async function m(t,h,E,v=512){const y=await g.Promises.open(t,"r"),u=Buffer.allocUnsafe(v),l=new L.CancellationTokenSource(E);let c,n=!1;const o=i(t,async s=>{if(s==="changed"){if(n)return;n=!0;try{for(;!l.token.isCancellationRequested;){const{bytesRead:r}=await g.Promises.read(y,u,0,v,null);if(!r||l.token.isCancellationRequested)break;h(u.slice(0,r))}}catch(r){c=new Error(r),l.dispose(!0)}finally{n=!1}}},s=>{c=new Error(s),l.dispose(!0)});return new Promise((s,r)=>{l.token.onCancellationRequested(async()=>{o.dispose(),await g.Promises.close(y),c?r(c):s()})})}e.watchFileContents=m}),define(Q[118],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CONTEXT_MENU_CLOSE_CHANNEL=e.CONTEXT_MENU_CHANNEL=void 0,e.CONTEXT_MENU_CHANNEL="vscode:contextmenu",e.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(Q[119],J([0,1,13,14,118]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerContextMenuListener=void 0;function M(){p.ipcMain.on(D.CONTEXT_MENU_CHANNEL,(b,d,g,i,I)=>{const S=P(b,i,g);S.popup({window:(0,L.withNullAsUndefined)(p.BrowserWindow.fromWebContents(b.sender)),x:I?I.x:void 0,y:I?I.y:void 0,positioningItem:I?I.positioningItem:void 0,callback:()=>{S&&b.sender.send(D.CONTEXT_MENU_CLOSE_CHANNEL,d)}})})}e.registerContextMenuListener=M;function P(b,d,g){const i=new p.Menu;return g.forEach(I=>{let S;I.type==="separator"?S=new p.MenuItem({type:I.type}):Array.isArray(I.submenu)?S=new p.MenuItem({submenu:P(b,d,I.submenu),label:I.label}):S=new p.MenuItem({label:I.label,type:I.type,accelerator:I.accelerator,checked:I.checked,enabled:I.enabled,visible:I.visible,click:(m,t,h)=>b.sender.send(d,I.id,h)}),i.append(S)}),i}});var he=this&&this.__decorate||function(j,e,p,L){var D=arguments.length,M=D<3?e:L===null?L=Object.getOwnPropertyDescriptor(e,p):L,P;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")M=Reflect.decorate(j,e,p,L);else for(var b=j.length-1;b>=0;b--)(P=j[b])&&(M=(D<3?P(M):D>3?P(e,p,M):P(e,p))||M);return D>3&&M&&Object.defineProperty(e,p,M),M};define(Q[35],J([0,1,30,9,16,23,47,18,4,2,110,27,14]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var m;(function(U){U[U.Promise=100]="Promise",U[U.PromiseCancel=101]="PromiseCancel",U[U.EventListen=102]="EventListen",U[U.EventDispose=103]="EventDispose"})(m=e.RequestType||(e.RequestType={}));function t(U){switch(U){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var h;(function(U){U[U.Initialize=200]="Initialize",U[U.PromiseSuccess=201]="PromiseSuccess",U[U.PromiseError=202]="PromiseError",U[U.PromiseErrorObj=203]="PromiseErrorObj",U[U.EventFire=204]="EventFire"})(h=e.ResponseType||(e.ResponseType={}));function E(U){switch(U){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var v;(function(U){U[U.Uninitialized=0]="Uninitialized",U[U.Idle=1]="Idle"})(v||(v={}));class y{constructor(C){this.buffer=C,this.pos=0}read(C){const X=this.buffer.slice(this.pos,this.pos+C);return this.pos+=X.byteLength,X}}class u{constructor(){this.buffers=[]}get buffer(){return D.VSBuffer.concat(this.buffers)}write(C){this.buffers.push(C)}}var l;(function(U){U[U.Undefined=0]="Undefined",U[U.String=1]="String",U[U.Buffer=2]="Buffer",U[U.VSBuffer=3]="VSBuffer",U[U.Array=4]="Array",U[U.Object=5]="Object"})(l||(l={}));function c(U){const C=D.VSBuffer.alloc(4);return C.writeUInt32BE(U,0),C}function n(U){return U.read(4).readUInt32BE(0)}function o(U){const C=D.VSBuffer.alloc(1);return C.writeUInt8(U,0),C}const s={Undefined:o(l.Undefined),String:o(l.String),Buffer:o(l.Buffer),VSBuffer:o(l.VSBuffer),Array:o(l.Array),Object:o(l.Object)},r=typeof Buffer!="undefined";function a(U,C){if(typeof C=="undefined")U.write(s.Undefined);else if(typeof C=="string"){const X=D.VSBuffer.fromString(C);U.write(s.String),U.write(c(X.byteLength)),U.write(X)}else if(r&&Buffer.isBuffer(C)){const X=D.VSBuffer.wrap(C);U.write(s.Buffer),U.write(c(X.byteLength)),U.write(X)}else if(C instanceof D.VSBuffer)U.write(s.VSBuffer),U.write(c(C.byteLength)),U.write(C);else if(Array.isArray(C)){U.write(s.Array),U.write(c(C.length));for(const X of C)a(U,X)}else{const X=D.VSBuffer.fromString(JSON.stringify(C));U.write(s.Object),U.write(c(X.byteLength)),U.write(X)}}function f(U){switch(U.read(1).readUInt8(0)){case l.Undefined:return;case l.String:return U.read(n(U)).toString();case l.Buffer:return U.read(n(U)).buffer;case l.VSBuffer:return U.read(n(U));case l.Array:{const X=n(U),W=[];for(let T=0;T<X;T++)W.push(f(U));return W}case l.Object:return JSON.parse(U.read(n(U)).toString())}}class w{constructor(C,X,W=null,T=1e3){this.protocol=C,this.ctx=X,this.logger=W,this.timeoutDelay=T,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(_=>this.onRawMessage(_)),this.sendResponse({type:200})}registerChannel(C,X){this.channels.set(C,X),setTimeout(()=>this.flushPendingRequests(C),0)}sendResponse(C){switch(C.type){case 200:{const X=this.send([C.type]);this.logger&&this.logger.logOutgoing(X,0,1,E(C.type));return}case 201:case 202:case 204:case 203:{const X=this.send([C.type,C.id],C.data);this.logger&&this.logger.logOutgoing(X,C.id,1,E(C.type),C.data);return}}}send(C,X=void 0){const W=new u;return a(W,C),a(W,X),this.sendBuffer(W.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch(X){return 0}}onRawMessage(C){const X=new y(C),W=f(X),T=f(X),_=W[0];switch(_){case 100:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(_)}: ${W[2]}.${W[3]}`,T),this.onPromise({type:_,id:W[1],channelName:W[2],name:W[3],arg:T});case 102:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(_)}: ${W[2]}.${W[3]}`,T),this.onEventListen({type:_,id:W[1],channelName:W[2],name:W[3],arg:T});case 101:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(_)}`),this.disposeActiveRequest({type:_,id:W[1]});case 103:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],1,`${t(_)}`),this.disposeActiveRequest({type:_,id:W[1]})}}onPromise(C){const X=this.channels.get(C.channelName);if(!X){this.collectPendingRequest(C);return}const W=new M.CancellationTokenSource;let T;try{T=X.call(this.ctx,C.name,C.arg,W.token)}catch(Y){T=Promise.reject(Y)}const _=C.id;T.then(Y=>{this.sendResponse({id:_,data:Y,type:201}),this.activeRequests.delete(C.id)},Y=>{Y instanceof Error?this.sendResponse({id:_,data:{message:Y.message,name:Y.name,stack:Y.stack?Y.stack.split?Y.stack.split(`
`):Y.stack:void 0},type:202}):this.sendResponse({id:_,data:Y,type:203}),this.activeRequests.delete(C.id)});const q=(0,g.toDisposable)(()=>W.cancel());this.activeRequests.set(C.id,q)}onEventListen(C){const X=this.channels.get(C.channelName);if(!X){this.collectPendingRequest(C);return}const W=C.id,_=X.listen(this.ctx,C.name,C.arg)(q=>this.sendResponse({id:W,data:q,type:204}));this.activeRequests.set(C.id,_)}disposeActiveRequest(C){const X=this.activeRequests.get(C.id);X&&(X.dispose(),this.activeRequests.delete(C.id))}collectPendingRequest(C){let X=this.pendingRequests.get(C.channelName);X||(X=[],this.pendingRequests.set(C.channelName,X));const W=setTimeout(()=>{console.error(`Unknown channel: ${C.channelName}`),C.type===100&&this.sendResponse({id:C.id,data:{name:"Unknown channel",message:`Channel name '${C.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);X.push({request:C,timeoutTimer:W})}flushPendingRequests(C){const X=this.pendingRequests.get(C);if(X){for(const W of X)switch(clearTimeout(W.timeoutTimer),W.request.type){case 100:this.onPromise(W.request);break;case 102:this.onEventListen(W.request);break}this.pendingRequests.delete(C)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(C=>C.dispose()),this.activeRequests.clear()}}e.ChannelServer=w;var k;(function(U){U[U.LocalSide=0]="LocalSide",U[U.OtherSide=1]="OtherSide"})(k=e.RequestInitiator||(e.RequestInitiator={}));class R{constructor(C,X=null){this.protocol=C,this.isDisposed=!1,this.state=v.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new d.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(W=>this.onBuffer(W)),this.logger=X}getChannel(C){const X=this;return{call(W,T,_){return X.isDisposed?Promise.reject(b.canceled()):X.requestPromise(C,W,T,_)},listen(W,T){return X.isDisposed?Promise.reject(b.canceled()):X.requestEvent(C,W,T)}}}requestPromise(C,X,W,T=M.CancellationToken.None){const _=this.lastRequestId++,Y={id:_,type:100,channelName:C,name:X,arg:W};if(T.isCancellationRequested)return Promise.reject(b.canceled());let $;return new Promise((Z,ie)=>{if(T.isCancellationRequested)return ie(b.canceled());const oe=()=>{const ue=de=>{switch(de.type){case 201:this.handlers.delete(_),Z(de.data);break;case 202:this.handlers.delete(_);const ve=new Error(de.data.message);ve.stack=de.data.stack,ve.name=de.data.name,ie(ve);break;case 203:this.handlers.delete(_),ie(de.data);break}};this.handlers.set(_,ue),this.sendRequest(Y)};let le=null;this.state===v.Idle?oe():(le=(0,L.createCancelablePromise)(ue=>this.whenInitialized()),le.then(()=>{le=null,oe()}));const ne=()=>{le?(le.cancel(),le=null):this.sendRequest({id:_,type:101}),ie(b.canceled())},ae=T.onCancellationRequested(ne);$=(0,g.combinedDisposable)((0,g.toDisposable)(ne),ae),this.activeRequests.add($)}).finally(()=>{this.activeRequests.delete($)})}requestEvent(C,X,W){const T=this.lastRequestId++,q={id:T,type:102,channelName:C,name:X,arg:W};let Y=null;const $=new d.Emitter({onFirstListenerAdd:()=>{Y=(0,L.createCancelablePromise)(Z=>this.whenInitialized()),Y.then(()=>{Y=null,this.activeRequests.add($),this.sendRequest(q)})},onLastListenerRemove:()=>{Y?(Y.cancel(),Y=null):(this.activeRequests.delete($),this.sendRequest({id:T,type:103}))}}),N=Z=>$.fire(Z.data);return this.handlers.set(T,N),$.event}sendRequest(C){switch(C.type){case 100:case 102:{const X=this.send([C.type,C.id,C.channelName,C.name],C.arg);this.logger&&this.logger.logOutgoing(X,C.id,0,`${t(C.type)}: ${C.channelName}.${C.name}`,C.arg);return}case 101:case 103:{const X=this.send([C.type,C.id]);this.logger&&this.logger.logOutgoing(X,C.id,0,t(C.type));return}}}send(C,X=void 0){const W=new u;return a(W,C),a(W,X),this.sendBuffer(W.buffer)}sendBuffer(C){try{return this.protocol.send(C),C.byteLength}catch(X){return 0}}onBuffer(C){const X=new y(C),W=f(X),T=f(X),_=W[0];switch(_){case 200:return this.logger&&this.logger.logIncoming(C.byteLength,0,0,E(_)),this.onResponse({type:W[0]});case 201:case 202:case 204:case 203:return this.logger&&this.logger.logIncoming(C.byteLength,W[1],0,E(_),T),this.onResponse({type:W[0],id:W[1],data:T})}}onResponse(C){if(C.type===200){this.state=v.Idle,this._onDidInitialize.fire();return}const X=this.handlers.get(C.id);X&&X(C)}get onDidInitializePromise(){return d.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===v.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),this.activeRequests.forEach(C=>C.dispose()),this.activeRequests.clear()}}he([P.memoize],R.prototype,"onDidInitializePromise",null),e.ChannelClient=R;class A{constructor(C){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new d.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new d.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,C(({protocol:X,onDidClientDisconnect:W})=>{d.Event.once(X.onMessage)(_=>{const q=new y(_),Y=f(q),$=new w(X,Y),N=new R(X);this.channels.forEach((ie,oe)=>$.registerChannel(oe,ie));const Z={channelServer:$,channelClient:N,ctx:Y};this._connections.add(Z),this._onDidAddConnection.fire(Z),W(()=>{$.dispose(),N.dispose(),this._connections.delete(Z),this._onDidRemoveConnection.fire(Z)})})})}get connections(){const C=[];return this._connections.forEach(X=>C.push(X)),C}getChannel(C,X){const W=this;return{call(T,_,q){let Y;if((0,S.isFunction)(X)){let N=(0,p.getRandomElement)(W.connections.filter(X));Y=N?Promise.resolve(N):d.Event.toPromise(d.Event.filter(W.onDidAddConnection,X))}else Y=X.routeCall(W,T,_);const $=Y.then(N=>N.channelClient.getChannel(C));return H($).call(T,_,q)},listen(T,_){if((0,S.isFunction)(X))return W.getMulticastEvent(C,X,T,_);const q=X.routeEvent(W,T,_).then(Y=>Y.channelClient.getChannel(C));return H(q).listen(T,_)}}}getMulticastEvent(C,X,W,T){const _=this;let q=new g.DisposableStore;const Y=new d.Emitter({onFirstListenerAdd:()=>{q=new g.DisposableStore;const $=new d.EventMultiplexer,N=new Map,Z=oe=>{const ne=oe.channelClient.getChannel(C).listen(W,T),ae=$.add(ne);N.set(oe,ae)},ie=oe=>{const le=N.get(oe);!le||(le.dispose(),N.delete(oe))};_.connections.filter(X).forEach(Z),d.Event.filter(_.onDidAddConnection,X)(Z,void 0,q),_.onDidRemoveConnection(ie,void 0,q),$.event(Y.fire,Y,q),q.add($)},onLastListenerRemove:()=>{q.dispose()}});return Y.event}registerChannel(C,X){this.channels.set(C,X),this._connections.forEach(W=>{W.channelServer.registerChannel(C,X)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=A;class O{constructor(C,X,W=null){const T=new u;a(T,X),C.send(T.buffer),this.channelClient=new R(C,W),this.channelServer=new w(C,X,W)}getChannel(C){return this.channelClient.getChannel(C)}registerChannel(C,X){this.channelServer.registerChannel(C,X)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=O;function H(U){return{call(C,X,W){return U.then(T=>T.call(C,X,W))},listen(C,X){const W=new d.Relay;return U.then(T=>W.input=T.listen(C,X)),W.event}}}e.getDelayedChannel=H;function x(U){let C=!1;return{call(X,W,T){return C?U.call(X,W,T):(0,L.timeout)(0).then(()=>C=!0).then(()=>U.call(X,W,T))},listen(X,W){if(C)return U.listen(X,W);const T=new d.Relay;return(0,L.timeout)(0).then(()=>C=!0).then(()=>T.input=U.listen(X,W)),T.event}}}e.getNextTickChannel=x;class re{constructor(C){this.fn=C}routeCall(C){return this.route(C)}routeEvent(C){return this.route(C)}async route(C){for(const X of C.connections)if(await Promise.resolve(this.fn(X.ctx)))return Promise.resolve(X);return await d.Event.toPromise(C.onDidAddConnection),await this.route(C)}}e.StaticRouter=re;var K;(function(U){function C(_,q){const Y=_,$=q&&q.disableMarshalling,N=new Map;for(const Z in Y)W(Z)&&N.set(Z,d.Event.buffer(Y[Z],!0));return new class{listen(Z,ie,oe){const le=N.get(ie);if(le)return le;if(T(ie)){const ne=Y[ie];if(typeof ne=="function")return ne.call(Y,oe)}throw new Error(`Event not found: ${ie}`)}call(Z,ie,oe){const le=Y[ie];if(typeof le=="function"){if(!$&&Array.isArray(oe))for(let ne=0;ne<oe.length;ne++)oe[ne]=(0,i.revive)(oe[ne]);return le.apply(Y,oe)}throw new Error(`Method not found: ${ie}`)}}}U.fromService=C;function X(_,q){const Y=q&&q.disableMarshalling;return new Proxy({},{get($,N){if(typeof N=="string")return q?.properties?.has(N)?q.properties.get(N):T(N)?function(Z){return _.listen(N,Z)}:W(N)?_.listen(N):async function(...Z){let ie;q&&!(0,S.isUndefinedOrNull)(q.context)?ie=[q.context,...Z]:ie=Z;const oe=await _.call(N,ie);return Y?oe:(0,i.revive)(oe)};throw new Error(`Property not found: ${String(N)}`)}})}U.toService=X;function W(_){return _[0]==="o"&&_[1]==="n"&&I.isUpperAsciiLetter(_.charCodeAt(2))}function T(_){return/^onDynamic/.test(_)&&I.isUpperAsciiLetter(_.charCodeAt(9))}})(K=e.ProxyChannel||(e.ProxyChannel={}));const ee=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function F(U){if(Array.isArray(U))return U;if(U&&typeof U=="object"&&typeof U.toString=="function"){let C=U.toString();if(C!=="[object Object]")return C}return U}function V(U){return Array.isArray(U)?U.map(F):F(U)}function z(U,C,X,W,T,_,q){q=V(q);const Y=ee[T],$=Y[W%Y.length];let N=[`%c[${U}]%c[${String(C).padStart(7," ")}]%c[len: ${String(X).padStart(5," ")}]%c${String(W).padStart(5," ")} - ${_}`,"color: darkgreen","color: grey","color: grey",`color: ${$}`];/\($/.test(_)?(N=N.concat(q),N.push(")")):N.push(q),console.log.apply(console,N)}e.logWithColors=z;class B{constructor(C,X){this._outgoingPrefix=C,this._incomingPrefix=X,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(C,X,W,T,_){this._totalOutgoing+=C,z(this._outgoingPrefix,this._totalOutgoing,C,X,W,T,_)}logIncoming(C,X,W,T,_){this._totalIncoming+=C,z(this._incomingPrefix,this._totalIncoming,C,X,W,T,_)}}e.IPCLogger=B}),define(Q[120],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Protocol=void 0;class p{constructor(D,M){this.sender=D,this.onMessage=M}send(D){try{this.sender.send("vscode:message",D.buffer)}catch(M){}}disconnect(){this.sender.send("vscode:disconnect",null)}}e.Protocol=p}),define(Q[121],J([0,1,16,4,35]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class M{constructor(d){this.port=d,this.onMessage=L.Event.fromDOMEventEmitter(this.port,"message",g=>p.VSBuffer.wrap(g.data)),d.start()}send(d){this.port.postMessage(d.buffer)}disconnect(){this.port.close()}}e.Protocol=M;class P extends D.IPCClient{constructor(d,g){const i=new M(d);super(i,g);this.protocol=i}dispose(){this.protocol.disconnect()}}e.Client=P}),define(Q[85],J([0,1,16,4,2,3,32,35]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=void 0;var d;(function(s){s[s.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",s[s.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(d=e.SocketCloseEventType||(e.SocketCloseEventType={}));let g=null;function i(){return g||(g=p.VSBuffer.alloc(0)),g}class I{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(r){this._chunks.push(r),this._totalLength+=r.byteLength}read(r){return this._read(r,!0)}peek(r){return this._read(r,!1)}_read(r,a){if(r===0)return i();if(r>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===r){const R=this._chunks[0];return a&&(this._chunks.shift(),this._totalLength-=r),R}if(this._chunks[0].byteLength>r){const R=this._chunks[0].slice(0,r);return a&&(this._chunks[0]=this._chunks[0].slice(r),this._totalLength-=r),R}let f=p.VSBuffer.alloc(r),w=0,k=0;for(;r>0;){const R=this._chunks[k];if(R.byteLength>r){const A=R.slice(0,r);f.set(A,w),w+=r,a&&(this._chunks[k]=R.slice(r),this._totalLength-=r),r-=r}else f.set(R,w),w+=R.byteLength,a?(this._chunks.shift(),this._totalLength-=R.byteLength):k++,r-=R.byteLength}return f}}e.ChunkStream=I;var S;(function(s){s[s.None=0]="None",s[s.Regular=1]="Regular",s[s.Control=2]="Control",s[s.Ack=3]="Ack",s[s.KeepAlive=4]="KeepAlive",s[s.Disconnect=5]="Disconnect",s[s.ReplayRequest=6]="ReplayRequest"})(S||(S={}));var m;(function(s){s[s.HeaderLength=13]="HeaderLength",s[s.AcknowledgeTime=2e3]="AcknowledgeTime",s[s.AcknowledgeTimeoutTime=2e4]="AcknowledgeTimeoutTime",s[s.KeepAliveTime=5e3]="KeepAliveTime",s[s.KeepAliveTimeoutTime=2e4]="KeepAliveTimeoutTime",s[s.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",s[s.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(m=e.ProtocolConstants||(e.ProtocolConstants={}));class t{constructor(r,a,f,w){this.type=r,this.id=a,this.ack=f,this.data=w,this.writtenTime=0}get size(){return this.data.byteLength}}class h extends D.Disposable{constructor(r){super();this._onMessage=this._register(new L.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=r,this._isDisposed=!1,this._incomingData=new I,this._register(this._socket.onData(a=>this.acceptChunk(a))),this.lastReadTime=Date.now()}acceptChunk(r){if(!(!r||r.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(r);this._incomingData.byteLength>=this._state.readLen;){const a=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=a.readUInt32BE(9),this._state.messageType=a.readUInt8(0),this._state.id=a.readUInt32BE(1),this._state.ack=a.readUInt32BE(5);else{const f=this._state.messageType,w=this._state.id,k=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._onMessage.fire(new t(f,w,k,a)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class E{constructor(r){this._isDisposed=!1,this._socket=r,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch(r){}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}write(r){if(this._isDisposed)return;r.writtenTime=Date.now(),this.lastWriteTime=Date.now();const a=p.VSBuffer.alloc(13);a.writeUInt8(r.type,0),a.writeUInt32BE(r.id,1),a.writeUInt32BE(r.ack,5),a.writeUInt32BE(r.data.byteLength,9),this._writeSoon(a,r.data)}_bufferAdd(r,a){const f=this._totalLength===0;return this._data.push(r,a),this._totalLength+=r.byteLength+a.byteLength,f}_bufferTake(){const r=p.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,r}_writeSoon(r,a){this._bufferAdd(r,a)&&M.setImmediate(()=>{this._writeNow()})}_writeNow(){this._totalLength!==0&&this._socket.write(this._bufferTake())}}class v extends D.Disposable{constructor(r){super();this._onMessage=new L.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new L.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=r,this._socketWriter=this._register(new E(this._socket)),this._socketReader=this._register(new h(this._socket)),this._register(this._socketReader.onMessage(a=>{a.type===1&&this._onMessage.fire(a.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(r){this._socketWriter.write(new t(1,0,0,r))}}e.Protocol=v;class y extends b.IPCClient{constructor(r,a,f=null){super(r,a,f);this.protocol=r}static fromSocket(r,a){return new y(new v(r),a)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const r=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),r.end()}}e.Client=y;class u{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new L.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,P.nextTick(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(r){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(r):this._emitter.fire(r):this._bufferedMessages.push(r)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=u;class l{constructor(r){this.data=r,this.next=null}}class c{constructor(){this._first=null,this._last=null}peek(){return this._first?this._first.data:null}toArray(){let r=[],a=0,f=this._first;for(;f;)r[a++]=f.data,f=f.next;return r}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(r){const a=new l(r);if(!this._first){this._first=a,this._last=a;return}this._last.next=a,this._last=a}}class n{constructor(){this.lastRuns=[];const r=Date.now();for(let a=0;a<n._HISTORY_LENGTH;a++)this.lastRuns[a]=r-1e3*a;setInterval(()=>{for(let a=n._HISTORY_LENGTH;a>=1;a--)this.lastRuns[a]=this.lastRuns[a-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return n._INSTANCE||(n._INSTANCE=new n),n._INSTANCE}load(){const r=Date.now(),a=(1+n._HISTORY_LENGTH)*1e3;let f=0;for(let w=0;w<n._HISTORY_LENGTH;w++)r-this.lastRuns[w]<=a&&f++;return 1-f/n._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}n._HISTORY_LENGTH=10,n._INSTANCE=null;class o{constructor(r,a=null,f=n.getInstance()){this._onControlMessage=new u,this.onControlMessage=this._onControlMessage.event,this._onMessage=new u,this.onMessage=this._onMessage.event,this._onDidDispose=new u,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new u,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new u,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=f,this._isReconnecting=!1,this._outgoingUnackMsg=new c,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._outgoingKeepAliveTimeout=null,this._incomingKeepAliveTimeout=null,this._lastReplayRequestTime=0,this._socketDisposables=[],this._socket=r,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(w=>this._receiveMessage(w))),this._socketDisposables.push(this._socket.onClose(w=>this._onSocketClose.fire(w))),a&&this._socketReader.acceptChunk(a),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._outgoingKeepAliveTimeout&&(clearTimeout(this._outgoingKeepAliveTimeout),this._outgoingKeepAliveTimeout=null),this._incomingKeepAliveTimeout&&(clearTimeout(this._incomingKeepAliveTimeout),this._incomingKeepAliveTimeout=null),this._socketDisposables=(0,D.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const r=new t(5,0,0,i());this._socketWriter.write(r),this._socketWriter.flush()}_sendKeepAliveCheck(){if(this._outgoingKeepAliveTimeout)return;const r=Date.now()-this._socketWriter.lastWriteTime;if(r>=5e3){const a=new t(4,0,0,i());this._socketWriter.write(a),this._sendKeepAliveCheck();return}this._outgoingKeepAliveTimeout=setTimeout(()=>{this._outgoingKeepAliveTimeout=null,this._sendKeepAliveCheck()},5e3-r+5)}_recvKeepAliveCheck(){if(this._incomingKeepAliveTimeout)return;const r=Date.now()-this._socketReader.lastReadTime;if(r>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._incomingKeepAliveTimeout=setTimeout(()=>{this._incomingKeepAliveTimeout=null,this._recvKeepAliveCheck()},Math.max(2e4-r,0)+5)}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(r,a){this._isReconnecting=!0,this._socketDisposables=(0,D.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._socket=r,this._socketWriter=new E(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new h(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(f=>this._receiveMessage(f))),this._socketDisposables.push(this._socket.onClose(f=>this._onSocketClose.fire(f))),this._socketReader.acceptChunk(a)}endAcceptReconnection(){this._isReconnecting=!1;const r=this._outgoingUnackMsg.toArray();for(let a=0,f=r.length;a<f;a++)this._socketWriter.write(r[a]);this._recvAckCheck(),this._sendKeepAliveCheck(),this._recvKeepAliveCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(r){if(r.ack>this._outgoingAckId){this._outgoingAckId=r.ack;do{const a=this._outgoingUnackMsg.peek();if(a&&a.id<=r.ack)this._outgoingUnackMsg.pop();else break}while(!0)}if(r.type===1){if(r.id>this._incomingMsgId)if(r.id!==this._incomingMsgId+1){const a=Date.now();a-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=a,this._socketWriter.write(new t(6,0,0,i())))}else this._incomingMsgId=r.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(r.data)}else if(r.type===2)this._onControlMessage.fire(r.data);else if(r.type===5)this._onDidDispose.fire();else if(r.type===6){const a=this._outgoingUnackMsg.toArray();for(let f=0,w=a.length;f<w;f++)this._socketWriter.write(a[f]);this._recvAckCheck()}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(r){const a=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const f=new t(1,a,this._incomingAckId,r);this._outgoingUnackMsg.push(f),this._isReconnecting||(this._socketWriter.write(f),this._recvAckCheck())}sendControl(r){const a=new t(2,0,0,r);this._socketWriter.write(a)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const r=Date.now()-this._incomingMsgLastTime;if(r>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-r+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const r=this._outgoingUnackMsg.peek(),a=Date.now()-r.writtenTime;if(a>=2e4&&!this._loadEstimator.hasHighLoad()){this._onSocketTimeout.fire(void 0);return}this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},Math.max(2e4-a,0)+5)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const r=new t(3,0,this._incomingAckId,i());this._socketWriter.write(r)}}e.PersistentProtocol=o}),define(Q[122],J([0,1,13,16,4,2,35,120]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;function d(i,I){const S=D.Event.fromNodeEventEmitter(p.ipcMain,I,(t,h)=>({event:t,message:h})),m=D.Event.filter(S,({event:t})=>t.sender.id===i);return D.Event.map(m,({message:t})=>t&&L.VSBuffer.wrap(t))}class g extends P.IPCServer{constructor(){super(g.getOnDidClientConnect())}static getOnDidClientConnect(){const I=D.Event.fromNodeEventEmitter(p.ipcMain,"vscode:hello",({sender:S})=>S);return D.Event.map(I,S=>{const m=S.id,t=g.Clients.get(m);t&&t.dispose();const h=new D.Emitter;g.Clients.set(m,(0,M.toDisposable)(()=>h.fire()));const E=d(m,"vscode:message"),v=D.Event.any(D.Event.signal(d(m,"vscode:disconnect")),h.event);return{protocol:new b.Protocol(S,E),onDidClientDisconnect:v}})}}e.Server=g,g.Clients=new Map}),define(Q[86],J([0,1,13,4,28,121]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.Client=void 0;class P extends M.Client{constructor(g,i){super({addEventListener:(I,S)=>g.addListener(I,S),removeEventListener:(I,S)=>g.removeListener(I,S),postMessage:I=>g.postMessage(I),start:()=>g.start(),close:()=>g.close()},i)}}e.Client=P;async function b(d){if(d.isDestroyed()||d.webContents.isDestroyed())throw new Error("ipc.mp#connect: Cannot talk to window because it is closed or destroyed");const g=(0,D.generateUuid)();d.webContents.send("vscode:createMessageChannel",g);const i=L.Event.fromNodeEventEmitter(p.ipcMain,"vscode:createMessageChannelResult",(S,m)=>({nonce:m,port:S.ports[0]})),{port:I}=await L.Event.toPromise(L.Event.once(L.Event.filter(i,S=>S.nonce===g)));return I}e.connect=b}),define(Q[87],J([0,1,9,4,2,14]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var P;(function(I){I[I.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(P=e.StorageHint||(e.StorageHint={}));function b(I){const S=I;return S?.changed instanceof Map||S?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var d;(function(I){I[I.None=0]="None",I[I.Initialized=1]="Initialized",I[I.Closed=2]="Closed"})(d||(d={}));class g extends D.Disposable{constructor(S,m=Object.create(null)){super();this.database=S,this.options=m,this._onDidChangeStorage=this._register(new L.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=d.None,this.cache=new Map,this.flushDelayer=new p.ThrottledDelayer(g.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(S=>this.onDidChangeItemsExternal(S)))}onDidChangeItemsExternal(S){S.changed?.forEach((m,t)=>this.accept(t,m)),S.deleted?.forEach(m=>this.accept(m,void 0))}accept(S,m){if(this.state===d.Closed)return;let t=!1;(0,M.isUndefinedOrNull)(m)?t=this.cache.delete(S):this.cache.get(S)!==m&&(this.cache.set(S,m),t=!0),t&&this._onDidChangeStorage.fire(S)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===d.None&&(this.state=d.Initialized,this.options.hint!==P.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(S,m){const t=this.cache.get(S);return(0,M.isUndefinedOrNull)(t)?m:t}getBoolean(S,m){const t=this.get(S);return(0,M.isUndefinedOrNull)(t)?m:t==="true"}getNumber(S,m){const t=this.get(S);return(0,M.isUndefinedOrNull)(t)?m:parseInt(t,10)}async set(S,m){if(this.state===d.Closed)return;if((0,M.isUndefinedOrNull)(m))return this.delete(S);const t=String(m);if(this.cache.get(S)!==t)return this.cache.set(S,t),this.pendingInserts.set(S,t),this.pendingDeletes.delete(S),this._onDidChangeStorage.fire(S),this.flushDelayer.trigger(()=>this.flushPending())}async delete(S){if(!(this.state===d.Closed||!this.cache.delete(S)))return this.pendingDeletes.has(S)||this.pendingDeletes.add(S),this.pendingInserts.delete(S),this._onDidChangeStorage.fire(S),this.flushDelayer.trigger(()=>this.flushPending())}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=d.Closed;try{await this.flushDelayer.trigger(()=>this.flushPending(),0)}catch(S){}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const S={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(S).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async whenFlushed(){if(!!this.hasPending)return new Promise(S=>this.whenFlushedCallbacks.push(S))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=g,g.DEFAULT_FLUSH_DELAY=100;class i{constructor(){this.onDidChangeItemsExternal=L.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(S){S.insert&&S.insert.forEach((m,t)=>this.items.set(t,m)),S.delete&&S.delete.forEach(m=>this.items.delete(m))}async close(){}}e.InMemoryStorageDatabase=i}),define(Q[123],J([0,1,9,4,40,8,19]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SQLiteStorageDatabase=void 0;class b{constructor(i,I=Object.create(null)){this.path=i,this.options=I,this.name=(0,M.basename)(this.path),this.logger=new d(this.options.logging),this.whenConnected=this.connect(this.path)}get onDidChangeItemsExternal(){return L.Event.None}async getItems(){const i=await this.whenConnected,I=new Map;return(await this.all(i,"SELECT * FROM ItemTable")).forEach(m=>I.set(m.key,m.value)),this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] getItems(): ${I.size} rows`),I}async updateItems(i){const I=await this.whenConnected;return this.doUpdateItems(I,i)}doUpdateItems(i,I){return this.logger.isTracing&&this.logger.trace(`[storage ${this.name}] updateItems(): insert(${I.insert?(0,D.mapToString)(I.insert):"0"}), delete(${I.delete?(0,D.setToString)(I.delete):"0"})`),this.transaction(i,()=>{const S=I.insert,m=I.delete;if(S&&S.size>0){const t=[];t.push([]);let h=0;S.forEach((E,v)=>{let y=t[h];y.length>b.MAX_HOST_PARAMETERS&&(h++,y=[],t.push(y)),y.push(v,E)}),t.forEach(E=>{this.prepare(i,`INSERT INTO ItemTable VALUES ${new Array(E.length/2).fill("(?,?)").join(",")}`,v=>v.run(E),()=>{const v=[];let y=0;return S.forEach((u,l)=>{v.push(l),y+=u.length}),`Keys: ${v.join(", ")} Length: ${y}`})})}if(m&&m.size){const t=[];t.push([]);let h=0;m.forEach(E=>{let v=t[h];v.length>b.MAX_HOST_PARAMETERS&&(h++,v=[],t.push(v)),v.push(E)}),t.forEach(E=>{this.prepare(i,`DELETE FROM ItemTable WHERE key IN (${new Array(E.length).fill("?").join(",")})`,v=>v.run(E),()=>{const v=[];return m.forEach(y=>{v.push(y)}),`Keys: ${v.join(", ")}`})})}})}async close(i){this.logger.trace(`[storage ${this.name}] close()`);const I=await this.whenConnected;return this.doClose(I,i)}doClose(i,I){return new Promise((S,m)=>{i.db.close(t=>(t&&this.handleSQLiteError(i,`[storage ${this.name}] close(): ${t}`),this.path===b.IN_MEMORY_PATH?S():!i.isErroneous&&!i.isInMemory?this.backup().then(S,h=>(this.logger.error(`[storage ${this.name}] backup(): ${h}`),S())):typeof I=="function"?P.Promises.unlink(this.path).then(()=>this.doConnect(this.path).then(h=>{const E=()=>this.doClose(h,void 0);return this.doUpdateItems(h,{insert:I()}).then(()=>E(),v=>(E(),Promise.reject(v)))})).then(S,m):m(t||new Error("Database has errors or is in-memory without recovery option"))))})}backup(){const i=this.toBackupPath(this.path);return P.Promises.copy(this.path,i,{preserveSymlinks:!1})}toBackupPath(i){return`${i}.backup`}async checkIntegrity(i){this.logger.trace(`[storage ${this.name}] checkIntegrity(full: ${i})`);const I=await this.whenConnected,S=await this.get(I,i?"PRAGMA integrity_check":"PRAGMA quick_check"),m=i?S.integrity_check:S.quick_check;return I.isErroneous?`${m} (last error: ${I.lastError})`:I.isInMemory?`${m} (in-memory!)`:m}async connect(i,I=!0){this.logger.trace(`[storage ${this.name}] open(${i}, retryOnBusy: ${I})`);try{return await this.doConnect(i)}catch(S){if(this.logger.error(`[storage ${this.name}] open(): Unable to open DB due to ${S}`),S.code==="SQLITE_BUSY"&&I)return await(0,p.timeout)(b.BUSY_OPEN_TIMEOUT),this.connect(i,!1);try{await P.Promises.unlink(i);try{await P.Promises.rename(this.toBackupPath(i),i)}catch(m){}return await this.doConnect(i)}catch(m){return this.logger.error(`[storage ${this.name}] open(): Unable to use backup due to ${m}`),this.doConnect(b.IN_MEMORY_PATH)}}}handleSQLiteError(i,I){i.isErroneous=!0,i.lastError=I,this.logger.error(I)}doConnect(i){return new Promise((I,S)=>{new Promise((m,t)=>{j(["@vscode/sqlite3"],m,t)}).then(m=>{const t={db:new(this.logger.isTracing?m.verbose().Database:m.Database)(i,h=>h?t.db?t.db.close(()=>S(h)):S(h):this.exec(t,["PRAGMA user_version = 1;","CREATE TABLE IF NOT EXISTS ItemTable (key TEXT UNIQUE ON CONFLICT REPLACE, value BLOB)"].join("")).then(()=>I(t),E=>t.db.close(()=>S(E)))),isInMemory:i===b.IN_MEMORY_PATH};t.db.on("error",h=>this.handleSQLiteError(t,`[storage ${this.name}] Error (event): ${h}`)),this.logger.isTracing&&t.db.on("trace",h=>this.logger.trace(`[storage ${this.name}] Trace (event): ${h}`))},S)})}exec(i,I){return new Promise((S,m)=>{i.db.exec(I,t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] exec(): ${t}`),m(t)):S())})}get(i,I){return new Promise((S,m)=>{i.db.get(I,(t,h)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] get(): ${t}`),m(t)):S(h))})}all(i,I){return new Promise((S,m)=>{i.db.all(I,(t,h)=>t?(this.handleSQLiteError(i,`[storage ${this.name}] all(): ${t}`),m(t)):S(h))})}transaction(i,I){return new Promise((S,m)=>{i.db.serialize(()=>{i.db.run("BEGIN TRANSACTION"),I(),i.db.run("END TRANSACTION",t=>t?(this.handleSQLiteError(i,`[storage ${this.name}] transaction(): ${t}`),m(t)):S())})})}prepare(i,I,S,m){const t=i.db.prepare(I),h=E=>{this.handleSQLiteError(i,`[storage ${this.name}] prepare(): ${E} (${I}). Details: ${m()}`)};t.on("error",h),S(t),t.finalize(E=>{E&&h(E),t.removeListener("error",h)})}}e.SQLiteStorageDatabase=b,b.IN_MEMORY_PATH=":memory:",b.BUSY_OPEN_TIMEOUT=2e3,b.MAX_HOST_PARAMETERS=256;class d{constructor(i){i&&typeof i.logTrace=="function"&&process.env[d.VSCODE_TRACE_STORAGE]&&(this.logTrace=i.logTrace),i&&typeof i.logError=="function"&&(this.logError=i.logError)}get isTracing(){return!!this.logTrace}trace(i){this.logTrace&&this.logTrace(i)}error(i){this.logError&&this.logError(i)}}d.VSCODE_TRACE_STORAGE="VSCODE_TRACE_STORAGE"}),define(Q[124],J([12,11]),function(j,e){return j.create("vs/base/common/date",e)}),define(Q[125],J([0,1,124]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const L=60,D=L*60,M=D*24,P=M*7,b=M*30,d=M*365;function g(I,S){typeof I!="number"&&(I=I.getTime());const m=Math.round((new Date().getTime()-I)/1e3);if(m<-30)return(0,p.localize)(0,null,g(new Date().getTime()+m*1e3,!1));if(m<30)return(0,p.localize)(1,null);let t;return m<L?(t=m,S?t===1?(0,p.localize)(2,null,t):(0,p.localize)(3,null,t):t===1?(0,p.localize)(4,null,t):(0,p.localize)(5,null,t)):m<D?(t=Math.floor(m/L),S?t===1?(0,p.localize)(6,null,t):(0,p.localize)(7,null,t):t===1?(0,p.localize)(8,null,t):(0,p.localize)(9,null,t)):m<M?(t=Math.floor(m/D),S?t===1?(0,p.localize)(10,null,t):(0,p.localize)(11,null,t):t===1?(0,p.localize)(12,null,t):(0,p.localize)(13,null,t)):m<P?(t=Math.floor(m/M),S?t===1?(0,p.localize)(14,null,t):(0,p.localize)(15,null,t):t===1?(0,p.localize)(16,null,t):(0,p.localize)(17,null,t)):m<b?(t=Math.floor(m/P),S?t===1?(0,p.localize)(18,null,t):(0,p.localize)(19,null,t):t===1?(0,p.localize)(20,null,t):(0,p.localize)(21,null,t)):m<d?(t=Math.floor(m/b),S?t===1?(0,p.localize)(22,null,t):(0,p.localize)(23,null,t):t===1?(0,p.localize)(24,null,t):(0,p.localize)(25,null,t)):(t=Math.floor(m/d),S?t===1?(0,p.localize)(26,null,t):(0,p.localize)(27,null,t):t===1?(0,p.localize)(28,null,t):(0,p.localize)(29,null,t))}e.fromNow=g;function i(I){return I.getFullYear()+"-"+String(I.getMonth()+1).padStart(2,"0")+"-"+String(I.getDate()).padStart(2,"0")+"T"+String(I.getHours()).padStart(2,"0")+":"+String(I.getMinutes()).padStart(2,"0")+":"+String(I.getSeconds()).padStart(2,"0")+"."+(I.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=i}),define(Q[126],J([12,11]),function(j,e){return j.create("vs/base/common/errorMessage",e)}),define(Q[62],J([0,1,30,14,126]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toErrorMessage=void 0;function M(g,i){return i&&(g.stack||g.stacktrace)?D.localize(0,null,b(g),P(g.stack)||P(g.stacktrace)):b(g)}function P(g){return Array.isArray(g)?g.join(`
`):g}function b(g){return typeof g.code=="string"&&typeof g.errno=="number"&&typeof g.syscall=="string"?D.localize(1,null,g.message):g.message||D.localize(2,null)}function d(g=null,i=!1){if(!g)return D.localize(3,null);if(Array.isArray(g)){const I=p.coalesce(g),S=d(I[0],i);return I.length>1?D.localize(4,null,S,I.length):S}if(L.isString(g))return g;if(g.detail){const I=g.detail;if(I.error)return M(I.error,i);if(I.exception)return M(I.exception,i)}return g.stack?M(g,i):g.message?g.message:D.localize(5,null)}e.toErrorMessage=d}),define(Q[127],J([12,11]),function(j,e){return j.create("vs/base/common/keybindingLabels",e)}),define(Q[128],J([0,1,127]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserSettingsLabelProvider=e.ElectronAcceleratorLabelProvider=e.AriaLabelProvider=e.UILabelProvider=e.ModifierLabelProvider=void 0;class L{constructor(P,b,d=b){this.modifierLabels=[null],this.modifierLabels[2]=P,this.modifierLabels[1]=b,this.modifierLabels[3]=d}toLabel(P,b,d){if(b.length===0)return null;const g=[];for(let i=0,I=b.length;i<I;i++){const S=b[i],m=d(S);if(m===null)return null;g[i]=D(S,m,this.modifierLabels[P])}return g.join(" ")}}e.ModifierLabelProvider=L,e.UILabelProvider=new L({ctrlKey:"\u2303",shiftKey:"\u21E7",altKey:"\u2325",metaKey:"\u2318",separator:""},{ctrlKey:p.localize(0,null),shiftKey:p.localize(1,null),altKey:p.localize(2,null),metaKey:p.localize(3,null),separator:"+"},{ctrlKey:p.localize(4,null),shiftKey:p.localize(5,null),altKey:p.localize(6,null),metaKey:p.localize(7,null),separator:"+"}),e.AriaLabelProvider=new L({ctrlKey:p.localize(8,null),shiftKey:p.localize(9,null),altKey:p.localize(10,null),metaKey:p.localize(11,null),separator:"+"},{ctrlKey:p.localize(12,null),shiftKey:p.localize(13,null),altKey:p.localize(14,null),metaKey:p.localize(15,null),separator:"+"},{ctrlKey:p.localize(16,null),shiftKey:p.localize(17,null),altKey:p.localize(18,null),metaKey:p.localize(19,null),separator:"+"}),e.ElectronAcceleratorLabelProvider=new L({ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Cmd",separator:"+"},{ctrlKey:"Ctrl",shiftKey:"Shift",altKey:"Alt",metaKey:"Super",separator:"+"}),e.UserSettingsLabelProvider=new L({ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"cmd",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"win",separator:"+"},{ctrlKey:"ctrl",shiftKey:"shift",altKey:"alt",metaKey:"meta",separator:"+"});function D(M,P,b){if(P===null)return"";const d=[];return M.ctrlKey&&d.push(b.ctrlKey),M.shiftKey&&d.push(b.shiftKey),M.altKey&&d.push(b.altKey),M.metaKey&&d.push(b.metaKey),P!==""&&d.push(P),d.join(b.separator)}}),define(Q[129],J([12,11]),function(j,e){return j.create("vs/base/node/processes",e)}),define(Q[71],J([0,1,44,33,10,43,8,3,32,81,14,112,19,129]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.LineProcess=e.AbstractProcess=e.getWindowsShell=e.removeDangerousEnvVariables=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return g.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return g.TerminateResponseCode}});function t(n){switch(n){case 0:return 0;case 1:return 2;case 128:return 3;default:return 1}}function h(n,o){if(b.isWindows)try{const s={stdio:["pipe","pipe","ignore"]};o&&(s.cwd=o);const r=p.execFile("taskkill",["/T","/F","/PID",n.pid.toString()],s);return new Promise(a=>{r.once("error",f=>{a({success:!1,error:f})}),r.once("exit",(f,w)=>{a(f===0?{success:!0}:{success:!1,code:f!==null?f:1})})})}catch(s){return Promise.resolve({success:!1,error:s,code:s.status?t(s.status):1})}else if(b.isLinux||b.isMacintosh)try{const s=D.FileAccess.asFileUri("vs/base/node/terminateProcess.sh",j).fsPath;return new Promise(r=>{p.execFile(s,[n.pid.toString()],{encoding:"utf8",shell:!0},(a,f,w)=>{r(a?{success:!1,error:a}:{success:!0})})})}catch(s){return Promise.resolve({success:!1,error:s})}else n.kill("SIGKILL");return Promise.resolve({success:!0})}function E(n){!n||(delete n.DEBUG,b.isMacintosh&&delete n.DYLD_LIBRARY_PATH,b.isLinux&&delete n.LD_PRELOAD)}e.removeDangerousEnvVariables=E;function v(n=d.env){return n.comspec||"cmd.exe"}e.getWindowsShell=v;class y{constructor(o,s,r,a){if(s!==void 0&&r!==void 0&&a!==void 0)this.cmd=o,this.args=s,this.shell=r,this.options=a;else{const f=o;this.cmd=f.command,this.shell=f.isShellCommand,this.args=f.args.slice(0),this.options=f.options||{}}if(this.childProcess=null,this.childProcessPromise=null,this.terminateRequested=!1,this.options.env){const f=Object.create(null);Object.keys(d.env).forEach(w=>{f[w]=d.env[w]}),Object.keys(this.options.env).forEach(w=>{f[w]=this.options.env[w]}),this.options.env=f}}getSanitizedCommand(){let o=this.cmd.toLowerCase();const s=o.lastIndexOf(P.sep);return s!==-1&&(o=o.substring(s+1)),y.WellKnowCommands[o]?o:"other"}start(o){return b.isWindows&&(this.options&&this.options.cwd&&L.isUNC(this.options.cwd)||!this.options&&L.isUNC(d.cwd()))?Promise.reject(new Error(m.localize(0,null))):this.useExec().then(s=>{let r,a;const f=new Promise((w,k)=>{r=w,a=k});if(s){let w=this.cmd;this.args&&(w=w+" "+this.args.join(" ")),this.childProcess=p.exec(w,this.options,(k,R,A)=>{this.childProcess=null;const O=k;O&&O.killed?a({killed:this.terminateRequested,stdout:R.toString(),stderr:A.toString()}):this.handleExec(r,o,k,R,A)})}else{let w=null;const k=R=>{this.childProcess=null,this.childProcessPromise=null,this.handleClose(R,r,o,a);const A={terminated:this.terminateRequested};i.isNumber(R)&&(A.cmdCode=R),r(A)};if(this.shell&&b.isWindows){const R=M.deepClone(this.options);R.windowsVerbatimArguments=!0,R.detached=!1;let A=!1,O=!1;const H=[];let x=this.ensureQuotes(this.cmd);H.push(x.value),A=x.quoted,this.args&&this.args.forEach(K=>{x=this.ensureQuotes(K),H.push(x.value),O=O&&x.quoted});const re=["/s","/c"];A?O?re.push('"'+H.join(" ")+'"'):H.length>1?re.push('"'+H[0]+'" '+H.slice(1).join(" ")):re.push('"'+H[0]+'"'):re.push(H.join(" ")),w=p.spawn(v(),re,R)}else this.cmd&&(w=p.spawn(this.cmd,this.args,this.options));w&&(this.childProcess=w,this.childProcessPromise=Promise.resolve(w),this.pidResolve&&(this.pidResolve(i.isNumber(w.pid)?w.pid:-1),this.pidResolve=void 0),w.on("error",R=>{this.childProcess=null,a({terminated:this.terminateRequested,error:R})}),w.pid&&(this.childProcess.on("close",k),this.handleSpawn(w,r,o,a,!0)))}return f})}handleClose(o,s,r,a){}ensureQuotes(o){return y.regexp.test(o)?{value:'"'+o+'"',quoted:!0}:{value:o,quoted:o.length>0&&o[0]==='"'&&o[o.length-1]==='"'}}get pid(){return this.childProcessPromise?this.childProcessPromise.then(o=>o.pid,o=>-1):new Promise(o=>{this.pidResolve=o})}terminate(){return this.childProcessPromise?this.childProcessPromise.then(o=>(this.terminateRequested=!0,h(o,this.options.cwd).then(s=>(s.success&&(this.childProcess=null),s))),o=>({success:!0})):Promise.resolve({success:!0})}useExec(){return new Promise(o=>{if(!this.shell||!b.isWindows)return o(!1);const s=p.spawn(v(),["/s","/c"]);s.on("error",r=>o(!0)),s.on("exit",r=>o(!1))})}}e.AbstractProcess=y,y.WellKnowCommands={ant:!0,cmake:!0,eslint:!0,gradle:!0,grunt:!0,gulp:!0,jake:!0,jenkins:!0,jshint:!0,make:!0,maven:!0,msbuild:!0,msc:!0,nmake:!0,npm:!0,rake:!0,tsc:!0,xbuild:!0},y.regexp=/^[^"].* .*[^"]/;class u extends y{constructor(o,s,r,a){super(o,s,r,a);this.stdoutLineDecoder=null,this.stderrLineDecoder=null}handleExec(o,s,r,a,f){[a,f].forEach((w,k)=>{const R=new I.LineDecoder;R.write(w).forEach(H=>{s({line:H,source:k===0?0:1})});const O=R.end();O&&s({line:O,source:k===0?0:1})}),o({terminated:this.terminateRequested,error:r})}handleSpawn(o,s,r,a,f){const w=new I.LineDecoder,k=new I.LineDecoder;o.stdout.on("data",R=>{w.write(R).forEach(O=>r({line:O,source:0}))}),o.stderr.on("data",R=>{k.write(R).forEach(O=>r({line:O,source:1}))}),this.stdoutLineDecoder=w,this.stderrLineDecoder=k}handleClose(o,s,r,a){const f=this.stdoutLineDecoder?this.stdoutLineDecoder.end():null;f&&r({line:f,source:0});const w=this.stderrLineDecoder?this.stderrLineDecoder.end():null;w&&r({line:w,source:1})}}e.LineProcess=u;function l(n){let o=[],s=!1;const r=function(a){if(s){o.push(a);return}(!n.send(a,w=>{if(w&&console.error(w),s=!1,o.length>0){const k=o.slice(0);o=[],k.forEach(R=>r(R))}})||b.isWindows)&&(s=!0)};return{send:r}}e.createQueuedSender=l;var c;(function(n){async function o(s,r,a){if(P.isAbsolute(s))return s;if(r===void 0&&(r=d.cwd()),P.dirname(s)!=="."||(a===void 0&&i.isString(d.env.PATH)&&(a=d.env.PATH.split(P.delimiter)),a===void 0||a.length===0))return P.join(r,s);async function w(k){if(await S.Promises.exists(k)){let R;try{R=await S.Promises.stat(k)}catch(A){A.message.startsWith("EACCES")&&(R=await S.Promises.lstat(k))}return R?!R.isDirectory():!1}return!1}for(let k of a){let R;if(P.isAbsolute(k)?R=P.join(k,s):R=P.join(r,k,s),await w(R))return R;let A=R+".com";if(await w(A)||(A=R+".exe",await w(A)))return A}return P.join(r,s)}n.findExecutable=o})(c=e.win32||(e.win32={}))}),define(Q[130],J([0,1,25,3,116,71]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function P(m,t){return m===1?L.isWindows?I():M.getWindowsShell(t):g(m,t)}e.getSystemShell=P;function b(m,t){return m===1?L.isWindows?S(t):M.getWindowsShell(t):g(m,t)}e.getSystemShellSync=b;let d=null;function g(m,t){if(L.isLinux&&m===2||L.isMacintosh&&m===3)return"/bin/bash";if(!d){let h;if(L.isWindows)h="/bin/bash";else{if(h=t.SHELL,!h)try{h=(0,p.userInfo)().shell}catch(E){}h||(h="sh"),h==="/bin/false"&&(h="/bin/bash")}d=h}return d}let i=null;async function I(){return i||(i=(await(0,D.getFirstAvailablePowerShellInstallation)()).exePath),i}function S(m){if(i)return i;const t=L.isWindows&&parseFloat((0,p.release)())>=10,h=m.hasOwnProperty("PROCESSOR_ARCHITEW6432"),E=`${m.windir}\\${h?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return t?E:M.getWindowsShell(m)}}),define(Q[72],J([0,1,44,9,16,23,109,18,4,2,43,71,35]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class m extends S.ChannelServer{constructor(E){super({send:v=>{try{process.send&&process.send(v.buffer.toString("base64"))}catch(y){}},onMessage:d.Event.fromNodeEventEmitter(process,"message",v=>D.VSBuffer.wrap(Buffer.from(v,"base64")))},E);process.once("disconnect",()=>this.dispose())}}e.Server=m;class t{constructor(E,v){this.modulePath=E,this.options=v,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new d.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const y=v&&v.timeout?v.timeout:6e4;this.disposeDelayer=new L.Delayer(y),this.child=null,this._client=null}getChannel(E){const v=this;return{call(y,u,l){return v.requestPromise(E,y,u,l)},listen(y,u){return v.requestEvent(E,y,u)}}}requestPromise(E,v,y,u=M.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(u.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const l=this.getCachedChannel(E),c=(0,L.createCancelablePromise)(s=>l.call(v,y,s)),n=u.onCancellationRequested(()=>c.cancel()),o=(0,g.toDisposable)(()=>c.cancel());return this.activeRequests.add(o),c.finally(()=>{n.dispose(),this.activeRequests.delete(o),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),c}requestEvent(E,v,y){if(!this.disposeDelayer)return d.Event.None;this.disposeDelayer.cancel();let u;const l=new d.Emitter({onFirstListenerAdd:()=>{u=this.getCachedChannel(E).listen(v,y)(l.fire,l),this.activeRequests.add(u)},onLastListenerRemove:()=>{this.activeRequests.delete(u),u.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return l.event}get client(){if(!this._client){const E=this.options&&this.options.args?this.options.args:[],v=Object.create(null);v.env={...(0,i.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(v.env={...v.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(v.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(v.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(v.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),v.execArgv===void 0&&(v.execArgv=process.execArgv.filter(r=>!/^--inspect(-brk)?=/.test(r))),(0,I.removeDangerousEnvVariables)(v.env),this.child=(0,p.fork)(this.modulePath,E,v);const y=new d.Emitter;d.Event.fromNodeEventEmitter(this.child,"message",r=>r)(r=>{if((0,P.isRemoteConsoleLog)(r)){(0,P.log)(r,`IPC Library: ${this.options.serverName}`);return}y.fire(D.VSBuffer.wrap(Buffer.from(r,"base64")))});const l=this.options.useQueue?(0,I.createQueuedSender)(this.child):this.child,c=r=>this.child&&this.child.connected&&l.send(r.buffer.toString("base64")),n=y.event,o={send:c,onMessage:n};this._client=new S.ChannelClient(o);const s=()=>this.disposeClient();process.once("exit",s),this.child.on("error",r=>console.warn('IPC "'+this.options.serverName+'" errored with '+r)),this.child.on("exit",(r,a)=>{process.removeListener("exit",s),this.activeRequests.forEach(f=>(0,g.dispose)(f)),this.activeRequests.clear(),r!==0&&a!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+r+" and signal "+a),this.disposeDelayer&&this.disposeDelayer.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:r,signal:a})})}return this._client}getCachedChannel(E){let v=this.channels.get(E);return v||(v=this.client.getChannel(E),this.channels.set(E,v)),v}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=t}),define(Q[131],J([12,11]),function(j,e){return j.create("vs/code/electron-main/app",e)}),define(Q[132],J([12,11]),function(j,e){return j.create("vs/platform/configuration/common/configurationRegistry",e)}),define(Q[133],J([12,11]),function(j,e){return j.create("vs/platform/dialogs/electron-main/dialogMainService",e)}),define(Q[134],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argv",e)}),define(Q[135],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/argvHelper",e)}),define(Q[136],J([12,11]),function(j,e){return j.create("vs/platform/environment/node/shellEnv",e)}),define(Q[137],J([12,11]),function(j,e){return j.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(Q[138],J([12,11]),function(j,e){return j.create("vs/platform/extensions/common/extensionValidator",e)}),define(Q[139],J([12,11]),function(j,e){return j.create("vs/platform/externalTerminal/node/externalTerminalService",e)}),define(Q[140],J([12,11]),function(j,e){return j.create("vs/platform/files/common/fileService",e)}),define(Q[141],J([12,11]),function(j,e){return j.create("vs/platform/files/common/files",e)}),define(Q[142],J([12,11]),function(j,e){return j.create("vs/platform/files/common/io",e)}),define(Q[143],J([12,11]),function(j,e){return j.create("vs/platform/files/electron-main/diskFileSystemProviderChannel",e)}),define(Q[144],J([12,11]),function(j,e){return j.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(Q[145],J([12,11]),function(j,e){return j.create("vs/platform/issue/electron-main/issueMainService",e)}),define(Q[146],J([12,11]),function(j,e){return j.create("vs/platform/menubar/electron-main/menubar",e)}),define(Q[147],J([12,11]),function(j,e){return j.create("vs/platform/native/electron-main/nativeHostMainService",e)}),define(Q[148],J([12,11]),function(j,e){return j.create("vs/platform/request/common/request",e)}),define(Q[149],J([12,11]),function(j,e){return j.create("vs/platform/telemetry/common/telemetryService",e)}),define(Q[150],J([12,11]),function(j,e){return j.create("vs/platform/update/common/update.config.contribution",e)}),define(Q[151],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/window",e)}),define(Q[152],J([12,11]),function(j,e){return j.create("vs/platform/windows/electron-main/windowsMainService",e)}),define(Q[153],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/common/workspaces",e)}),define(Q[154],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesHistoryMainService",e)}),define(Q[155],J([12,11]),function(j,e){return j.create("vs/platform/workspaces/electron-main/workspacesManagementMainService",e)}),define(Q[156],J([0,1,4,2]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostDebugChannelClient=e.ExtensionHostDebugBroadcastChannel=void 0;class D{constructor(){this._onCloseEmitter=new p.Emitter,this._onReloadEmitter=new p.Emitter,this._onTerminateEmitter=new p.Emitter,this._onAttachEmitter=new p.Emitter}call(b,d,g){switch(d){case"close":return Promise.resolve(this._onCloseEmitter.fire({sessionId:g[0]}));case"reload":return Promise.resolve(this._onReloadEmitter.fire({sessionId:g[0]}));case"terminate":return Promise.resolve(this._onTerminateEmitter.fire({sessionId:g[0]}));case"attach":return Promise.resolve(this._onAttachEmitter.fire({sessionId:g[0],port:g[1],subId:g[2]}))}throw new Error("Method not implemented.")}listen(b,d,g){switch(d){case"close":return this._onCloseEmitter.event;case"reload":return this._onReloadEmitter.event;case"terminate":return this._onTerminateEmitter.event;case"attach":return this._onAttachEmitter.event}throw new Error("Method not implemented.")}}e.ExtensionHostDebugBroadcastChannel=D,D.ChannelName="extensionhostdebugservice";class M extends L.Disposable{constructor(b){super();this.channel=b}reload(b){this.channel.call("reload",[b])}get onReload(){return this.channel.listen("reload")}close(b){this.channel.call("close",[b])}get onClose(){return this.channel.listen("close")}attachSession(b,d,g){this.channel.call("attach",[b,d,g])}get onAttachSession(){return this.channel.listen("attach")}terminateSession(b,d){this.channel.call("terminate",[b,d])}get onTerminateSession(){return this.channel.listen("terminate")}openExtensionDevelopmentHostWindow(b,d){return this.channel.call("openExtensionDevelopmentHostWindow",[b,d])}}e.ExtensionHostDebugChannelClient=M}),define(Q[157],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowDriverRegistryChannelClient=e.WindowDriverChannelClient=e.WindowDriverChannel=void 0;class p{constructor(P){this.driver=P}listen(P,b){throw new Error(`No event found: ${b}`)}call(P,b,d){switch(b){case"click":return this.driver.click(d[0],d[1],d[2]);case"doubleClick":return this.driver.doubleClick(d);case"setValue":return this.driver.setValue(d[0],d[1]);case"getTitle":return this.driver.getTitle();case"isActiveElement":return this.driver.isActiveElement(d);case"getElements":return this.driver.getElements(d[0],d[1]);case"getElementXY":return this.driver.getElementXY(d[0],d[1],d[2]);case"typeInEditor":return this.driver.typeInEditor(d[0],d[1]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(d);case"writeInTerminal":return this.driver.writeInTerminal(d[0],d[1]);case"getLocaleInfo":return this.driver.getLocaleInfo();case"getLocalizedStrings":return this.driver.getLocalizedStrings()}throw new Error(`Call not found: ${b}`)}}e.WindowDriverChannel=p;class L{constructor(P){this.channel=P}click(P,b,d){return this.channel.call("click",[P,b,d])}doubleClick(P){return this.channel.call("doubleClick",P)}setValue(P,b){return this.channel.call("setValue",[P,b])}getTitle(){return this.channel.call("getTitle")}isActiveElement(P){return this.channel.call("isActiveElement",P)}getElements(P,b){return this.channel.call("getElements",[P,b])}getElementXY(P,b,d){return this.channel.call("getElementXY",[P,b,d])}typeInEditor(P,b){return this.channel.call("typeInEditor",[P,b])}getTerminalBuffer(P){return this.channel.call("getTerminalBuffer",P)}writeInTerminal(P,b){return this.channel.call("writeInTerminal",[P,b])}getLocaleInfo(){return this.channel.call("getLocaleInfo")}getLocalizedStrings(){return this.channel.call("getLocalizedStrings")}}e.WindowDriverChannelClient=L;class D{constructor(P){this.channel=P}registerWindowDriver(P){return this.channel.call("registerWindowDriver",P)}reloadWindowDriver(P){return this.channel.call("reloadWindowDriver",P)}}e.WindowDriverRegistryChannelClient=D}),define(Q[158],J([0,1,125,47,10,8,32,15,7]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class g{constructor(h,E,v){this._args=h,this.paths=E,this.productService=v}get appRoot(){return(0,M.dirname)(D.FileAccess.asFileUri("",j).fsPath)}get userHome(){return d.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return d.URI.file((0,M.join)(this.userDataPath,"User"))}get tmpDir(){return d.URI.file(this.paths.tmpDir)}get userRoamingDataHome(){return this.appSettingsHome}get settingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"settings.json")}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const h=(0,p.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,M.join)(this.userDataPath,"logs",h)}return this.args.logsPath}get userDataSyncLogResource(){return d.URI.file((0,M.join)(this.logsPath,"userDataSync.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(d.URI.file((0,M.join)(this.userDataPath,"Machine")),"settings.json")}get globalStorageHome(){return d.URI.joinPath(this.appSettingsHome,"globalStorage")}get workspaceStorageHome(){return d.URI.joinPath(this.appSettingsHome,"workspaceStorage")}get keybindingsResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keybindings.json")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const h=P.env.VSCODE_PORTABLE;return h?d.URI.file((0,M.join)(h,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get snippetsHome(){return(0,b.joinPath)(this.userRoamingDataHome,"snippets")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return d.URI.file((0,M.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,M.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const h=this.args["builtin-extensions-dir"];return h?(0,M.resolve)(h):(0,M.normalize)((0,M.join)(D.FileAccess.asFileUri("",j).fsPath,"..","extensions"))}get extensionsDownloadPath(){const h=this.args["extensions-download-dir"];return h?(0,M.resolve)(h):(0,M.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const h=this.args["extensions-dir"];if(h)return(0,M.resolve)(h);const E=P.env.VSCODE_EXTENSIONS;if(E)return E;const v=P.env.VSCODE_PORTABLE;return v?(0,M.join)(v,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const h=this.args.extensionDevelopmentPath;if(Array.isArray(h))return h.map(E=>/^[^:/?#]+?:\/\//.test(E)?d.URI.parse(E):d.URI.file((0,M.normalize)(E)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(h=>h==="ui"||h==="workspace"||h==="web"?h:"workspace")}get extensionTestsLocationURI(){const h=this.args.extensionTestsPath;if(h)return/^[^:/?#]+?:\/\//.test(h)?d.URI.parse(h):d.URI.file((0,M.normalize)(h))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const h=this.args["disable-extension"];if(h){if(typeof h=="string")return[h];if(Array.isArray(h)&&h.length>0)return h}return!1}get debugExtensionHost(){return i(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!P.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(d.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get driverHandle(){return this.args.driver}get telemetryLogResource(){return d.URI.file((0,M.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get args(){return this._args}}he([L.memoize],g.prototype,"appRoot",null),he([L.memoize],g.prototype,"userHome",null),he([L.memoize],g.prototype,"userDataPath",null),he([L.memoize],g.prototype,"appSettingsHome",null),he([L.memoize],g.prototype,"tmpDir",null),he([L.memoize],g.prototype,"userRoamingDataHome",null),he([L.memoize],g.prototype,"settingsResource",null),he([L.memoize],g.prototype,"userDataSyncHome",null),he([L.memoize],g.prototype,"userDataSyncLogResource",null),he([L.memoize],g.prototype,"sync",null),he([L.memoize],g.prototype,"machineSettingsResource",null),he([L.memoize],g.prototype,"globalStorageHome",null),he([L.memoize],g.prototype,"workspaceStorageHome",null),he([L.memoize],g.prototype,"keybindingsResource",null),he([L.memoize],g.prototype,"keyboardLayoutResource",null),he([L.memoize],g.prototype,"argvResource",null),he([L.memoize],g.prototype,"snippetsHome",null),he([L.memoize],g.prototype,"isExtensionDevelopment",null),he([L.memoize],g.prototype,"untitledWorkspacesHome",null),he([L.memoize],g.prototype,"installSourcePath",null),he([L.memoize],g.prototype,"builtinExtensionsPath",null),he([L.memoize],g.prototype,"extensionsPath",null),he([L.memoize],g.prototype,"extensionDevelopmentLocationURI",null),he([L.memoize],g.prototype,"extensionDevelopmentKind",null),he([L.memoize],g.prototype,"extensionTestsLocationURI",null),he([L.memoize],g.prototype,"debugExtensionHost",null),he([L.memoize],g.prototype,"serviceMachineIdResource",null),he([L.memoize],g.prototype,"telemetryLogResource",null),he([L.memoize],g.prototype,"disableWorkspaceTrust",null),e.AbstractNativeEnvironmentService=g;function i(t,h){return m(t["inspect-extensions"],t["inspect-brk-extensions"],5870,h,t.debugId,t.extensionEnvironment)}e.parseExtensionHostPort=i;function I(t,h){return m(t["inspect-search"],t["inspect-brk-search"],5876,h,t.extensionEnvironment)}e.parseSearchPort=I;function S(t,h){return m(t["inspect-ptyhost"],t["inspect-brk-ptyhost"],5877,h,t.extensionEnvironment)}e.parsePtyHostPort=S;function m(t,h,E,v,y,u){const c=Number(h||t)||(v?null:E),n=c?Boolean(!!h):!1;let o;if(u)try{o=JSON.parse(u)}catch{}return{port:c,break:n,debugId:y,env:o}}}),define(Q[88],J([0,1,241,3,134]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const M={o:(0,D.localize)(0,null),e:(0,D.localize)(1,null),t:(0,D.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,D.localize)(3,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,D.localize)(4,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,D.localize)(5,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,D.localize)(6,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,D.localize)(7,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,D.localize)(8,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,D.localize)(9,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,D.localize)(10,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,D.localize)(11,null)},"extensions-dir":{type:"string",deprecates:"extensionHomePath",cat:"e",args:"dir",description:(0,D.localize)(12,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,D.localize)(13,null)},"show-versions":{type:"boolean",cat:"e",description:(0,D.localize)(14,null)},category:{type:"string",cat:"e",description:(0,D.localize)(15,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"extension-id[@version] | path-to-vsix",description:(0,D.localize)(16,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(17,null)},"enable-proposed-api":{type:"string[]",cat:"e",args:"extension-id",description:(0,D.localize)(18,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,D.localize)(19,null)},verbose:{type:"boolean",cat:"t",description:(0,D.localize)(20,null)},log:{type:"string",cat:"t",args:"level",description:(0,D.localize)(21,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,D.localize)(22,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,D.localize)(23,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:"disableExtensions",cat:"t",description:(0,D.localize)(24,null)},"disable-extension":{type:"string[]",cat:"t",args:"extension-id",description:(0,D.localize)(25,null)},sync:{type:"string",cat:"t",description:(0,D.localize)(26,null),args:["on","off"]},"inspect-extensions":{type:"string",deprecates:"debugPluginHost",args:"port",cat:"t",description:(0,D.localize)(27,null)},"inspect-brk-extensions":{type:"string",deprecates:"debugBrkPluginHost",args:"port",cat:"t",description:(0,D.localize)(28,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,D.localize)(29,null)},"max-memory":{type:"string",cat:"t",description:(0,D.localize)(30,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,D.localize)(31,null)},remote:{type:"string"},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string"},"inspect-brk-ptyhost":{type:"string"},"inspect-search":{type:"string",deprecates:"debugSearch"},"inspect-brk-search":{type:"string",deprecates:"debugBrkSearch"},"export-default-configuration":{type:"string"},"install-source":{type:"string"},driver:{type:"string"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"driver-verbose":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},__sandbox:{type:"boolean"},logsPath:{type:"string"},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string"},"inspect-brk":{type:"string"},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},_:{type:"string[]"}};const P={onUnknownOption:()=>{},onMultipleValues:()=>{}};function b(t,h,E=P){const v={},y=[],u=[];for(let o in h){const s=h[o];s.alias&&(v[o]=s.alias),s.type==="string"||s.type==="string[]"?(y.push(o),s.deprecates&&y.push(s.deprecates)):s.type==="boolean"&&(u.push(o),s.deprecates&&u.push(s.deprecates))}const l=p(t,{string:y,boolean:u,alias:v}),c={},n=l;c._=l._.map(o=>String(o)).filter(o=>o.length>0),delete n._;for(let o in h){const s=h[o];s.alias&&delete n[s.alias];let r=n[o];s.deprecates&&n.hasOwnProperty(s.deprecates)&&(r||(r=n[s.deprecates]),delete n[s.deprecates]),typeof r!="undefined"&&(s.type==="string[]"?r&&!Array.isArray(r)&&(r=[r]):s.type==="string"&&Array.isArray(r)&&(r=r.pop(),E.onMultipleValues(o,r)),c[o]=r),delete n[o]}for(let o in n)E.onUnknownOption(o);return c}e.parseArgs=b;function d(t,h){let E="";return h.args&&(Array.isArray(h.args)?E=` <${h.args.join("> <")}>`:E=` <${h.args}>`),h.alias?`-${h.alias} --${t}${E}`:`--${t}${E}`}function g(t,h){let E=0,v=[];for(const c in t){const n=t[c],o=d(c,n);E=Math.max(E,o.length),v.push([o,n.description])}let y=E+2+1;if(h-y<25)return v.reduce((c,n)=>c.concat([`  ${n[0]}`,`      ${n[1]}`]),[]);let u=h-y-1,l=[];for(const c of v){let n=c[0],o=I(c[1],u),s=i(y-n.length-2);l.push("  "+n+s+o[0]);for(let r=1;r<o.length;r++)l.push(i(y)+o[r])}return l}e.formatOptions=g;function i(t){return" ".repeat(t)}function I(t,h){let E=[];for(;t.length;){let v=t.length<h?t.length:t.lastIndexOf(" ",h),y=t.slice(0,v).trim();t=t.slice(v),E.push(y)}return E}function S(t,h,E,v,y=!0){const u=process.stdout.isTTY&&process.stdout.columns||80;let l=[`${t} ${E}`];l.push(""),l.push(`${(0,D.localize)(32,null)}: ${h} [${(0,D.localize)(33,null)}][${(0,D.localize)(34,null)}...]`),l.push(""),y&&(L.isWindows?l.push((0,D.localize)(35,null,h)):l.push((0,D.localize)(36,null,h)),l.push(""));const c={};for(const n in v){const o=v[n];if(o.description&&o.cat){let s=c[o.cat];s||(c[o.cat]=s={}),s[n]=o}}for(let n in c){const o=n;let s=c[o];s&&(l.push(M[o]),l.push(...g(s,u)),l.push(""))}return l.join(`
`)}e.buildHelpMessage=S;function m(t,h){return`${t||(0,D.localize)(37,null)}
${h||(0,D.localize)(38,null)}
${process.arch}`}e.buildVersionMessage=m}),define(Q[159],J([0,1,61,156,88]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronExtensionHostDebugBroadcastChannel=void 0;class M extends L.ExtensionHostDebugBroadcastChannel{constructor(b){super();this.windowsMainService=b}call(b,d,g){return d==="openExtensionDevelopmentHostWindow"?this.openExtensionDevelopmentHostWindow(g[0],g[1]):super.call(b,d,g)}async openExtensionDevelopmentHostWindow(b,d){const g=(0,D.parseArgs)(b,D.OPTIONS);g.debugRenderer=d;const i=g.extensionDevelopmentPath;if(!i)return{success:!1};const[I]=this.windowsMainService.openExtensionDevelopmentHostWindow(i,{context:5,cli:g});if(!d)return{success:!0};const S=I.win;if(!S)return{success:!0};const m=S.webContents.debugger;let t=m.isAttached()?Infinity:0;const h=(0,p.createServer)(E=>{t++==0&&m.attach();let v=!1;const y=c=>{v||E.write(JSON.stringify(c)+"\0")},u=(c,n,o,s)=>y({method:n,params:o,sessionId:s});S.on("close",()=>{m.removeListener("message",u),E.end(),v=!0}),m.addListener("message",u);let l=Buffer.alloc(0);E.on("data",c=>{l=Buffer.concat([l,c]);for(let n=l.indexOf(0);n!==-1;n=l.indexOf(0)){let o;try{const s=l.slice(0,n).toString("utf8");l=l.slice(n+1),o=JSON.parse(s)}catch(s){console.error("error reading cdp line",s)}m.sendCommand(o.method,o.params,o.sessionId).then(s=>y({id:o.id,sessionId:o.sessionId,result:s})).catch(s=>y({id:o.id,sessionId:o.sessionId,error:{code:0,message:s.message}}))}}),E.on("error",c=>{console.error("error on cdp pipe:",c)}),E.on("close",()=>{v=!0,--t==0&&m.detach()})});return await new Promise(E=>h.listen(0,E)),S.on("close",()=>h.close()),{rendererDebugPort:h.address().port,success:!0}}}e.ElectronExtensionHostDebugBroadcastChannel=M}),function(){"use strict";function j(e,p,L,D){function M(b){const d=P(b),g=[d];return e.isAbsolute(d)||g.unshift(D),e.resolve(...g)}function P(b){const d=process.env.VSCODE_PORTABLE;if(d)return e.join(d,"user-data");let g=process.env.VSCODE_APPDATA;if(g)return e.join(g,L);const i=b["user-data-dir"];if(i)return i;switch(process.platform){case"win32":if(g=process.env.APPDATA,!g){const I=process.env.USERPROFILE;if(typeof I!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");g=e.join(I,"AppData","Roaming")}break;case"darwin":g=e.join(p.homedir(),"Library","Application Support");break;case"linux":g=process.env.XDG_CONFIG_HOME||e.join(p.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(g,L)}return{getUserDataPath:M}}if(typeof define=="function")define(Q[160],J([0,242,25,10,15,32]),function(e,p,L,D,M,P){const b=M.dirname(D.FileAccess.asFileUri("",e)),d=e.__$__nodeRequire(M.joinPath(b,"package.json").fsPath);return j(p,L,d.name,P.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),p=require("path"),L=require("os");module.exports=j(p,L,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Q[161],J([0,1,25,158,160]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class M extends L.AbstractNativeEnvironmentService{constructor(b,d){super(b,{homeDir:(0,p.homedir)(),tmpDir:(0,p.tmpdir)(),userDataDir:(0,D.getUserDataPath)(b)},d)}}e.NativeEnvironmentService=M}),define(Q[162],J([0,1,31,25,8]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createWaitMarkerFile=void 0;function M(P){const b=(0,D.join)((0,L.tmpdir)(),Math.random().toString(36).replace(/[^a-z]+/g,"").substr(0,10));try{return p.writeFileSync(b,""),P&&console.log(`Marker file for --wait created: ${b}`),b}catch(d){P&&console.error(`Failed to create marker file for --wait: ${d}`);return}}e.createWaitMarkerFile=M}),define(Q[163],J([0,1,138]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const L=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,D=/^-(\d{4})(\d{2})(\d{2})$/;function M(S){return S=S.trim(),S==="*"||L.test(S)}e.isValidVersionStr=M;function P(S){if(!M(S))return null;if(S=S.trim(),S==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};let m=S.match(L);return m?{hasCaret:m[1]==="^",hasGreaterEquals:m[1]===">=",majorBase:m[2]==="x"?0:parseInt(m[2],10),majorMustEqual:m[2]!=="x",minorBase:m[4]==="x"?0:parseInt(m[4],10),minorMustEqual:m[4]!=="x",patchBase:m[6]==="x"?0:parseInt(m[6],10),patchMustEqual:m[6]!=="x",preRelease:m[8]||null}:null}e.parseVersion=P;function b(S){if(!S)return null;let m=S.majorBase,t=S.majorMustEqual,h=S.minorBase,E=S.minorMustEqual,v=S.patchBase,y=S.patchMustEqual;S.hasCaret&&(m===0||(E=!1),y=!1);let u=0;if(S.preRelease){const l=D.exec(S.preRelease);if(l){const[,c,n,o]=l;u=Date.UTC(Number(c),Number(n)-1,Number(o))}}return{majorBase:m,majorMustEqual:t,minorBase:h,minorMustEqual:E,patchBase:v,patchMustEqual:y,isMinimum:S.hasGreaterEquals,notBefore:u}}e.normalizeVersion=b;function d(S,m,t){let h;typeof S=="string"?h=b(P(S)):h=S;let E;m instanceof Date?E=m.getTime():typeof m=="string"&&(E=new Date(m).getTime());let v;if(typeof t=="string"?v=b(P(t)):v=t,!h||!v)return!1;let y=h.majorBase,u=h.minorBase,l=h.patchBase,c=v.majorBase,n=v.minorBase,o=v.patchBase,s=v.notBefore,r=v.majorMustEqual,a=v.minorMustEqual,f=v.patchMustEqual;return v.isMinimum?y>c?!0:y<c?!1:u>n?!0:u<n||E&&E<s?!1:l>=o:(y===1&&c===0&&(!r||!a||!f)&&(c=1,n=0,o=0,r=!0,a=!1,f=!1),y<c?!1:y>c?!r:u<n?!1:u>n?!a:l<o?!1:l>o?!f:!(E&&E<s))}e.isValidVersion=d;function g(S,m,t,h){return t.isBuiltin||typeof t.main=="undefined"?!0:I(S,m,t.engines.vscode,h)}e.isValidExtensionVersion=g;function i(S,m,t){return S==="*"||I(m,t,S)}e.isEngineValid=i;function I(S,m,t,h=[]){let E=b(P(t));if(!E)return h.push(p.localize(0,null,t)),!1;if(E.majorBase===0){if(!E.majorMustEqual||!E.minorMustEqual)return h.push(p.localize(1,null,t)),!1}else if(!E.majorMustEqual)return h.push(p.localize(2,null,t)),!1;return d(S,m,E)?!0:(h.push(p.localize(3,null,S,t)),!1)}}),define(Q[164],J([0,1,13,143,3,4,7,16,59,23,8]),function(j,e,p,L,D,M,P,b,d,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderChannel=void 0;class I{constructor(m){this.provider=m}call(m,t,h){switch(t){case"stat":return this.stat(P.URI.revive(h[0]));case"readdir":return this.readdir(P.URI.revive(h[0]));case"open":return this.open(P.URI.revive(h[0]),h[1]);case"close":return this.close(h[0]);case"read":return this.read(h[0],h[1],h[2]);case"readFile":return this.readFile(P.URI.revive(h[0]));case"write":return this.write(h[0],h[1],h[2],h[3],h[4]);case"writeFile":return this.writeFile(P.URI.revive(h[0]),h[1],h[2]);case"rename":return this.rename(P.URI.revive(h[0]),P.URI.revive(h[1]),h[2]);case"copy":return this.copy(P.URI.revive(h[0]),P.URI.revive(h[1]),h[2]);case"mkdir":return this.mkdir(P.URI.revive(h[0]));case"delete":return this.delete(P.URI.revive(h[0]),h[1])}throw new Error(`IPC Command ${t} not found`)}listen(m,t,h){switch(t){case"filechange":return M.Event.None;case"readFileStream":return this.onReadFileStream(h[0],h[1])}throw new Error(`Unknown event ${t}`)}onReadFileStream(m,t){const h=new g.CancellationTokenSource,E=new M.Emitter({onLastListenerRemove:()=>{h.cancel()}}),v=this.provider.readFileStream(P.URI.revive(m),t,h.token);return(0,d.listenStream)(v,{onData:y=>E.fire(b.VSBuffer.wrap(y)),onError:y=>E.fire(y),onEnd:()=>{E.fire("end"),E.dispose(),h.dispose()}}),E.event}stat(m){return this.provider.stat(m)}readdir(m){return this.provider.readdir(m)}open(m,t){return this.provider.open(m,t)}close(m){return this.provider.close(m)}async read(m,t,h){const E=b.VSBuffer.alloc(h),v=0,y=await this.provider.read(m,t,E.buffer,v,h);return[E,y]}async readFile(m){const t=await this.provider.readFile(m);return b.VSBuffer.wrap(t)}write(m,t,h,E,v){return this.provider.write(m,t,h.buffer,E,v)}writeFile(m,t,h){return this.provider.writeFile(m,t.buffer,h)}rename(m,t,h){return this.provider.rename(m,t,h)}copy(m,t,h){return this.provider.copy(m,t,h)}mkdir(m){return this.provider.mkdir(m)}async delete(m,t){if(!t.useTrash)return this.provider.delete(m,t);const h=(0,i.normalize)(m.fsPath);try{await p.shell.trashItem(h)}catch(E){throw new Error(D.isWindows?(0,L.localize)(0,null,(0,i.basename)(h)):(0,L.localize)(1,null,(0,i.basename)(h)))}}}e.DiskFileSystemProviderChannel=I}),define(Q[73],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class p{constructor(D,M=[],P=!1){this.ctor=D,this.staticArguments=M,this.supportsDelayedInstantiation=P}}e.SyncDescriptor=p}),define(Q[165],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class p{constructor(M){this.incoming=new Map,this.outgoing=new Map,this.data=M}}e.Node=p;class L{constructor(M){this._hashFn=M,this._nodes=new Map}roots(){const M=[];for(let P of this._nodes.values())P.outgoing.size===0&&M.push(P);return M}insertEdge(M,P){const b=this.lookupOrInsertNode(M),d=this.lookupOrInsertNode(P);b.outgoing.set(this._hashFn(P),d),d.incoming.set(this._hashFn(M),b)}removeNode(M){const P=this._hashFn(M);this._nodes.delete(P);for(let b of this._nodes.values())b.outgoing.delete(P),b.incoming.delete(P)}lookupOrInsertNode(M){const P=this._hashFn(M);let b=this._nodes.get(P);return b||(b=new p(M),this._nodes.set(P,b)),b}lookup(M){return this._nodes.get(this._hashFn(M))}isEmpty(){return this._nodes.size===0}toString(){let M=[];for(let[P,b]of this._nodes)M.push(`${P}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return M.join(`
`)}findCycleSlow(){for(let[M,P]of this._nodes){const b=new Set([M]),d=this._findCycle(P,b);if(d)return d}}_findCycle(M,P){for(let[b,d]of M.outgoing){if(P.has(b))return[...P,b].join(" -> ");P.add(b);const g=this._findCycle(d,P);if(g)return g;P.delete(b)}}}e.Graph=L}),define(Q[5],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.optional=e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var p;(function(b){b.serviceIds=new Map,b.DI_TARGET="$di$target",b.DI_DEPENDENCIES="$di$dependencies";function d(g){return g[b.DI_DEPENDENCIES]||[]}b.getServiceDependencies=d})(p=e._util||(e._util={})),e.IInstantiationService=D("instantiationService");function L(b,d,g,i){d[p.DI_TARGET]===d?d[p.DI_DEPENDENCIES].push({id:b,index:g,optional:i}):(d[p.DI_DEPENDENCIES]=[{id:b,index:g,optional:i}],d[p.DI_TARGET]=d)}function D(b){if(p.serviceIds.has(b))return p.serviceIds.get(b);const d=function(g,i,I){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");L(d,g,I,!1)};return d.toString=()=>b,p.serviceIds.set(b,d),d}e.createDecorator=D;function M(b){return b}e.refineServiceDecorator=M;function P(b){return function(d,g,i){if(arguments.length!==3)throw new Error("@optional-decorator can only be used to decorate a parameter");L(b,d,i,!0)}}e.optional=P}),define(Q[74],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,p.createDecorator)(e.ID);function L(D){return!!D.hostName&&!!D.errorMessage}e.isRemoteDiagnosticError=L}),define(Q[89],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EncryptionMainService=e.IEncryptionMainService=void 0,e.IEncryptionMainService=(0,p.createDecorator)("encryptionMainService");class L{constructor(M){this.machineId=M}encryption(){return new Promise((M,P)=>j(["vscode-encrypt"],M,P))}async encrypt(M){try{return(await this.encryption()).encrypt(this.machineId,M)}catch(P){return M}}async decrypt(M){try{return(await this.encryption()).decrypt(this.machineId,M)}catch(P){return M}}}e.EncryptionMainService=L}),define(Q[48],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,p.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,p.refineServiceDecorator)(e.IEnvironmentService)}),define(Q[166],J([0,1,10,137,5]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.DefaultIconPath=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IExtensionManagementService=e.ExtensionManagementError=e.INSTALL_ERROR_INCOMPATIBLE=e.INSTALL_ERROR_MALICIOUS=e.INSTALL_ERROR_NOT_SUPPORTED=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.TargetPlatform=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";var M;(function(y){y.WIN32_X64="win32-x64",y.WIN32_IA32="win32-ia32",y.WIN32_ARM64="win32-arm64",y.LINUX_X64="linux-x64",y.LINUX_ARM64="linux-arm64",y.LINUX_ARMHF="linux-armhf",y.ALPINE_X64="alpine-x64",y.ALPINE_ARM64="alpine-arm64",y.DARWIN_X64="darwin-x64",y.DARWIN_ARM64="darwin-arm64",y.WEB="web",y.UNIVERSAL="universal",y.UNKNOWN="unknown",y.UNDEFINED="undefined"})(M=e.TargetPlatform||(e.TargetPlatform={}));function P(y){switch(y){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=P;function b(y){switch(y){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=b;function d(y,u){switch(y){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=d;function g(y,u){return u==="web"&&!y.includes("web")}e.isNotWebExtensionInWebTargetPlatform=g;function i(y,u,l){return g(u,l)?!1:y==="undefined"||y==="universal"?!0:y==="unknown"?!1:y===l?!0:I(l).includes(y)}e.isTargetPlatformCompatible=i;function I(y){switch(y){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function S(y){return y&&typeof y=="object"&&typeof y.id=="string"&&(!y.uuid||typeof y.uuid=="string")}e.isIExtensionIdentifier=S;var m;(function(y){y[y.NoneOrRelevance=0]="NoneOrRelevance",y[y.LastUpdatedDate=1]="LastUpdatedDate",y[y.Title=2]="Title",y[y.PublisherName=3]="PublisherName",y[y.InstallCount=4]="InstallCount",y[y.PublishedDate=10]="PublishedDate",y[y.AverageRating=6]="AverageRating",y[y.WeightedRating=12]="WeightedRating"})(m=e.SortBy||(e.SortBy={}));var t;(function(y){y[y.Default=0]="Default",y[y.Ascending=1]="Ascending",y[y.Descending=2]="Descending"})(t=e.SortOrder||(e.SortOrder={}));var h;(function(y){y.Install="install",y.Uninstall="uninstall"})(h=e.StatisticType||(e.StatisticType={}));var E;(function(y){y[y.None=0]="None",y[y.Install=1]="Install",y[y.Update=2]="Update"})(E=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,D.createDecorator)("extensionGalleryService"),e.INSTALL_ERROR_NOT_SUPPORTED="notsupported",e.INSTALL_ERROR_MALICIOUS="malicious",e.INSTALL_ERROR_INCOMPATIBLE="incompatible";class v extends Error{constructor(u,l){super(u);this.code=l,this.name=l}}e.ExtensionManagementError=v,e.IExtensionManagementService=(0,D.createDecorator)("extensionManagementService"),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,D.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,D.createDecorator)("IExtensionTipsService"),e.DefaultIconPath=p.FileAccess.asBrowserUri("./media/defaultIcon.png",j).toString(!0),e.ExtensionsLabel=(0,L.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,L.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,D.createDecorator)("IExtensionManagementCLIService")}),define(Q[167],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionUrlTrustService=void 0,e.IExtensionUrlTrustService=(0,p.createDecorator)("extensionUrlTrustService")}),define(Q[90],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExternalTerminalMainService=e.DEFAULT_TERMINAL_OSX=e.IExternalTerminalService=void 0,e.IExternalTerminalService=(0,p.createDecorator)("externalTerminal"),e.DEFAULT_TERMINAL_OSX="Terminal.app",e.IExternalTerminalMainService=(0,p.createDecorator)("externalTerminal")}),define(Q[168],J([0,1,44,10,8,3,81,19,71,139,90]),function(j,e,p,L,D,M,P,b,d,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxExternalTerminalService=e.MacExternalTerminalService=e.WindowsExternalTerminalService=void 0;const I=g.localize(0,null);class S{async getDefaultTerminalForPlatforms(){return{windows:m.getDefaultTerminalWindows(),linux:await h.getDefaultTerminalLinuxReady(),osx:"xterm"}}}class m extends S{openTerminal(l,c){return this.spawnTerminal(p,l,d.getWindowsShell(),c)}spawnTerminal(l,c,n,o){const s=c.windowsExec||m.getDefaultTerminalWindows();o&&o[1]===":"&&(o=o[0].toUpperCase()+o.substr(1));const r=D.basename(s).toLowerCase();if(r==="cmder"||r==="cmder.exe")return l.spawn(s,o?[o]:void 0),Promise.resolve(void 0);const a=["/c","start","/wait"];return s.indexOf(" ")>=0&&a.push('""'),a.push(s),(r==="wt"||r==="wt.exe")&&a.push("-d ."),new Promise((f,w)=>{const k=E(process),R=l.spawn(n,a,{cwd:o,env:k});R.on("error",w),R.on("exit",()=>f())})}runInTerminal(l,c,n,o,s){const r="windowsExec"in s&&s.windowsExec?s.windowsExec:m.getDefaultTerminalWindows();return new Promise((a,f)=>{const w=`"${c} - ${I}"`,k=`""${n.join('" "')}" & pause"`,R=["/c","start",w,"/wait",r,"/c",k],A=Object.assign({},E(process),o);Object.keys(A).filter(x=>A[x]===null).forEach(x=>delete A[x]);const O={cwd:c,env:A,windowsVerbatimArguments:!0};p.spawn(m.CMD,R,O).on("error",x=>{f(v(x))}),a(void 0)})}static getDefaultTerminalWindows(){if(!m._DEFAULT_TERMINAL_WINDOWS){const l=!!process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432");m._DEFAULT_TERMINAL_WINDOWS=`${process.env.windir?process.env.windir:"C:\\Windows"}\\${l?"Sysnative":"System32"}\\cmd.exe`}return m._DEFAULT_TERMINAL_WINDOWS}}e.WindowsExternalTerminalService=m,m.CMD="cmd.exe";class t extends S{openTerminal(l,c){return this.spawnTerminal(p,l,c)}runInTerminal(l,c,n,o,s){const r=s.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((a,f)=>{if(r===i.DEFAULT_TERMINAL_OSX||r==="iTerm.app"){const w=r===i.DEFAULT_TERMINAL_OSX?"TerminalHelper":"iTermHelper",R=[L.FileAccess.asFileUri(`vs/workbench/contrib/externalTerminal/node/${w}.scpt`,j).fsPath,"-t",l||I,"-w",c];for(let H of n)R.push("-a"),R.push(H);if(o){const H=Object.assign({},E(process),o);for(let x in H){const re=H[x];re===null?(R.push("-u"),R.push(x)):(R.push("-e"),R.push(`${x}=${re}`))}}let A="";const O=p.spawn(t.OSASCRIPT,R);O.on("error",H=>{f(v(H))}),O.stderr.on("data",H=>{A+=H.toString()}),O.on("exit",H=>{if(H===0)a(void 0);else if(A){const x=A.split(`
`,1);f(new Error(x[0]))}else f(new Error(g.localize(1,null,w,H)))})}else f(new Error(g.localize(2,null,r)))})}spawnTerminal(l,c,n){const o=c.osxExec||i.DEFAULT_TERMINAL_OSX;return new Promise((s,r)=>{const a=["-a",o];n&&a.push(n);const f=E(process),w=l.spawn("/usr/bin/open",a,{cwd:n,env:f});w.on("error",r),w.on("exit",()=>s())})}}e.MacExternalTerminalService=t,t.OSASCRIPT="/usr/bin/osascript";class h extends S{openTerminal(l,c){return this.spawnTerminal(p,l,c)}runInTerminal(l,c,n,o,s){const r=s.linuxExec?Promise.resolve(s.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((a,f)=>{let w=[];r.then(k=>{k.indexOf("gnome-terminal")>=0?w.push("-x"):w.push("-e"),w.push("bash"),w.push("-c");const R=`${y(n)}; echo; read -p "${h.WAIT_MESSAGE}" -n1;`;w.push(`''${R}''`);const A=Object.assign({},E(process),o);Object.keys(A).filter(re=>A[re]===null).forEach(re=>delete A[re]);const O={cwd:c,env:A};let H="";const x=p.spawn(k,w,O);x.on("error",re=>{f(v(re))}),x.stderr.on("data",re=>{H+=re.toString()}),x.on("exit",re=>{if(re===0)a(void 0);else if(H){const K=H.split(`
`,1);f(new Error(K[0]))}else f(new Error(g.localize(4,null,k,re)))})})})}static async getDefaultTerminalLinuxReady(){if(!h._DEFAULT_TERMINAL_LINUX_READY)if(!M.isLinux)h._DEFAULT_TERMINAL_LINUX_READY=Promise.resolve("xterm");else{const l=await b.Promises.exists("/etc/debian_version");h._DEFAULT_TERMINAL_LINUX_READY=new Promise(c=>{l?c("x-terminal-emulator"):process.env.DESKTOP_SESSION==="gnome"||process.env.DESKTOP_SESSION==="gnome-classic"?c("gnome-terminal"):process.env.DESKTOP_SESSION==="kde-plasma"?c("konsole"):process.env.COLORTERM?c(process.env.COLORTERM):process.env.TERM?c(process.env.TERM):c("xterm")})}return h._DEFAULT_TERMINAL_LINUX_READY}spawnTerminal(l,c,n){const o=c.linuxExec?Promise.resolve(c.linuxExec):h.getDefaultTerminalLinuxReady();return new Promise((s,r)=>{o.then(a=>{const f=E(process),w=l.spawn(a,[],{cwd:n,env:f});w.on("error",r),w.on("exit",()=>s())})})}}e.LinuxExternalTerminalService=h,h.WAIT_MESSAGE=g.localize(3,null);function E(u){const l={...u.env};return(0,P.sanitizeProcessEnvironment)(l),l}function v(u){return"errno"in u&&u.errno==="ENOENT"&&"path"in u&&typeof u.path=="string"?new Error(g.localize(5,null,u.path)):u}function y(u){let l="";for(let c of u)c.indexOf(" ")>=0?l+='"'+c+'"':l+=c,l+=" ";return l}}),define(Q[20],J([0,1,40,8,27,14,7,141,5]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,d.createDecorator)("fileService");function g(F){return F.create===!0}e.isFileOpenForWriteOptions=g;var i;(function(F){F[F.Unknown=0]="Unknown",F[F.File=1]="File",F[F.Directory=2]="Directory",F[F.SymbolicLink=64]="SymbolicLink"})(i=e.FileType||(e.FileType={}));var I;(function(F){F[F.Readonly=1]="Readonly"})(I=e.FilePermission||(e.FilePermission={}));var S;(function(F){F[F.FileReadWrite=2]="FileReadWrite",F[F.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",F[F.FileReadStream=16]="FileReadStream",F[F.FileFolderCopy=8]="FileFolderCopy",F[F.PathCaseSensitive=1024]="PathCaseSensitive",F[F.Readonly=2048]="Readonly",F[F.Trash=4096]="Trash",F[F.FileWriteUnlock=8192]="FileWriteUnlock"})(S=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function m(F){return!!(F.capabilities&2)}e.hasReadWriteCapability=m;function t(F){return!!(F.capabilities&8)}e.hasFileFolderCopyCapability=t;function h(F){return!!(F.capabilities&4)}e.hasOpenReadWriteCloseCapability=h;function E(F){return!!(F.capabilities&16)}e.hasFileReadStreamCapability=E;var v;(function(F){F.FileExists="EntryExists",F.FileNotFound="EntryNotFound",F.FileNotADirectory="EntryNotADirectory",F.FileIsADirectory="EntryIsADirectory",F.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",F.FileTooLarge="EntryTooLarge",F.FileWriteLocked="EntryWriteLocked",F.NoPermissions="NoPermissions",F.Unavailable="Unavailable",F.Unknown="Unknown"})(v=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class y extends Error{constructor(V,z){super(V);this.code=z}}e.FileSystemProviderError=y;function u(F,V){const z=new y(F.toString(),V);return c(z,V),z}e.createFileSystemProviderError=u;function l(F){return F||u((0,b.localize)(0,null),v.Unknown)}e.ensureFileSystemProviderError=l;function c(F,V){return F.name=V?`${V} (FileSystemError)`:"FileSystemError",F}e.markAsFileSystemProviderError=c;function n(F){if(!F)return v.Unknown;if(F instanceof y)return F.code;const V=/^(.+) \(FileSystemError\)$/.exec(F.name);if(!V)return v.Unknown;switch(V[1]){case v.FileExists:return v.FileExists;case v.FileIsADirectory:return v.FileIsADirectory;case v.FileNotADirectory:return v.FileNotADirectory;case v.FileNotFound:return v.FileNotFound;case v.FileExceedsMemoryLimit:return v.FileExceedsMemoryLimit;case v.FileTooLarge:return v.FileTooLarge;case v.FileWriteLocked:return v.FileWriteLocked;case v.NoPermissions:return v.NoPermissions;case v.Unavailable:return v.Unavailable}return v.Unknown}e.toFileSystemProviderErrorCode=n;function o(F){if(F instanceof k)return F.fileOperationResult;switch(n(F)){case v.FileNotFound:return 1;case v.FileIsADirectory:return 0;case v.FileNotADirectory:return 10;case v.FileWriteLocked:return 5;case v.NoPermissions:return 6;case v.FileExists:return 4;case v.FileExceedsMemoryLimit:return 9;case v.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=o;var s;(function(F){F[F.CREATE=0]="CREATE",F[F.DELETE=1]="DELETE",F[F.MOVE=2]="MOVE",F[F.COPY=3]="COPY"})(s=e.FileOperation||(e.FileOperation={}));class r{constructor(V,z,B){this.resource=V,this.operation=z,this.target=B}isOperation(V){return this.operation===V}}e.FileOperationEvent=r;var a;(function(F){F[F.UPDATED=0]="UPDATED",F[F.ADDED=1]="ADDED",F[F.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class f{constructor(V,z){this.added=void 0,this.updated=void 0,this.deleted=void 0;const B=new Map;for(const U of V){const C=B.get(U.type);C?C.push([U.resource,U]):B.set(U.type,[[U.resource,U]])}for(const[U,C]of B)switch(U){case 1:this.added=p.TernarySearchTree.forUris(()=>z),this.added.fill(C);break;case 0:this.updated=p.TernarySearchTree.forUris(()=>z),this.updated.fill(C);break;case 2:this.deleted=p.TernarySearchTree.forUris(()=>z),this.deleted.fill(C);break}}contains(V,...z){return this.doContains(V,{includeChildren:!1},...z)}affects(V,...z){return this.doContains(V,{includeChildren:!0},...z)}doContains(V,z,...B){if(!V)return!1;const U=B.length>0;return!!((!U||B.includes(1))&&(this.added?.get(V)||z.includeChildren&&this.added?.findSuperstr(V))||(!U||B.includes(0))&&(this.updated?.get(V)||z.includeChildren&&this.updated?.findSuperstr(V))||(!U||B.includes(2))&&(this.deleted?.findSubstr(V)||z.includeChildren&&this.deleted?.findSuperstr(V)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}get rawAdded(){return this.added}get rawDeleted(){return this.deleted}}e.FileChangesEvent=f;function w(F,V,z){return!F||!V||F===V||V.length>F.length?!1:(V.charAt(V.length-1)!==L.sep&&(V+=L.sep),z?(0,D.startsWithIgnoreCase)(F,V):F.indexOf(V)===0)}e.isParent=w;class k extends Error{constructor(V,z,B){super(V);this.fileOperationResult=z,this.options=B}}e.FileOperationError=k;class R extends k{constructor(V,z,B){super(V,2,B);this.stat=z}}e.NotModifiedSinceFileOperationError=R;var A;(function(F){F[F.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",F[F.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",F[F.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",F[F.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",F[F.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",F[F.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",F[F.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",F[F.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",F[F.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",F[F.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",F[F.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",F[F.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(A=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var O;(function(F){F[F.FILE=0]="FILE",F[F.FOLDER=1]="FOLDER",F[F.ROOT_FOLDER=2]="ROOT_FOLDER"})(O=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function H(F){if(!(typeof F.size!="number"||typeof F.mtime!="number"))return F.mtime.toString(29)+F.size.toString(31)}e.etag=H;async function x(F,V){if(!V.hasProvider(P.URI.from({scheme:F.scheme})))return new Promise(z=>{const B=V.onDidChangeFileSystemProviderRegistrations(U=>{U.scheme===F.scheme&&U.added&&(B.dispose(),z())})})}e.whenProviderRegistered=x,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class re{static formatSize(V){return(0,M.isNumber)(V)||(V=0),V<re.KB?(0,b.localize)(1,null,V.toFixed(0)):V<re.MB?(0,b.localize)(2,null,(V/re.KB).toFixed(2)):V<re.GB?(0,b.localize)(3,null,(V/re.MB).toFixed(2)):V<re.TB?(0,b.localize)(4,null,(V/re.GB).toFixed(2)):(0,b.localize)(5,null,(V/re.TB).toFixed(2))}}e.ByteSize=re,re.KB=1024,re.MB=re.KB*re.KB,re.GB=re.MB*re.KB,re.TB=re.GB*re.KB;var K;(function(F){F[F.IA32=0]="IA32",F[F.OTHER=1]="OTHER"})(K=e.Arch||(e.Arch={}));function ee(F){return{maxFileSize:F===0?300*re.MB:16*re.GB,maxHeapSize:F===0?700*re.MB:2*700*re.MB}}e.getPlatformLimits=ee}),define(Q[54],J([0,1,243,135,88,20]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;function P(S,m){const t={onUnknownOption:E=>{console.warn((0,L.localize)(0,null,E))},onMultipleValues:(E,v)=>{console.warn((0,L.localize)(1,null,E,v))}},h=(0,D.parseArgs)(S,D.OPTIONS,m?t:void 0);return h.goto&&h._.forEach(E=>p(/^(\w:)?[^:]+(:\d*){0,2}$/.test(E),(0,L.localize)(2,null))),h["max-memory"]&&p(parseInt(h["max-memory"])>=M.MIN_MAX_MEMORY_SIZE_MB,`The max-memory argument cannot be specified lower than ${M.MIN_MAX_MEMORY_SIZE_MB} MB.`),h}function b(S){const m=S.findIndex(t=>!/^-/.test(t));if(m>-1)return[...S.slice(0,m),...S.slice(m+1)]}function d(S){let[,...m]=S;process.env.VSCODE_DEV&&(m=b(m)||[]);const t=!I(process.env);return P(m,t)}e.parseMainProcessArgv=d;function g(S){const[,,...m]=S;return P(m,!0)}e.parseCLIProcessArgv=g;function i(S,...m){const t=S.indexOf("--");return t===-1?S.push(...m):S.splice(t,0,...m),S}e.addArg=i;function I(S){return S.VSCODE_CLI==="1"}e.isLaunchedFromCli=I}),define(Q[91],J([0,1,44,8,136,23,62,18,3,28,130,54,9]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveShellEnv=void 0;const m=1e4;let t;async function h(v,y,u){return y["force-disable-user-env"]?(v.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):d.isWindows?(v.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,I.isLaunchedFromCli)(u)&&!y["force-user-env"]?(v.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,I.isLaunchedFromCli)(u)?v.trace("resolveShellEnv(): running (--force-user-env)"):v.trace("resolveShellEnv(): running (macOS/Linux)"),t||(t=S.Promises.withAsyncBody(async(l,c)=>{const n=new M.CancellationTokenSource,o=setTimeout(()=>{n.dispose(!0),c(new Error((0,D.localize)(0,null)))},m);try{l(await E(v,n.token))}catch(s){!(0,b.isPromiseCanceledError)(s)&&!n.token.isCancellationRequested?c(new Error((0,D.localize)(1,null,(0,P.toErrorMessage)(s)))):l({})}finally{clearTimeout(o),n.dispose()}})),t)}e.resolveShellEnv=h;async function E(v,y){const u=process.env.ELECTRON_RUN_AS_NODE;v.trace("getUnixShellEnvironment#runAsNode",u);const l=process.env.ELECTRON_NO_ATTACH_CONSOLE;v.trace("getUnixShellEnvironment#noAttach",l);const c=(0,g.generateUuid)().replace(/-/g,"").substr(0,12),n=new RegExp(c+"(.*)"+c),o={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};v.trace("getUnixShellEnvironment#env",o);const s=await(0,i.getSystemShell)(d.OS,o);return v.trace("getUnixShellEnvironment#shell",s),new Promise((r,a)=>{if(y.isCancellationRequested)return a((0,b.canceled)());const f=(0,L.basename)(s);let w,k;/^pwsh(-preview)?$/.test(f)?(w=`& '${process.execPath}' -p '''${c}'' + JSON.stringify(process.env) + ''${c}'''`,k=["-Login","-Command"]):(w=`'${process.execPath}' -p '"${c}" + JSON.stringify(process.env) + "${c}"'`,k=["-ilc"]),v.trace("getUnixShellEnvironment#spawn",JSON.stringify(k),w);const R=(0,p.spawn)(s,[...k,w],{detached:!0,stdio:["ignore","pipe","pipe"],env:o});y.onCancellationRequested(()=>(R.kill(),a((0,b.canceled)()))),R.on("error",H=>{v.error("getUnixShellEnvironment#errorChildProcess",(0,P.toErrorMessage)(H)),a(H)});const A=[];R.stdout.on("data",H=>A.push(H));const O=[];R.stderr.on("data",H=>O.push(H)),R.on("close",(H,x)=>{const re=Buffer.concat(A).toString("utf8");v.trace("getUnixShellEnvironment#raw",re);const K=Buffer.concat(O).toString("utf8");if(K.trim()&&v.trace("getUnixShellEnvironment#stderr",K),H||x)return a(new Error((0,D.localize)(2,null,H,x)));const ee=n.exec(re),F=ee?ee[1]:"{}";try{const V=JSON.parse(F);u?V.ELECTRON_RUN_AS_NODE=u:delete V.ELECTRON_RUN_AS_NODE,l?V.ELECTRON_NO_ATTACH_CONSOLE=l:delete V.ELECTRON_NO_ATTACH_CONSOLE,delete V.XDG_RUNTIME_DIR,v.trace("getUnixShellEnvironment#result",V),r(V)}catch(V){v.error("getUnixShellEnvironment#errorCaught",(0,P.toErrorMessage)(V)),a(V)}})})}}),define(Q[55],J([0,1,2,3,7,20]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeFileChanges=e.toFileChanges=e.WatcherService=void 0;class P extends p.Disposable{}e.WatcherService=P;function b(i){return i.map(I=>({type:I.type,resource:D.URI.file(I.path)}))}e.toFileChanges=b;function d(i){const I=new g;for(const S of i)I.processEvent(S);return I.normalize()}e.normalizeFileChanges=d;class g{constructor(){this.normalized=new Set,this.mapPathToChange=new Map}toKey(I){return L.isLinux?I.path:I.path.toLowerCase()}processEvent(I){const S=this.mapPathToChange.get(this.toKey(I));let m=!1;if(S){const t=S.type,h=I.type;S.path!==I.path&&I.type===2?m=!0:t===1&&h===2?(this.mapPathToChange.delete(this.toKey(I)),this.normalized.delete(S)):t===2&&h===1?S.type=0:t===1&&h===0||(S.type=h)}else m=!0;m&&(this.normalized.add(I),this.mapPathToChange.set(this.toKey(I),I))}normalize(){const I=[],S=[];return Array.from(this.normalized).filter(m=>m.type!==2?(I.push(m),!1):!0).sort((m,t)=>m.path.length-t.path.length).filter(m=>S.some(t=>(0,M.isParent)(m.path,t,!L.isLinux))?!1:(S.push(m.path),!0)).concat(I)}}}),define(Q[169],J([0,1,9,2,8,83,19,117,55]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class g extends L.Disposable{constructor(I,S,m,t){super();this.path=I,this.onDidFilesChange=S,this.onLogMessage=m,this.verboseLogging=t,this.fileChangesDelayer=this._register(new p.ThrottledDelayer(b.CHANGE_BUFFER_DELAY*2)),this.fileChangesBuffer=[],this.startWatching()}setVerboseLogging(I){this.verboseLogging=I}async startWatching(){try{const{stat:I,symbolicLink:S}=await P.SymlinkSupport.stat(this.path);if(this.isDisposed)return;let m=this.path;if(S)try{m=await(0,M.realpath)(m)}catch(t){if(this.onError(t),S.dangling)return}I.isDirectory()?this._register((0,b.watchFolder)(m,(t,h)=>{this.onFileChange({type:t==="changed"?0:t==="added"?1:2,path:(0,D.join)(this.path,(0,D.basename)(h))})},t=>this.onError(t))):this._register((0,b.watchFile)(m,t=>{this.onFileChange({type:t==="changed"?0:2,path:this.path})},t=>this.onError(t)))}catch(I){I.code!=="ENOENT"&&this.onError(I)}}onFileChange(I){this.fileChangesBuffer.push(I),this.verboseLogging&&this.onVerbose(`${I.type===1?"[ADDED]":I.type===2?"[DELETED]":"[CHANGED]"} ${I.path}`),this.fileChangesDelayer.trigger(async()=>{const S=this.fileChangesBuffer;this.fileChangesBuffer=[];const m=(0,d.normalizeFileChanges)(S);if(this.verboseLogging)for(const t of m)this.onVerbose(`>> normalized ${t.type===1?"[ADDED]":t.type===2?"[DELETED]":"[CHANGED]"} ${t.path}`);m.length>0&&this.onDidFilesChange(m)})}onError(I){this.isDisposed||this.onLogMessage({type:"error",message:`[File Watcher (node.js)] ${I}`})}onVerbose(I){this.isDisposed||this.onLogMessage({type:"trace",message:`[File Watcher (node.js)] ${I}`})}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=g}),define(Q[170],J([0,1,10,35,72,55]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(d,g,i,I){super();this.requests=d,this.onDidFilesChange=g,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (nsfw)",args:["--type=watcherServiceNSFW"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/nsfw/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.watch(this.requests)}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (nsfw)] ${d}`})}async watch(d){this.requests=d,await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[171],J([0,1,10,35,72,55]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(d,g,i,I){super();this.requests=d,this.onDidFilesChange=g,this.onLogMessage=i,this.verboseLogging=I,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (parcel, node.js)",args:["--type=watcherServiceParcel"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/parcel/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(d.getChannel("watcher"))),this.service.setVerboseLogging(this.verboseLogging),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.watch(this.requests)}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (parcel)] ${d}`})}async watch(d){this.requests=d,await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[172],J([0,1,10,35,72,55]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileWatcher=void 0;class P extends M.WatcherService{constructor(d,g,i,I,S={}){super();this.requests=d,this.onDidFilesChange=g,this.onLogMessage=i,this.verboseLogging=I,this.watcherOptions=S,this.isDisposed=!1,this.restartCounter=0,this.startWatching()}startWatching(){const d=this._register(new D.Client(p.FileAccess.asFileUri("bootstrap-fork",j).fsPath,{serverName:"File Watcher (chokidar)",args:["--type=watcherServiceChokidar"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/unix/watcherApp",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));this._register(d.onDidProcessExit(()=>{this.isDisposed||(this.restartCounter<=P.MAX_RESTARTS?(this.error("terminated unexpectedly and is restarted again..."),this.restartCounter++,this.startWatching()):this.error("failed to start after retrying for some time, giving up. Please report this as a bug report!"))})),this.service=L.ProxyChannel.toService((0,L.getNextTickChannel)(d.getChannel("watcher"))),this.service.init({...this.watcherOptions,verboseLogging:this.verboseLogging}),this._register(this.service.onDidChangeFile(g=>!this.isDisposed&&this.onDidFilesChange(g))),this._register(this.service.onDidLogMessage(g=>this.onLogMessage(g))),this.watch(this.requests)}async setVerboseLogging(d){this.verboseLogging=d,this.isDisposed||await this.service?.setVerboseLogging(d)}error(d){this.onLogMessage({type:"error",message:`[File Watcher (chokidar)] ${d}`})}async watch(d){this.requests=d,await this.service?.watch(d)}dispose(){this.isDisposed=!0,super.dispose()}}e.FileWatcher=P,P.MAX_RESTARTS=5}),define(Q[75],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class p{constructor(...D){this._entries=new Map;for(let[M,P]of D)this.set(M,P)}set(D,M){const P=this._entries.get(D);return this._entries.set(D,M),P}has(D){return this._entries.has(D)}get(D){return this._entries.get(D)}}e.ServiceCollection=p}),define(Q[173],J([0,1,9,18,73,165,5,75]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InstantiationService=void 0;const d=!1;class g extends Error{constructor(t){super("cyclic dependency between services");this.message=t.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${t.toString()}`}}class i{constructor(t=new b.ServiceCollection,h=!1,E){this._activeInstantiations=new Set,this._services=t,this._strict=h,this._parent=E,this._services.set(P.IInstantiationService,this)}createChild(t){return new i(t,this._strict,this)}invokeFunction(t,...h){let E=S.traceInvocation(t),v=!1;try{return t({get:(u,l)=>{if(v)throw(0,L.illegalState)("service accessor is only valid during the invocation of its target method");const c=this._getOrCreateServiceInstance(u,E);if(!c&&l!==P.optional)throw new Error(`[invokeFunction] unknown service '${u}'`);return c}},...h)}finally{v=!0,E.stop()}}createInstance(t,...h){let E,v;return t instanceof D.SyncDescriptor?(E=S.traceCreation(t.ctor),v=this._createInstance(t.ctor,t.staticArguments.concat(h),E)):(E=S.traceCreation(t),v=this._createInstance(t,h,E)),E.stop(),v}_createInstance(t,h=[],E){let v=P._util.getServiceDependencies(t).sort((l,c)=>l.index-c.index),y=[];for(const l of v){let c=this._getOrCreateServiceInstance(l.id,E);if(!c&&this._strict&&!l.optional)throw new Error(`[createInstance] ${t.name} depends on UNKNOWN service ${l.id}.`);y.push(c)}let u=v.length>0?v[0].index:h.length;if(h.length!==u){console.warn(`[createInstance] First service dependency of ${t.name} at position ${u+1} conflicts with ${h.length} static arguments`);let l=u-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,u)}return new t(...[...h,...y])}_setServiceInstance(t,h){if(this._services.get(t)instanceof D.SyncDescriptor)this._services.set(t,h);else if(this._parent)this._parent._setServiceInstance(t,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(t){let h=this._services.get(t);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(t):h}_getOrCreateServiceInstance(t,h){let E=this._getServiceInstanceOrDescriptor(t);return E instanceof D.SyncDescriptor?this._safeCreateAndCacheServiceInstance(t,E,h.branch(t,!0)):(h.branch(t,!1),E)}_safeCreateAndCacheServiceInstance(t,h,E){if(this._activeInstantiations.has(t))throw new Error(`illegal state - RECURSIVELY instantiating service '${t}'`);this._activeInstantiations.add(t);try{return this._createAndCacheServiceInstance(t,h,E)}finally{this._activeInstantiations.delete(t)}}_createAndCacheServiceInstance(t,h,E){const v=new M.Graph(l=>l.id.toString());let y=0;const u=[{id:t,desc:h,_trace:E}];for(;u.length;){const l=u.pop();if(v.lookupOrInsertNode(l),y++>1e3)throw new g(v);for(let c of P._util.getServiceDependencies(l.desc.ctor)){let n=this._getServiceInstanceOrDescriptor(c.id);if(!n&&!c.optional&&console.warn(`[createInstance] ${t} depends on ${c.id} which is NOT registered.`),n instanceof D.SyncDescriptor){const o={id:c.id,desc:n,_trace:l._trace.branch(c.id,!0)};v.insertEdge(l,o),u.push(o)}}}for(;;){const l=v.roots();if(l.length===0){if(!v.isEmpty())throw new g(v);break}for(const{data:c}of l){if(this._getServiceInstanceOrDescriptor(c.id)instanceof D.SyncDescriptor){const o=this._createServiceInstanceWithOwner(c.id,c.desc.ctor,c.desc.staticArguments,c.desc.supportsDelayedInstantiation,c._trace);this._setServiceInstance(c.id,o)}v.removeNode(c)}}return this._getServiceInstanceOrDescriptor(t)}_createServiceInstanceWithOwner(t,h,E=[],v,y){if(this._services.get(t)instanceof D.SyncDescriptor)return this._createServiceInstance(h,E,v,y);if(this._parent)return this._parent._createServiceInstanceWithOwner(t,h,E,v,y);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(t,h=[],E,v){if(E){const y=new p.IdleValue(()=>this._createInstance(t,h,v));return new Proxy(Object.create(null),{get(u,l){if(l in u)return u[l];let c=y.value,n=c[l];return typeof n!="function"||(n=n.bind(c),u[l]=n),n},set(u,l,c){return y.value[l]=c,!0}})}else return this._createInstance(t,h,v)}}e.InstantiationService=i;var I;(function(m){m[m.Creation=0]="Creation",m[m.Invocation=1]="Invocation",m[m.Branch=2]="Branch"})(I||(I={}));class S{constructor(t,h){this.type=t,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(t){return d?new S(1,t.name||t.toString().substring(0,42).replace(/\n/g,"")):S._None}static traceCreation(t){return d?new S(0,t.name):S._None}branch(t,h){let E=new S(2,t.toString());return this._dep.push([t,h,E]),E}stop(){let t=Date.now()-this._start;S._totals+=t;let h=!1;function E(y,u){let l=[],c=new Array(y+1).join("	");for(const[n,o,s]of u._dep)if(o&&s){h=!0,l.push(`${c}CREATES -> ${n}`);let r=E(y+1,s);r&&l.push(r)}else l.push(`${c}uses -> ${n}`);return l.join(`
`)}let v=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${E(1,this)}`,`DONE, took ${t.toFixed(2)}ms (grand total ${S._totals.toFixed(2)}ms)`];(t>2||h)&&console.log(v.join(`
`))}}S._None=new class extends S{constructor(){super(-1,null)}stop(){}branch(){return this}},S._totals=0}),define(Q[174],J([0,1,18,128,58]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BaseResolvedKeybinding=void 0;class M extends D.ResolvedKeybinding{constructor(b,d){super();if(d.length===0)throw(0,p.illegalArgument)("parts");this._os=b,this._parts=d}getLabel(){return L.UILabelProvider.toLabel(this._os,this._parts,b=>this._getLabel(b))}getAriaLabel(){return L.AriaLabelProvider.toLabel(this._os,this._parts,b=>this._getAriaLabel(b))}getElectronAccelerator(){return this._parts.length>1||this._parts[0].isDuplicateModifierCase()?null:L.ElectronAcceleratorLabelProvider.toLabel(this._os,this._parts,b=>this._getElectronAccelerator(b))}getUserSettingsLabel(){return L.UserSettingsLabelProvider.toLabel(this._os,this._parts,b=>this._getUserSettingsLabel(b))}isWYSIWYG(){return this._parts.every(b=>this._isWYSIWYG(b))}isChord(){return this._parts.length>1}getParts(){return this._parts.map(b=>this._getPart(b))}_getPart(b){return new D.ResolvedKeybindingPart(b.ctrlKey,b.shiftKey,b.altKey,b.metaKey,this._getLabel(b),this._getAriaLabel(b))}getDispatchParts(){return this._parts.map(b=>this._getDispatchPart(b))}getSingleModifierDispatchParts(){return this._parts.map(b=>this._getSingleModifierDispatchPart(b))}}e.BaseResolvedKeybinding=M}),define(Q[175],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeElementsAfterNulls=e.ResolvedKeybindingItem=void 0;class p{constructor(M,P,b,d,g,i,I){this._resolvedKeybindingItemBrand=void 0,this.resolvedKeybinding=M,this.keypressParts=M?L(M.getDispatchParts()):[],M&&this.keypressParts.length===0&&(this.keypressParts=L(M.getSingleModifierDispatchParts())),this.bubble=P?P.charCodeAt(0)===94:!1,this.command=this.bubble?P.substr(1):P,this.commandArgs=b,this.when=d,this.isDefault=g,this.extensionId=i,this.isBuiltinExtension=I}}e.ResolvedKeybindingItem=p;function L(D){let M=[];for(let P=0,b=D.length;P<b;P++){const d=D[P];if(!d)return M;M.push(d)}return M}e.removeElementsAfterNulls=L}),define(Q[176],J([0,1,80,58,174,175]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.USLayoutResolvedKeybinding=void 0;class P extends D.BaseResolvedKeybinding{constructor(d,g){super(g,d.parts)}_keyCodeToUILabel(d){if(this._os===2)switch(d){case 15:return"\u2190";case 16:return"\u2191";case 17:return"\u2192";case 18:return"\u2193"}return p.KeyCodeUtils.toString(d)}_getLabel(d){return d.isDuplicateModifierCase()?"":this._keyCodeToUILabel(d.keyCode)}_getAriaLabel(d){return d.isDuplicateModifierCase()?"":p.KeyCodeUtils.toString(d.keyCode)}_getElectronAccelerator(d){return p.KeyCodeUtils.toElectronAccelerator(d.keyCode)}_getUserSettingsLabel(d){if(d.isDuplicateModifierCase())return"";const g=p.KeyCodeUtils.toUserSettingsUS(d.keyCode);return g&&g.toLowerCase()}_isWYSIWYG(){return!0}_getDispatchPart(d){return P.getDispatchStr(d)}static getDispatchStr(d){if(d.isModifierKey())return null;let g="";return d.ctrlKey&&(g+="ctrl+"),d.shiftKey&&(g+="shift+"),d.altKey&&(g+="alt+"),d.metaKey&&(g+="meta+"),g+=p.KeyCodeUtils.toString(d.keyCode),g}_getSingleModifierDispatchPart(d){return d.keyCode===5&&!d.shiftKey&&!d.altKey&&!d.metaKey?"ctrl":d.keyCode===4&&!d.ctrlKey&&!d.altKey&&!d.metaKey?"shift":d.keyCode===6&&!d.ctrlKey&&!d.shiftKey&&!d.metaKey?"alt":d.keyCode===57&&!d.ctrlKey&&!d.shiftKey&&!d.altKey?"meta":null}static _scanCodeToKeyCode(d){const g=p.IMMUTABLE_CODE_TO_KEY_CODE[d];if(g!==-1)return g;switch(d){case 10:return 31;case 11:return 32;case 12:return 33;case 13:return 34;case 14:return 35;case 15:return 36;case 16:return 37;case 17:return 38;case 18:return 39;case 19:return 40;case 20:return 41;case 21:return 42;case 22:return 43;case 23:return 44;case 24:return 45;case 25:return 46;case 26:return 47;case 27:return 48;case 28:return 49;case 29:return 50;case 30:return 51;case 31:return 52;case 32:return 53;case 33:return 54;case 34:return 55;case 35:return 56;case 36:return 22;case 37:return 23;case 38:return 24;case 39:return 25;case 40:return 26;case 41:return 27;case 42:return 28;case 43:return 29;case 44:return 30;case 45:return 21;case 51:return 83;case 52:return 81;case 53:return 87;case 54:return 89;case 55:return 88;case 56:return 0;case 57:return 80;case 58:return 90;case 59:return 86;case 60:return 82;case 61:return 84;case 62:return 85;case 106:return 92}return 0}static _resolveSimpleUserBinding(d){if(!d)return null;if(d instanceof L.SimpleKeybinding)return d;const g=this._scanCodeToKeyCode(d.scanCode);return g===0?null:new L.SimpleKeybinding(d.ctrlKey,d.shiftKey,d.altKey,d.metaKey,g)}static resolveUserBinding(d,g){const i=(0,M.removeElementsAfterNulls)(d.map(I=>this._resolveSimpleUserBinding(I)));return i.length>0?[new P(new L.ChordKeybinding(i),g)]:[]}}e.USLayoutResolvedKeybinding=P}),define(Q[177],J([0,1,9]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.handleVetos=void 0;function L(D,M){if(D.length===0)return Promise.resolve(!1);const P=[];let b=!1;for(let d of D){if(d===!0)return Promise.resolve(!0);(0,p.isThenable)(d)&&P.push(d.then(g=>{g&&(b=!0)},g=>{M(g),b=!0}))}return p.Promises.settled(P).then(()=>b)}e.handleVetos=L}),define(Q[6],J([0,1,62,4,2,3,5]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,P.createDecorator)("logService"),e.ILoggerService=(0,P.createDecorator)("loggerService");function b(){return new Date().toISOString()}var d;(function(c){c[c.Trace=0]="Trace",c[c.Debug=1]="Debug",c[c.Info=2]="Info",c[c.Warning=3]="Warning",c[c.Error=4]="Error",c[c.Critical=5]="Critical",c[c.Off=6]="Off"})(d=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=d.Info;class g extends D.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new L.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=g;class i extends g{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...o){this.checkLogLevel(d.Trace)&&this.log(d.Trace,this.format([n,...o]))}debug(n,...o){this.checkLogLevel(d.Debug)&&this.log(d.Debug,this.format([n,...o]))}info(n,...o){this.checkLogLevel(d.Info)&&this.log(d.Info,this.format([n,...o]))}warn(n,...o){this.checkLogLevel(d.Warning)&&this.log(d.Warning,this.format([n,...o]))}error(n,...o){if(this.checkLogLevel(d.Error))if(n instanceof Error){const s=Array.prototype.slice.call(arguments);s[0]=n.stack,this.log(d.Error,this.format(s))}else this.log(d.Error,this.format([n,...o]))}critical(n,...o){this.checkLogLevel(d.Critical)&&this.log(d.Critical,this.format([n,...o]))}flush(){}format(n){let o="";for(let s=0;s<n.length;s++){let r=n[s];if(typeof r=="object")try{r=JSON.stringify(r)}catch(a){}o+=(s>0?" ":"")+r}return o}}e.AbstractMessageLogger=i;class I extends g{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!M.isWindows}trace(n,...o){this.getLevel()<=d.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...o):console.log(`[main ${b()}]`,n,...o))}debug(n,...o){this.getLevel()<=d.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...o):console.log(`[main ${b()}]`,n,...o))}info(n,...o){this.getLevel()<=d.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,n,...o):console.log(`[main ${b()}]`,n,...o))}warn(n,...o){this.getLevel()<=d.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,n,...o):console.warn(`[main ${b()}]`,n,...o))}error(n,...o){this.getLevel()<=d.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,n,...o):console.error(`[main ${b()}]`,n,...o))}critical(n,...o){this.getLevel()<=d.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,n,...o):console.error(`[main ${b()}]`,n,...o))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class S extends g{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...o){this.getLevel()<=d.Trace&&console.log("%cTRACE","color: #888",n,...o)}debug(n,...o){this.getLevel()<=d.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...o)}info(n,...o){this.getLevel()<=d.Info&&console.log("%c INFO","color: #33f",n,...o)}warn(n,...o){this.getLevel()<=d.Warning&&console.log("%c WARN","color: #993",n,...o)}error(n,...o){this.getLevel()<=d.Error&&console.log("%c  ERR","color: #f33",n,...o)}critical(n,...o){this.getLevel()<=d.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...o)}dispose(){}flush(){}}e.ConsoleLogger=S;class m extends g{constructor(n,o=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(o)}trace(n,...o){this.getLevel()<=d.Trace&&this.adapter.log(d.Trace,[this.extractMessage(n),...o])}debug(n,...o){this.getLevel()<=d.Debug&&this.adapter.log(d.Debug,[this.extractMessage(n),...o])}info(n,...o){this.getLevel()<=d.Info&&this.adapter.log(d.Info,[this.extractMessage(n),...o])}warn(n,...o){this.getLevel()<=d.Warning&&this.adapter.log(d.Warning,[this.extractMessage(n),...o])}error(n,...o){this.getLevel()<=d.Error&&this.adapter.log(d.Error,[this.extractMessage(n),...o])}critical(n,...o){this.getLevel()<=d.Critical&&this.adapter.log(d.Critical,[this.extractMessage(n),...o])}extractMessage(n){return typeof n=="string"?n:(0,p.toErrorMessage)(n,this.getLevel()<=d.Trace)}dispose(){}flush(){}}e.AdapterLogger=m;class t extends g{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const o of this.logServices)o.setLevel(n);super.setLevel(n)}trace(n,...o){for(const s of this.logServices)s.trace(n,...o)}debug(n,...o){for(const s of this.logServices)s.debug(n,...o)}info(n,...o){for(const s of this.logServices)s.info(n,...o)}warn(n,...o){for(const s of this.logServices)s.warn(n,...o)}error(n,...o){for(const s of this.logServices)s.error(n,...o)}critical(n,...o){for(const s of this.logServices)s.critical(n,...o)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=t;class h extends D.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...o){this.logger.trace(n,...o)}debug(n,...o){this.logger.debug(n,...o)}info(n,...o){this.logger.info(n,...o)}warn(n,...o){this.logger.warn(n,...o)}error(n,...o){this.logger.error(n,...o)}critical(n,...o){this.logger.critical(n,...o)}flush(){this.logger.flush()}}e.LogService=h;class E extends D.Disposable{constructor(n,o){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(o(s=>{this.logLevel=s,this.logLevelChangeableLoggers.forEach(r=>r.setLevel(s))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,o){let s=this.loggers.get(n.toString());return s||(s=this.doCreateLogger(n,o?.always?d.Trace:this.logLevel,o),this.loggers.set(n.toString(),s),o?.always||this.logLevelChangeableLoggers.push(s)),s}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=E;class v{constructor(){this.onDidChangeLogLevel=new L.Emitter().event}setLevel(n){}getLevel(){return d.Info}trace(n,...o){}debug(n,...o){}info(n,...o){}warn(n,...o){}error(n,...o){}critical(n,...o){}dispose(){}flush(){}}e.NullLogService=v;function y(c){if(c.verbose)return d.Trace;if(typeof c.logLevel=="string"){const n=u(c.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=y;function u(c){switch(c){case"trace":return d.Trace;case"debug":return d.Debug;case"info":return d.Info;case"warn":return d.Warning;case"error":return d.Error;case"critical":return d.Critical;case"off":return d.Off}}e.parseLogLevel=u;function l(c){switch(c){case d.Trace:return"trace";case d.Debug:return"debug";case d.Info:return"info";case d.Warning:return"warn";case d.Error:return"error";case d.Critical:return"critical";case d.Off:return"off"}}e.LogLevelToString=l});var te=this&&this.__param||function(j,e){return function(p,L){e(p,L,j)}};define(Q[178],J([0,1,9,16,39,79,48,20,5,6]),function(j,e,p,L,D,M,P,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserConfigurationFileService=e.IUserConfigurationFileService=e.UserConfigurationFileServiceId=e.UserConfigurationErrorCode=void 0;var i;(function(S){S.ERROR_INVALID_FILE="ERROR_INVALID_FILE",S.ERROR_FILE_MODIFIED_SINCE="ERROR_FILE_MODIFIED_SINCE"})(i=e.UserConfigurationErrorCode||(e.UserConfigurationErrorCode={})),e.UserConfigurationFileServiceId="IUserConfigurationFileService",e.IUserConfigurationFileService=(0,d.createDecorator)(e.UserConfigurationFileServiceId);let I=class{constructor(m,t,h){this.environmentService=m,this.fileService=t,this.logService=h,this.queue=new p.Queue}async updateSettings(m,t){return this.queue.queue(()=>this.doWrite(this.environmentService.settingsResource,m,t))}async doWrite(m,t,h){this.logService.trace(`${e.UserConfigurationFileServiceId}#write`,m.toString(),t);const{value:E,mtime:v,etag:y}=await this.fileService.readFile(m,{atomic:!0});let u=E.toString();const l=[];if((0,D.parse)(u,l,{allowTrailingComma:!0,allowEmptyContent:!0}),l.length)throw new Error("ERROR_INVALID_FILE");const c=this.getEdits(t,u,h)[0];if(c){u=u.substring(0,c.offset)+c.content+u.substring(c.offset+c.length);try{await this.fileService.writeFile(m,L.VSBuffer.fromString(u),{etag:y,mtime:v})}catch(n){if(n.fileOperationResult===3)throw new Error("ERROR_FILE_MODIFIED_SINCE")}}}getEdits({value:m,path:t},h,E){return t.length?(0,M.setProperty)(h,t,m,E):[{content:JSON.stringify(m,null,E.insertSpaces&&E.tabSize?" ".repeat(E.tabSize):"	"),length:h.length,offset:0}]}};I=he([te(0,P.IEnvironmentService),te(1,b.IFileService),te(2,g.ILogService)],I),e.UserConfigurationFileService=I}),define(Q[92],J([0,1,6]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BufferLogService=void 0;function L(M,P){switch(P){case p.LogLevel.Trace:return M.trace;case p.LogLevel.Debug:return M.debug;case p.LogLevel.Info:return M.info;case p.LogLevel.Warning:return M.warn;case p.LogLevel.Error:return M.error;case p.LogLevel.Critical:return M.critical;default:throw new Error("Invalid log level")}}class D extends p.AbstractLogger{constructor(P=p.DEFAULT_LOG_LEVEL){super();this.buffer=[],this._logger=void 0,this.setLevel(P),this._register(this.onDidChangeLogLevel(b=>{this._logger&&this._logger.setLevel(b)}))}set logger(P){this._logger=P;for(const{level:b,args:d}of this.buffer)L(P,b).apply(P,d);this.buffer=[]}_log(P,...b){this._logger?L(this._logger,P).apply(this._logger,b):this.getLevel()<=P&&this.buffer.push({level:P,args:b})}trace(P,...b){this._log(p.LogLevel.Trace,P,...b)}debug(P,...b){this._log(p.LogLevel.Debug,P,...b)}info(P,...b){this._log(p.LogLevel.Info,P,...b)}warn(P,...b){this._log(p.LogLevel.Warning,P,...b)}error(P,...b){this._log(p.LogLevel.Error,P,...b)}critical(P,...b){this._log(p.LogLevel.Critical,P,...b)}dispose(){this._logger&&this._logger.dispose()}flush(){this._logger&&this._logger.flush()}}e.BufferLogService=D}),define(Q[179],J([0,1,9,16,15,20,5,92,6]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileLoggerService=e.FileLogger=void 0;const g=5*M.ByteSize.MB;let i=class extends d.AbstractLogger{constructor(m,t,h,E,v){super();this.name=m,this.resource=t,this.donotUseFormatters=E,this.fileService=v,this.backupIndex=1,this.setLevel(h),this.queue=this._register(new p.Queue),this.initializePromise=this.initialize()}trace(){this.getLevel()<=d.LogLevel.Trace&&this._log(d.LogLevel.Trace,this.format(arguments))}debug(){this.getLevel()<=d.LogLevel.Debug&&this._log(d.LogLevel.Debug,this.format(arguments))}info(){this.getLevel()<=d.LogLevel.Info&&this._log(d.LogLevel.Info,this.format(arguments))}warn(){this.getLevel()<=d.LogLevel.Warning&&this._log(d.LogLevel.Warning,this.format(arguments))}error(){if(this.getLevel()<=d.LogLevel.Error){const m=arguments[0];if(m instanceof Error){const t=Array.prototype.slice.call(arguments);t[0]=m.stack,this._log(d.LogLevel.Error,this.format(t))}else this._log(d.LogLevel.Error,this.format(arguments))}}critical(){this.getLevel()<=d.LogLevel.Critical&&this._log(d.LogLevel.Critical,this.format(arguments))}flush(){}log(m,t){this._log(m,this.format(t))}async initialize(){try{await this.fileService.createFile(this.resource)}catch(m){if(m.fileOperationResult!==3)throw m}}_log(m,t){this.queue.queue(async()=>{await this.initializePromise;let h=await this.loadContent();h.length>g&&(await this.fileService.writeFile(this.getBackupResource(),L.VSBuffer.fromString(h)),h=""),this.donotUseFormatters?h+=t:h+=`[${this.getCurrentTimestamp()}] [${this.name}] [${this.stringifyLogLevel(m)}] ${t}
`,await this.fileService.writeFile(this.resource,L.VSBuffer.fromString(h))})}getCurrentTimestamp(){const m=E=>E<10?`0${E}`:E,t=E=>E<10?`00${E}`:E<100?`0${E}`:E,h=new Date;return`${h.getFullYear()}-${m(h.getMonth()+1)}-${m(h.getDate())} ${m(h.getHours())}:${m(h.getMinutes())}:${m(h.getSeconds())}.${t(h.getMilliseconds())}`}getBackupResource(){return this.backupIndex=this.backupIndex>5?1:this.backupIndex,(0,D.joinPath)((0,D.dirname)(this.resource),`${(0,D.basename)(this.resource)}_${this.backupIndex++}`)}async loadContent(){try{return(await this.fileService.readFile(this.resource)).value.toString()}catch(m){return""}}stringifyLogLevel(m){switch(m){case d.LogLevel.Critical:return"critical";case d.LogLevel.Debug:return"debug";case d.LogLevel.Error:return"error";case d.LogLevel.Info:return"info";case d.LogLevel.Trace:return"trace";case d.LogLevel.Warning:return"warning"}return""}format(m){let t="";for(let h=0;h<m.length;h++){let E=m[h];if(typeof E=="object")try{E=JSON.stringify(E)}catch(v){}t+=(h>0?" ":"")+E}return t}};i=he([te(4,M.IFileService)],i),e.FileLogger=i;let I=class extends d.AbstractLoggerService{constructor(m,t,h){super(m.getLevel(),m.onDidChangeLogLevel);this.instantiationService=t,this.fileService=h}doCreateLogger(m,t,h){const E=new b.BufferLogService(t);return(0,M.whenProviderRegistered)(m,this.fileService).then(()=>E.logger=this.instantiationService.createInstance(i,(0,D.basename)(m),m,E.getLevel(),!!h?.donotUseFormatters)),E}};I=he([te(0,d.ILogService),te(1,P.IInstantiationService),te(2,M.IFileService)],I),e.FileLoggerService=I}),define(Q[180],J([0,1,4,7,6]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class M{constructor(S){this.service=S,this.onDidChangeLogLevel=p.Event.buffer(S.onDidChangeLogLevel,!0)}listen(S,m){switch(m){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${m}`)}async call(S,m,t){switch(m){case"setLevel":return this.service.setLevel(t)}throw new Error(`Call not found: ${m}`)}}e.LogLevelChannel=M;class P{constructor(S){this.channel=S}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(S){P.setLevel(this.channel,S)}static setLevel(S,m){return S.call("setLevel",m)}}e.LogLevelChannelClient=P;class b{constructor(S){this.loggerService=S,this.loggers=new Map}listen(S,m){throw new Error(`Event not found: ${m}`)}async call(S,m,t){switch(m){case"createLogger":this.createLogger(L.URI.revive(t[0]),t[1]);return;case"log":return this.log(L.URI.revive(t[0]),t[1]);case"consoleLog":return this.consoleLog(t[0],t[1])}throw new Error(`Call not found: ${m}`)}createLogger(S,m){this.loggers.set(S.toString(),this.loggerService.createLogger(S,m))}consoleLog(S,m){let t=console.log;switch(S){case D.LogLevel.Error:t=console.error;break;case D.LogLevel.Warning:t=console.warn;break;case D.LogLevel.Info:t=console.info;break}t.call(console,...m)}log(S,m){const t=this.loggers.get(S.toString());if(!t)throw new Error("Create the logger before logging");for(const[h,E]of m)switch(h){case D.LogLevel.Trace:t.trace(E);break;case D.LogLevel.Debug:t.debug(E);break;case D.LogLevel.Info:t.info(E);break;case D.LogLevel.Warning:t.warn(E);break;case D.LogLevel.Error:t.error(E);break;case D.LogLevel.Critical:t.critical(E);break;default:throw new Error("Invalid log level")}}}e.LoggerChannel=b;class d extends D.AbstractLoggerService{constructor(S,m,t){super(S,m);this.channel=t}createConsoleMainLogger(){return new D.AdapterLogger({log:(S,m)=>{this.channel.call("consoleLog",[S,m])}})}doCreateLogger(S,m,t){return new g(this.channel,S,m,t)}}e.LoggerChannelClient=d;class g extends D.AbstractMessageLogger{constructor(S,m,t,h){super(h?.always);this.channel=S,this.file=m,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(t),this.channel.call("createLogger",[m,h]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(S,m){const t=[[S,m]];this.isLoggerCreated?this.doLog(t):this.buffer.push(...t)}doLog(S){this.channel.call("log",[this.file,S])}}class i extends D.LogService{constructor(S,m){super(m);this.parent=S,this._register(S.onDidChangeLogLevel(t=>m.setLevel(t)))}setLevel(S){super.setLevel(S),this.parent.setLevel(S)}}e.FollowerLogService=i}),define(Q[93],J([0,1,20,6]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SpdLogLogger=e.createRotatingLogger=void 0;async function D(d,g,i,I){try{const S=await new Promise((m,t)=>{j(["spdlog"],m,t)});return S.setFlushOn(L.LogLevel.Trace),S.createAsyncRotatingLogger(d,g,i,I)}catch(S){console.error(S)}return null}function M(d,g,i,I){const S=j.__$__nodeRequire("spdlog");return S.setFlushOn(L.LogLevel.Trace),S.createRotatingLogger(d,g,i,I)}e.createRotatingLogger=M;function P(d,g,i){switch(g){case L.LogLevel.Trace:d.trace(i);break;case L.LogLevel.Debug:d.debug(i);break;case L.LogLevel.Info:d.info(i);break;case L.LogLevel.Warning:d.warn(i);break;case L.LogLevel.Error:d.error(i);break;case L.LogLevel.Critical:d.critical(i);break;default:throw new Error("Invalid log level")}}class b extends L.AbstractMessageLogger{constructor(g,i,I,S){super();this.name=g,this.filepath=i,this.rotating=I,this.buffer=[],this.setLevel(S),this._loggerCreationPromise=this._createSpdLogLogger(),this._register(this.onDidChangeLogLevel(m=>{this._logger&&this._logger.setLevel(m)}))}_createSpdLogLogger(){const g=this.rotating?6:1,i=30/g*p.ByteSize.MB;return D(this.name,this.filepath,i,g).then(I=>{if(I){this._logger=I,this._logger.setLevel(this.getLevel());for(const{level:S,message:m}of this.buffer)P(this._logger,S,m);this.buffer=[]}})}log(g,i){this._logger?P(this._logger,g,i):this.getLevel()<=g&&this.buffer.push({level:g,message:i})}clearFormatters(){this._logger?this._logger.clearFormatters():this._loggerCreationPromise.then(()=>this.clearFormatters())}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}e.SpdLogLogger=b}),define(Q[181],J([0,1,10,15,28,20,179,6,93]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LoggerService=void 0;let g=class extends b.AbstractLoggerService{constructor(I,S){super(I.getLevel(),I.onDidChangeLogLevel);this.fileService=S}doCreateLogger(I,S,m){if(I.scheme===p.Schemas.file){const t=new d.SpdLogLogger(m?.name||(0,D.generateUuid)(),I.fsPath,!m?.donotRotate,S);return m?.donotUseFormatters&&t.clearFormatters(),t}else return new P.FileLogger(m?.name??(0,L.basename)(I),I,S,!!m?.donotUseFormatters,this.fileService)}};g=he([te(0,b.ILogService),te(1,M.IFileService)],g),e.LoggerService=g}),define(Q[182],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isMenubarMenuItemAction=e.isMenubarMenuItemRecentAction=e.isMenubarMenuItemSeparator=e.isMenubarMenuItemSubmenu=void 0;function p(P){return P.submenu!==void 0}e.isMenubarMenuItemSubmenu=p;function L(P){return P.id==="vscode.menubar.separator"}e.isMenubarMenuItemSeparator=L;function D(P){return P.uri!==void 0}e.isMenubarMenuItemRecentAction=D;function M(P){return!p(P)&&!L(P)&&!D(P)}e.isMenubarMenuItemAction=M}),define(Q[45],J([0,1,10,3,32,15]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let P;if(typeof L.globals.vscode!="undefined"&&typeof L.globals.vscode.context!="undefined"){const b=L.globals.vscode.context.configuration();if(b)P=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof j?.__$__nodeRequire=="function"){const b=(0,M.dirname)(p.FileAccess.asFileUri("",j));P=j.__$__nodeRequire((0,M.joinPath)(b,"product.json").fsPath);const d=j.__$__nodeRequire((0,M.joinPath)(b,"package.json").fsPath);D.env.VSCODE_DEV&&Object.assign(P,{nameShort:`${P.nameShort} Dev`,nameLong:`${P.nameLong} Dev`,dataFolderName:`${P.dataFolderName}-dev`}),Object.assign(P,{version:d.version})}else P={},Object.keys(P).length===0&&Object.assign(P,{version:"1.61.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt",extensionAllowedProposedApi:["ms-vscode.vscode-js-profile-flame","ms-vscode.vscode-js-profile-table","ms-vscode.remotehub","ms-vscode.remotehub-insiders","GitHub.remotehub","GitHub.remotehub-insiders"]});e.default=P}),define(Q[94],J([0,1,16,18,142,20,45]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function b(I,S,m,t,h,E){let v;try{await d(I,S,m,t,h,E)}catch(y){v=y}finally{v&&h.errorTransformer&&(v=h.errorTransformer(v)),typeof v!="undefined"&&m.error(v),m.end()}}e.readFileIntoStream=b;async function d(I,S,m,t,h,E){g(E);const v=await I.open(S,{create:!1});try{g(E);let y=0,u=0,l=h&&typeof h.length=="number"?h.length:void 0,c=p.VSBuffer.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),n=h&&typeof h.position=="number"?h.position:0,o=0;do u=await I.read(v,n,c.buffer,o,c.byteLength-o),n+=u,o+=u,y+=u,typeof l=="number"&&(l-=u),o===c.byteLength&&(await m.write(t(c)),c=p.VSBuffer.alloc(Math.min(h.bufferSize,typeof l=="number"?l:h.bufferSize)),o=0);while(u>0&&(typeof l!="number"||l>0)&&g(E)&&i(y,h));if(o>0){let s=o;typeof l=="number"&&(s=Math.min(o,l)),m.write(t(c.slice(0,s)))}}catch(y){throw(0,M.ensureFileSystemProviderError)(y)}finally{await I.close(v)}}function g(I){if(I.isCancellationRequested)throw(0,L.canceled)();return!0}function i(I,S){if(S?.limits){if(typeof S.limits.memory=="number"&&I>S.limits.memory)throw(0,M.createFileSystemProviderError)((0,D.localize)(0,null,P.default.nameShort),M.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof S.limits.size=="number"&&I>S.limits.size)throw(0,M.createFileSystemProviderError)((0,D.localize)(1,null),M.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Q[183],J([0,1,30,9,16,23,4,68,2,40,10,76,15,59,140,20,94,6]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let y=class Ke extends d.Disposable{constructor(l){super();this.logService=l,this.BUFFER_SIZE=64*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new P.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new P.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new P.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new P.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onError=this._register(new P.Emitter),this.onError=this._onError.event,this._onDidFilesChange=this._register(new P.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidChangeFilesRaw=this._register(new P.Emitter),this.onDidChangeFilesRaw=this._onDidChangeFilesRaw.event,this.activeWatchers=new Map,this.caseSensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new h.FileChangesEvent(c,!1)))),this.caseInsensitiveFileEventsWorker=this._register(new L.ThrottledWorker(Ke.FILE_EVENTS_THROTTLING.maxChangesChunkSize,Ke.FILE_EVENTS_THROTTLING.maxChangesBufferSize,Ke.FILE_EVENTS_THROTTLING.coolDownDelay,c=>this._onDidFilesChange.fire(new h.FileChangesEvent(c,!0)))),this.watchedResources=g.TernarySearchTree.forUris(c=>{const n=this.getProvider(c.scheme);return n?!this.isPathCaseSensitive(n):!1}),this.writeQueue=this._register(new L.ResourceQueue)}registerProvider(l,c){if(this.provider.has(l))throw new Error(`A filesystem provider for the scheme '${l}' is already registered.`);(0,I.mark)(`code/registerFilesystem/${l}`),this.provider.set(l,c),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:l,provider:c});const n=new d.DisposableStore;return n.add(c.onDidChangeFile(o=>this.onDidChangeFile(o,this.isPathCaseSensitive(c)))),n.add(c.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:c,scheme:l}))),typeof c.onDidErrorOccur=="function"&&n.add(c.onDidErrorOccur(o=>this._onError.fire(new Error(o)))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:l,provider:c}),this.provider.delete(l),(0,d.dispose)(n)})}getProvider(l){return this.provider.get(l)}async activateProvider(l){const c=[];this._onWillActivateFileSystemProvider.fire({scheme:l,join(n){c.push(n)}}),!this.provider.has(l)&&await L.Promises.settled(c)}async canHandleResource(l){return await this.activateProvider(l.scheme),this.hasProvider(l)}hasProvider(l){return this.provider.has(l.scheme)}hasCapability(l,c){const n=this.provider.get(l.scheme);return!!(n&&n.capabilities&c)}listCapabilities(){return b.Iterable.map(this.provider,([l,c])=>({scheme:l,capabilities:c.capabilities}))}async withProvider(l){if(!(0,S.isAbsolutePath)(l))throw new h.FileOperationError((0,t.localize)(0,null,this.resourceForError(l)),8);await this.activateProvider(l.scheme);const c=this.provider.get(l.scheme);if(!c){const n=new Error;throw n.name="ENOPRO",n.message=(0,t.localize)(1,null,l.toString()),n}return c}async withReadProvider(l){const c=await this.withProvider(l);if((0,h.hasOpenReadWriteCloseCapability)(c)||(0,h.hasReadWriteCapability)(c)||(0,h.hasFileReadStreamCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(l){const c=await this.withProvider(l);if((0,h.hasOpenReadWriteCloseCapability)(c)||(0,h.hasReadWriteCapability)(c))return c;throw new Error(`Filesystem provider for scheme '${l.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(l,c){try{return await this.doResolveFile(l,c)}catch(n){throw(0,h.toFileSystemProviderErrorCode)(n)===h.FileSystemProviderErrorCode.FileNotFound?new h.FileOperationError((0,t.localize)(2,null,this.resourceForError(l)),1):(0,h.ensureFileSystemProviderError)(n)}}async doResolveFile(l,c){const n=await this.withProvider(l),o=this.isPathCaseSensitive(n),s=c?.resolveTo,r=c?.resolveSingleChildDescendants,a=c?.resolveMetadata,f=await n.stat(l);let w;return this.toFileStat(n,l,f,void 0,!!a,(k,R)=>(w||(w=g.TernarySearchTree.forUris(()=>!o),w.set(l,!0),s&&w.fill(!0,s)),w.get(k.resource)||w.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&r?R===1:!1))}async toFileStat(l,c,n,o,s,r){const{providerExtUri:a}=this.getExtUri(l),f={resource:c,name:a.basename(c),isFile:(n.type&h.FileType.File)!=0,isDirectory:(n.type&h.FileType.Directory)!=0,isSymbolicLink:(n.type&h.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&h.FilePermission.Readonly)||Boolean(l.capabilities&2048),etag:(0,h.etag)({mtime:n.mtime,size:n.size})};if(f.isDirectory&&r(f,o)){try{const w=await l.readdir(c),k=await L.Promises.settled(w.map(async([R,A])=>{try{const O=a.joinPath(c,R),H=s?await l.stat(O):{type:A};return await this.toFileStat(l,O,H,w.length,s,r)}catch(O){return this.logService.trace(O),null}}));f.children=(0,p.coalesce)(k)}catch(w){this.logService.trace(w),f.children=[]}return f}return f}async resolveAll(l){return L.Promises.settled(l.map(async c=>{try{return{stat:await this.doResolveFile(c.resource,c.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async exists(l){const c=await this.withProvider(l);try{return!!await c.stat(l)}catch(n){return!1}}async canCreateFile(l,c){try{await this.doValidateCreateFile(l,c)}catch(n){return n}return!0}async doValidateCreateFile(l,c){if(!c?.overwrite&&await this.exists(l))throw new h.FileOperationError((0,t.localize)(3,null,this.resourceForError(l)),3,c)}async createFile(l,c=D.VSBuffer.fromString(""),n){await this.doValidateCreateFile(l,n);const o=await this.writeFile(l,c);return this._onDidRunOperation.fire(new h.FileOperationEvent(l,0,o)),o}async writeFile(l,c,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),{providerExtUri:s}=this.getExtUri(o);try{await this.validateWriteFile(o,l,n)||await this.mkdirp(o,s.dirname(l));let a;if((0,h.hasReadWriteCapability)(o)&&!(c instanceof D.VSBuffer))if((0,m.isReadableStream)(c)){const f=await(0,m.peekStream)(c,3);f.ended?a=D.VSBuffer.concat(f.buffer):a=f}else a=(0,m.peekReadable)(c,f=>D.VSBuffer.concat(f),3);else a=c;!(0,h.hasOpenReadWriteCloseCapability)(o)||(0,h.hasReadWriteCapability)(o)&&a instanceof D.VSBuffer?await this.doWriteUnbuffered(o,l,n,a):await this.doWriteBuffered(o,l,n,a instanceof D.VSBuffer?(0,D.bufferToReadable)(a):a)}catch(r){throw new h.FileOperationError((0,t.localize)(4,null,this.resourceForError(l),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),n)}return this.resolve(l,{resolveMetadata:!0})}async validateWriteFile(l,c,n){if(!!n?.unlock&&!(l.capabilities&8192))throw new Error((0,t.localize)(5,null,this.resourceForError(c)));let s;try{s=await l.stat(c)}catch(r){return}if((s.type&h.FileType.Directory)!=0)throw new h.FileOperationError((0,t.localize)(6,null,this.resourceForError(c)),0,n);if(this.throwIfFileIsReadonly(c,s),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==h.ETAG_DISABLED&&typeof s.mtime=="number"&&typeof s.size=="number"&&n.mtime<s.mtime&&n.etag!==(0,h.etag)({mtime:n.mtime,size:s.size}))throw new h.FileOperationError((0,t.localize)(7,null),3,n);return s}async readFile(l,c){const n=await this.withReadProvider(l);return c?.atomic?this.doReadFileAtomic(n,l,c):this.doReadFile(n,l,c)}async doReadFileAtomic(l,c,n){return new Promise((o,s)=>{this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{try{const r=await this.doReadFile(l,c,n);o(r)}catch(r){s(r)}})})}async doReadFile(l,c,n){const o=await this.doReadFileStream(l,c,{...n,preferUnbuffered:!0});return{...o,value:await(0,D.streamToBuffer)(o.value)}}async readFileStream(l,c){const n=await this.withReadProvider(l);return this.doReadFileStream(n,l,c)}async doReadFileStream(l,c,n){const o=new M.CancellationTokenSource,s=this.validateReadFile(c,n).then(a=>a,a=>{throw o.cancel(),a});let r;try{return typeof n?.etag=="string"&&n.etag!==h.ETAG_DISABLED&&await s,!((0,h.hasOpenReadWriteCloseCapability)(l)||(0,h.hasFileReadStreamCapability)(l))||(0,h.hasReadWriteCapability)(l)&&n?.preferUnbuffered?r=this.readFileUnbuffered(l,c,n):(0,h.hasFileReadStreamCapability)(l)?r=this.readFileStreamed(l,c,o.token,n):r=this.readFileBuffered(l,c,o.token,n),{...await s,value:r}}catch(a){r&&await(0,m.consumeStream)(r);const f=(0,t.localize)(8,null,this.resourceForError(c),(0,h.ensureFileSystemProviderError)(a).toString());throw a instanceof h.NotModifiedSinceFileOperationError?new h.NotModifiedSinceFileOperationError(f,a.stat,n):new h.FileOperationError(f,(0,h.toFileOperationResult)(a),n)}}readFileStreamed(l,c,n,o=Object.create(null)){const s=l.readFileStream(c,o,n);return(0,m.transform)(s,{data:r=>r instanceof D.VSBuffer?r:D.VSBuffer.wrap(r),error:r=>new h.FileOperationError((0,t.localize)(9,null,this.resourceForError(c),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),o)},r=>D.VSBuffer.concat(r))}readFileBuffered(l,c,n,o=Object.create(null)){const s=(0,D.newWriteableBufferStream)();return(0,E.readFileIntoStream)(l,c,s,r=>r,{...o,bufferSize:this.BUFFER_SIZE,errorTransformer:r=>new h.FileOperationError((0,t.localize)(10,null,this.resourceForError(c),(0,h.ensureFileSystemProviderError)(r).toString()),(0,h.toFileOperationResult)(r),o)},n),s}readFileUnbuffered(l,c,n){const o=(0,m.newWriteableStream)(s=>D.VSBuffer.concat(s));return(async()=>{try{let s=await l.readFile(c);typeof n?.position=="number"&&(s=s.slice(n.position)),typeof n?.length=="number"&&(s=s.slice(0,n.length)),this.validateReadFileLimits(c,s.byteLength,n),o.end(D.VSBuffer.wrap(s))}catch(s){o.error(s),o.end()}})(),o}async validateReadFile(l,c){const n=await this.resolve(l,{resolveMetadata:!0});if(n.isDirectory)throw new h.FileOperationError((0,t.localize)(11,null,this.resourceForError(l)),0,c);if(typeof c?.etag=="string"&&c.etag!==h.ETAG_DISABLED&&c.etag===n.etag)throw new h.NotModifiedSinceFileOperationError((0,t.localize)(12,null),n,c);return this.validateReadFileLimits(l,n.size,c),n}validateReadFileLimits(l,c,n){if(n?.limits){let o;if(typeof n.limits.memory=="number"&&c>n.limits.memory&&(o=9),typeof n.limits.size=="number"&&c>n.limits.size&&(o=7),typeof o=="number")throw new h.FileOperationError((0,t.localize)(13,null,this.resourceForError(l)),o)}}async canMove(l,c,n){return this.doCanMoveCopy(l,c,"move",n)}async canCopy(l,c,n){return this.doCanMoveCopy(l,c,"copy",n)}async doCanMoveCopy(l,c,n,o){if(l.toString()!==c.toString())try{const s=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l):await this.withReadProvider(l),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c);await this.doValidateMoveCopy(s,l,r,c,n,o)}catch(s){return s}return!0}async move(l,c,n){const o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(l),l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=await this.doMoveCopy(o,l,s,c,"move",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(l,r==="move"?2:3,a)),a}async copy(l,c,n){const o=await this.withReadProvider(l),s=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(c),c),r=await this.doMoveCopy(o,l,s,c,"copy",!!n),a=await this.resolve(c,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(l,r==="copy"?3:2,a)),a}async doMoveCopy(l,c,n,o,s,r){if(c.toString()===o.toString())return s;const{exists:a,isSameResourceWithDifferentPathCase:f}=await this.doValidateMoveCopy(l,c,n,o,s,r);if(a&&!f&&r&&await this.del(o,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(o)),s==="copy"){if(l===n&&(0,h.hasFileFolderCopyCapability)(l))await l.copy(c,o,{overwrite:r});else{const w=await this.resolve(c);w.isDirectory?await this.doCopyFolder(l,w,n,o):await this.doCopyFile(l,c,n,o)}return s}else return l===n?(await l.rename(c,o,{overwrite:r}),s):(await this.doMoveCopy(l,c,n,o,"copy",r),await this.del(c,{recursive:!0}),"copy")}async doCopyFile(l,c,n,o){if((0,h.hasOpenReadWriteCloseCapability)(l)&&(0,h.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(l,c,n,o);if((0,h.hasOpenReadWriteCloseCapability)(l)&&(0,h.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(l,c,n,o);if((0,h.hasReadWriteCapability)(l)&&(0,h.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(l,c,n,o);if((0,h.hasReadWriteCapability)(l)&&(0,h.hasReadWriteCapability)(n))return this.doPipeUnbuffered(l,c,n,o)}async doCopyFolder(l,c,n,o){await n.mkdir(o),Array.isArray(c.children)&&await L.Promises.settled(c.children.map(async s=>{const r=this.getExtUri(n).providerExtUri.joinPath(o,s.name);return s.isDirectory?this.doCopyFolder(l,await this.resolve(s.resource),n,r):this.doCopyFile(l,s.resource,n,r)}))}async doValidateMoveCopy(l,c,n,o,s,r){let a=!1;if(l===n){const{providerExtUri:w,isPathCaseSensitive:k}=this.getExtUri(l);if(k||(a=w.isEqual(c,o)),a&&s==="copy")throw new Error((0,t.localize)(14,null,this.resourceForError(c),this.resourceForError(o)));if(!a&&w.isEqualOrParent(o,c))throw new Error((0,t.localize)(15,null,this.resourceForError(c),this.resourceForError(o)))}const f=await this.exists(o);if(f&&!a){if(!r)throw new h.FileOperationError((0,t.localize)(16,null,this.resourceForError(c),this.resourceForError(o)),4);if(l===n){const{providerExtUri:w}=this.getExtUri(l);if(w.isEqualOrParent(c,o))throw new Error((0,t.localize)(17,null,this.resourceForError(c),this.resourceForError(o)))}}return{exists:f,isSameResourceWithDifferentPathCase:a}}getExtUri(l){const c=this.isPathCaseSensitive(l);return{providerExtUri:c?S.extUri:S.extUriIgnorePathCase,isPathCaseSensitive:c}}isPathCaseSensitive(l){return!!(l.capabilities&1024)}async createFolder(l){const c=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);await this.mkdirp(c,l);const n=await this.resolve(l,{resolveMetadata:!0});return this._onDidRunOperation.fire(new h.FileOperationEvent(l,0,n)),n}async mkdirp(l,c){const n=[],{providerExtUri:o}=this.getExtUri(l);for(;!o.isEqual(c,o.dirname(c));)try{if(((await l.stat(c)).type&h.FileType.Directory)==0)throw new Error((0,t.localize)(18,null,this.resourceForError(c)));break}catch(s){if((0,h.toFileSystemProviderErrorCode)(s)!==h.FileSystemProviderErrorCode.FileNotFound)throw s;n.push(o.basename(c)),c=o.dirname(c)}for(let s=n.length-1;s>=0;s--){c=o.joinPath(c,n[s]);try{await l.mkdir(c)}catch(r){if((0,h.toFileSystemProviderErrorCode)(r)!==h.FileSystemProviderErrorCode.FileExists)throw r}}}async canDelete(l,c){try{await this.doValidateDelete(l,c)}catch(n){return n}return!0}async doValidateDelete(l,c){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(l),l);if(!!c?.useTrash&&!(n.capabilities&4096))throw new Error((0,t.localize)(19,null,this.resourceForError(l)));let s;try{s=await n.stat(l)}catch(a){}if(s)this.throwIfFileIsReadonly(l,s);else throw new h.FileOperationError((0,t.localize)(20,null,this.resourceForError(l)),1);if(!!!c?.recursive){const a=await this.resolve(l);if(a.isDirectory&&Array.isArray(a.children)&&a.children.length>0)throw new Error((0,t.localize)(21,null,this.resourceForError(l)))}return n}async del(l,c){const n=await this.doValidateDelete(l,c),o=!!c?.useTrash,s=!!c?.recursive;await n.delete(l,{recursive:s,useTrash:o}),this._onDidRunOperation.fire(new h.FileOperationEvent(l,1))}onDidChangeFile(l,c){this._onDidChangeFilesRaw.fire({changes:l});let n,o;{for(const s of l)this.watchedResources.has(s.resource)?(n||(n=[]),n.push(s)):(o||(o=[]),o.push(s));n&&this._onDidFilesChange.fire(new h.FileChangesEvent(n,!c))}if(o){const s=c?this.caseSensitiveFileEventsWorker:this.caseInsensitiveFileEventsWorker;!s.work(o)&&Ke.FILE_EVENTS_THROTTLING.warningscounter++<10&&this.logService.warn(`[File watcher]: started ignoring events due to too many file change events at once (incoming: ${o.length}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`),s.pending>0&&this.logService.trace(`[File watcher]: started throttling events due to large amount of file change events at once (pending: ${s.pending}, most recent change: ${o[0].resource.toString()}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}}watch(l,c={recursive:!1,excludes:[]}){const n=new d.DisposableStore;{let o=!1,s=()=>{o=!0};n.add((0,d.toDisposable)(()=>s())),this.doWatch(l,c).then(r=>{o?(0,d.dispose)(r):s=()=>(0,d.dispose)(r)},r=>this.logService.error(r))}return c.recursive||(this.watchedResources.set(l,(this.watchedResources.get(l)??0)+1),n.add((0,d.toDisposable)(()=>{const o=this.watchedResources.get(l);typeof o=="number"&&(o<=1?this.watchedResources.delete(l):this.watchedResources.set(l,o-1))}))),n}async doWatch(l,c){const n=await this.withProvider(l),o=this.toWatchKey(n,l,c),s=this.activeWatchers.get(o)||{count:0,disposable:n.watch(l,c)};return this.activeWatchers.has(o)||this.activeWatchers.set(o,s),s.count+=1,(0,d.toDisposable)(()=>{s.count--,s.count===0&&((0,d.dispose)(s.disposable),this.activeWatchers.delete(o))})}toWatchKey(l,c,n){const{providerExtUri:o}=this.getExtUri(l);return[o.getComparisonKey(c),String(n.recursive),n.excludes.join()].join()}dispose(){super.dispose();for(const[,l]of this.activeWatchers)(0,d.dispose)(l.disposable);this.activeWatchers.clear()}async doWriteBuffered(l,c,n,o){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(async()=>{const s=await l.open(c,{create:!0,unlock:n?.unlock??!1});try{(0,m.isReadableStream)(o)||(0,m.isReadableBufferedStream)(o)?await this.doWriteStreamBufferedQueued(l,s,o):await this.doWriteReadableBufferedQueued(l,s,o)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await l.close(s)}})}async doWriteStreamBufferedQueued(l,c,n){let o=0,s;if((0,m.isReadableBufferedStream)(n)){if(n.buffer.length>0){const r=D.VSBuffer.concat(n.buffer);await this.doWriteBuffer(l,c,r,r.byteLength,o,0),o+=r.byteLength}if(n.ended)return;s=n.stream}else s=n;return new Promise((r,a)=>{(0,m.listenStream)(s,{onData:async f=>{s.pause();try{await this.doWriteBuffer(l,c,f,f.byteLength,o,0)}catch(w){return a(w)}o+=f.byteLength,setTimeout(()=>s.resume())},onError:f=>a(f),onEnd:()=>r()})})}async doWriteReadableBufferedQueued(l,c,n){let o=0,s;for(;(s=n.read())!==null;)await this.doWriteBuffer(l,c,s,s.byteLength,o,0),o+=s.byteLength}async doWriteBuffer(l,c,n,o,s,r){let a=0;for(;a<o;)a+=await l.write(c,s+a,n.buffer,r+a,o-a)}async doWriteUnbuffered(l,c,n,o){return this.writeQueue.queueFor(c,this.getExtUri(l).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(l,c,n,o))}async doWriteUnbufferedQueued(l,c,n,o){let s;o instanceof D.VSBuffer?s=o:(0,m.isReadableStream)(o)?s=await(0,D.streamToBuffer)(o):(0,m.isReadableBufferedStream)(o)?s=await(0,D.bufferedStreamToBuffer)(o):s=(0,D.readableToBuffer)(o),await l.writeFile(c,s.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(l,c,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(l,c,n,o))}async doPipeBufferedQueued(l,c,n,o){let s,r;try{s=await l.open(c,{create:!1}),r=await n.open(o,{create:!0,unlock:!1});const a=D.VSBuffer.alloc(this.BUFFER_SIZE);let f=0,w=0,k=0;do k=await l.read(s,f,a.buffer,w,a.byteLength-w),await this.doWriteBuffer(n,r,a,k,f,w),f+=k,w+=k,w===a.byteLength&&(w=0);while(k>0)}catch(a){throw(0,h.ensureFileSystemProviderError)(a)}finally{await L.Promises.settled([typeof s=="number"?l.close(s):Promise.resolve(),typeof r=="number"?n.close(r):Promise.resolve()])}}async doPipeUnbuffered(l,c,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(l,c,n,o))}async doPipeUnbufferedQueued(l,c,n,o){return n.writeFile(o,await l.readFile(c),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(l,c,n,o){return this.writeQueue.queueFor(o,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(l,c,n,o))}async doPipeUnbufferedToBufferedQueued(l,c,n,o){const s=await n.open(o,{create:!0,unlock:!1});try{const r=await l.readFile(c);await this.doWriteBuffer(n,s,D.VSBuffer.wrap(r),r.byteLength,0,0)}catch(r){throw(0,h.ensureFileSystemProviderError)(r)}finally{await n.close(s)}}async doPipeBufferedToUnbuffered(l,c,n,o){const s=await(0,D.streamToBuffer)(this.readFileBuffered(l,c,M.CancellationToken.None));await this.doWriteUnbuffered(n,o,void 0,s)}throwIfFileSystemIsReadonly(l,c){if(l.capabilities&2048)throw new h.FileOperationError((0,t.localize)(22,null,this.resourceForError(c)),6);return l}throwIfFileIsReadonly(l,c){if((c.permissions??0)&h.FilePermission.Readonly)throw new h.FileOperationError((0,t.localize)(23,null,this.resourceForError(l)),6)}resourceForError(l){return l.scheme===i.Schemas.file?l.fsPath:l.toString(!0)}};y.FILE_EVENTS_THROTTLING={maxChangesChunkSize:500,maxChangesBufferSize:3e4,coolDownDelay:200,warningscounter:0},y=he([te(0,v.ILogService)],y),e.FileService=y}),define(Q[95],J([0,1,30,9,16,4,33,2,8,3,15,59,19,144,20,94,169,170,171,172,55,6,45]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0;class o extends b.Disposable{constructor(r,a){super();this.logService=r,this.options=a,this.BUFFER_SIZE=this.options?.bufferSize||256*1024,this.onDidChangeCapabilities=M.Event.None,this.mapHandleToPos=new Map,this.writeHandles=new Map,this.canFlush=!0,this._onDidWatchErrorOccur=this._register(new M.Emitter),this.onDidErrorOccur=this._onDidWatchErrorOccur.event,this._onDidChangeFile=this._register(new M.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.recursiveFoldersToWatch=[],this.recursiveWatchRequestDelayer=this._register(new L.ThrottledDelayer(0))}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192,g.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(r){try{const{stat:a,symbolicLink:f}=await S.SymlinkSupport.stat(this.toFilePath(r));return{type:this.toType(a,f),ctime:a.birthtime.getTime(),mtime:a.mtime.getTime(),size:a.size}}catch(a){throw this.toFileSystemProviderError(a)}}async readdir(r){try{const a=await S.Promises.readdir(this.toFilePath(r),{withFileTypes:!0}),f=[];return await Promise.all(a.map(async w=>{try{let k;w.isSymbolicLink()?k=(await this.stat((0,i.joinPath)(r,w.name))).type:k=this.toType(w),f.push([w.name,k])}catch(k){this.logService.trace(k)}})),f}catch(a){throw this.toFileSystemProviderError(a)}}toType(r,a){let f;return a?.dangling?f=t.FileType.Unknown:r.isFile()?f=t.FileType.File:r.isDirectory()?f=t.FileType.Directory:f=t.FileType.Unknown,a&&(f|=t.FileType.SymbolicLink),f}async readFile(r){try{const a=this.toFilePath(r);return await S.Promises.readFile(a)}catch(a){throw this.toFileSystemProviderError(a)}}readFileStream(r,a,f){const w=(0,I.newWriteableStream)(k=>D.VSBuffer.concat(k.map(R=>D.VSBuffer.wrap(R))).buffer);return(0,h.readFileIntoStream)(this,r,w,k=>k.buffer,{...a,bufferSize:this.BUFFER_SIZE},f),w}async writeFile(r,a,f){let w;try{const k=this.toFilePath(r);if(!f.create||!f.overwrite){if(await S.Promises.exists(k)){if(!f.overwrite)throw(0,t.createFileSystemProviderError)((0,m.localize)(0,null),t.FileSystemProviderErrorCode.FileExists)}else if(!f.create)throw(0,t.createFileSystemProviderError)((0,m.localize)(1,null),t.FileSystemProviderErrorCode.FileNotFound)}w=await this.open(r,{create:!0,unlock:f.unlock}),await this.write(w,0,a,0,a.byteLength)}catch(k){throw await this.toFileSystemProviderWriteError(r,k)}finally{typeof w=="number"&&await this.close(w)}}async open(r,a){try{const f=this.toFilePath(r);if((0,t.isFileOpenForWriteOptions)(a)&&a.unlock)try{const{stat:R}=await S.SymlinkSupport.stat(f);R.mode&128||await S.Promises.chmod(f,R.mode|128)}catch(R){this.logService.trace(R)}let w;if((0,t.isFileOpenForWriteOptions)(a)){if(g.isWindows)try{await S.Promises.truncate(f,0),w="r+"}catch(R){R.code!=="ENOENT"&&this.logService.trace(R)}w||(w="w")}else w="r";const k=await S.Promises.open(f,w);return this.mapHandleToPos.set(k,0),(0,t.isFileOpenForWriteOptions)(a)&&this.writeHandles.set(k,r),k}catch(f){throw(0,t.isFileOpenForWriteOptions)(a)?await this.toFileSystemProviderWriteError(r,f):this.toFileSystemProviderError(f)}}async close(r){try{if(this.mapHandleToPos.delete(r),this.writeHandles.delete(r)&&this.canFlush)try{await S.Promises.fdatasync(r)}catch(a){this.canFlush=!1,this.logService.error(a)}return await S.Promises.close(r)}catch(a){throw this.toFileSystemProviderError(a)}}async read(r,a,f,w,k){const R=this.normalizePos(r,a);let A=null;try{const O=await S.Promises.read(r,f,w,k,R);return typeof O=="number"?A=O:A=O.bytesRead,A}catch(O){throw this.toFileSystemProviderError(O)}finally{this.updatePos(r,R,A)}}normalizePos(r,a){return a===this.mapHandleToPos.get(r)?null:a}updatePos(r,a,f){const w=this.mapHandleToPos.get(r);typeof w=="number"&&(typeof a=="number"||(typeof f=="number"?this.mapHandleToPos.set(r,w+f):this.mapHandleToPos.delete(r)))}async write(r,a,f,w,k){return(0,L.retry)(()=>this.doWrite(r,a,f,w,k),100,3)}async doWrite(r,a,f,w,k){const R=this.normalizePos(r,a);let A=null;try{const O=await S.Promises.write(r,f,w,k,R);return typeof O=="number"?A=O:A=O.bytesWritten,A}catch(O){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(r),O)}finally{this.updatePos(r,R,A)}}async mkdir(r){try{await S.Promises.mkdir(this.toFilePath(r))}catch(a){throw this.toFileSystemProviderError(a)}}async delete(r,a){try{const f=this.toFilePath(r);await this.doDelete(f,a)}catch(f){throw this.toFileSystemProviderError(f)}}async doDelete(r,a){a.recursive?await S.Promises.rm(r,S.RimRafMode.MOVE):await S.Promises.unlink(r)}async rename(r,a,f){const w=this.toFilePath(r),k=this.toFilePath(a);if(w!==k)try{await this.validateTargetDeleted(r,a,"move",f.overwrite),await S.Promises.move(w,k)}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,m.localize)(2,null,(0,d.basename)(w),(0,d.basename)((0,d.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async copy(r,a,f){const w=this.toFilePath(r),k=this.toFilePath(a);if(w!==k)try{await this.validateTargetDeleted(r,a,"copy",f.overwrite),await S.Promises.copy(w,k,{preserveSymlinks:!0})}catch(R){throw(R.code==="EINVAL"||R.code==="EBUSY"||R.code==="ENAMETOOLONG")&&(R=new Error((0,m.localize)(3,null,(0,d.basename)(w),(0,d.basename)((0,d.dirname)(k)),R.toString()))),this.toFileSystemProviderError(R)}}async validateTargetDeleted(r,a,f,w){const k=this.toFilePath(r),R=this.toFilePath(a);let A=!1;if(!!(this.capabilities&1024)||(A=(0,P.isEqual)(k,R,!0)),A&&f==="copy")throw(0,t.createFileSystemProviderError)((0,m.localize)(4,null),t.FileSystemProviderErrorCode.FileExists);if(!A&&await S.Promises.exists(R)){if(!w)throw(0,t.createFileSystemProviderError)((0,m.localize)(5,null),t.FileSystemProviderErrorCode.FileExists);await this.delete(a,{recursive:!0,useTrash:!1})}}watch(r,a){return a.recursive?this.watchRecursive(r,a):this.watchNonRecursive(r)}watchRecursive(r,a){const f={path:this.toFilePath(r),excludes:a.excludes},w=(0,p.insert)(this.recursiveFoldersToWatch,f);return this.refreshRecursiveWatchers(),(0,b.toDisposable)(()=>{w(),this.refreshRecursiveWatchers()})}refreshRecursiveWatchers(){this.recursiveWatchRequestDelayer.trigger(async()=>{this.doRefreshRecursiveWatchers()})}doRefreshRecursiveWatchers(){this.recursiveWatcher?this.recursiveWatcher.watch(this.recursiveFoldersToWatch):this.recursiveFoldersToWatch.length>0&&(this.recursiveWatcher=this._register(this.createRecursiveWatcher(this.recursiveFoldersToWatch,r=>this._onDidChangeFile.fire((0,l.toFileChanges)(r)),r=>{r.type==="error"&&this._onDidWatchErrorOccur.fire(r.message),this.logService[r.type](r.message)},this.logService.getLevel()===c.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.recursiveWatcher?.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)})))}createRecursiveWatcher(r,a,f,w){let k,R;if(this.options?.watcher?.usePolling)k=u.FileWatcher,R=this.options?.watcher;else{let A=!1;this.options?.legacyWatcher==="on"||this.options?.legacyWatcher==="off"?A=this.options.legacyWatcher==="on":n.default.quality==="stable"&&(A=this.recursiveFoldersToWatch.length===1),A?g.isLinux?k=u.FileWatcher:k=v.FileWatcher:k=y.FileWatcher}return new k(r,A=>a(A),A=>f(A),w,R)}watchNonRecursive(r){const a=new E.FileWatcher(this.toFilePath(r),w=>this._onDidChangeFile.fire((0,l.toFileChanges)(w)),w=>{w.type==="error"&&this._onDidWatchErrorOccur.fire(w.message),this.logService[w.type](w.message)},this.logService.getLevel()===c.LogLevel.Trace),f=this.logService.onDidChangeLogLevel(()=>{a.setVerboseLogging(this.logService.getLevel()===c.LogLevel.Trace)});return(0,b.combinedDisposable)(a,f)}toFilePath(r){return(0,d.normalize)(r.fsPath)}toFileSystemProviderError(r){if(r instanceof t.FileSystemProviderError)return r;let a;switch(r.code){case"ENOENT":a=t.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":a=t.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":a=t.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":a=t.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":a=t.FileSystemProviderErrorCode.NoPermissions;break;default:a=t.FileSystemProviderErrorCode.Unknown}return(0,t.createFileSystemProviderError)(r,a)}async toFileSystemProviderWriteError(r,a){let f=this.toFileSystemProviderError(a);if(r&&f.code===t.FileSystemProviderErrorCode.NoPermissions)try{const{stat:w}=await S.SymlinkSupport.stat(this.toFilePath(r));w.mode&128||(f=(0,t.createFileSystemProviderError)(a,t.FileSystemProviderErrorCode.FileWriteLocked))}catch(w){this.logService.trace(w)}return f}}e.DiskFileSystemProvider=o}),define(Q[21],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProductService=void 0,e.IProductService=(0,p.createDecorator)("productService")}),define(Q[184],J([0,1,60,6,21]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionUrlTrustService=void 0;let M=class{constructor(b,d){this.productService=b,this.logService=d,this.trustedExtensionUrlPublicKeys=new Map}async isExtensionUrlTrusted(b,d){if(!this.productService.trustedExtensionUrlPublicKeys)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","There are no configured trusted keys"),!1;const g=/^(.*)#([^#]+)$/.exec(d);if(!g)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri has no fragment",d),!1;const[,i,I]=g;let S=this.trustedExtensionUrlPublicKeys.get(b);if(!S){if(S=this.productService.trustedExtensionUrlPublicKeys[b],!S||S.length===0)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Extension doesn't have any trusted keys",b),!1;this.trustedExtensionUrlPublicKeys.set(b,[...S])}const m=Buffer.from(decodeURIComponent(I),"base64");if(m.length<=6)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Uri fragment is not a signature",d),!1;const t=m.slice(0,6),h=m.readUIntBE(0,6),E=Date.now()-h;if(E<0||E>36e5)return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri has expired",d),!1;const v=m.slice(6),y=p.createVerify("SHA256");y.write(t),y.write(Buffer.from(i)),y.end();for(let u=0;u<S.length;u++){let l=S[u];if(l!==null){if(typeof l=="string")try{l=p.createPublicKey({key:Buffer.from(l,"base64"),format:"der",type:"spki"}),S[u]=l}catch(c){this.logService.warn("ExtensionUrlTrustService#isExtensionUrlTrusted",`Failed to parse trusted extension uri public key #${u+1} for ${b}:`,c),S[u]=null;continue}if(y.verify(l,v))return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri is valid",d),!0}}return this.logService.trace("ExtensionUrlTrustService#isExtensionUrlTrusted","Signed uri could not be verified",d),!1}};M=he([te(0,D.IProductService),te(1,L.ILogService)],M),e.ExtensionUrlTrustService=M}),define(Q[56],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IProtocolMainService=void 0,e.IProtocolMainService=(0,p.createDecorator)("protocolMainService")}),define(Q[185],J([0,1,13,2,40,10,3,15,7,28,48,6]),function(j,e,p,L,D,M,P,b,d,g,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProtocolMainService=void 0;let S=class extends L.Disposable{constructor(t,h){super();this.logService=h,this.validRoots=D.TernarySearchTree.forUris(()=>!P.isLinux),this.validExtensions=new Set([".svg",".png",".jpg",".jpeg",".gif",".bmp"]),this.addValidFileRoot(d.URI.file(t.appRoot)),this.addValidFileRoot(d.URI.file(t.extensionsPath)),this.addValidFileRoot(t.globalStorageHome),this.addValidFileRoot(t.workspaceStorageHome),this.handleProtocols()}handleProtocols(){const{defaultSession:t}=p.session;t.protocol.registerFileProtocol(M.Schemas.vscodeFileResource,(h,E)=>this.handleResourceRequest(h,E)),t.protocol.interceptFileProtocol(M.Schemas.file,(h,E)=>this.handleFileRequest(h,E)),this._register((0,L.toDisposable)(()=>{t.protocol.unregisterProtocol(M.Schemas.vscodeFileResource),t.protocol.uninterceptProtocol(M.Schemas.file)}))}addValidFileRoot(t){return this.validRoots.get(t)?L.Disposable.None:(this.validRoots.set(t,!0),(0,L.toDisposable)(()=>this.validRoots.delete(t)))}handleFileRequest(t,h){const E=d.URI.parse(t.url);return this.logService.error(`Refused to load resource ${E.fsPath} from ${M.Schemas.file}: protocol (original URL: ${t.url})`),h({error:-3})}handleResourceRequest(t,h){const E=d.URI.parse(t.url),v=M.FileAccess.asFileUri(E);return this.validRoots.findSubstr(v)?h({path:v.fsPath}):this.validExtensions.has((0,b.extname)(v))?h({path:v.fsPath}):(this.logService.error(`${M.Schemas.vscodeFileResource}: Refused to load resource ${v.fsPath} from ${M.Schemas.vscodeFileResource}: protocol (original URL: ${t.url})`),h({error:-3}))}createIPCObjectUrl(){let t;const h=d.URI.from({scheme:"vscode",path:(0,g.generateUuid)()}),E=h.toString(),v=async()=>t;return p.ipcMain.handle(E,v),this.logService.trace(`IPC Object URL: Registered new channel ${E}.`),{resource:h,update:y=>t=y,dispose:()=>{this.logService.trace(`IPC Object URL: Removed channel ${E}.`),p.ipcMain.removeHandler(E)}}}};S=he([te(0,i.INativeEnvironmentService),te(1,I.ILogService)],S),e.ProtocolMainService=S}),define(Q[37],J([0,1,103,14]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class D{constructor(){this.data=new Map}add(P,b){p.ok(L.isString(P)),p.ok(L.isObject(b)),p.ok(!this.data.has(P),"There is already an extension with this id"),this.data.set(P,b)}knows(P){return this.data.has(P)}as(P){return this.data.get(P)||null}}e.Registry=new D}),define(Q[186],J([0,1,4,37]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function D(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class M{constructor(){this._onDidChangeSchema=new p.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(d,g){this.schemasById[D(d)]=g,this._onDidChangeSchema.fire(d)}notifySchemaChanged(d){this._onDidChangeSchema.fire(d)}getSchemaContributions(){return{schemas:this.schemasById}}}const P=new M;L.Registry.add(e.Extensions.JSONContribution,P)}),define(Q[49],J([0,1,30,4,14,132,186,37]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.overrideIdentifierFromKey=e.OVERRIDE_PROPERTY_PATTERN=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var d;(function(y){y.Multiline="multilineText",y.Singleline="singlelineText"})(d=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var g;(function(y){y[y.APPLICATION=1]="APPLICATION",y[y.MACHINE=2]="MACHINE",y[y.WINDOW=3]="WINDOW",y[y.RESOURCE=4]="RESOURCE",y[y.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",y[y.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(g=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage";const i=b.Registry.as(P.Extensions.JSONContribution);class I{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new L.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new L.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.defaultValues={},this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:M.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.excludedConfigurationProperties={},i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema)}registerConfiguration(u,l=!0){this.registerConfigurations([u],l)}registerConfigurations(u,l=!0){const c=this.doRegisterConfigurations(u,l);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(c)}deregisterConfigurations(u){const l=this.doDeregisterConfigurations(u);i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}updateConfigurations({add:u,remove:l}){const c=[];c.push(...this.doDeregisterConfigurations(l)),c.push(...this.doRegisterConfigurations(u,!1)),i.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire((0,p.distinct)(c))}registerDefaultConfigurations(u){const l=[],c=[];for(const n of u)for(const o in n)if(l.push(o),e.OVERRIDE_PROPERTY_PATTERN.test(o)){this.defaultValues[o]={...this.defaultValues[o]||{},...n[o]};const s={type:"object",default:this.defaultValues[o],description:M.localize(1,null,o),$ref:e.resourceLanguageSettingsSchemaId};c.push(m(o)),this.configurationProperties[o]=s,this.defaultLanguageConfigurationOverridesNode.properties[o]=s}else{this.defaultValues[o]=n[o];const s=this.configurationProperties[o];s&&(this.updatePropertyDefaultValue(o,s),this.updateSchema(o,s))}this.registerOverrideIdentifiers(c),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}deregisterDefaultConfigurations(u){const l=[];for(const c of u)for(const n in c)if(l.push(n),delete this.defaultValues[n],e.OVERRIDE_PROPERTY_PATTERN.test(n))delete this.configurationProperties[n],delete this.defaultLanguageConfigurationOverridesNode.properties[n];else{const o=this.configurationProperties[n];o&&(this.updatePropertyDefaultValue(n,o),this.updateSchema(n,o))}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire(l)}notifyConfigurationSchemaUpdated(...u){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(u){for(const l of u)this.overrideIdentifiers.add(l);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(u,l){const c=[];return u.forEach(n=>{c.push(...this.validateAndRegisterProperties(n,l,n.extensionInfo)),this.configurationContributors.push(n),this.registerJSONConfiguration(n)}),c}doDeregisterConfigurations(u){const l=[],c=n=>{if(n.properties)for(const o in n.properties)l.push(o),delete this.configurationProperties[o],this.removeFromSchema(o,n.properties[o]);n.allOf&&n.allOf.forEach(o=>c(o))};for(const n of u){c(n);const o=this.configurationContributors.indexOf(n);o!==-1&&this.configurationContributors.splice(o,1)}return l}validateAndRegisterProperties(u,l=!0,c,n=3){n=D.isUndefinedOrNull(u.scope)?n:u.scope;let o=[],s=u.properties;if(s)for(let a in s){if(l&&E(a)){delete s[a];continue}const f=s[a];if(this.updatePropertyDefaultValue(a,f),e.OVERRIDE_PROPERTY_PATTERN.test(a)?f.scope=void 0:(f.scope=D.isUndefinedOrNull(f.scope)?n:f.scope,f.restricted=D.isUndefinedOrNull(f.restricted)?!!c?.restrictedConfigurations?.includes(a):f.restricted),s[a].hasOwnProperty("included")&&!s[a].included){this.excludedConfigurationProperties[a]=s[a],delete s[a];continue}else this.configurationProperties[a]=s[a];!s[a].deprecationMessage&&s[a].markdownDeprecationMessage&&(s[a].deprecationMessage=s[a].markdownDeprecationMessage),o.push(a)}let r=u.allOf;if(r)for(let a of r)o.push(...this.validateAndRegisterProperties(a,l,c,n));return o}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}registerJSONConfiguration(u){const l=c=>{let n=c.properties;if(n)for(const s in n)this.updateSchema(s,n[s]);let o=c.allOf;o&&o.forEach(l)};l(u)}updateSchema(u,l){switch(e.allSettings.properties[u]=l,l.scope){case 1:e.applicationSettings.properties[u]=l;break;case 2:e.machineSettings.properties[u]=l;break;case 6:e.machineOverridableSettings.properties[u]=l;break;case 3:e.windowSettings.properties[u]=l;break;case 4:e.resourceSettings.properties[u]=l;break;case 5:e.resourceSettings.properties[u]=l,this.resourceLanguageSettingsSchema.properties[u]=l;break}}removeFromSchema(u,l){switch(delete e.allSettings.properties[u],l.scope){case 1:delete e.applicationSettings.properties[u];break;case 2:delete e.machineSettings.properties[u];break;case 6:delete e.machineOverridableSettings.properties[u];break;case 3:delete e.windowSettings.properties[u];break;case 4:case 5:delete e.resourceSettings.properties[u];break}}updateOverridePropertyPatternKey(){for(const u of this.overrideIdentifiers.values()){const l=`[${u}]`,c={type:"object",description:M.localize(2,null),errorMessage:M.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(l,c),e.allSettings.properties[l]=c,e.applicationSettings.properties[l]=c,e.machineSettings.properties[l]=c,e.machineOverridableSettings.properties[l]=c,e.windowSettings.properties[l]=c,e.resourceSettings.properties[l]=c}this._onDidSchemaChange.fire()}updatePropertyDefaultValue(u,l){let c=this.defaultValues[u];D.isUndefined(c)&&(c=l.default),D.isUndefined(c)&&(c=t(l.type)),l.default=c}}const S="\\[.*\\]$";e.OVERRIDE_PROPERTY_PATTERN=new RegExp(S);function m(y){return y.substring(1,y.length-1)}e.overrideIdentifierFromKey=m;function t(y){switch(Array.isArray(y)?y[0]:y){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=t;const h=new I;b.Registry.add(e.Extensions.Configuration,h);function E(y){return y.trim()?e.OVERRIDE_PROPERTY_PATTERN.test(y)?M.localize(5,null,y):h.getConfigurationProperties()[y]!==void 0?M.localize(6,null,y):null:M.localize(4,null)}e.validateProperty=E;function v(){const y=[],u=h.getConfigurationProperties();for(const l of Object.keys(u))y.push([l,u[l].scope]);return y.push(["launch",4]),y.push(["task",4]),y}e.getScopes=v}),define(Q[17],J([0,1,43,14,7,49,5,37]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMigratedSettingValue=e.keyFromOverrideIdentifier=e.getDefaultValues=e.getConfigurationKeys=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.toOverrides=e.compare=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,P.createDecorator)("configurationService");function d(o){return o&&typeof o=="object"&&(!o.overrideIdentifier||typeof o.overrideIdentifier=="string")&&(!o.resource||o.resource instanceof D.URI)}e.isConfigurationOverrides=d;var g;(function(o){o[o.USER=1]="USER",o[o.USER_LOCAL=2]="USER_LOCAL",o[o.USER_REMOTE=3]="USER_REMOTE",o[o.WORKSPACE=4]="WORKSPACE",o[o.WORKSPACE_FOLDER=5]="WORKSPACE_FOLDER",o[o.DEFAULT=6]="DEFAULT",o[o.MEMORY=7]="MEMORY"})(g=e.ConfigurationTarget||(e.ConfigurationTarget={}));function i(o){switch(o){case 1:return"USER";case 2:return"USER_LOCAL";case 3:return"USER_REMOTE";case 4:return"WORKSPACE";case 5:return"WORKSPACE_FOLDER";case 6:return"DEFAULT";case 7:return"MEMORY"}}e.ConfigurationTargetToString=i;function I(o,s){const r=s?o?s.keys.filter(O=>o.keys.indexOf(O)===-1):[...s.keys]:[],a=o?s?o.keys.filter(O=>s.keys.indexOf(O)===-1):[...o.keys]:[],f=[];if(s&&o){for(const O of o.keys)if(s.keys.indexOf(O)!==-1){const H=v(o.contents,O),x=v(s.contents,O);p.equals(H,x)||f.push(O)}}const w=[],k=O=>{const H={};for(const x of O)for(const re of x.identifiers)H[c(re)]=x;return H},R=s?k(s.overrides):{},A=o?k(o.overrides):{};if(Object.keys(R).length)for(const O of r){const H=R[O];H&&w.push([(0,M.overrideIdentifierFromKey)(O),H.keys])}if(Object.keys(A).length)for(const O of a){const H=A[O];H&&w.push([(0,M.overrideIdentifierFromKey)(O),H.keys])}if(Object.keys(R).length&&Object.keys(A).length)for(const O of f){const H=A[O],x=R[O];if(H&&x){const re=I({contents:H.contents,keys:H.keys,overrides:[]},{contents:x.contents,keys:x.keys,overrides:[]});w.push([(0,M.overrideIdentifierFromKey)(O),[...re.added,...re.removed,...re.updated]])}}return{added:r,removed:a,updated:f,overrides:w}}e.compare=I;function S(o,s){const r=[];for(const a of Object.keys(o))if(M.OVERRIDE_PROPERTY_PATTERN.test(a)){const f={};for(const w in o[a])f[w]=o[a][w];r.push({identifiers:[(0,M.overrideIdentifierFromKey)(a).trim()],keys:Object.keys(f),contents:m(f,s)})}return r}e.toOverrides=S;function m(o,s){const r=Object.create(null);for(let a in o)t(r,a,o[a],s);return r}e.toValuesTree=m;function t(o,s,r,a){const f=s.split("."),w=f.pop();let k=o;for(let R=0;R<f.length;R++){let A=f[R],O=k[A];switch(typeof O){case"undefined":O=k[A]=Object.create(null);break;case"object":break;default:a(`Ignoring ${s} as ${f.slice(0,R+1).join(".")} is ${JSON.stringify(O)}`);return}k=O}if(typeof k=="object"&&k!==null)try{k[w]=r}catch(R){a(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}else a(`Ignoring ${s} as ${f.join(".")} is ${JSON.stringify(k)}`)}e.addToValueTree=t;function h(o,s){const r=s.split(".");E(o,r)}e.removeFromValueTree=h;function E(o,s){const r=s.shift();if(s.length===0){delete o[r];return}if(Object.keys(o).indexOf(r)!==-1){const a=o[r];typeof a=="object"&&!Array.isArray(a)&&(E(a,s),Object.keys(a).length===0&&delete o[r])}}function v(o,s,r){function a(k,R){let A=k;for(const O of R){if(typeof A!="object"||A===null)return;A=A[O]}return A}const f=s.split("."),w=a(o,f);return typeof w=="undefined"?r:w}e.getConfigurationValue=v;function y(o,s,r){Object.keys(s).forEach(a=>{a!=="__proto__"&&(a in o?L.isObject(o[a])&&L.isObject(s[a])?y(o[a],s[a],r):r&&(o[a]=s[a]):o[a]=s[a])})}e.merge=y;function u(){const o=b.Registry.as(M.Extensions.Configuration).getConfigurationProperties();return Object.keys(o)}e.getConfigurationKeys=u;function l(){const o=Object.create(null),s=b.Registry.as(M.Extensions.Configuration).getConfigurationProperties();for(let r in s){let a=s[r].default;t(o,r,a,f=>console.error(`Conflict in default settings: ${f}`))}return o}e.getDefaultValues=l;function c(o){return`[${o}]`}e.keyFromOverrideIdentifier=c;function n(o,s,r){const a=o.inspect(s),f=o.inspect(r);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof f.userValue!="undefined"||typeof f.workspaceValue!="undefined"||typeof f.workspaceFolderValue!="undefined"?f.value:a.defaultValue}e.getMigratedSettingValue=n}),define(Q[187],J([0,1,30,4,39,2,40,43,14,7,17,49,37]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.DefaultConfigurationModel=e.ConfigurationModel=void 0;class m{constructor(n={},o=[],s=[]){this._contents=n,this._keys=o,this._overrides=s,this.isFrozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}getValue(n){return n?(0,i.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,o){const s=this.getContentsForOverrideIdentifer(o);return s?n?(0,i.getConfigurationValue)(s,n):s:void 0}getKeysForOverrideIdentifier(n){for(const o of this.overrides)if(o.identifiers.indexOf(n)!==-1)return o.keys;return[]}override(n){let o=this.overrideConfigurations.get(n);return o||(o=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,o)),o}merge(...n){const o=b.deepClone(this.contents),s=b.deepClone(this.overrides),r=[...this.keys];for(const a of n){this.mergeContents(o,a.contents);for(const f of a.overrides){const[w]=s.filter(k=>p.equals(k.identifiers,f.identifiers));w?this.mergeContents(w.contents,f.contents):s.push(b.deepClone(f))}for(const f of a.keys)r.indexOf(f)===-1&&r.push(f)}return new m(o,r,s)}freeze(){return this.isFrozen=!0,this}createOverrideConfigurationModel(n){const o=this.getContentsForOverrideIdentifer(n);if(!o||typeof o!="object"||!Object.keys(o).length)return this;let s={};for(const r of p.distinct([...Object.keys(this.contents),...Object.keys(o)])){let a=this.contents[r],f=o[r];f&&(typeof a=="object"&&typeof f=="object"?(a=b.deepClone(a),this.mergeContents(a,f)):a=f),s[r]=a}return new m(s,this.keys,this.overrides)}mergeContents(n,o){for(const s of Object.keys(o)){if(s in n&&d.isObject(n[s])&&d.isObject(o[s])){this.mergeContents(n[s],o[s]);continue}n[s]=b.deepClone(o[s])}}checkAndFreeze(n){return this.isFrozen&&!Object.isFrozen(n)?b.deepFreeze(n):n}getContentsForOverrideIdentifer(n){for(const o of this.overrides)if(o.identifiers.indexOf(n)!==-1)return o.contents;return null}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,o){this.addKey(n),(0,i.addToValueTree)(this.contents,n,o,s=>{throw new Error(s)})}removeValue(n){this.removeKey(n)&&(0,i.removeFromValueTree)(this.contents,n)}addKey(n){let o=this.keys.length;for(let s=0;s<o;s++)n.indexOf(this.keys[s])===0&&(o=s);this.keys.splice(o,1,n)}removeKey(n){let o=this.keys.indexOf(n);return o!==-1?(this.keys.splice(o,1),!0):!1}}e.ConfigurationModel=m;class t extends m{constructor(){const n=(0,i.getDefaultValues)(),o=(0,i.getConfigurationKeys)(),s=[];for(const r of Object.keys(n))I.OVERRIDE_PROPERTY_PATTERN.test(r)&&s.push({identifiers:[(0,I.overrideIdentifierFromKey)(r).trim()],keys:Object.keys(n[r]),contents:(0,i.toValuesTree)(n[r],a=>console.error(`Conflict in default settings file: ${a}`))});super(n,o,s)}}e.DefaultConfigurationModel=t;class h{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new m}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,o){if(!d.isUndefinedOrNull(n)){const s=this.doParseContent(n);this.parseRaw(s,o)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,o){this._raw=n;const{contents:s,keys:r,overrides:a,restricted:f}=this.doParseRaw(n,o);this._configurationModel=new m(s,r,a),this._restrictedConfigurations=f||[]}doParseContent(n){let o={},s=null,r=[],a=[],f=[];function w(R){Array.isArray(r)?r.push(R):s!==null&&(r[s]=R)}let k={onObjectBegin:()=>{let R={};w(R),a.push(r),r=R,s=null},onObjectProperty:R=>{s=R},onObjectEnd:()=>{r=a.pop()},onArrayBegin:()=>{let R=[];w(R),a.push(r),r=R,s=null},onArrayEnd:()=>{r=a.pop()},onLiteralValue:w,onError:(R,A,O)=>{f.push({error:R,offset:A,length:O})}};if(n)try{D.visit(n,k),o=r[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return o}doParseRaw(n,o){const s=S.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),r=this.filter(n,s,!0,o);n=r.raw;const a=(0,i.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),f=Object.keys(n),w=(0,i.toOverrides)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:a,keys:f,overrides:w,restricted:r.restricted}}filter(n,o,s,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:n,restricted:[]};const a={},f=[];for(let w in n)if(I.OVERRIDE_PROPERTY_PATTERN.test(w)&&s){const k=this.filter(n[w],o,!1,r);a[w]=k.raw,f.push(...k.restricted)}else{const k=o[w],R=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&f.push(w),(R===void 0||r.scopes===void 0||r.scopes.includes(R))&&(r.skipRestricted&&k?.restricted||(a[w]=n[w]))}return{raw:a,restricted:f}}}e.ConfigurationModelParser=h;class E extends M.Disposable{constructor(n,o,s,r){super();this.userSettingsResource=n,this.scopes=o,this.fileService=r,this._onDidChange=this._register(new L.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new h(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(s.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(L.Event.filter(this.fileService.onDidFilesChange,a=>a.contains(this.userSettingsResource))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch(n){return new m}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=E;class v{constructor(n,o,s=new m,r=new m,a=new P.ResourceMap,f=new m,w=new P.ResourceMap,k=!0){this._defaultConfiguration=n,this._localUserConfiguration=o,this._remoteUserConfiguration=s,this._workspaceConfiguration=r,this._folderConfigurations=a,this._memoryConfiguration=f,this._memoryConfigurationByResource=w,this._freeze=k,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new P.ResourceMap,this._userConfiguration=null}getValue(n,o,s){return this.getConsolidateConfigurationModel(o,s).getValue(n)}updateValue(n,o,s={}){let r;s.resource?(r=this._memoryConfigurationByResource.get(s.resource),r||(r=new m,this._memoryConfigurationByResource.set(s.resource,r))):r=this._memoryConfiguration,o===void 0?r.removeValue(n):r.setValue(n,o),s.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,o,s){const r=this.getConsolidateConfigurationModel(o,s),a=this.getFolderConfigurationModelForResource(o.resource,s),f=o.resource?this._memoryConfigurationByResource.get(o.resource)||this._memoryConfiguration:this._memoryConfiguration,w=o.overrideIdentifier?this._defaultConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=o.overrideIdentifier?this.userConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),R=o.overrideIdentifier?this.localUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),A=o.overrideIdentifier?this.remoteUserConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),O=s?o.overrideIdentifier?this._workspaceConfiguration.freeze().override(o.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,H=a?o.overrideIdentifier?a.freeze().override(o.overrideIdentifier).getValue(n):a.freeze().getValue(n):void 0,x=o.overrideIdentifier?f.override(o.overrideIdentifier).getValue(n):f.getValue(n),re=r.getValue(n),K=p.distinct(p.flatten(r.overrides.map(ee=>ee.identifiers))).filter(ee=>r.getOverrideValue(n,ee)!==void 0);return{defaultValue:w,userValue:k,userLocalValue:R,userRemoteValue:A,workspaceValue:O,workspaceFolderValue:H,memoryValue:x,value:re,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,user:k!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userLocal:R!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,userRemote:A!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspace:O!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:o.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,workspaceFolder:H!==void 0?{value:a?.freeze().getValue(n),override:o.overrideIdentifier?a?.freeze().getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,memory:x!==void 0?{value:f.getValue(n),override:o.overrideIdentifier?f.getOverrideValue(n,o.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(n){const o=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:o?o.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,o){this._folderConfigurations.set(n,o),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,o){const s=o.filter(r=>I.OVERRIDE_PROPERTY_PATTERN.test(r)).map(r=>{const a=(0,I.overrideIdentifierFromKey)(r),f=this._defaultConfiguration.getKeysForOverrideIdentifier(a),w=n.getKeysForOverrideIdentifier(a),k=[...w.filter(R=>f.indexOf(R)===-1),...f.filter(R=>w.indexOf(R)===-1),...f.filter(R=>!b.equals(this._defaultConfiguration.override(a).getValue(R),n.override(a).getValue(R)))];return[a,k]});return this.updateDefaultConfiguration(n),{keys:o,overrides:s}}compareAndUpdateLocalUserConfiguration(n){const{added:o,updated:s,removed:r,overrides:a}=(0,i.compare)(this.localUserConfiguration,n),f=[...o,...s,...r];return f.length&&this.updateLocalUserConfiguration(n),{keys:f,overrides:a}}compareAndUpdateRemoteUserConfiguration(n){const{added:o,updated:s,removed:r,overrides:a}=(0,i.compare)(this.remoteUserConfiguration,n);let f=[...o,...s,...r];return f.length&&this.updateRemoteUserConfiguration(n),{keys:f,overrides:a}}compareAndUpdateWorkspaceConfiguration(n){const{added:o,updated:s,removed:r,overrides:a}=(0,i.compare)(this.workspaceConfiguration,n);let f=[...o,...s,...r];return f.length&&this.updateWorkspaceConfiguration(n),{keys:f,overrides:a}}compareAndUpdateFolderConfiguration(n,o){const s=this.folderConfigurations.get(n),{added:r,updated:a,removed:f,overrides:w}=(0,i.compare)(s,o);let k=[...r,...a,...f];return(k.length||!s)&&this.updateFolderConfiguration(n,o),{keys:k,overrides:w}}compareAndDeleteFolderConfiguration(n){const o=this.folderConfigurations.get(n);if(!o)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:s,updated:r,removed:a,overrides:f}=(0,i.compare)(o,void 0);return{keys:[...s,...r,...a],overrides:f}}get defaults(){return this._defaultConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidateConfigurationModel(n,o){let s=this.getConsolidatedConfigurationModelForResource(n,o);return n.overrideIdentifier?s.override(n.overrideIdentifier):s}getConsolidatedConfigurationModelForResource({resource:n},o){let s=this.getWorkspaceConsolidatedConfiguration();if(o&&n){const r=o.getFolder(n);r&&(s=this.getFolderConsolidatedConfiguration(r.uri)||s);const a=this._memoryConfigurationByResource.get(n);a&&(s=s.merge(a))}return s}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let o=this._foldersConsolidatedConfigurations.get(n);if(!o){const s=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(n);r?(o=s.merge(r),this._freeze&&(o=o.freeze()),this._foldersConsolidatedConfigurations.set(n,o)):o=s}return o}getFolderConfigurationModelForResource(n,o){if(o&&n){const s=o.getFolder(n);if(s)return this._folderConfigurations.get(s.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,o)=>{const{contents:s,overrides:r,keys:a}=this._folderConfigurations.get(o);return n.push([o,{contents:s,overrides:r,keys:a}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(o=>n.add(o)),this.userConfiguration.freeze().keys.forEach(o=>n.add(o)),this._workspaceConfiguration.freeze().keys.forEach(o=>n.add(o)),this._folderConfigurations.forEach(o=>o.freeze().keys.forEach(s=>n.add(s))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const o=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(s=>o.add(s)),this._folderConfigurations.forEach(s=>s.getKeysForOverrideIdentifier(n).forEach(r=>o.add(r))),[...o.values()]}static parse(n){const o=this.parseConfigurationModel(n.defaults),s=this.parseConfigurationModel(n.user),r=this.parseConfigurationModel(n.workspace),a=n.folders.reduce((f,w)=>(f.set(g.URI.revive(w[0]),this.parseConfigurationModel(w[1])),f),new P.ResourceMap);return new v(o,s,new m,r,a,new m,new P.ResourceMap,!1)}static parseConfigurationModel(n){return new m(n.contents,n.keys,n.overrides).freeze()}}e.Configuration=v;function y(...c){if(c.length===0)return{keys:[],overrides:[]};if(c.length===1)return c[0];const n=new Set,o=new Map;for(const r of c)r.keys.forEach(a=>n.add(a)),r.overrides.forEach(([a,f])=>{const w=(0,P.getOrSet)(o,a,new Set);f.forEach(k=>w.add(k))});const s=[];return o.forEach((r,a)=>s.push([a,[...r.values()]])),{keys:[...n.values()],overrides:s}}e.mergeChanges=y;class u{constructor(n,o,s,r){this.change=n,this.previous=o,this.currentConfiguraiton=s,this.currentWorkspace=r,this._previousConfiguration=void 0;const a=new Set;n.keys.forEach(w=>a.add(w)),n.overrides.forEach(([,w])=>w.forEach(k=>a.add(k))),this.affectedKeys=[...a.values()];const f=new m;this.affectedKeys.forEach(w=>f.setValue(w,{})),this.affectedKeysTree=f.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=v.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,o){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(o){const s=this.previousConfiguration?this.previousConfiguration.getValue(n,o,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(n,o,this.currentWorkspace);return!b.equals(s,r)}return!0}return!1}doesAffectedKeysTreeContains(n,o){let s=(0,i.toValuesTree)({[o]:!0},()=>{}),r;for(;typeof s=="object"&&(r=Object.keys(s)[0]);){if(n=n[r],!n)return!1;s=s[r]}return!0}}e.ConfigurationChangeEvent=u;class l extends u{constructor(n,o,s,r){super({keys:n.allKeys(),overrides:[]},void 0,n,o);this.source=s,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=l}),define(Q[188],J([0,1,9,4,2,15,17,187,49,37]),function(j,e,p,L,D,M,P,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class i extends D.Disposable{constructor(S,m){super();this.settingsResource=S,this._onDidChangeConfiguration=this._register(new L.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,M.extUriBiasedIgnorePathCase,m)),this.configuration=new b.Configuration(new b.DefaultConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new p.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(g.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(t=>this.onDidDefaultConfigurationChange(t))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const S=await this.userConfiguration.loadConfiguration();this.configuration=new b.Configuration(new b.DefaultConfigurationModel,S)}getConfigurationData(){return this.configuration.toData()}getValue(S,m){const t=typeof S=="string"?S:void 0,h=(0,P.isConfigurationOverrides)(S)?S:(0,P.isConfigurationOverrides)(m)?m:{};return this.configuration.getValue(t,h,void 0)}updateValue(S,m,t,h){return Promise.reject(new Error("not supported"))}inspect(S){return this.configuration.inspect(S,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const S=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(S)}onDidChangeUserConfiguration(S){const m=this.configuration.toData(),t=this.configuration.compareAndUpdateLocalUserConfiguration(S);this.trigger(t,m,1)}onDidDefaultConfigurationChange(S){const m=this.configuration.toData(),t=this.configuration.compareAndUpdateDefaultConfiguration(new b.DefaultConfigurationModel,S);this.trigger(t,m,6)}trigger(S,m,t){const h=new b.ConfigurationChangeEvent(S,{data:m},this.configuration);h.source=t,h.sourceConfig=this.getTargetConfiguration(t),this._onDidChangeConfiguration.fire(h)}getTargetConfiguration(S){switch(S){case 6:return this.configuration.defaults.contents;case 1:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=i}),define(Q[189],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var L;(function(M){M.Unknown="Unknown",M.NotAvailable="NotAvailable",M.TemporarilyNotAvailable="TemporarilyNotAvailable",M.NoResolverFound="NoResolverFound"})(L=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class D extends Error{constructor(P,b=L.Unknown,d){super(P);this._message=P,this._code=b,this._detail=d,this.isHandled=b===L.NotAvailable&&d===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,D.prototype)}static isTemporarilyNotAvailable(P){return P instanceof D&&P._code===L.TemporarilyNotAvailable}static isNoResolverFound(P){return P instanceof D&&P._code===L.NoResolverFound}static isHandled(P){return P instanceof D&&P.isHandled}}e.RemoteAuthorityResolverError=D}),define(Q[190],J([0,1,9,16,23,18,4,2,28,85,189]),function(j,e,p,L,D,M,P,b,d,g,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const I=30*1e3;var S;(function(W){W[W.Management=1]="Management",W[W.ExtensionHost=2]="ExtensionHost",W[W.Tunnel=3]="Tunnel"})(S=e.ConnectionType||(e.ConnectionType={}));function m(W){switch(W){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function t(W){const T=new D.CancellationTokenSource;return setTimeout(()=>T.cancel(),W),T.token}function h(W,T){if(W.isCancellationRequested||T.isCancellationRequested)return D.CancellationToken.Cancelled;const _=new D.CancellationTokenSource;return W.onCancellationRequested(()=>_.cancel()),T.onCancellationRequested(()=>_.cancel()),_.token}class E{constructor(T){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((_,q)=>{this._resolvePromise=_,this._rejectPromise=q}),T.isCancellationRequested?this._timeout():this._disposables.add(T.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(T){this._state==="pending"?this._disposables.add(T):T.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const T=new Error("Time limit reached");return T.code="ETIMEDOUT",T.syscall="connect",T}resolve(T){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(T))}reject(T){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(T))}}function v(W,T){const _=new E(T);return _.registerDisposable(W.onControlMessage(q=>{const Y=JSON.parse(q.toString()),$=z(Y);$?_.reject($):_.resolve(Y)})),_.promise}function y(W,T,_,q,Y,$){const N=new E($);return T.connect(_,q,Y,(Z,ie)=>{N.didTimeout?(Z&&W.error(Z),ie?.dispose()):Z||!ie?N.reject(Z):N.resolve(ie)}),N.promise}function u(W,T){const _=new E(T);return W.then(q=>{_.didTimeout||_.resolve(q)},q=>{_.didTimeout||_.reject(q)}),_.promise}async function l(W,T,_,q){const Y=C(W,T);W.logService.trace(`${Y} 1/6. invoking socketFactory.connect().`);let $;try{$=await y(W.logService,W.socketFactory,W.host,W.port,`reconnectionToken=${W.reconnectionToken}&reconnection=${W.reconnectionProtocol?"true":"false"}`,q)}catch(oe){throw W.logService.error(`${Y} socketFactory.connect() failed or timed out. Error:`),W.logService.error(oe),oe}W.logService.trace(`${Y} 2/6. socketFactory.connect() was successful.`);let N,Z;W.reconnectionProtocol?(W.reconnectionProtocol.beginAcceptReconnection($,null),N=W.reconnectionProtocol,Z=!1):(N=new g.PersistentProtocol($,null),Z=!0),W.logService.trace(`${Y} 3/6. sending AuthRequest control message.`);const ie={type:"auth",auth:W.connectionToken||"00000000000000000000"};N.sendControl(L.VSBuffer.fromString(JSON.stringify(ie)));try{const oe=await v(N,h(q,t(1e4)));if(oe.type!=="sign"||typeof oe.data!="string"){const ae=new Error("Unexpected handshake message");throw ae.code="VSCODE_CONNECTION_ERROR",ae}W.logService.trace(`${Y} 4/6. received SignRequest control message.`);const le=await u(W.signService.sign(oe.data),q),ne={type:"connectionType",commit:W.commit,signedData:le,desiredConnectionType:T};return _&&(ne.args=_),W.logService.trace(`${Y} 5/6. sending ConnectionTypeRequest control message.`),N.sendControl(L.VSBuffer.fromString(JSON.stringify(ne))),{protocol:N,ownsProtocol:Z}}catch(oe){throw oe&&oe.code==="ETIMEDOUT"&&(W.logService.error(`${Y} the handshake timed out. Error:`),W.logService.error(oe)),oe&&oe.code==="VSCODE_CONNECTION_ERROR"&&(W.logService.error(`${Y} received error control message when negotiating connection. Error:`),W.logService.error(oe)),Z&&V(N),oe}}async function c(W,T,_,q){const Y=Date.now(),$=C(W,T),{protocol:N,ownsProtocol:Z}=await l(W,T,_,q),ie=new E(q);return ie.registerDisposable(N.onControlMessage(oe=>{const le=JSON.parse(oe.toString()),ne=z(le);ne?(W.logService.error(`${$} received error control message when negotiating connection. Error:`),W.logService.error(ne),Z&&V(N),ie.reject(ne)):(W.reconnectionProtocol&&W.reconnectionProtocol.endAcceptReconnection(),W.logService.trace(`${$} 6/6. handshake finished, connection is up and running after ${X(Y)}!`),ie.resolve({protocol:N,firstMessage:le}))})),ie.promise}async function n(W,T){const{protocol:_}=await c(W,1,void 0,T);return{protocol:_}}async function o(W,T,_){const{protocol:q,firstMessage:Y}=await c(W,2,T,_),$=Y&&Y.debugPort;return{protocol:q,debugPort:$}}async function s(W,T,_){const q=Date.now(),Y=C(W,3),{protocol:$}=await l(W,3,T,_);return W.logService.trace(`${Y} 6/6. handshake finished, connection is up and running after ${X(q)}!`),$}async function r(W,T,_){const{host:q,port:Y,connectionToken:$}=await W.addressProvider.getAddress();return{commit:W.commit,host:q,port:Y,connectionToken:$,reconnectionToken:T,reconnectionProtocol:_,socketFactory:W.socketFactory,signService:W.signService,logService:W.logService}}async function a(W,T,_){try{const q=(0,d.generateUuid)(),Y=await r(W,q,null),{protocol:$}=await n(Y,D.CancellationToken.None);return new ee(W,T,_,q,$)}catch(q){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(q),K.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(q)),q}}e.connectRemoteAgentManagement=a;async function f(W,T){try{const _=(0,d.generateUuid)(),q=await r(W,_,null),{protocol:Y,debugPort:$}=await o(q,T,D.CancellationToken.None);return new F(W,T,_,Y,$)}catch(_){throw W.logService.error("[remote-connection] An error occurred in the very first connect attempt, it will be treated as a permanent error! Error:"),W.logService.error(_),K.triggerPermanentFailure(0,0,i.RemoteAuthorityResolverError.isHandled(_)),_}}e.connectRemoteAgentExtensionHost=f;async function w(W,T,_){const q=await r(W,(0,d.generateUuid)(),null);return await s(q,{host:T,port:_},D.CancellationToken.None)}e.connectRemoteAgentTunnel=w;function k(W){return(0,p.createCancelablePromise)(T=>new Promise((_,q)=>{const Y=setTimeout(_,W*1e3);T.onCancellationRequested(()=>{clearTimeout(Y),_()})}))}var R;(function(W){W[W.ConnectionLost=0]="ConnectionLost",W[W.ReconnectionWait=1]="ReconnectionWait",W[W.ReconnectionRunning=2]="ReconnectionRunning",W[W.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",W[W.ConnectionGain=4]="ConnectionGain"})(R=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class A{constructor(T,_){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=A;class O{constructor(T,_,q,Y){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.durationSeconds=q,this.cancellableTimer=Y,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=O;class H{constructor(T,_,q){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=2}}e.ReconnectionRunningEvent=H;class x{constructor(T,_,q){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=q,this.type=4}}e.ConnectionGainEvent=x;class re{constructor(T,_,q,Y){this.reconnectionToken=T,this.millisSinceLastIncomingData=_,this.attempt=q,this.handled=Y,this.type=3}}e.ReconnectionPermanentFailureEvent=re;class K extends b.Disposable{constructor(T,_,q,Y){super();this._connectionType=T,this._onDidStateChange=this._register(new P.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._options=_,this.reconnectionToken=q,this.protocol=Y,this._isReconnecting=!1,this._onDidStateChange.fire(new x(this.reconnectionToken,0,0)),this._register(Y.onSocketClose($=>{const N=U(this._connectionType,this.reconnectionToken,!0);$?$.type===0?(this._options.logService.info(`${N} received socket close event (hadError: ${$.hadError}).`),$.error&&this._options.logService.error($.error)):(this._options.logService.info(`${N} received socket close event (wasClean: ${$.wasClean}, code: ${$.code}, reason: ${$.reason}).`),$.event&&this._options.logService.error($.event)):this._options.logService.info(`${N} received socket close event.`),this._beginReconnecting()})),this._register(Y.onSocketTimeout(()=>{const $=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.trace(`${$} received socket timeout event.`),this._beginReconnecting()})),K._instances.push(this),K._permanentFailure&&this._gotoPermanentFailure(K._permanentFailureMillisSinceLastIncomingData,K._permanentFailureAttempt,K._permanentFailureHandled)}static triggerPermanentFailure(T,_,q){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=T,this._permanentFailureAttempt=_,this._permanentFailureHandled=q,this._instances.forEach(Y=>Y._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(K._permanentFailure)return;const T=U(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${T} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new A(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let q=-1;do{q++;const Y=q<_.length?_[q]:_[_.length-1];try{if(Y>0){const N=k(Y);this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),Y,N)),this._options.logService.info(`${T} waiting for ${Y} seconds before reconnecting...`);try{await N}catch{}}if(K._permanentFailure){this._options.logService.error(`${T} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new H(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1)),this._options.logService.info(`${T} resolving connection...`);const $=await r(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${T} connecting to ${$.host}:${$.port}...`),await this._reconnect($,t(I)),this._options.logService.info(`${T} reconnected!`),this._onDidStateChange.fire(new x(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q+1));break}catch($){if($.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${T} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(q>360){this._options.logService.error(`${T} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}if(i.RemoteAuthorityResolverError.isTemporarilyNotAvailable($)){this._options.logService.info(`${T} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if(($.code==="ETIMEDOUT"||$.code==="ENETUNREACH"||$.code==="ECONNREFUSED"||$.code==="ECONNRESET")&&$.syscall==="connect"){this._options.logService.info(`${T} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if((0,M.isPromiseCanceledError)($)){this._options.logService.info(`${T} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace($);continue}if($ instanceof i.RemoteAuthorityResolverError){this._options.logService.error(`${T} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,i.RemoteAuthorityResolverError.isHandled($));break}this._options.logService.error(`${T} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error($),K.triggerPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),q+1,!1);break}}while(!K._permanentFailure)}_gotoPermanentFailure(T,_,q){this._onDidStateChange.fire(new re(this.reconnectionToken,T,_,q)),V(this.protocol)}}K._permanentFailure=!1,K._permanentFailureMillisSinceLastIncomingData=0,K._permanentFailureAttempt=0,K._permanentFailureHandled=!1,K._instances=[];class ee extends K{constructor(T,_,q,Y,$){super(1,T,Y,$);this.client=this._register(new g.Client($,{remoteAuthority:_,clientId:q},T.ipcLogger))}async _reconnect(T,_){await n(T,_)}}e.ManagementPersistentConnection=ee;class F extends K{constructor(T,_,q,Y,$){super(2,T,q,Y);this._startArguments=_,this.debugPort=$}async _reconnect(T,_){await o(T,this._startArguments,_)}}e.ExtensionHostPersistentConnection=F;function V(W){try{W.acceptDisconnect();const T=W.getSocket();W.dispose(),T.dispose()}catch(T){(0,M.onUnexpectedError)(T)}}function z(W){if(W&&W.type==="error"){const T=new Error(`Connection error: ${W.reason}`);return T.code="VSCODE_CONNECTION_ERROR",T}return null}function B(W,T){for(;W.length<T;)W+=" ";return W}function U(W,T,_){return`[remote-connection][${B(m(W),13)}][${T.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function C(W,T){return`${U(T,W.reconnectionToken,!!W.reconnectionProtocol)}[${W.host}:${W.port}]`}function X(W){return`${Date.now()-W} ms`}}),define(Q[63],J([0,1,10]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=e.getRemoteName=e.getRemoteAuthority=void 0;function L(g){return g.scheme===p.Schemas.vscodeRemote?g.authority:void 0}e.getRemoteAuthority=L;function D(g){if(!g)return;const i=g.indexOf("+");return i<0?g:g.substr(0,i)}e.getRemoteName=D;function M(g){return g.scheme!==p.Schemas.file&&g.scheme!==p.Schemas.vscodeRemote}e.isVirtualResource=M;function P(g){if(g.folders.length)return g.folders.every(i=>M(i.uri))?g.folders[0].uri:void 0;if(g.configuration&&M(g.configuration))return g.configuration}e.getVirtualWorkspaceLocation=P;function b(g){return P(g)?.scheme}e.getVirtualWorkspaceScheme=b;function d(g){return P(g)!==void 0}e.isVirtualWorkspace=d}),define(Q[191],J([0,1,27,5,63]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.ExtensionIdentifier=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function M(S){if(typeof S=="object"&&S!==null&&S.supported!==!0)return S.description}e.getWorkspaceSupportTypeMessage=M;function P(S){return S&&typeof S=="object"&&typeof S.id=="string"&&(!S.uuid||typeof S.uuid=="string")}e.isIExtensionIdentifier=P,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(S){S[S.System=0]="System",S[S.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,t){if(typeof m=="undefined"||m===null)return typeof t=="undefined"||t===null;if(typeof t=="undefined"||t===null)return!1;if(typeof m=="string"||typeof t=="string"){let h=typeof m=="string"?m:m.value,E=typeof t=="string"?t:t.value;return p.equalsIgnoreCase(h,E)}return m._lower===t._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}e.ExtensionIdentifier=d;function g(S){return S.contributes&&S.contributes.localizations?S.contributes.localizations.length>0:!1}e.isLanguagePackExtension=g;function i(S){return S.contributes&&S.contributes.authentication?S.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=i;function I(S,m){if(m&&S.enableProposedApi){const t=`onResolveRemoteAuthority:${(0,D.getRemoteName)(m)}`;return S.activationEvents?.indexOf(t)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,L.createDecorator)("IBuiltinExtensionsScannerService")}),define(Q[192],J([0,1,27,191]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getExtensionDependencies=e.getMaliciousExtensionsSet=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.ExtensionIdentifierWithVersion=e.areSameExtensions=void 0;function D(t,h){return t.uuid&&h.uuid?t.uuid===h.uuid:t.id===h.id?!0:(0,p.compareIgnoreCase)(t.id,h.id)===0}e.areSameExtensions=D;class M{constructor(h,E){this.version=E,this.id=h.id,this.uuid=h.uuid}key(){return`${this.id}-${this.version}`}equals(h){return h instanceof M?D(this,h)&&this.version===h.version:!1}}e.ExtensionIdentifierWithVersion=M;function P(t,h){return`${t}.${h}`}e.getExtensionId=P;function b(t){return t.toLocaleLowerCase()}e.adoptToGalleryExtensionId=b;function d(t,h){return b(P(t,h))}e.getGalleryExtensionId=d;function g(t,h){const E=[],v=y=>{for(const u of E)if(u.some(l=>D(h(l),h(y))))return u;return null};for(const y of t){const u=v(y);u?u.push(y):E.push([y])}return E}e.groupByExtension=g;function i(t){return{id:t.identifier.id,name:t.manifest.name,galleryId:null,publisherId:t.publisherId,publisherName:t.manifest.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:t.manifest.extensionDependencies&&t.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=i;function I(t){return{id:t.identifier.id,name:t.name,galleryId:t.identifier.uuid,publisherId:t.publisherId,publisherName:t.publisher,publisherDisplayName:t.publisherDisplayName,dependencies:!!(t.properties.dependencies&&t.properties.dependencies.length>0),...t.telemetryData}}e.getGalleryExtensionTelemetryData=I,e.BetterMergeId=new L.ExtensionIdentifier("pprice.better-merge");function S(t){const h=new Set;for(const E of t)E.malicious&&h.add(E.id.id);return h}e.getMaliciousExtensionsSet=S;function m(t,h){const E=[],v=h.manifest.extensionDependencies?.slice(0)??[];for(;v.length;){const y=v.shift();if(y&&E.every(u=>!D(u.identifier,{id:y}))){const u=t.filter(l=>D(l.identifier,{id:y}));u.length===1&&(E.push(u[0]),v.push(...u[0].manifest.extensionDependencies?.slice(0)??[]))}}return E}e.getExtensionDependencies=m}),define(Q[96],J([0,1,4,3,5,6]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ITunnelService=void 0,e.ITunnelService=(0,D.createDecorator)("tunnelService");var P;(function(t){t.Http="http",t.Https="https"})(P=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(t){t.ConstantPrivate="constantPrivate",t.Private="private",t.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var d;(function(t){t[t.Notify=1]="Notify",t[t.OpenBrowser=2]="OpenBrowser",t[t.OpenPreview=3]="OpenPreview",t[t.Silent=4]="Silent",t[t.Ignore=5]="Ignore",t[t.OpenBrowserOnce=6]="OpenBrowserOnce"})(d=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function g(t){if(t.scheme!=="http"&&t.scheme!=="https")return;const h=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(t.authority);if(!!h)return{address:h[1],port:+h[2]}}e.extractLocalHostUriMetaDataForPortMapping=g,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function i(t){return e.LOCALHOST_ADDRESSES.indexOf(t)>=0}e.isLocalhost=i,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function I(t){return e.ALL_INTERFACES_ADDRESSES.indexOf(t)>=0}e.isAllInterfaces=I;function S(t,h){return h?h!==1&&t<1024:!L.isWindows&&t<1024}e.isPortPrivileged=S;let m=class{constructor(h){this.logService=h,this._onTunnelOpened=new p.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new p.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new p.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[]}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(h,E){return this._tunnelProvider=h,h?(this._canElevate=E.elevation,this._privacyOptions=E.privacyOptions,this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const h=[],E=Array.from(this._tunnels.values());for(let v of E){const y=Array.from(v.values());for(let u of y){const l=await u.value;l&&h.push(l)}}return h}async dispose(){for(const h of this._tunnels.values()){for(const{value:E}of h.values())await E.then(v=>v?.dispose());h.clear()}this._tunnels.clear()}openTunnel(h,E,v,y,u=!1,l=b.Private,c){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${E}:${v} on local port ${y}.`),!h)return;E||(E="localhost");const n=this.retainOrCreateTunnel(h,E,v,y,u,l,c);return n?n.then(o=>{if(!o){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(E,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const s=this.makeTunnel(o);return(o.tunnelRemoteHost!==E||o.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(s),s}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),n)}makeTunnel(h){return{tunnelRemotePort:h.tunnelRemotePort,tunnelRemoteHost:h.tunnelRemoteHost,tunnelLocalPort:h.tunnelLocalPort,localAddress:h.localAddress,privacy:h.privacy,protocol:h.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${h.tunnelRemoteHost}:${h.tunnelRemotePort} `);const E=this._tunnels.get(h.tunnelRemoteHost);if(E){const v=E.get(h.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(h.tunnelRemoteHost,h.tunnelRemotePort,v))}}}}async tryDisposeTunnel(h,E,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${h}:${E}.`);const y=v.value.then(async u=>{u&&(await u.dispose(!0),this._onTunnelClosed.fire({host:u.tunnelRemoteHost,port:u.tunnelRemotePort}))});return this._tunnels.has(h)&&this._tunnels.get(h).delete(E),y}}async closeTunnel(h,E){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${h}:${E} `);const v=this._tunnels.get(h);if(v&&v.has(E)){const y=v.get(E);y.refcount=0,await this.tryDisposeTunnel(h,E,y)}}addTunnelToMap(h,E,v){this._tunnels.has(h)||this._tunnels.set(h,new Map),this._tunnels.get(h).set(E,{refcount:1,value:v})}async removeEmptyTunnelFromMap(h,E){const v=this._tunnels.get(h);v&&(await v.get(E)||v.delete(E),v.size===0&&this._tunnels.delete(h))}getTunnelFromMap(h,E){let v=[h];i(h)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):I(h)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const y=v.map(u=>this._tunnels.get(u));for(const u of y){const l=u?.get(E);if(l)return l}}canTunnel(h){return!!g(h)}createWithProvider(h,E,v,y,u,l,c){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${E}:${v} on local port ${y}.`);const o={elevationRequired:u?S(y===void 0?v:y):!1},s={remoteAddress:{host:E,port:v},localAddressPort:y,privacy:l,public:l!==b.Private,protocol:c},r=h.forwardPort(s,o);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),r&&this.addTunnelToMap(E,v,r),r}};m=he([te(0,M.ILogService)],m),e.AbstractTunnelService=m}),define(Q[50],J([0,1,16,148,49,5,37]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,M.createDecorator)("requestService");function b(t){return t.res.statusCode&&t.res.statusCode>=200&&t.res.statusCode<300||t.res.statusCode===1223}e.isSuccess=b;function d(t){return t.res.statusCode===204}async function g(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);return d(t)?null:(await(0,p.streamToBuffer)(t.stream)).toString()}e.asText=g;async function i(t){if(!b(t))throw new Error("Server returned "+t.res.statusCode);if(d(t))return null;const E=(await(0,p.streamToBuffer)(t.stream)).toString();try{return JSON.parse(E)}catch(v){throw v.message+=`:
`+E,v}}e.asJson=i;function I(t){m(t)}e.updateProxyConfigurationsScope=I;let S;function m(t){const h=P.Registry.as(D.Extensions.Configuration),E=S;S={id:"http",order:15,title:(0,L.localize)(0,null),type:"object",scope:t,properties:{"http.proxy":{type:"string",pattern:"^https?://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,L.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,L.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,L.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,L.localize)(4,null),(0,L.localize)(5,null),(0,L.localize)(6,null),(0,L.localize)(7,null)],default:"override",description:(0,L.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,L.localize)(9,null),restricted:!0}}},h.updateConfigurations({add:[S],remove:E?[E]:[]})}m(2)}),define(Q[193],J([0,1,194,14]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getProxyAgent=void 0;function D(P,b){return P.protocol==="http:"?b.HTTP_PROXY||b.http_proxy||null:P.protocol==="https:"&&(b.HTTPS_PROXY||b.https_proxy||b.HTTP_PROXY||b.http_proxy)||null}async function M(P,b,d={}){const g=(0,p.parse)(P),i=d.proxyUrl||D(g,b);if(!i)return null;const I=(0,p.parse)(i);if(!/^https?:$/.test(I.protocol||""))return null;const S={host:I.hostname||"",port:I.port||(I.protocol==="https"?"443":"80"),auth:I.auth,rejectUnauthorized:(0,L.isBoolean)(d.strictSSL)?d.strictSSL:!0};return g.protocol==="http:"?new(await new Promise((m,t)=>{j(["http-proxy-agent"],m,t)}))(S):new(await new Promise((m,t)=>{j(["https-proxy-agent"],m,t)}))(S)}e.getProxyAgent=M}),define(Q[195],J([0,1,16,28]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function D(M,P,b){let d=b&&b.get("storage.serviceMachineId",0)||null;if(d)return d;try{const i=(await P.readFile(M.serviceMachineIdResource)).value.toString();d=(0,L.isUUID)(i)?i:null}catch(g){d=null}if(!d){d=(0,L.generateUuid)();try{await P.writeFile(M.serviceMachineIdResource,p.VSBuffer.fromString(d))}catch(g){}}return b&&b.store("storage.serviceMachineId",d,0,1),d}e.getServiceMachineId=D}),define(Q[77],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,p.createDecorator)(e.SIGN_SERVICE_ID)}),define(Q[196],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class p{vsda(){return new Promise((D,M)=>j(["vsda"],D,M))}async sign(D){try{const M=await this.vsda(),P=new M.signer;if(P)return P.sign(D)}catch(M){}return D}}e.SignService=p}),define(Q[38],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IStateMainService=void 0,e.IStateMainService=(0,p.createDecorator)("stateMainService")}),define(Q[22],J([0,1,13,9,4,2,3,32,14,5,177,6,38]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LifecycleMainService=e.LifecycleMainPhase=e.ILifecycleMainService=void 0,e.ILifecycleMainService=(0,g.createDecorator)("lifecycleMainService");var m;(function(h){h[h.Starting=1]="Starting",h[h.Ready=2]="Ready",h[h.AfterWindowOpen=3]="AfterWindowOpen"})(m=e.LifecycleMainPhase||(e.LifecycleMainPhase={}));let t=class ct extends M.Disposable{constructor(E,v){super();this.logService=E,this.stateMainService=v,this._onBeforeShutdown=this._register(new D.Emitter),this.onBeforeShutdown=this._onBeforeShutdown.event,this._onWillShutdown=this._register(new D.Emitter),this.onWillShutdown=this._onWillShutdown.event,this._onWillLoadWindow=this._register(new D.Emitter),this.onWillLoadWindow=this._onWillLoadWindow.event,this._onBeforeCloseWindow=this._register(new D.Emitter),this.onBeforeCloseWindow=this._onBeforeCloseWindow.event,this._onBeforeUnloadWindow=this._register(new D.Emitter),this.onBeforeUnloadWindow=this._onBeforeUnloadWindow.event,this._quitRequested=!1,this._wasRestarted=!1,this._phase=1,this.windowToCloseRequest=new Set,this.oneTimeListenerTokenGenerator=0,this.windowCounter=0,this.pendingQuitPromise=void 0,this.pendingQuitPromiseResolve=void 0,this.pendingWillShutdownPromise=void 0,this.phaseWhen=new Map,this.resolveRestarted(),this.when(2).then(()=>this.registerListeners())}get quitRequested(){return this._quitRequested}get wasRestarted(){return this._wasRestarted}get phase(){return this._phase}resolveRestarted(){this._wasRestarted=!!this.stateMainService.getItem(ct.QUIT_AND_RESTART_KEY),this._wasRestarted&&this.stateMainService.removeItem(ct.QUIT_AND_RESTART_KEY)}registerListeners(){const E=()=>{this._quitRequested||(this.logService.trace("Lifecycle#app.on(before-quit)"),this._quitRequested=!0,this.logService.trace("Lifecycle#onBeforeShutdown.fire()"),this._onBeforeShutdown.fire(),P.isMacintosh&&this.windowCounter===0&&this.beginOnWillShutdown())};p.app.addListener("before-quit",E);const v=()=>{this.logService.trace("Lifecycle#app.on(window-all-closed)"),(this._quitRequested||!P.isMacintosh)&&p.app.quit()};p.app.addListener("window-all-closed",v),p.app.once("will-quit",y=>{this.logService.trace("Lifecycle#app.on(will-quit)"),y.preventDefault(),this.beginOnWillShutdown().finally(()=>{this.resolvePendingQuitPromise(!1),p.app.removeListener("before-quit",E),p.app.removeListener("window-all-closed",v),p.app.quit()})})}beginOnWillShutdown(){if(this.pendingWillShutdownPromise)return this.pendingWillShutdownPromise;this.logService.trace("Lifecycle#onWillShutdown.fire()");const E=[];return this._onWillShutdown.fire({join(v){E.push(v)}}),this.pendingWillShutdownPromise=(async()=>{try{await L.Promises.settled(E)}catch(v){this.logService.error(v)}try{await this.stateMainService.close()}catch(v){this.logService.error(v)}})(),this.pendingWillShutdownPromise}set phase(E){if(E<this.phase)throw new Error("Lifecycle cannot go backwards");if(this._phase===E)return;this.logService.trace(`lifecycle (main): phase changed (value: ${E})`),this._phase=E;const v=this.phaseWhen.get(this._phase);v&&(v.open(),this.phaseWhen.delete(this._phase))}async when(E){if(E<=this._phase)return;let v=this.phaseWhen.get(E);v||(v=new L.Barrier,this.phaseWhen.set(E,v)),await v.wait()}registerWindow(E){const v=new M.DisposableStore;this.windowCounter++,v.add(E.onWillLoad(u=>this._onWillLoadWindow.fire({window:E,workspace:u.workspace,reason:u.reason})));const y=(0,d.assertIsDefined)(E.win);y.on("close",u=>{const l=E.id;if(this.windowToCloseRequest.has(l)){this.windowToCloseRequest.delete(l);return}this.logService.trace(`Lifecycle#window.on('close') - window ID ${E.id}`),u.preventDefault(),this.unload(E,1).then(c=>{if(c){this.windowToCloseRequest.delete(l);return}this.windowToCloseRequest.add(l),this.logService.trace(`Lifecycle#onBeforeCloseWindow.fire() - window ID ${l}`),this._onBeforeCloseWindow.fire(E),E.close()})}),y.on("closed",()=>{this.logService.trace(`Lifecycle#window.on('closed') - window ID ${E.id}`),this.windowCounter--,v.dispose(),this.windowCounter===0&&(!P.isMacintosh||this._quitRequested)&&this.beginOnWillShutdown()})}async reload(E,v){await this.unload(E,3)||E.reload(v)}async unload(E,v){if(!E.isReady)return!1;this.logService.trace(`Lifecycle#unload() - window ID ${E.id}`);const y=this._quitRequested?2:v;let u=await this.onBeforeUnloadWindowInRenderer(E,y);return u?(this.logService.trace(`Lifecycle#unload() - veto in renderer (window ID ${E.id})`),this.handleWindowUnloadVeto(u)):(u=await this.onBeforeUnloadWindowInMain(E,y),u?(this.logService.trace(`Lifecycle#unload() - veto in main (window ID ${E.id})`),this.handleWindowUnloadVeto(u)):(this.logService.trace(`Lifecycle#unload() - no veto (window ID ${E.id})`),await this.onWillUnloadWindowInRenderer(E,y),!1))}handleWindowUnloadVeto(E){return E?(this.resolvePendingQuitPromise(!0),this._quitRequested=!1,!0):!1}resolvePendingQuitPromise(E){this.pendingQuitPromiseResolve&&(this.pendingQuitPromiseResolve(E),this.pendingQuitPromiseResolve=void 0,this.pendingQuitPromise=void 0)}onBeforeUnloadWindowInRenderer(E,v){return new Promise(y=>{const u=this.oneTimeListenerTokenGenerator++,l=`vscode:ok${u}`,c=`vscode:cancel${u}`;p.ipcMain.once(l,()=>{y(!1)}),p.ipcMain.once(c,()=>{y(!0)}),E.send("vscode:onBeforeUnload",{okChannel:l,cancelChannel:c,reason:v})})}onBeforeUnloadWindowInMain(E,v){const y=[];return this._onBeforeUnloadWindow.fire({reason:v,window:E,veto(u){y.push(u)}}),(0,i.handleVetos)(y,u=>this.logService.error(u))}onWillUnloadWindowInRenderer(E,v){return new Promise(y=>{const l=`vscode:reply${this.oneTimeListenerTokenGenerator++}`;p.ipcMain.once(l,()=>y()),E.send("vscode:onWillUnload",{replyChannel:l,reason:v})})}quit(E){return this.pendingQuitPromise?this.pendingQuitPromise:(this.logService.trace(`Lifecycle#quit() - will restart: ${E}`),E&&this.stateMainService.setItem(ct.QUIT_AND_RESTART_KEY,!0),this.pendingQuitPromise=new Promise(v=>{this.pendingQuitPromiseResolve=v,this.logService.trace("Lifecycle#quit() - calling app.quit()"),p.app.quit()}),this.pendingQuitPromise)}async relaunch(E){this.logService.trace("Lifecycle#relaunch()");const v=process.argv.slice(1);if(E?.addArgs&&v.push(...E.addArgs),E?.removeArgs)for(const l of E.removeArgs){const c=v.indexOf(l);c>=0&&v.splice(c,1)}const y=()=>{try{if(P.isWindows){const l=(0,b.cwd)();l!==process.cwd()&&process.chdir(l)}}catch(l){this.logService.error(l)}this.logService.trace("Lifecycle#relaunch() - calling app.relaunch()"),p.app.relaunch({args:v})};p.app.once("quit",y),await this.quit(!0)&&p.app.removeListener("quit",y)}async kill(E){this.logService.trace("Lifecycle#kill()"),await Promise.race([(0,L.timeout)(1e3),(async()=>{for(const v of p.BrowserWindow.getAllWindows())if(v&&!v.isDestroyed()){let y;v.webContents&&!v.webContents.isDestroyed()?y=new Promise(u=>v.once("closed",u)):y=Promise.resolve(),v.destroy(),await y}})()]),p.app.exit(E)}};t.QUIT_AND_RESTART_KEY="lifecycle.quitAndRestart",t=he([te(0,I.ILogService),te(1,S.IStateMainService)],t),e.LifecycleMainService=t}),define(Q[197],J([0,1,4,2,5,22]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeyboardLayoutMainService=e.IKeyboardLayoutMainService=void 0,e.IKeyboardLayoutMainService=(0,D.createDecorator)("keyboardLayoutMainService");let P=class extends L.Disposable{constructor(g){super();this._onDidChangeKeyboardLayout=this._register(new p.Emitter),this.onDidChangeKeyboardLayout=this._onDidChangeKeyboardLayout.event,this._initPromise=null,this._keyboardLayoutData=null,g.when(3).then(()=>this._initialize())}_initialize(){return this._initPromise||(this._initPromise=this._doInitialize()),this._initPromise}async _doInitialize(){const g=await new Promise((i,I)=>{j(["native-keymap"],i,I)});this._keyboardLayoutData=b(g),g.onDidChangeKeyboardLayout(()=>{this._keyboardLayoutData=b(g),this._onDidChangeKeyboardLayout.fire(this._keyboardLayoutData)})}async getKeyboardLayoutData(){return await this._initialize(),this._keyboardLayoutData}};P=he([te(0,M.ILifecycleMainService)],P),e.KeyboardLayoutMainService=P;function b(d){const g=d.getKeyMap(),i=d.getCurrentKeyboardLayout();return{keyboardMapping:g,keyboardLayoutInfo:i}}}),define(Q[97],J([0,1,9,4,2,14,87,5]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const d="__$__targetStorageMarker";e.IStorageService=(0,b.createDecorator)("storageService");var g;(function(h){h[h.NONE=0]="NONE",h[h.SHUTDOWN=1]="SHUTDOWN"})(g=e.WillSaveStateReason||(e.WillSaveStateReason={}));var i;(function(h){h[h.GLOBAL=0]="GLOBAL",h[h.WORKSPACE=1]="WORKSPACE"})(i=e.StorageScope||(e.StorageScope={}));var I;(function(h){h[h.USER=0]="USER",h[h.MACHINE=1]="MACHINE"})(I=e.StorageTarget||(e.StorageTarget={}));class S extends D.Disposable{constructor(E={flushInterval:S.DEFAULT_FLUSH_INTERVAL}){super();this.options=E,this._onDidChangeValue=this._register(new L.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new L.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new L.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new p.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new D.MutableDisposable),this._workspaceKeyTargets=void 0,this._globalKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,p.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,D.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{await this.doInitialize(),this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(E,v){v===d?(E===0?this._globalKeyTargets=void 0:E===1&&(this._workspaceKeyTargets=void 0),this._onDidChangeTarget.fire({scope:E})):this._onDidChangeValue.fire({scope:E,key:v,target:this.getKeyTargets(E)[v]})}emitWillSaveState(E){this._onWillSaveState.fire({reason:E})}get(E,v,y){return this.getStorage(v)?.get(E,y)}getBoolean(E,v,y){return this.getStorage(v)?.getBoolean(E,y)}getNumber(E,v,y){return this.getStorage(v)?.getNumber(E,y)}store(E,v,y,u){if((0,M.isUndefinedOrNull)(v)){this.remove(E,y);return}this.withPausedEmitters(()=>{this.updateKeyTarget(E,y,u),this.getStorage(y)?.set(E,v)})}remove(E,v){this.withPausedEmitters(()=>{this.updateKeyTarget(E,v,void 0),this.getStorage(v)?.delete(E)})}withPausedEmitters(E){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{E()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(E,v){const y=[],u=this.getKeyTargets(E);for(const l of Object.keys(u))u[l]===v&&y.push(l);return y}updateKeyTarget(E,v,y){const u=this.getKeyTargets(v);typeof y=="number"?u[E]!==y&&(u[E]=y,this.getStorage(v)?.set(d,JSON.stringify(u))):typeof u[E]=="number"&&(delete u[E],this.getStorage(v)?.set(d,JSON.stringify(u)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get globalKeyTargets(){return this._globalKeyTargets||(this._globalKeyTargets=this.loadKeyTargets(0)),this._globalKeyTargets}getKeyTargets(E){return E===0?this.globalKeyTargets:this.workspaceKeyTargets}loadKeyTargets(E){const v=this.get(d,E);if(v)try{return JSON.parse(v)}catch(y){}return Object.create(null)}isNew(E){return this.getBoolean(e.IS_NEW_KEY,E)===!0}async flush(E=g.NONE){this._onWillSaveState.fire({reason:E}),await p.Promises.settled([this.getStorage(0)?.whenFlushed()??Promise.resolve(),this.getStorage(1)?.whenFlushed()??Promise.resolve()])}async logStorage(){const E=this.getStorage(0)?.items??new Map,v=this.getStorage(1)?.items??new Map;return t(E,v,this.getLogDetails(0)??"",this.getLogDetails(1)??"")}}e.AbstractStorageService=S,S.DEFAULT_FLUSH_INTERVAL=60*1e3;class m extends S{constructor(){super();this.globalStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new P.Storage(new P.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(E=>this.emitDidChangeValue(1,E))),this._register(this.globalStorage.onDidChangeStorage(E=>this.emitDidChangeValue(0,E)))}getStorage(E){return E===0?this.globalStorage:this.workspaceStorage}getLogDetails(E){return E===0?"inMemory (global)":"inMemory (workspace)"}async doInitialize(){}async migrate(E){}}e.InMemoryStorageService=m;async function t(h,E,v,y){const u=a=>{try{return JSON.parse(a)}catch(f){return a}},l=new Map,c=new Map;h.forEach((a,f)=>{l.set(f,a),c.set(f,u(a))});const n=new Map,o=new Map;E.forEach((a,f)=>{n.set(f,a),o.set(f,u(a))}),console.group(`Storage: Global (path: ${v})`);let s=[];l.forEach((a,f)=>{s.push({key:f,value:a})}),console.table(s),console.groupEnd(),console.log(c),console.group(`Storage: Workspace (path: ${y})`);let r=[];n.forEach((a,f)=>{r.push({key:f,value:a})}),console.table(r),console.groupEnd(),console.log(o)}e.logStorage=t}),define(Q[198],J([0,1,3,32,7,28]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function P(g){if(p.platform===2&&/^penguin(\.|$)/i.test(g))return"chromebook"}async function b(g,i,I,S,m,t,h,E,v,y){const u=Object.create(null);u["common.machineId"]=h,u.sessionID=(0,M.generateUuid)()+Date.now(),u.commitHash=m,u.version=t,u["common.platformVersion"]=(i||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),u["common.platform"]=(0,p.PlatformToString)(p.platform),u["common.nodePlatform"]=L.platform,u["common.nodeArch"]=S,u["common.product"]=y||"desktop";const l=d(E||[]);l&&(u["common.msftInternal"]=l);let c=0;const n=Date.now();Object.defineProperties(u,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-n,enumerable:!0},"common.sequence":{get:()=>c++,enumerable:!0}}),p.isLinuxSnap&&(u["common.snap"]="true");const o=P(I);o&&(u["common.platformDetail"]=o);try{const s=await g.readFile(D.URI.file(v));u["common.source"]=s.value.toString().slice(0,30)}catch(s){}return u}e.resolveCommonProperties=b;function d(g){const i=L.env.USERDNSDOMAIN;if(!i)return!1;const I=i.toLowerCase();return g.some(S=>I===S)}e.verifyMicrosoftInternalDomain=d}),define(Q[29],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.instanceStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,p.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,p.createDecorator)("customEndpointTelemetryService"),e.instanceStorageKey="telemetry.instanceId",e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var L;(function(M){M[M.NONE=0]="NONE",M[M.CRASH=1]="CRASH",M[M.ERROR=2]="ERROR",M[M.USAGE=3]="USAGE"})(L=e.TelemetryLevel||(e.TelemetryLevel={}));var D;(function(M){M.OFF="off",M.CRASH="crash",M.ERROR="error",M.ON="all"})(D=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(Q[199],J([0,1,25,68,9,39,10,8,3,7,70,19,84,74,20,21,29]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;async function v(n,o){const s=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.yml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i}],r=new Map,a=new Map,f=2e4;function w(A,O,H,x){const re=O.substring(A.length+1);return D.Promises.withAsyncBody(async K=>{let ee;try{ee=await I.Promises.readdir(O,{withFileTypes:!0})}catch(z){K();return}if(x.count>=f){x.count+=ee.length,x.maxReached=!0,K();return}let F=ee.length;if(F===0){K();return}let V=ee;x.count+ee.length>f&&(x.maxReached=!0,F=f-x.count,V=ee.slice(0,F)),x.count+=ee.length;for(const z of V)if(z.isDirectory()){if(H.includes(z.name)||await w(A,(0,b.join)(O,z.name),H,x),--F==0){K();return}}else{const B=z.name.lastIndexOf(".");if(B>=0){const U=z.name.substring(B+1);U&&r.set(U,(r.get(U)??0)+1)}for(const U of s)U.relativePathPattern?.test(re)!==!1&&U.filePattern.test(z.name)&&a.set(U.tag,(a.get(U.tag)??0)+1);if(--F==0){K();return}}})}const k={count:0,maxReached:!1};await w(n,n,o,k);const R=await l(n);return{configFiles:y(a),fileTypes:y(r),fileCount:k.count,maxFilesReached:k.maxReached,launchConfigFiles:R}}e.collectWorkspaceStats=v;function y(n){return[...L.Iterable.map(n.entries(),([o,s])=>({name:o,count:s}))].sort((o,s)=>s.count-o.count)}function u(){const n={os:`${p.type()} ${p.arch()} ${p.release()}`,memory:`${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(i.virtualMachineHint.value()*100)}%`},o=p.cpus();return o&&o.length>0&&(n.cpus=`${o[0].model} (${o.length} x ${o[0].speed})`),n}e.getMachineInfo=u;async function l(n){try{const o=new Map,s=(0,b.join)(n,".vscode","launch.json"),r=await I.Promises.readFile(s),a=[],f=(0,M.parse)(r.toString(),a);if(a.length)return console.log(`Unable to parse ${s}`),[];if((0,M.getNodeType)(f)==="object"&&f.configurations)for(const w of f.configurations){const k=w.type;k&&(o.has(k)?o.set(k,o.get(k)+1):o.set(k,1))}return y(o)}catch(o){return[]}}e.collectLaunchConfigs=l;let c=class{constructor(o,s){this.telemetryService=o,this.productService=s}formatMachineInfo(o){const s=[];return s.push(`OS Version:       ${o.os}`),s.push(`CPUs:             ${o.cpus}`),s.push(`Memory (System):  ${o.memory}`),s.push(`VM:               ${o.vmHint}`),s.join(`
`)}formatEnvironment(o){const s=[];s.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),s.push(`OS Version:       ${p.type()} ${p.arch()} ${p.release()}`);const r=p.cpus();return r&&r.length>0&&s.push(`CPUs:             ${r[0].model} (${r.length} x ${r[0].speed})`),s.push(`Memory (System):  ${(p.totalmem()/t.ByteSize.GB).toFixed(2)}GB (${(p.freemem()/t.ByteSize.GB).toFixed(2)}GB free)`),d.isWindows||s.push(`Load (avg):       ${p.loadavg().map(a=>Math.round(a)).join(", ")}`),s.push(`VM:               ${Math.round(i.virtualMachineHint.value()*100)}%`),s.push(`Screen Reader:    ${o.screenReader?"yes":"no"}`),s.push(`Process Argv:     ${o.mainArguments.join(" ")}`),s.push(`GPU Status:       ${this.expandGPUFeatures(o.gpuFeatureStatus)}`),s.join(`
`)}async getPerformanceInfo(o,s){return Promise.all([(0,S.listProcesses)(o.mainPID),this.formatWorkspaceMetadata(o)]).then(async r=>{let[a,f]=r,w=this.formatProcessList(o,a);return s.forEach(k=>{if((0,m.isRemoteDiagnosticError)(k))w+=`
${k.errorMessage}`,f+=`
${k.errorMessage}`;else if(w+=`

Remote: ${k.hostName}`,k.processes&&(w+=`
${this.formatProcessList(o,k.processes)}`),k.workspaceMetadata){f+=`
|  Remote: ${k.hostName}`;for(const R of Object.keys(k.workspaceMetadata)){const A=k.workspaceMetadata[R];let O=`${A.fileCount} files`;A.maxFilesReached&&(O=`more than ${O}`),f+=`|    Folder (${R}): ${O}`,f+=this.formatWorkspaceStats(A)}}}),{processInfo:w,workspaceInfo:f}})}async getSystemInfo(o,s){const{memory:r,vmHint:a,os:f,cpus:w}=u(),k={os:f,memory:r,cpus:w,vmHint:a,processArgs:`${o.mainArguments.join(" ")}`,gpuStatus:o.gpuFeatureStatus,screenReader:`${o.screenReader?"yes":"no"}`,remoteData:s};return d.isWindows||(k.load=`${p.loadavg().map(R=>Math.round(R)).join(", ")}`),d.isLinux&&(k.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(k)}async getDiagnostics(o,s){const r=[];return(0,S.listProcesses)(o.mainPID).then(async a=>(r.push(""),r.push(this.formatEnvironment(o)),r.push(""),r.push(this.formatProcessList(o,a)),o.windows.some(f=>f.folderURIs&&f.folderURIs.length>0&&!f.remoteAuthority)&&(r.push(""),r.push("Workspace Stats: "),r.push(await this.formatWorkspaceMetadata(o))),s.forEach(f=>{if((0,m.isRemoteDiagnosticError)(f))r.push(`
${f.errorMessage}`);else if(r.push(`

`),r.push(`Remote:           ${f.hostName}`),r.push(this.formatMachineInfo(f.machineInfo)),f.processes&&r.push(this.formatProcessList(o,f.processes)),f.workspaceMetadata)for(const w of Object.keys(f.workspaceMetadata)){const k=f.workspaceMetadata[w];let R=`${k.fileCount} files`;k.maxFilesReached&&(R=`more than ${R}`),r.push(`Folder (${w}): ${R}`),r.push(this.formatWorkspaceStats(k))}}),r.push(""),r.push(""),r.join(`
`)))}formatWorkspaceStats(o){const s=[],r=60;let a=0;const f=(A,O)=>{const H=` ${A}(${O})`;a+H.length>r?(s.push(w),w="|                 ",a=w.length):a+=H.length,w+=H};let w="|      File types:";const k=10;let R=o.fileTypes.length>k?k:o.fileTypes.length;for(let A=0;A<R;A++){const O=o.fileTypes[A];f(O.name,O.count)}if(s.push(w),o.configFiles.length>=0&&(w="|      Conf files:",a=0,o.configFiles.forEach(A=>{f(A.name,A.count)}),s.push(w)),o.launchConfigFiles.length>0){let A="|      Launch Configs:";o.launchConfigFiles.forEach(O=>{A+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),s.push(A)}return s.join(`
`)}expandGPUFeatures(o){const s=Math.max(...Object.keys(o).map(r=>r.length));return Object.keys(o).map(r=>`${r}:  ${" ".repeat(s-r.length)}  ${o[r]}`).join(`
                  `)}formatWorkspaceMetadata(o){const s=[],r=[];return o.windows.forEach(a=>{a.folderURIs.length===0||!!a.remoteAuthority||(s.push(`|  Window (${a.title})`),a.folderURIs.forEach(f=>{const w=g.URI.revive(f);if(w.scheme===P.Schemas.file){const k=w.fsPath;r.push(v(k,["node_modules",".git"]).then(R=>{let A=`${R.fileCount} files`;R.maxFilesReached&&(A=`more than ${A}`),s.push(`|    Folder (${(0,b.basename)(k)}): ${A}`),s.push(this.formatWorkspaceStats(R))}).catch(R=>{s.push(`|      Error: Unable to collect workspace stats for folder ${k} (${R.toString()})`)}))}else s.push(`|    Folder (${w.toString()}): Workspace stats not available.`)}))}),Promise.all(r).then(a=>s.join(`
`)).catch(a=>`Unable to collect workspace stats: ${a}`)}formatProcessList(o,s){const r=new Map;o.windows.forEach(f=>r.set(f.pid,f.title));const a=[];return a.push("CPU %	Mem MB	   PID	Process"),s&&this.formatProcessItem(o.mainPID,r,a,s,0),a.join(`
`)}formatProcessItem(o,s,r,a,f){const w=f===0;let k;w?k=a.pid===o?`${this.productService.applicationName} main`:"remote agent":(k=`${"  ".repeat(f)} ${a.name}`,a.name==="window"&&(k=`${k} (${s.get(a.pid)})`));const R=process.platform==="win32"?a.mem:p.totalmem()*(a.mem/100);r.push(`${a.load.toFixed(0).padStart(5," ")}	${(R/t.ByteSize.MB).toFixed(0).padStart(6," ")}	${a.pid.toFixed(0).padStart(6," ")}	${k}`),Array.isArray(a.children)&&a.children.forEach(A=>this.formatProcessItem(o,s,r,A,f+1))}async reportWorkspaceStats(o){for(const{uri:s}of o.folders){const r=g.URI.revive(s);if(r.scheme!==P.Schemas.file)continue;const a=r.fsPath;try{const f=await v(a,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":o.telemetryId,rendererSessionId:o.rendererSessionId}),f.fileTypes.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),f.launchConfigFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})}),f.configFiles.forEach(w=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:o.rendererSessionId,type:w.name,count:w.count})})}catch{}}}};c=he([te(0,E.ITelemetryService),te(1,h.IProductService)],c),e.DiagnosticsService=c}),define(Q[200],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class p{constructor(M){this.appenders=M}listen(M,P){throw new Error(`Event not found: ${P}`)}call(M,P,{eventName:b,data:d}){return this.appenders.forEach(g=>g.log(b,d)),Promise.resolve(null)}}e.TelemetryAppenderChannel=p;class L{constructor(M){this.channel=M}log(M,P){return this.channel.call("log",{eventName:M,data:P}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=L}),define(Q[64],J([0,1,43,14,17,29]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=0}publicLog(v,y){return Promise.resolve(void 0)}publicLog2(v,y){return this.publicLog(v,y)}publicLogError(v,y){return Promise.resolve(void 0)}publicLogError2(v,y){return this.publicLogError(v,y)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class b{async publicLog(v,y,u){}async publicLogError(v,y,u){}}e.NullEndpointTelemetryService=b,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function d(E,v){return v.onDidChangeConfiguration(y=>{y.source!==6&&E.publicLog2("updateConfiguration",{configurationSource:(0,D.ConfigurationTargetToString)(y.source),configurationKeys:t(y.sourceConfig)})})}e.configurationTelemetry=d;function g(E,v){return!(v.disableTelemetry||!E.enableTelemetry)}e.supportsTelemetry=g;function i(E){const v=E.getValue(M.TELEMETRY_SETTING_ID),y=E.getValue("telemetry.enableCrashReporter");if(E.getValue(M.TELEMETRY_OLD_SETTING_ID)===!1||y===!1)return 0;switch(v??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=i;function I(E){const v=Object.create(null),y=Object.create(null),u=Object.create(null);m(E,u);for(let l in u){l=l.length>150?l.substr(l.length-149):l;const c=u[l];typeof c=="number"?y[l]=c:typeof c=="boolean"?y[l]=c?1:0:typeof c=="string"?v[l]=c.substring(0,1023):typeof c!="undefined"&&c!==null&&(v[l]=c)}return{properties:v,measurements:y}}e.validateTelemetryData=I;function S(E){if(!E)return"none";let v="other";return["ssh-remote","dev-container","attached-container","wsl"].forEach(u=>{E.indexOf(`${u}+`)===0&&(v=u)}),v}e.cleanRemoteAuthority=S;function m(E,v,y=0,u){if(!!E)for(let l of Object.getOwnPropertyNames(E)){const c=E[l],n=u?u+l:l;Array.isArray(c)?v[n]=(0,p.safeStringify)(c):c instanceof Date?v[n]=c.toISOString():(0,L.isObject)(c)?y<2?m(c,v,y+1,n+"."):v[n]=(0,p.safeStringify)(c):v[n]=c}}function t(E){if(!E)return[];const v=[];return h(v,"",E),v}function h(E,v,y){y&&typeof y=="object"&&!Array.isArray(y)?Object.keys(y).forEach(u=>h(E,v?`${v}.${u}`:u,y[u])):E.push(v)}}),define(Q[201],J([0,1,30,23,18,43,3,32,7,17,48,166,192,163,20,6,21,50,195,97,29,64]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const n=P.isWeb?"web":(0,I.getTargetPlatform)(P.platform,b.arch);var o;(function($){$[$.None=0]="None",$[$.IncludeVersions=1]="IncludeVersions",$[$.IncludeFiles=2]="IncludeFiles",$[$.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",$[$.IncludeSharedAccounts=8]="IncludeSharedAccounts",$[$.IncludeVersionProperties=16]="IncludeVersionProperties",$[$.ExcludeNonValidated=32]="ExcludeNonValidated",$[$.IncludeInstallationTargets=64]="IncludeInstallationTargets",$[$.IncludeAssetUri=128]="IncludeAssetUri",$[$.IncludeStatistics=256]="IncludeStatistics",$[$.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",$[$.Unpublished=4096]="Unpublished"})(o||(o={}));function s(...$){return String($.reduce((N,Z)=>N|Z,0))}var r;(function($){$[$.Tag=1]="Tag",$[$.ExtensionId=4]="ExtensionId",$[$.Category=5]="Category",$[$.ExtensionName=7]="ExtensionName",$[$.Target=8]="Target",$[$.Featured=9]="Featured",$[$.SearchText=10]="SearchText",$[$.ExcludeWithFlags=12]="ExcludeWithFlags"})(r||(r={}));const a={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},f={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension"},k={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:o.None,criteria:[],assetTypes:[]};class R{constructor(N=k){this.state=N}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(N,Z=this.state.pageSize){return new R({...this.state,pageNumber:N,pageSize:Z})}withFilter(N,...Z){const ie=[...this.state.criteria,...Z.length?Z.map(oe=>({filterType:N,value:oe})):[{filterType:N}]];return new R({...this.state,criteria:ie})}withSortBy(N){return new R({...this.state,sortBy:N})}withSortOrder(N){return new R({...this.state,sortOrder:N})}withFlags(...N){return new R({...this.state,flags:N.reduce((Z,ie)=>Z|ie,0)})}withAssetTypes(...N){return new R({...this.state,assetTypes:N})}get raw(){const{criteria:N,pageNumber:Z,pageSize:ie,sortBy:oe,sortOrder:le,flags:ne,assetTypes:ae}=this.state;return{filters:[{criteria:N,pageNumber:Z,pageSize:ie,sortBy:oe,sortOrder:le}],assetTypes:ae,flags:ne}}get searchText(){const N=this.state.criteria.filter(Z=>Z.filterType===r.SearchText)[0];return N&&N.value?N.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(N=>String(N.filterType)),sortBy:String(this.sortBy),sortOrder:String(this.sortOrder)}}}function A($,N){const Z=($||[]).filter(ie=>ie.statisticName===N)[0];return Z?Z.value:0}function O($){const N="Microsoft.VisualStudio.Code.Translation.";return $.files.filter(ie=>ie.assetType.indexOf(N)===0).reduce((ie,oe)=>{const le=K($,oe.assetType);return le&&ie.push([oe.assetType.substring(N.length),le]),ie},[])}function H($){if($.properties){const N=$.properties.filter(oe=>oe.key===a.Repository),Z=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),ie=N.filter(oe=>Z.test(oe.value))[0];return ie?{uri:ie.value,fallbackUri:ie.value}:null}return K($,a.Repository)}function x($){return{uri:`${$.fallbackAssetUri}/${a.VSIX}?redirect=true${$.targetPlatform?`&targetPlatform=${$.targetPlatform}`:""}`,fallbackUri:`${$.fallbackAssetUri}/${a.VSIX}${$.targetPlatform?`?targetPlatform=${$.targetPlatform}`:""}`}}function re($){const N=K($,a.Icon);if(N)return N;const Z=I.DefaultIconPath;return{uri:Z,fallbackUri:Z}}function K($,N){return $.files.filter(ie=>ie.assetType===N)[0]?{uri:`${$.assetUri}/${N}`,fallbackUri:`${$.fallbackAssetUri}/${N}`}:null}function ee($,N){const Z=$.properties?$.properties.filter(oe=>oe.key===N):[],ie=Z.length>0&&Z[0].value;return ie?ie.split(",").map(oe=>(0,S.adoptToGalleryExtensionId)(oe)):[]}function F($){const N=$.properties?$.properties.filter(Z=>Z.key===f.Engine):[];return N.length>0&&N[0].value||""}function V($){const N=$.properties?$.properties.filter(ie=>ie.key===f.LocalizedLanguages):[],Z=N.length>0&&N[0].value||"";return Z?Z.split(","):[]}function z($){return $.indexOf("preview")!==-1}function B($){return $.targetPlatform?(0,I.toTargetPlatform)($.targetPlatform):"undefined"}function U($){const N=(0,p.distinct)($.versions.map(B)),Z=!!$.tags?.includes(I.WEB_EXTENSION_TAG),ie=N.indexOf("web");return Z?ie===-1&&N.push("web"):ie!==-1&&N.splice(ie,1),N}function C($,N){const Z=(0,I.getFallbackTargetPlarforms)(N);for(let ie=0;ie<$.length;ie++){const oe=$[ie];if(oe.version===$[ie-1]?.version){let le=ie;const ne=B(oe);if(ne===N)for(;le>0&&$[le-1].version===oe.version;)le--;else if(Z.includes(ne))for(;le>0&&$[le-1].version===oe.version&&B($[le-1])!==N;)le--;le!==ie&&($.splice(ie,1),$.splice(le,0,oe))}}return $}e.sortExtensionVersions=C;function X($,N,Z,ie,oe){const le=U($);let ne=$.versions[0];return ne=$.versions.find(ae=>ae.version===ne.version&&(0,I.isTargetPlatformCompatible)(B(ae),le,oe))||ne,W($,ne,le,N,Z,ie)}function W($,N,Z,ie,oe,le){const ne={manifest:K(N,a.Manifest),readme:K(N,a.Details),changelog:K(N,a.Changelog),license:K(N,a.License),repository:H(N),download:x(N),icon:re(N),coreTranslations:O(N)};return{identifier:{id:(0,S.getGalleryExtensionId)($.publisher.publisherName,$.extensionName),uuid:$.extensionId},name:$.extensionName,version:N.version,displayName:$.displayName,publisherId:$.publisher.publisherId,publisher:$.publisher.publisherName,publisherDisplayName:$.publisher.displayName,description:$.shortDescription||"",installCount:A($.statistics,"install"),rating:A($.statistics,"averagerating"),ratingCount:A($.statistics,"ratingcount"),categories:$.categories||[],tags:$.tags||[],releaseDate:Date.parse($.releaseDate),lastUpdated:Date.parse($.lastUpdated),allTargetPlatforms:Z,assets:ne,properties:{dependencies:ee(N,f.Dependency),extensionPack:ee(N,f.ExtensionPack),engine:F(N),localizedLanguages:V(N),targetPlatform:B(N)},preview:z($.flags),telemetryData:{index:(oe.pageNumber-1)*oe.pageSize+ie,querySource:le}}}let T=class{constructor(N,Z,ie,oe,le,ne,ae,ue){this.requestService=Z,this.logService=ie,this.environmentService=oe,this.telemetryService=le,this.fileService=ne,this.productService=ae,this.configurationService=ue;const de=ae.extensionsGallery;this.extensionsGalleryUrl=de&&de.serviceUrl,this.extensionsControlUrl=de&&de.controlUrl,this.commonHeadersPromise=Y(ae.version,ae,this.environmentService,this.configurationService,this.fileService,N)}api(N=""){return`${this.extensionsGalleryUrl}${N}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(N,Z){const ie=[];let oe=new R().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,N.length).withFilter(r.Target,"Microsoft.VisualStudio.Code").withFilter(r.ExtensionName,...N.map(({id:ne})=>ne.toLowerCase()));N.every(ne=>!ne.version)&&(oe=oe.withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties,o.IncludeLatestVersionOnly));const{galleryExtensions:le}=await this.queryGallery(oe,n,L.CancellationToken.None);for(let ne=0;ne<le.length;ne++){const ae=le[ne];if(!ae.versions.length)continue;const ue=(0,S.getGalleryExtensionId)(ae.publisher.publisherName,ae.extensionName),de=N.find(ve=>(0,S.areSameExtensions)(ve,{id:ue}))?.version;if(de){const ve=ae.versions.find(Ie=>Ie.version===de);ve&&ie.push(W(ae,ve,U(ae),ne,oe))}else ie.push(X(ae,ne,oe,void 0,n))}return ie}async getCompatibleExtension(N,Z){const ie=(0,I.isIExtensionIdentifier)(N)?null:N;if(ie){if((0,I.isNotWebExtensionInWebTargetPlatform)(ie.allTargetPlatforms,Z))return null;if(await this.isExtensionCompatible(ie,Z))return ie}const{id:oe,uuid:le}=ie?ie.identifier:N;let ne=new R().withFlags(o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?ne=ne.withFilter(r.ExtensionId,le):ne=ne.withFilter(r.ExtensionName,oe);const{galleryExtensions:ae}=await this.queryGallery(ne,Z,L.CancellationToken.None),[ue]=ae;if(!ue||!ue.versions.length)return null;const de=U(ue);if((0,I.isNotWebExtensionInWebTargetPlatform)(de,Z))return null;for(let ve of ue.versions){if(!F(ve)){const Ie=await this.getEngine(ve);ve={...ve,properties:[...ve.properties||[],{key:f.Engine,value:Ie}]}}if(await this.isRawExtensionVersionCompatible(ve,de,Z))return W(ue,ve,de,0,ne)}return null}async isExtensionCompatible(N,Z){if(!(0,I.isTargetPlatformCompatible)(N.properties.targetPlatform,N.allTargetPlatforms,Z))return!1;let ie=N.properties.engine;if(!ie){const oe=await this.getManifest(N,L.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");ie=oe.engines.vscode}return(0,m.isEngineValid)(ie,this.productService.version,this.productService.date)}async isRawExtensionVersionCompatible(N,Z,ie){if(!(0,I.isTargetPlatformCompatible)(B(N),Z,ie))return!1;const oe=await this.getEngine(N);return(0,m.isEngineValid)(oe,this.productService.version,this.productService.date)}async query(N,Z){const ie=L.CancellationToken.isCancellationToken(N)?{}:N,oe=L.CancellationToken.isCancellationToken(N)?N:Z;if(!this.isEnabled())throw new Error("No extension gallery service configured.");let le=ie.text||"";const ne=(0,M.getOrDefault)(ie,me=>me.pageSize,50);let ae=new R().withFlags(o.IncludeLatestVersionOnly,o.IncludeAssetUri,o.IncludeStatistics,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,ne).withFilter(r.Target,"Microsoft.VisualStudio.Code");le?(le=le.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,be)=>(ae=ae.withFilter(r.Category,be||ge),"")),le=le.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(me,ge,be)=>(ae=ae.withFilter(r.Tag,be||ge),"")),le=le.replace(/\bfeatured(\s+|\b|$)/g,()=>(ae=ae.withFilter(r.Featured),"")),le=le.trim(),le&&(le=le.length<200?le:le.substring(0,200),ae=ae.withFilter(r.SearchText,le)),ae=ae.withSortBy(0)):ie.ids?ae=ae.withFilter(r.ExtensionId,...ie.ids):ie.names?ae=ae.withFilter(r.ExtensionName,...ie.names):ae=ae.withSortBy(4),typeof ie.sortBy=="number"&&(ae=ae.withSortBy(ie.sortBy)),typeof ie.sortOrder=="number"&&(ae=ae.withSortOrder(ie.sortOrder));const{galleryExtensions:ue,total:de}=await this.queryGallery(ae,n,oe),ve=ue.map((me,ge)=>X(me,ge,ae,ie.source,n)),Ie=async(me,ge)=>{if(ge.isCancellationRequested)throw(0,D.canceled)();const be=ae.withPage(me+1),{galleryExtensions:ke}=await this.queryGallery(be,n,ge);return ke.map((Te,Ne)=>X(Te,Ne,be,ie.source,n))};return{firstPage:ve,total:de,pageSize:ae.pageSize,getPage:Ie}}async queryGallery(N,Z,ie){if(!this.isEnabled())throw new Error("No extension gallery service configured.");N=N.withFlags(N.flags,o.ExcludeNonValidated).withFilter(r.ExcludeWithFlags,s(o.Unpublished));const oe=await this.commonHeadersPromise,le=JSON.stringify(N.raw),ne={...oe,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(le.length)},ae=new Date().getTime();let ue,de,ve=0;try{if(ue=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:le,headers:ne},ie),ue.res.statusCode&&ue.res.statusCode>=400&&ue.res.statusCode<500)return{galleryExtensions:[],total:ve};const Ie=await(0,v.asJson)(ue);if(Ie){const me=Ie.results[0],ge=me.extensions;ge.forEach(ke=>C(ke.versions,Z));const be=me.resultMetadata&&me.resultMetadata.filter(ke=>ke.metadataType==="ResultCount")[0];return ve=be&&be.metadataItems.filter(ke=>ke.name==="TotalCount")[0].count||0,{galleryExtensions:ge,total:ve}}return{galleryExtensions:[],total:ve}}catch(Ie){throw de=Ie,Ie}finally{this.telemetryService.publicLog2("galleryService:query",{...N.telemetryData,requestBodySize:String(le.length),duration:new Date().getTime()-ae,success:!!ue&&(0,v.isSuccess)(ue),responseBodySize:ue?.res.headers["Content-Length"],statusCode:ue?String(ue.res.statusCode):void 0,errorCode:de?(0,D.isPromiseCanceledError)(de)?"canceled":(0,D.getErrorMessage)(de).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(N,Z,ie,oe){if(!this.isEnabled())return;const le=P.isWeb?this.api(`/itemName/${N}.${Z}/version/${ie}/statType/${oe==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${N}/extensions/${Z}/${ie}/stats?statType=${oe}`),ne=P.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ue={...await this.commonHeadersPromise,Accept:ne};try{await this.requestService.request({type:"POST",url:le,headers:ue},L.CancellationToken.None)}catch(de){}}async download(N,Z,ie){this.logService.trace("ExtensionGalleryService#download",N.identifier.id);const oe=(0,S.getGalleryExtensionTelemetryData)(N),le=new Date().getTime(),ne=ve=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...oe,duration:ve}),ae=ie===1?"install":ie===2?"update":"",ue=ae?{uri:`${N.assets.download.uri}${d.URI.parse(N.assets.download.uri).query?"&":"?"}${ae}=true`,fallbackUri:`${N.assets.download.fallbackUri}${d.URI.parse(N.assets.download.fallbackUri).query?"&":"?"}${ae}=true`}:N.assets.download,de=await this.getAsset(ue);await this.fileService.writeFile(Z,de.stream),ne(new Date().getTime()-le)}async getReadme(N,Z){if(N.assets.readme){const ie=await this.getAsset(N.assets.readme,{},Z);return await(0,v.asText)(ie)||""}return""}async getManifest(N,Z){if(N.assets.manifest){const ie=await this.getAsset(N.assets.manifest,{},Z),oe=await(0,v.asText)(ie);return oe?JSON.parse(oe):null}return null}async getManifestFromRawExtensionVersion(N,Z){const ie=K(N,a.Manifest);if(!ie)throw new Error("Manifest was not found");const oe={"Accept-Encoding":"gzip"},le=await this.getAsset(ie,{headers:oe});return await(0,v.asJson)(le)}async getCoreTranslation(N,Z){const ie=N.assets.coreTranslations.filter(oe=>oe[0]===Z.toUpperCase())[0];if(ie){const oe=await this.getAsset(ie[1]),le=await(0,v.asText)(oe);return le?JSON.parse(le):null}return null}async getChangelog(N,Z){if(N.assets.changelog){const ie=await this.getAsset(N.assets.changelog,{},Z);return await(0,v.asText)(ie)||""}return""}async getAllCompatibleVersions(N,Z){let ie=new R().withFlags(o.IncludeVersions,o.IncludeCategoryAndTags,o.IncludeFiles,o.IncludeVersionProperties).withPage(1,1).withFilter(r.Target,"Microsoft.VisualStudio.Code");N.identifier.uuid?ie=ie.withFilter(r.ExtensionId,N.identifier.uuid):ie=ie.withFilter(r.ExtensionName,N.identifier.id);const{galleryExtensions:oe}=await this.queryGallery(ie,Z,L.CancellationToken.None);if(!oe.length)return[];const le=U(oe[0]);if((0,I.isNotWebExtensionInWebTargetPlatform)(le,Z))return[];const ne=[];for(const ae of oe[0].versions)try{ne[ne.length-1]?.version!==ae.version&&await this.isRawExtensionVersionCompatible(ae,le,Z)&&ne.push({version:ae.version,date:ae.lastUpdated})}catch(ue){}return ne}async getAsset(N,Z={},ie=L.CancellationToken.None){const oe=await this.commonHeadersPromise,le={type:"GET"},ne={...oe,...Z.headers||{}};Z={...Z,...le,headers:ne};const ae=N.uri,ue=N.fallbackUri,de={...Z,url:ae};try{const ve=await this.requestService.request(de,ie);if(ve.res.statusCode===200)return ve;const Ie=await(0,v.asText)(ve);throw new Error(`Expected 200, got back ${ve.res.statusCode} instead.

${Ie}`)}catch(ve){if((0,D.isPromiseCanceledError)(ve))throw ve;const Ie=(0,D.getErrorMessage)(ve);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:ae,message:Ie});const me={...Z,url:ue};return this.requestService.request(me,ie)}}async getEngine(N){let Z=F(N);if(!Z){const ie=await this.getManifestFromRawExtensionVersion(N,L.CancellationToken.None);if(!ie)throw new Error("Manifest was not found");Z=ie.engines.vscode}return Z}async getExtensionsReport(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return[];const N=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},L.CancellationToken.None);if(N.res.statusCode!==200)throw new Error("Could not get extensions report.");const Z=await(0,v.asJson)(N),ie=new Map;if(Z)for(const oe of Z.malicious){const le=ie.get(oe)||{id:{id:oe},malicious:!0,slow:!1};le.malicious=!0,ie.set(oe,le)}return[...ie.values()]}};T=he([te(1,v.IRequestService),te(2,h.ILogService),te(3,i.IEnvironmentService),te(4,l.ITelemetryService),te(5,t.IFileService),te(6,E.IProductService),te(7,g.IConfigurationService)],T);let _=class extends T{constructor(N,Z,ie,oe,le,ne,ae,ue){super(N,Z,ie,oe,le,ne,ae,ue)}};_=he([te(0,u.IStorageService),te(1,v.IRequestService),te(2,h.ILogService),te(3,i.IEnvironmentService),te(4,l.ITelemetryService),te(5,t.IFileService),te(6,E.IProductService),te(7,g.IConfigurationService)],_),e.ExtensionGalleryService=_;let q=class extends T{constructor(N,Z,ie,oe,le,ne,ae){super(void 0,N,Z,ie,oe,le,ne,ae)}};q=he([te(0,v.IRequestService),te(1,h.ILogService),te(2,i.IEnvironmentService),te(3,l.ITelemetryService),te(4,t.IFileService),te(5,E.IProductService),te(6,g.IConfigurationService)],q),e.ExtensionGalleryServiceWithNoStorageService=q;async function Y($,N,Z,ie,oe,le){const ne={"X-Market-Client-Id":`VSCode ${$}`,"User-Agent":`VSCode ${$}`},ae=await(0,y.getServiceMachineId)(Z,oe,le);return(0,c.supportsTelemetry)(N,Z)&&(0,c.getTelemetryLevel)(ie)===3&&(ne["X-Market-User-Id"]=ae),ne}e.resolveMarketplaceHeaders=Y}),define(Q[202],J([0,1,2,43,3,27,149,17,49,45,37,29,64]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let m=class{constructor(E,v){this._configurationService=v,this._experimentProperties={},this._disposables=new p.DisposableStore,this._cleanupPatterns=[],this._appenders=E.appenders,this._commonProperties=E.commonProperties||Promise.resolve({}),this._piiPaths=E.piiPaths||[],this._telemetryLevel=3,this.sendErrorTelemetry=!!E.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(let y of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,M.escapeRegExpCharacters)(y),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables),this.publicLog2("optInStatus",{optIn:this._telemetryLevel===3}),this._commonProperties.then(y=>{const u=/^[a-f0-9]+$/i.test(y["common.machineId"]);this.publicLog2("machineIdFallback",{usingFallbackGuid:!u})})}setExperimentProperty(E,v){this._experimentProperties[E]=v}_updateTelemetryLevel(){this._telemetryLevel=(0,S.getTelemetryLevel)(this._configurationService)}get telemetryLevel(){return this._telemetryLevel}async getTelemetryInfo(){const E=await this._commonProperties;let v=E.sessionID,y=E["common.instanceId"],u=E["common.machineId"],l=E["common.firstSessionDate"],c=E["common.msftInternal"];return{sessionId:v,instanceId:y,machineId:u,firstSessionDate:l,msftInternal:c}}dispose(){this._disposables.dispose()}_log(E,v,y,u){return this.telemetryLevel<v?Promise.resolve(void 0):this._commonProperties.then(l=>{y=(0,L.mixin)(y,l),y=(0,L.mixin)(y,this._experimentProperties),y=(0,L.cloneAndChange)(y,c=>{if(typeof c=="string")return this._cleanupInfo(c,u)}),this._appenders.forEach(c=>c.log(E,y))},l=>{console.error(l)})}publicLog(E,v,y){return this._log(E,3,v,y)}publicLog2(E,v,y){return this.publicLog(E,v,y)}publicLogError(E,v){return this.sendErrorTelemetry?this._log(E,2,v,!0):Promise.resolve(void 0)}publicLogError2(E,v){return this.publicLogError(E,v)}_anonymizeFilePaths(E){let v=E;const y=[];for(let n of this._cleanupPatterns)for(;;){const o=n.exec(E);if(!o)break;y.push([o.index,n.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,l=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let c=0;for(v="";;){const n=l.exec(E);if(!n)break;!u.test(n[0])&&y.every(([o,s])=>n.index<o||n.index>=s)&&(v+=E.substring(c,n.index)+"<REDACTED: user-file-path>",c=l.lastIndex)}return c<E.length&&(v+=E.substr(c)),v}_removePropertiesWithPossibleUserInfo(E){if(!E)return E;const v=E.toLowerCase(),y=/@[a-zA-Z0-9-.]+/;return/\S*(key|token|sig|password|passwd|pwd)[="':\s]+\S*/.test(v)?"<REDACTED: secret>":y.test(v)?"<REDACTED: email>":E}_cleanupInfo(E,v){let y=E;v&&(y=this._anonymizeFilePaths(y));for(let u of this._cleanupPatterns)y=y.replace(u,"");return y=this._removePropertiesWithPossibleUserInfo(y),y}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=he([te(1,b.IConfigurationService)],m),e.TelemetryService=m;function t(){const h=(0,P.localize)(0,null,g.default.nameLong),E=g.default.privacyStatementUrl?(0,P.localize)(2,null,"https://aka.ms/vscode-telemetry",g.default.privacyStatementUrl):(0,P.localize)(1,null,"https://aka.ms/vscode-telemetry"),v=D.isWeb?"":(0,P.localize)(3,null),y=(0,P.localize)(4,null),u=(0,P.localize)(5,null),l=(0,P.localize)(6,null),c=(0,P.localize)(7,null),n=`
|       | ${y} | ${u} | ${l} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,o=(0,P.localize)(8,null);return`
${h} ${E} ${v}

&nbsp;

${c}
${n}

&nbsp;

${o}
`}i.Registry.as(d.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(9,null),properties:{[I.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,P.localize)(10,null),(0,P.localize)(11,null),(0,P.localize)(12,null),(0,P.localize)(13,null)],markdownDescription:t(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),i.Registry.as(d.Extensions.Configuration).registerConfiguration({id:I.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,P.localize)(14,null),properties:{[I.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:g.default.privacyStatementUrl?(0,P.localize)(16,null,g.default.nameLong,g.default.privacyStatementUrl):(0,P.localize)(15,null,g.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,P.localize)(17,null,`\`#${I.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Q[203],J([0,1]),function(j,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ColorScheme=void 0;var p;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST="hc"})(p=e.ColorScheme||(e.ColorScheme={}))}),define(Q[204],J([0,1,108,4,2,5,37,203]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,M.createDecorator)("themeService");var d;(function(E){function v(y){return y&&typeof y=="object"&&typeof y.id=="string"}E.isThemeColor=v})(d=e.ThemeColor||(e.ThemeColor={}));function g(E){return{id:E}}e.themeColorFromId=g;var i;(function(E){function v(o){return o&&typeof o=="object"&&typeof o.id=="string"&&(typeof o.color=="undefined"||d.isThemeColor(o.color))}E.isThemeIcon=v;const y=new RegExp(`^\\$\\((${p.CSSIcon.iconNameExpression}(?:${p.CSSIcon.iconModifierExpression})?)\\)$`);function u(o){const s=y.exec(o);if(!s)return;let[,r]=s;return{id:r}}E.fromString=u;function l(o,s){let r=o.id;const a=r.lastIndexOf("~");return a!==-1&&(r=r.substring(0,a)),s&&(r=`${r}~${s}`),{id:r}}E.modify=l;function c(o,s){return o.id===s.id&&o.color?.id===s.color?.id}E.isEqual=c;function n(o,s){return{id:o.id,color:s?g(s):void 0}}E.asThemeIcon=n,E.asClassNameArray=p.CSSIcon.asClassNameArray,E.asClassName=p.CSSIcon.asClassName,E.asCSSSelector=p.CSSIcon.asCSSSelector})(i=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=p.Codicon.file,e.FolderThemeIcon=p.Codicon.folder;function I(E){switch(E){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST:return"hc-black";default:return"vs"}}e.getThemeTypeSelector=I,e.Extensions={ThemingContribution:"base.contributions.theming"};class S{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new L.Emitter}onColorThemeChange(v){return this.themingParticipants.push(v),this.onThemingParticipantAddedEmitter.fire(v),(0,D.toDisposable)(()=>{const y=this.themingParticipants.indexOf(v);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}let m=new S;P.Registry.add(e.Extensions.ThemingContribution,m);function t(E){return m.onColorThemeChange(E)}e.registerThemingParticipant=t;class h extends D.Disposable{constructor(v){super();this.themeService=v,this.theme=v.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(v){this.theme=v,this.updateStyles()}updateStyles(){}getColor(v,y){let u=this.theme.getColor(v);return u&&y&&(u=y(u,this.theme)),u?u.toString():null}}e.Themable=h}),define(Q[65],J([0,1,13,3,5,38]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ThemeMainService=e.IThemeMainService=void 0;const P="#FFFFFF",b="#1E1E1E",d="#000000",g="theme",i="themeBackground",I="windowSplash";e.IThemeMainService=(0,D.createDecorator)("themeMainService");let S=class{constructor(t){this.stateMainService=t}getBackgroundColor(){if((L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme)return d;let t=this.stateMainService.getItem(i,null);if(!t){let h;(L.isWindows||L.isMacintosh)&&p.nativeTheme.shouldUseInvertedColorScheme?h="hc-black":h=this.stateMainService.getItem(g,"vs-dark").split(" ")[0],t=h==="hc-black"?d:h==="vs"?P:b}return L.isMacintosh&&t.toUpperCase()===b&&(t="#171717"),t}saveWindowSplash(t,h){this.stateMainService.setItems([{key:g,data:h.baseTheme},{key:i,data:h.colorInfo.background},{key:I,data:h}]),typeof t=="number"&&this.updateBackgroundColor(t,h)}updateBackgroundColor(t,h){for(const E of p.BrowserWindow.getAllWindows())if(E.id===t){E.setBackgroundColor(h.colorInfo.background);break}}getWindowSplash(){return this.stateMainService.getItem(I)}};S=he([te(0,M.IStateMainService)],S),e.ThemeMainService=S}),define(Q[41],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUpdateService=e.State=e.UpdateType=e.StateType=void 0;var L;(function(M){M.Uninitialized="uninitialized",M.Idle="idle",M.CheckingForUpdates="checking for updates",M.AvailableForDownload="available for download",M.Downloading="downloading",M.Downloaded="downloaded",M.Updating="updating",M.Ready="ready"})(L=e.StateType||(e.StateType={}));var D;(function(M){M[M.Setup=0]="Setup",M[M.Archive=1]="Archive",M[M.Snap=2]="Snap"})(D=e.UpdateType||(e.UpdateType={})),e.State={Uninitialized:{type:"uninitialized"},Idle:(M,P)=>({type:"idle",updateType:M,error:P}),CheckingForUpdates:M=>({type:"checking for updates",explicit:M}),AvailableForDownload:M=>({type:"available for download",update:M}),Downloading:M=>({type:"downloading",update:M}),Downloaded:M=>({type:"downloaded",update:M}),Updating:M=>({type:"updating",update:M}),Ready:M=>({type:"ready",update:M})},e.IUpdateService=(0,p.createDecorator)("updateService")}),define(Q[205],J([0,1,3,150,49,37]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),M.Registry.as(D.Extensions.Configuration).registerConfiguration({id:"update",order:15,title:(0,L.localize)(0,null),type:"object",properties:{"update.mode":{type:"string",enum:["none","manual","start","default"],default:"default",scope:1,description:(0,L.localize)(1,null),tags:["usesOnlineServices"],enumDescriptions:[(0,L.localize)(2,null),(0,L.localize)(3,null),(0,L.localize)(4,null),(0,L.localize)(5,null)]},"update.channel":{type:"string",default:"default",scope:1,description:(0,L.localize)(6,null),deprecationMessage:(0,L.localize)(7,null,"update.mode")},"update.enableWindowsBackgroundUpdates":{type:"boolean",default:!0,scope:1,title:(0,L.localize)(8,null),description:(0,L.localize)(9,null),included:p.isWindows&&!p.isWeb},"update.showReleaseNotes":{type:"boolean",default:!0,scope:1,description:(0,L.localize)(10,null),tags:["usesOnlineServices"]}}})}),define(Q[206],J([0,1,4,41]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UpdateChannelClient=e.UpdateChannel=void 0;class D{constructor(b){this.service=b}listen(b,d){switch(d){case"onStateChange":return this.service.onStateChange}throw new Error(`Event not found: ${d}`)}call(b,d,g){switch(d){case"checkForUpdates":return this.service.checkForUpdates(g);case"downloadUpdate":return this.service.downloadUpdate();case"applyUpdate":return this.service.applyUpdate();case"quitAndInstall":return this.service.quitAndInstall();case"_getInitialState":return Promise.resolve(this.service.state);case"isLatestVersion":return this.service.isLatestVersion()}throw new Error(`Call not found: ${d}`)}}e.UpdateChannel=D;class M{constructor(b){this.channel=b,this._onStateChange=new p.Emitter,this.onStateChange=this._onStateChange.event,this._state=L.State.Uninitialized,this.channel.listen("onStateChange")(d=>this.state=d),this.channel.call("_getInitialState").then(d=>this.state=d)}get state(){return this._state}set state(b){this._state=b,this._onStateChange.fire(b)}checkForUpdates(b){return this.channel.call("checkForUpdates",b)}downloadUpdate(){return this.channel.call("downloadUpdate")}applyUpdate(){return this.channel.call("applyUpdate")}quitAndInstall(){return this.channel.call("quitAndInstall")}isLatestVersion(){return this.channel.call("isLatestVersion")}}e.UpdateChannelClient=M}),define(Q[98],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IURLService=void 0,e.IURLService=(0,p.createDecorator)("urlService")}),define(Q[207],J([0,1,7]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URLHandlerRouter=e.URLHandlerChannelClient=e.URLHandlerChannel=void 0;class L{constructor(b){this.handler=b}listen(b,d){throw new Error(`Event not found: ${d}`)}call(b,d,g){switch(d){case"handleURL":return this.handler.handleURL(p.URI.revive(g[0]),g[1])}throw new Error(`Call not found: ${d}`)}}e.URLHandlerChannel=L;class D{constructor(b){this.channel=b}handleURL(b,d){return this.channel.call("handleURL",[b.toJSON(),d])}}e.URLHandlerChannelClient=D;class M{constructor(b){this.next=b}async routeCall(b,d,g,i){if(d!=="handleURL")throw new Error(`Call not found: ${d}`);if(g){const I=p.URI.revive(g);if(I&&I.query){const S=/\bwindowId=(\d+)/.exec(I.query);if(S){const m=S[1],t=new RegExp(`window:${m}`),h=b.connections.find(E=>t.test(E.ctx));if(h)return h}}}return this.next.routeCall(b,d,g,i)}routeEvent(b,d){throw new Error(`Event not found: ${d}`)}}e.URLHandlerRouter=M}),define(Q[208],J([0,1,9,2,7,21]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeURLService=e.AbstractURLService=void 0;class P extends L.Disposable{constructor(){super(...arguments);this.handlers=new Set}open(g,i){const I=[...this.handlers.values()];return(0,p.first)(I.map(S=>()=>S.handleURL(g,i)),void 0,!1).then(S=>S||!1)}registerHandler(g){return this.handlers.add(g),(0,L.toDisposable)(()=>this.handlers.delete(g))}}e.AbstractURLService=P;let b=class extends P{constructor(g){super();this.productService=g}create(g){let{authority:i,path:I,query:S,fragment:m}=g||{authority:void 0,path:void 0,query:void 0,fragment:void 0};return i&&I&&I.indexOf("/")!==0&&(I=`/${I}`),D.URI.from({scheme:this.productService.urlProtocol,authority:i,path:I,query:S,fragment:m})}};b=he([te(0,M.IProductService)],b),e.NativeURLService=b}),define(Q[209],J([0,1,13,9,4,2,3,7]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ElectronURLListener=void 0;function d(i){try{return b.URI.parse(i)}catch(I){return null}}class g{constructor(I,S,m,t,h){if(this.urlService=S,this.uris=[],this.retryCount=0,this.flushDisposable=M.Disposable.None,this.disposables=new M.DisposableStore,this.uris=I,P.isWindows){const y=t.isBuilt?[]:[`"${t.appRoot}"`];y.push("--open-url","--"),p.app.setAsDefaultProtocolClient(h.urlProtocol,process.execPath,y)}const E=D.Event.map(D.Event.fromNodeEventEmitter(p.app,"open-url",(y,u)=>({event:y,url:u})),({event:y,url:u})=>(y.preventDefault(),u));this.disposables.add(E(y=>{const u=d(y);!u||this.urlService.open(u,{originalUrl:y})})),m.getWindows().filter(y=>y.isReady).length>0?this.flush():D.Event.once(m.onDidSignalReadyWindow)(this.flush,this,this.disposables)}async flush(){if(this.retryCount++>10)return;const I=[];for(const S of this.uris)await this.urlService.open(S.uri,{originalUrl:S.url})||I.push(S);I.length!==0&&(this.uris=I,this.flushDisposable=(0,L.disposableTimeout)(()=>this.flush(),500))}dispose(){this.disposables.dispose(),this.flushDisposable.dispose()}}e.ElectronURLListener=g}),define(Q[210],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWebviewManagerService=void 0,e.IWebviewManagerService=(0,p.createDecorator)("webviewManagerService")}),define(Q[211],J([0,1,13,2,10,7]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewProtocolProvider=void 0;class P extends L.Disposable{constructor(){super();const d=this.handleWebviewRequest.bind(this);p.protocol.registerFileProtocol(D.Schemas.vscodeWebview,d)}handleWebviewRequest(d,g){try{const i=M.URI.parse(d.url),I=P.validWebviewFilePaths.get(i.path);if(typeof I=="string"){const S=`vs/workbench/contrib/webview/browser/pre/${I}`,m=D.FileAccess.asFileUri(S,j);return g(decodeURIComponent(m.fsPath))}else return g({error:-10})}catch{}return g({error:-2})}}e.WebviewProtocolProvider=P,P.validWebviewFilePaths=new Map([["/index.html","index.html"],["/fake.html","fake.html"],["/main.js","main.js"],["/service-worker.js","service-worker.js"]])}),define(Q[66],J([0,1,3]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.zoomLevelToZoomFactor=e.getTitleBarStyle=e.getMenuBarVisibility=e.isFileToOpen=e.isFolderToOpen=e.isWorkspaceToOpen=e.WindowMinimumSize=void 0,e.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function L(g){return!!g.workspaceUri}e.isWorkspaceToOpen=L;function D(g){return!!g.folderUri}e.isFolderToOpen=D;function M(g){return!!g.fileUri}e.isFileToOpen=M;function P(g){const i=b(g),I=g.getValue("window.menuBarVisibility");return I==="default"||i==="native"&&I==="compact"||p.isMacintosh&&p.isNative?"classic":I}e.getMenuBarVisibility=P;function b(g){if(p.isWeb)return"custom";const i=g.getValue("window");if(i){if(p.isMacintosh&&i.nativeTabs===!0||p.isMacintosh&&i.nativeFullScreen===!1)return"native";const m=i.titleBarStyle;if(m==="native"||m==="custom")return m}return p.isLinux?"native":"custom"}e.getTitleBarStyle=b;function d(g=0){return Math.pow(1.2,g)}e.zoomLevelToZoomFactor=d}),define(Q[36],J([0,1,5]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWindowsMainService=e.WindowError=e.WindowMode=e.defaultWindowState=e.OpenContext=e.UnloadReason=e.LoadReason=void 0;var L;(function(g){g[g.INITIAL=1]="INITIAL",g[g.LOAD=2]="LOAD",g[g.RELOAD=3]="RELOAD"})(L=e.LoadReason||(e.LoadReason={}));var D;(function(g){g[g.CLOSE=1]="CLOSE",g[g.QUIT=2]="QUIT",g[g.RELOAD=3]="RELOAD",g[g.LOAD=4]="LOAD"})(D=e.UnloadReason||(e.UnloadReason={}));var M;(function(g){g[g.CLI=0]="CLI",g[g.DOCK=1]="DOCK",g[g.MENU=2]="MENU",g[g.DIALOG=3]="DIALOG",g[g.DESKTOP=4]="DESKTOP",g[g.API=5]="API"})(M=e.OpenContext||(e.OpenContext={}));const P=function(g=1){return{width:1024,height:768,mode:g}};e.defaultWindowState=P;var b;(function(g){g[g.Maximized=0]="Maximized",g[g.Normal=1]="Normal",g[g.Minimized=2]="Minimized",g[g.Fullscreen=3]="Fullscreen"})(b=e.WindowMode||(e.WindowMode={}));var d;(function(g){g[g.UNRESPONSIVE=1]="UNRESPONSIVE",g[g.CRASHED=2]="CRASHED",g[g.LOAD=3]="LOAD"})(d=e.WindowError||(e.WindowError={})),e.IWindowsMainService=(0,p.createDecorator)("windowsMainService")}),define(Q[212],J([0,1,13,4,2,211,36]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WebviewMainService=void 0;let b=class extends D.Disposable{constructor(g){super();this.windowsMainService=g,this._onFoundInFrame=this._register(new L.Emitter),this.onFoundInFrame=this._onFoundInFrame.event,this._register(new M.WebviewProtocolProvider)}async setIgnoreMenuShortcuts(g,i){let I;if(typeof g.windowId=="number"){const{windowId:S}=g,m=this.windowsMainService.getWindowById(S);if(!m?.win)throw new Error(`Invalid windowId: ${S}`);I=m.win.webContents}else{const{webContentsId:S}=g;if(I=p.webContents.fromId(S),!I)throw new Error(`Invalid webContentsId: ${S}`)}I.isDestroyed()||I.setIgnoreMenuShortcuts(i)}async findInFrame(g,i,I,S){const m=this.getFrameByName(g,i),t=m;if(typeof t.findInFrame=="function"){t.findInFrame(I,{findNext:S.findNext,forward:S.forward});const h=(E,v)=>{v.finalUpdate&&(this._onFoundInFrame.fire(v),m.removeListener("found-in-frame",h))};m.on("found-in-frame",h)}}async stopFindInFrame(g,i,I){const m=this.getFrameByName(g,i);typeof m.stopFindInFrame=="function"&&m.stopFindInFrame(I.keepSelection?"keepSelection":"clearSelection")}getFrameByName(g,i){const I=this.windowsMainService.getWindowById(g.windowId);if(!I?.win)throw new Error(`Invalid windowId: ${g}`);const S=I.win.webContents.mainFrame.framesInSubtree.find(m=>m.name===i);if(!S)throw new Error(`Unknown frame: ${i}`);return S}};b=he([te(0,P.IWindowsMainService)],b),e.WebviewMainService=b}),define(Q[213],J([0,1,9,4,2]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class M extends D.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:d,getActiveWindowId:g}){super();this.disposables=this._register(new D.DisposableStore),L.Event.latch(L.Event.any(b,d))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,p.createCancelablePromise)(()=>g()),(async()=>{try{const I=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:I}catch(I){}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=M}),define(Q[214],J([0,1,40,15,7,5]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,M.createDecorator)("contextService");var P;(function(S){S[S.EMPTY=1]="EMPTY",S[S.FOLDER=2]="FOLDER",S[S.WORKSPACE=3]="WORKSPACE"})(P=e.WorkbenchState||(e.WorkbenchState={}));function b(S){const m=S;return!!(m&&typeof m=="object"&&typeof m.id=="string"&&Array.isArray(m.folders))}e.isWorkspace=b;function d(S){const m=S;return!!(m&&typeof m=="object"&&D.URI.isUri(m.uri)&&typeof m.name=="string"&&typeof m.toResource=="function")}e.isWorkspaceFolder=d;class g{constructor(m,t,h,E,v){this._id=m,this._transient=h,this._configuration=E,this._ignorePathCasing=v,this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing),this.folders=t}update(m){this._id=m.id,this._configuration=m.configuration,this._transient=m.transient,this._ignorePathCasing=m._ignorePathCasing,this.folders=m.folders}get folders(){return this._folders}set folders(m){this._folders=m,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(m){this._configuration=m}getFolder(m){return m&&this._foldersMap.findSubstr(m.with({scheme:m.scheme,authority:m.authority,path:m.path}))||null}updateFoldersMap(){this._foldersMap=p.TernarySearchTree.forUris(this._ignorePathCasing);for(const m of this.folders)this._foldersMap.set(m.uri,m)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=g;class i{constructor(m,t){this.raw=t,this.uri=m.uri,this.index=m.index,this.name=m.name}toResource(m){return(0,L.joinPath)(this.uri,m)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=i;function I(S){return new i({uri:S,index:0,name:(0,L.basenameOrAuthority)(S)},{uri:S.toString()})}e.toWorkspaceFolder=I}),define(Q[26],J([0,1,33,39,79,34,10,8,3,15,7,153,5,63,214]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toStoreData=e.restoreRecentlyOpened=e.useSlashForPath=e.rewriteWorkspaceFileForNewLocation=e.toWorkspaceFolders=e.getStoredWorkspaceFolder=e.isRawUriWorkspaceFolder=e.isRawFileWorkspaceFolder=e.isStoredWorkspaceFolder=e.isUntitledWorkspace=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.isRecentFile=e.isRecentFolder=e.isRecentWorkspace=e.IWorkspacesService=e.hasWorkspaceFileExtension=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=void 0,e.WORKSPACE_EXTENSION="code-workspace";const h=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function E(F){return(typeof F=="string"?(0,b.extname)(F):(0,g.extname)(F))===h}e.hasWorkspaceFileExtension=E,e.IWorkspacesService=(0,S.createDecorator)("workspacesService");function v(F){return F.hasOwnProperty("workspace")}e.isRecentWorkspace=v;function y(F){return F.hasOwnProperty("folderUri")}e.isRecentFolder=y;function u(F){return F.hasOwnProperty("fileUri")}e.isRecentFile=u;function l(F){const V=F;return typeof V?.id=="string"&&i.URI.isUri(V.uri)}e.isSingleFolderWorkspaceIdentifier=l;function c(F){if(F.configuration)return{id:F.id,configPath:F.configuration};if(F.folders.length===1)return{id:F.id,uri:F.folders[0].uri}}e.toWorkspaceIdentifier=c;function n(F){const V=F;return typeof V?.id=="string"&&i.URI.isUri(V.configPath)}e.isWorkspaceIdentifier=n;function o(F){const V=F;if(V?.uri)return{id:V.id,uri:i.URI.revive(V.uri)};const z=F;if(z?.configPath)return{id:z.id,configPath:i.URI.revive(z.configPath)};if(F?.id)return{id:F.id}}e.reviveIdentifier=o;function s(F,V){return g.extUriBiasedIgnorePathCase.isEqualOrParent(F,V.untitledWorkspacesHome)}e.isUntitledWorkspace=s;function r(F){return a(F)||f(F)}e.isStoredWorkspaceFolder=r;function a(F){const V=F;return typeof V?.path=="string"&&(!V.name||typeof V.name=="string")}e.isRawFileWorkspaceFolder=a;function f(F){const V=F;return typeof V?.uri=="string"&&(!V.name||typeof V.name=="string")}e.isRawUriWorkspaceFolder=f;function w(F,V,z,B,U=!d.isWindows,C){if(F.scheme!==B.scheme)return{name:z,uri:F.toString(!0)};let X=V?void 0:C.relativePath(B,F);if(X!==void 0)X.length===0?X=".":d.isWindows&&F.scheme===P.Schemas.file&&!U&&(X=X.replace(/\//g,"\\"));else if(F.scheme===P.Schemas.file)X=F.fsPath,d.isWindows&&(X=(0,M.normalizeDriveLetter)(X),U&&(X=(0,p.toSlashes)(X)));else{if(!C.isEqualAuthority(F.authority,B.authority))return{name:z,uri:F.toString(!0)};X=F.path}return{name:z,path:X}}e.getStoredWorkspaceFolder=w;function k(F,V,z){let B=[],U=new Set;const C=z.dirname(V);for(let X of F){let W;if(a(X))X.path&&(W=z.resolvePath(C,X.path));else if(f(X))try{W=i.URI.parse(X.uri),W.path[0]!=="/"&&(W=W.with({path:"/"+W.path}))}catch(T){console.warn(T)}if(W){let T=z.getComparisonKey(W);if(!U.has(T)){U.add(T);const _=X.name||z.basenameOrAuthority(W);B.push(new t.WorkspaceFolder({uri:W,name:_,index:B.length},X))}}}return B}e.toWorkspaceFolders=k;function R(F,V,z,B,U){let C=A(V,F);const X=U.dirname(V),W=U.dirname(B),T=[],_=O(C.folders);for(const N of C.folders){const Z=a(N)?U.resolvePath(X,N.path):i.URI.parse(N.uri);let ie;z?ie=!1:ie=!a(N)||(0,b.isAbsolute)(N.path),T.push(w(Z,ie,N.name,W,_,U))}const q={insertSpaces:!1,tabSize:4,eol:d.isLinux||d.isMacintosh?`
`:`\r
`},Y=D.setProperty(F,["folders"],T,q);let $=D.applyEdits(F,Y);return C.remoteAuthority===(0,m.getRemoteAuthority)(B)&&($=D.applyEdits($,D.removeProperty($,["remoteAuthority"],q))),$}e.rewriteWorkspaceFileForNewLocation=R;function A(F,V){let z=L.parse(V);if(z&&Array.isArray(z.folders))z.folders=z.folders.filter(B=>r(B));else throw new Error(`${F} looks like an invalid workspace file.`);return z}function O(F){return d.isWindows?F.some(V=>a(V)&&V.path.indexOf("/")>=0):!0}e.useSlashForPath=O;function H(F){return F.workspace&&typeof F.workspace=="object"&&typeof F.workspace.id=="string"&&typeof F.workspace.configPath=="string"}function x(F){return typeof F.folderUri=="string"}function re(F){return typeof F.fileUri=="string"}function K(F,V){const z={workspaces:[],files:[]};if(F){const B=function(C,X){for(let W=0;W<C.length;W++)try{X(C[W],W)}catch(T){V.warn(`Error restoring recent entry ${JSON.stringify(C[W])}: ${T.toString()}. Skip entry.`)}},U=F;if(Array.isArray(U.entries))B(U.entries,C=>{const X=C.label,W=C.remoteAuthority;H(C)?z.workspaces.push({label:X,remoteAuthority:W,workspace:{id:C.workspace.id,configPath:i.URI.parse(C.workspace.configPath)}}):x(C)?z.workspaces.push({label:X,remoteAuthority:W,folderUri:i.URI.parse(C.folderUri)}):re(C)&&z.files.push({label:X,remoteAuthority:W,fileUri:i.URI.parse(C.fileUri)})});else{const C=F;Array.isArray(C.workspaces3)&&B(C.workspaces3,(X,W)=>{const T=Array.isArray(C.workspaceLabels)&&C.workspaceLabels[W]||void 0;typeof X=="object"&&typeof X.id=="string"&&typeof X.configURIPath=="string"?z.workspaces.push({label:T,workspace:{id:X.id,configPath:i.URI.parse(X.configURIPath)}}):typeof X=="string"&&z.workspaces.push({label:T,folderUri:i.URI.parse(X)})}),Array.isArray(C.files2)&&B(C.files2,(X,W)=>{const T=Array.isArray(C.fileLabels)&&C.fileLabels[W]||void 0;typeof X=="string"&&z.files.push({label:T,fileUri:i.URI.parse(X)})})}}return z}e.restoreRecentlyOpened=K;function ee(F){const V={entries:[]};for(const z of F.workspaces)y(z)?V.entries.push({folderUri:z.folderUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority}):V.entries.push({workspace:{id:z.workspace.id,configPath:z.workspace.configPath.toString()},label:z.label,remoteAuthority:z.remoteAuthority});for(const z of F.files)V.entries.push({fileUri:z.fileUri.toString(),label:z.label,remoteAuthority:z.remoteAuthority});return V}e.toStoreData=ee}),define(Q[51],J([0,1,5,26]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isWorkspaceBackupInfo=e.IBackupMainService=void 0,e.IBackupMainService=(0,p.createDecorator)("backupMainService");function D(M){const P=M;return P&&(0,L.isWorkspaceIdentifier)(P.workspace)}e.isWorkspaceBackupInfo=D}),define(Q[52],J([0,1,13,9,82,34,2,69,8,3,14,19,133,5,6,38,26]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DialogMainService=e.IDialogMainService=void 0,e.IDialogMainService=(0,m.createDecorator)("dialogMainService");let v=class mt{constructor(u,l){this.stateMainService=u,this.logService=l,this.windowFileDialogLocks=new Map,this.windowDialogQueues=new Map,this.noWindowDialogueQueue=new L.Queue}pickFileFolder(u,l){return this.doPick({...u,pickFolders:!0,pickFiles:!0,title:(0,S.localize)(0,null)},l)}pickFolder(u,l){return this.doPick({...u,pickFolders:!0,title:(0,S.localize)(1,null)},l)}pickFile(u,l){return this.doPick({...u,pickFiles:!0,title:(0,S.localize)(2,null)},l)}pickWorkspace(u,l){const c=(0,S.localize)(3,null),n=(0,M.mnemonicButtonLabel)((0,S.localize)(4,null)),o=E.WORKSPACE_FILTER;return this.doPick({...u,pickFiles:!0,title:c,filters:o,buttonLabel:n},l)}async doPick(u,l){const c={title:u.title,buttonLabel:u.buttonLabel,filters:u.filters};c.defaultPath=u.defaultPath||this.stateMainService.getItem(mt.workingDirPickerStorageKey),(typeof u.pickFiles=="boolean"||typeof u.pickFolders=="boolean")&&(c.properties=void 0,u.pickFiles&&u.pickFolders&&(c.properties=["multiSelections","openDirectory","openFile","createDirectory"])),c.properties||(c.properties=["multiSelections",u.pickFolders?"openDirectory":"openFile","createDirectory"]),g.isMacintosh&&c.properties.push("treatPackageAsDirectory");const n=l||p.BrowserWindow.getFocusedWindow(),o=await this.showOpenDialog(c,(0,i.withNullAsUndefined)(n));if(o&&o.filePaths&&o.filePaths.length>0)return this.stateMainService.setItem(mt.workingDirPickerStorageKey,(0,d.dirname)(o.filePaths[0])),o.filePaths}getWindowDialogQueue(u){if(u){let l=this.windowDialogQueues.get(u.id);return l||(l=new L.Queue,this.windowDialogQueues.set(u.id,l)),l}else return this.noWindowDialogueQueue}showMessageBox(u,l){return this.getWindowDialogQueue(l).queue(async()=>l?p.dialog.showMessageBox(l,u):p.dialog.showMessageBox(u))}async showSaveDialog(u,l){const c=this.acquireFileDialogLock(u,l);if(!c)return this.logService.error("[DialogMainService]: file save dialog is already or will be showing for the window with the same configuration"),{canceled:!0};try{return await this.getWindowDialogQueue(l).queue(async()=>{let n;return l?n=await p.dialog.showSaveDialog(l,u):n=await p.dialog.showSaveDialog(u),n.filePath=this.normalizePath(n.filePath),n})}finally{(0,P.dispose)(c)}}normalizePath(u){return u&&g.isMacintosh&&(u=(0,b.normalizeNFC)(u)),u}normalizePaths(u){return u.map(l=>this.normalizePath(l))}async showOpenDialog(u,l){u.defaultPath&&(await I.Promises.exists(u.defaultPath)||(u.defaultPath=void 0));const c=this.acquireFileDialogLock(u,l);if(!c)return this.logService.error("[DialogMainService]: file open dialog is already or will be showing for the window with the same configuration"),{canceled:!0,filePaths:[]};try{return await this.getWindowDialogQueue(l).queue(async()=>{let n;return l?n=await p.dialog.showOpenDialog(l,u):n=await p.dialog.showOpenDialog(u),n.filePaths=this.normalizePaths(n.filePaths),n})}finally{(0,P.dispose)(c)}}acquireFileDialogLock(u,l){if(!l)return P.Disposable.None;let c=this.windowFileDialogLocks.get(l.id);c||(c=new Set,this.windowFileDialogLocks.set(l.id,c));const n=(0,D.hash)(u);if(!c.has(n))return c.add(n),(0,P.toDisposable)(()=>{c?.delete(n),c?.size===0&&this.windowFileDialogLocks.delete(l.id)})}};v.workingDirPickerStorageKey="pickerWorkingDir",v=he([te(0,h.IStateMainService),te(1,t.ILogService)],v),e.DialogMainService=v}),define(Q[215],J([0,1,4,2,26]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDatabaseChannel=void 0;class M extends L.Disposable{constructor(b,d){super();this.logService=b,this.storageMainService=d,this._onDidChangeGlobalStorage=this._register(new p.Emitter),this.onDidChangeGlobalStorage=this._onDidChangeGlobalStorage.event,this.registerGlobalStorageListeners()}registerGlobalStorageListeners(){this._register(p.Event.debounce(this.storageMainService.globalStorage.onDidChangeStorage,(b,d)=>(b?b.push(d):b=[d],b),M.STORAGE_CHANGE_DEBOUNCE_TIME)(b=>{b.length&&this._onDidChangeGlobalStorage.fire(this.serializeGlobalStorageEvents(b))}))}serializeGlobalStorageEvents(b){const d=new Map,g=new Set;return b.forEach(i=>{const I=this.storageMainService.globalStorage.get(i.key);typeof I=="string"?d.set(i.key,I):g.add(i.key)}),{changed:Array.from(d.entries()),deleted:Array.from(g.values())}}listen(b,d){switch(d){case"onDidChangeGlobalStorage":return this.onDidChangeGlobalStorage}throw new Error(`Event not found: ${d}`)}async call(b,d,g){const i=(0,D.reviveIdentifier)(g.workspace),I=await this.withStorageInitialized(i);switch(d){case"getItems":return Array.from(I.items.entries());case"updateItems":{const S=g;if(S.insert)for(const[m,t]of S.insert)I.set(m,t);S.delete&&S.delete.forEach(m=>I.delete(m));break}case"close":{if(i)return I.close();break}default:throw new Error(`Call not found: ${d}`)}}async withStorageInitialized(b){const d=b?this.storageMainService.workspaceStorage(b):this.storageMainService.globalStorage;try{await d.init()}catch(g){this.logService.error(`StorageIPC#init: Unable to init ${b?"workspace":"global"} storage due to ${g}`)}return d}}e.StorageDatabaseChannel=M,M.STORAGE_CHANGE_DEBOUNCE_TIME=100}),define(Q[216],J([0,1,4,2,8,28,19,87,123,6,97,29,26]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageMain=e.GlobalStorageMain=void 0;class m extends L.Disposable{constructor(v){super();this.logService=v,this._onDidChangeStorage=this._register(new p.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this._onDidCloseStorage=this._register(new p.Emitter),this.onDidCloseStorage=this._onDidCloseStorage.event,this.storage=new b.Storage(new b.InMemoryStorageDatabase),this.initializePromise=void 0}init(){return this.initializePromise||(this.initializePromise=(async()=>{try{const v=await this.doCreate();this.storage.dispose(),this.storage=v,this._register(v.onDidChangeStorage(u=>this._onDidChangeStorage.fire({key:u}))),await this.doInit(v);const y=v.getBoolean(i.IS_NEW_KEY);y===void 0?v.set(i.IS_NEW_KEY,!0):y&&v.set(i.IS_NEW_KEY,!1)}catch(v){this.logService.error(`StorageMain#initialize(): Unable to init storage due to ${v}`)}})()),this.initializePromise}createLoggingOptions(){return{logTrace:this.logService.getLevel()===g.LogLevel.Trace?v=>this.logService.trace(v):void 0,logError:v=>this.logService.error(v)}}doInit(v){return v.init()}get items(){return this.storage.items}get(v,y){return this.storage.get(v,y)}set(v,y){return this.storage.set(v,y)}delete(v){return this.storage.delete(v)}async close(){this.initializePromise&&await this.initializePromise,await this.storage.close(),this._onDidCloseStorage.fire()}}class t extends m{constructor(v,y,u){super(y);this.options=v,this.environmentService=u}async doCreate(){let v;return this.options.useInMemoryStorage?v=d.SQLiteStorageDatabase.IN_MEMORY_PATH:v=(0,D.join)(this.environmentService.globalStorageHome.fsPath,t.STORAGE_NAME),new b.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}))}async doInit(v){await super.doInit(v),this.updateTelemetryState(v)}updateTelemetryState(v){v.get(I.instanceStorageKey,void 0)===void 0&&v.set(I.instanceStorageKey,(0,M.generateUuid)()),v.get(I.firstSessionDateStorageKey,void 0)===void 0&&v.set(I.firstSessionDateStorageKey,new Date().toUTCString());const l=v.get(I.currentSessionDateStorageKey,void 0),c=new Date().toUTCString();v.set(I.lastSessionDateStorageKey,typeof l=="undefined"?null:l),v.set(I.currentSessionDateStorageKey,c)}}e.GlobalStorageMain=t,t.STORAGE_NAME="state.vscdb";class h extends m{constructor(v,y,u,l){super(u);this.workspace=v,this.options=y,this.environmentService=l}async doCreate(){const{storageFilePath:v,wasCreated:y}=await this.prepareWorkspaceStorageFolder();return new b.Storage(new d.SQLiteStorageDatabase(v,{logging:this.createLoggingOptions()}),{hint:y?b.StorageHint.STORAGE_DOES_NOT_EXIST:void 0})}async prepareWorkspaceStorageFolder(){if(this.options.useInMemoryStorage)return{storageFilePath:d.SQLiteStorageDatabase.IN_MEMORY_PATH,wasCreated:!0};const v=(0,D.join)(this.environmentService.workspaceStorageHome.fsPath,this.workspace.id),y=(0,D.join)(v,h.WORKSPACE_STORAGE_NAME);return await P.Promises.exists(v)?{storageFilePath:y,wasCreated:!1}:(await P.Promises.mkdir(v,{recursive:!0}),this.ensureWorkspaceStorageFolderMeta(v),{storageFilePath:y,wasCreated:!0})}async ensureWorkspaceStorageFolderMeta(v){let y;if((0,S.isSingleFolderWorkspaceIdentifier)(this.workspace)?y={folder:this.workspace.uri.toString()}:(0,S.isWorkspaceIdentifier)(this.workspace)&&(y={workspace:this.workspace.configPath.toString()}),y)try{const u=(0,D.join)(v,h.WORKSPACE_META_NAME);await P.Promises.exists(u)||await P.Promises.writeFile(u,JSON.stringify(y,void 0,2))}catch(u){this.logService.error(`StorageMain#ensureWorkspaceStorageFolderMeta(): Unable to create workspace storage metadata due to ${u}`)}}}e.WorkspaceStorageMain=h,h.WORKSPACE_STORAGE_NAME="state.vscdb",h.WORKSPACE_META_NAME="workspace.json"}),define(Q[99],J([0,1,42,2,48,5,22,6,216]),function(j,e,p,L,D,M,P,b,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageMainService=e.IStorageMainService=void 0,e.IStorageMainService=(0,M.createDecorator)("storageMainService");let g=class extends L.Disposable{constructor(I,S,m){super();this.logService=I,this.environmentService=S,this.lifecycleMainService=m,this.globalStorage=this.createGlobalStorage(),this.mapWorkspaceToStorage=new Map,this.registerListeners()}getStorageOptions(){return{useInMemoryStorage:!!this.environmentService.extensionTestsLocationURI}}registerListeners(){(async()=>{await this.lifecycleMainService.when(3),this.globalStorage.init()})(),this._register(this.lifecycleMainService.onWillLoadWindow(async I=>{I.workspace&&this.workspaceStorage(I.workspace).init()})),this._register(this.lifecycleMainService.onWillShutdown(I=>{I.join(this.globalStorage.close());for(const[,S]of this.mapWorkspaceToStorage)I.join(S.close())}))}createGlobalStorage(){if(this.globalStorage)return this.globalStorage;this.logService.trace("StorageMainService: creating global storage");const I=new d.GlobalStorageMain(this.getStorageOptions(),this.logService,this.environmentService);return(0,p.once)(I.onDidCloseStorage)(()=>{this.logService.trace("StorageMainService: closed global storage")}),I}createWorkspaceStorage(I){return new d.WorkspaceStorageMain(I,this.getStorageOptions(),this.logService,this.environmentService)}workspaceStorage(I){let S=this.mapWorkspaceToStorage.get(I.id);return S||(this.logService.trace(`StorageMainService: creating workspace storage (${I.id})`),S=this.createWorkspaceStorage(I),this.mapWorkspaceToStorage.set(I.id,S),(0,p.once)(S.onDidCloseStorage)(()=>{this.logService.trace(`StorageMainService: closed workspace storage (${I.id})`),this.mapWorkspaceToStorage.delete(I.id)})),S}};g=he([te(0,b.ILogService),te(1,D.IEnvironmentService),te(2,P.ILifecycleMainService)],g),e.StorageMainService=g}),define(Q[100],J([0,1,15,7,26]),function(j,e,p,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findWindowOnExtensionDevelopmentPath=e.findWindowOnWorkspaceOrFolder=e.findWindowOnFile=void 0;function M(d,g,i){for(const S of d){const m=S.openedWorkspace;if((0,D.isWorkspaceIdentifier)(m)){const t=i(m);if(t){if(t.folders.some(h=>p.extUriBiasedIgnorePathCase.isEqualOrParent(g,h.uri)))return S}else if(p.extUriBiasedIgnorePathCase.isEqualOrParent(g,m.configPath))return S}}const I=d.filter(S=>(0,D.isSingleFolderWorkspaceIdentifier)(S.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqualOrParent(g,S.openedWorkspace.uri));if(I.length)return I.sort((S,m)=>-(S.openedWorkspace.uri.path.length-m.openedWorkspace.uri.path.length))[0]}e.findWindowOnFile=M;function P(d,g){for(const i of d)if((0,D.isWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.configPath,g)||(0,D.isSingleFolderWorkspaceIdentifier)(i.openedWorkspace)&&p.extUriBiasedIgnorePathCase.isEqual(i.openedWorkspace.uri,g))return i}e.findWindowOnWorkspaceOrFolder=P;function b(d,g){const i=I=>g.some(S=>p.extUriBiasedIgnorePathCase.isEqual(L.URI.file(S),L.URI.file(I)));for(const I of d)if(I.config?.extensionDevelopmentPath?.some(S=>i(S)))return I}e.findWindowOnExtensionDevelopmentPath=b}),define(Q[217],J([0,1,13,2,3,15,7,17,22,6,38,36,26]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getWindowsStateStoreData=e.restoreWindowsState=e.WindowsStateHandler=void 0;let m=class wt extends L.Disposable{constructor(u,l,c,n,o){super();this.windowsMainService=u,this.stateMainService=l,this.lifecycleMainService=c,this.logService=n,this.configurationService=o,this._state=t(this.stateMainService.getItem(wt.windowsStateStorageKey)),this.lastClosedState=void 0,this.shuttingDown=!1,this.registerListeners()}get state(){return this._state}registerListeners(){p.app.on("browser-window-blur",()=>{this.shuttingDown||this.saveWindowsState()}),this.lifecycleMainService.onBeforeCloseWindow(u=>this.onBeforeCloseWindow(u)),this.lifecycleMainService.onBeforeShutdown(()=>this.onBeforeShutdown()),this.windowsMainService.onDidChangeWindowsCount(u=>{u.newCount-u.oldCount>0&&(this.lastClosedState=void 0)}),this.windowsMainService.onDidDestroyWindow(u=>this.onBeforeCloseWindow(u))}onBeforeShutdown(){this.shuttingDown=!0,this.saveWindowsState()}saveWindowsState(){const u={openedWindows:[],lastPluginDevelopmentHostWindow:this._state.lastPluginDevelopmentHostWindow,lastActiveWindow:this.lastClosedState};if(!u.lastActiveWindow){let n=this.windowsMainService.getLastActiveWindow();(!n||n.isExtensionDevelopmentHost)&&(n=this.windowsMainService.getWindows().find(o=>!o.isExtensionDevelopmentHost)),n&&(u.lastActiveWindow=this.toWindowState(n))}const l=this.windowsMainService.getWindows().find(n=>n.isExtensionDevelopmentHost&&!n.isExtensionTestHost);l&&(u.lastPluginDevelopmentHostWindow=this.toWindowState(l)),this.windowsMainService.getWindowCount()>1&&(u.openedWindows=this.windowsMainService.getWindows().filter(n=>!n.isExtensionDevelopmentHost).map(n=>this.toWindowState(n)));const c=E(u);this.stateMainService.setItem(wt.windowsStateStorageKey,c),this.shuttingDown&&this.logService.trace("[WindowsStateHandler] onBeforeShutdown",c)}onBeforeCloseWindow(u){if(this.lifecycleMainService.quitRequested)return;const l=this.toWindowState(u);u.isExtensionDevelopmentHost&&!u.isExtensionTestHost?this._state.lastPluginDevelopmentHostWindow=l:!u.isExtensionDevelopmentHost&&u.openedWorkspace&&this._state.openedWindows.forEach(c=>{const n=(0,S.isWorkspaceIdentifier)(u.openedWorkspace)&&c.workspace?.id===u.openedWorkspace.id,o=(0,S.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)&&c.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(c.folderUri,u.openedWorkspace.uri);(n||o)&&(c.uiState=l.uiState)}),this.windowsMainService.getWindowCount()===1&&(this.lastClosedState=l)}toWindowState(u){return{workspace:(0,S.isWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace:void 0,folderUri:(0,S.isSingleFolderWorkspaceIdentifier)(u.openedWorkspace)?u.openedWorkspace.uri:void 0,backupPath:u.backupPath,remoteAuthority:u.remoteAuthority,uiState:u.serializeWindowState()}}getNewWindowState(u){const l=this.doGetNewWindowState(u),c=this.configurationService.getValue("window");let n;return l.hasDefaultState?n=!!(c?.newWindowDimensions&&["fullscreen","inherit","offset"].indexOf(c.newWindowDimensions)>=0):(n=!!(this.lifecycleMainService.wasRestarted||c?.restoreFullscreen),n&&D.isMacintosh&&this.windowsMainService.getWindows().some(o=>o.isFullScreen)&&(n=!1)),l.mode===3&&!n&&(l.mode=1),l}doGetNewWindowState(u){const l=this.windowsMainService.getLastActiveWindow();if(!u.extensionTestsPath){if(!!u.extensionDevelopmentPath&&this.state.lastPluginDevelopmentHostWindow)return this.state.lastPluginDevelopmentHostWindow.uiState;const a=u.workspace;if((0,S.isWorkspaceIdentifier)(a)){const w=this.state.openedWindows.filter(k=>k.workspace&&k.workspace.id===a.id).map(k=>k.uiState);if(w.length)return w[0]}if((0,S.isSingleFolderWorkspaceIdentifier)(a)){const w=this.state.openedWindows.filter(k=>k.folderUri&&M.extUriBiasedIgnorePathCase.isEqual(k.folderUri,a.uri)).map(k=>k.uiState);if(w.length)return w[0]}else if(u.backupPath){const w=this.state.openedWindows.filter(k=>k.backupPath===u.backupPath).map(k=>k.uiState);if(w.length)return w[0]}const f=this.lastClosedState||this.state.lastActiveWindow;if(!l&&f)return f.uiState}let c;const n=p.screen.getAllDisplays();if(n.length===1)c=n[0];else{if(D.isMacintosh){const a=p.screen.getCursorScreenPoint();c=p.screen.getDisplayNearestPoint(a)}!c&&l&&(c=p.screen.getDisplayMatching(l.getBounds())),c||(c=p.screen.getPrimaryDisplay()||n[0])}let o=(0,I.defaultWindowState)();o.x=Math.round(c.bounds.x+c.bounds.width/2-o.width/2),o.y=Math.round(c.bounds.y+c.bounds.height/2-o.height/2);const s=this.configurationService.getValue("window");let r=!0;if(s?.newWindowDimensions){if(s.newWindowDimensions==="maximized")o.mode=0,r=!1;else if(s.newWindowDimensions==="fullscreen")o.mode=3,r=!1;else if((s.newWindowDimensions==="inherit"||s.newWindowDimensions==="offset")&&l){const a=l.serializeWindowState();a.mode===3?o.mode=3:o=a,r=o.mode!==3&&s.newWindowDimensions==="offset"}}return r&&(o=this.ensureNoOverlap(o)),o.hasDefaultState=!0,o}ensureNoOverlap(u){if(this.windowsMainService.getWindows().length===0)return u;u.x=typeof u.x=="number"?u.x:0,u.y=typeof u.y=="number"?u.y:0;const l=this.windowsMainService.getWindows().map(c=>c.getBounds());for(;l.some(c=>c.x===u.x||c.y===u.y);)u.x+=30,u.y+=30;return u}};m.windowsStateStorageKey="windowsState",m=he([te(0,I.IWindowsMainService),te(1,i.IStateMainService),te(2,d.ILifecycleMainService),te(3,g.ILogService),te(4,b.IConfigurationService)],m),e.WindowsStateHandler=m;function t(y){const u={openedWindows:[]},l=y||{openedWindows:[]};return l.lastActiveWindow&&(u.lastActiveWindow=h(l.lastActiveWindow)),l.lastPluginDevelopmentHostWindow&&(u.lastPluginDevelopmentHostWindow=h(l.lastPluginDevelopmentHostWindow)),Array.isArray(l.openedWindows)&&(u.openedWindows=l.openedWindows.map(c=>h(c))),u}e.restoreWindowsState=t;function h(y){const u={uiState:y.uiState};return y.backupPath&&(u.backupPath=y.backupPath),y.remoteAuthority&&(u.remoteAuthority=y.remoteAuthority),y.folder&&(u.folderUri=P.URI.parse(y.folder)),y.workspaceIdentifier&&(u.workspace={id:y.workspaceIdentifier.id,configPath:P.URI.parse(y.workspaceIdentifier.configURIPath)}),u}function E(y){return{lastActiveWindow:y.lastActiveWindow&&v(y.lastActiveWindow),lastPluginDevelopmentHostWindow:y.lastPluginDevelopmentHostWindow&&v(y.lastPluginDevelopmentHostWindow),openedWindows:y.openedWindows.map(u=>v(u))}}e.getWindowsStateStoreData=E;function v(y){return{workspaceIdentifier:y.workspace&&{id:y.workspace.id,configURIPath:y.workspace.configPath.toString()},folder:y.folderUri&&y.folderUri.toString(),backupPath:y.backupPath,remoteAuthority:y.remoteAuthority,uiState:y.uiState}}}),define(Q[101],J([0,1,60,31,10,3,15]),function(j,e,p,L,D,M,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingleFolderWorkspaceIdentifier=e.getWorkspaceIdentifier=void 0;function b(g){function i(){let I=g.scheme===D.Schemas.file?(0,P.originalFSPath)(g):g.toString();return M.isLinux||(I=I.toLowerCase()),(0,p.createHash)("md5").update(I).digest("hex")}return{id:i(),configPath:g}}e.getWorkspaceIdentifier=b;function d(g,i){function I(){if(g.scheme!==D.Schemas.file)return(0,p.createHash)("md5").update(g.toString()).digest("hex");if(!i)try{i=(0,L.statSync)(g.fsPath)}catch(t){return}let m;return M.isLinux?m=i.ino:M.isMacintosh?m=i.birthtime.getTime():M.isWindows&&(typeof i.birthtimeMs=="number"?m=Math.floor(i.birthtimeMs):m=i.birthtime.getTime()),(0,p.createHash)("md5").update(g.fsPath).update(m?String(m):"").digest("hex")}const S=I();if(typeof S=="string")return{id:S,uri:g}}e.getSingleFolderWorkspaceIdentifier=d}),define(Q[57],J([0,1,60,61,25,16,18,4,2,8,3,28,35,85,218]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;class h{constructor(w){this.socket=w,this._errorListener=k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}},this.socket.on("error",this._errorListener)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(w){const k=R=>w(M.VSBuffer.wrap(R));return this.socket.on("data",k),{dispose:()=>this.socket.off("data",k)}}onClose(w){const k=R=>{w({type:0,hadError:R,error:void 0})};return this.socket.on("close",k),{dispose:()=>this.socket.off("close",k)}}onEnd(w){return this.socket.on("end",w),{dispose:()=>this.socket.off("end",w)}}write(w){if(!this.socket.destroyed)try{this.socket.write(w.buffer,k=>{if(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}})}catch(k){if(k.code==="EPIPE")return;(0,P.onUnexpectedError)(k)}}end(){this.socket.end()}drain(){return new Promise((w,k)=>{if(this.socket.bufferSize===0){w();return}const R=()=>{this.socket.off("close",R),this.socket.off("end",R),this.socket.off("error",R),this.socket.off("timeout",R),this.socket.off("drain",R),w()};this.socket.on("close",R),this.socket.on("end",R),this.socket.on("error",R),this.socket.on("timeout",R),this.socket.on("drain",R)})}}e.NodeSocket=h;var E;(function(f){f[f.MinHeaderByteSize=2]="MinHeaderByteSize"})(E||(E={}));var v;(function(f){f[f.PeekHeader=1]="PeekHeader",f[f.ReadHeader=2]="ReadHeader",f[f.ReadBody=3]="ReadBody",f[f.Fin=4]="Fin"})(v||(v={}));class y extends d.Disposable{constructor(w,k,R,A){super();this._onDidZlibFlush=this._register(new b.Emitter),this._recordedInflateBytes=[],this._pendingInflateData=[],this._pendingDeflateData=[],this._onData=this._register(new b.Emitter),this._onClose=this._register(new b.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=w,this._totalIncomingWireBytes=0,this._totalIncomingDataBytes=0,this._totalOutgoingWireBytes=0,this._totalOutgoingDataBytes=0,this.permessageDeflate=k,this._recordInflateBytes=A,k?(this._zlibInflate=t.createInflateRaw({windowBits:15}),this._zlibInflate.on("error",O=>{console.error(O),(0,P.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibInflate.on("data",O=>{this._pendingInflateData.push(O)}),R&&(this._zlibInflate.write(R.buffer),this._zlibInflate.flush(()=>{this._pendingInflateData.length=0})),this._zlibDeflate=t.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",O=>{console.error(O),(0,P.onUnexpectedError)(O),this._onClose.fire({type:0,hadError:!0,error:O})}),this._zlibDeflate.on("data",O=>{this._pendingDeflateData.push(O)})):(this._zlibInflate=null,this._zlibDeflate=null),this._zlibDeflateFlushWaitingCount=0,this._incomingData=new m.ChunkStream,this._register(this.socket.onData(O=>this._acceptChunk(O))),this._register(this.socket.onClose(O=>this._onClose.fire(O)))}get totalIncomingWireBytes(){return this._totalIncomingWireBytes}get totalIncomingDataBytes(){return this._totalIncomingDataBytes}get totalOutgoingWireBytes(){return this._totalOutgoingWireBytes}get totalOutgoingDataBytes(){return this._totalOutgoingDataBytes}get recordedInflateBytes(){return this._recordInflateBytes?M.VSBuffer.wrap(Buffer.concat(this._recordedInflateBytes)):M.VSBuffer.alloc(0)}dispose(){this._zlibDeflateFlushWaitingCount>0?this._register(this._onDidZlibFlush.event(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(w){return this._onData.event(w)}onClose(w){return this._onClose.event(w)}onEnd(w){return this.socket.onEnd(w)}write(w){this._totalOutgoingDataBytes+=w.byteLength,this._zlibDeflate?(this._zlibDeflate.write(w.buffer),this._zlibDeflateFlushWaitingCount++,this._zlibDeflate.flush(2,()=>{this._zlibDeflateFlushWaitingCount--;let k=Buffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,k=k.slice(0,k.length-4),this._isEnded||this._write(M.VSBuffer.wrap(k),!0),this._zlibDeflateFlushWaitingCount===0&&this._onDidZlibFlush.fire()})):this._write(w,!1)}_write(w,k){let R=2;w.byteLength<126?R+=0:w.byteLength<2**16?R+=2:R+=8;const A=M.VSBuffer.alloc(R);if(k?A.writeUInt8(194,0):A.writeUInt8(130,0),w.byteLength<126)A.writeUInt8(w.byteLength,1);else if(w.byteLength<2**16){A.writeUInt8(126,1);let O=1;A.writeUInt8(w.byteLength>>>8&255,++O),A.writeUInt8(w.byteLength>>>0&255,++O)}else{A.writeUInt8(127,1);let O=1;A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(0,++O),A.writeUInt8(w.byteLength>>>24&255,++O),A.writeUInt8(w.byteLength>>>16&255,++O),A.writeUInt8(w.byteLength>>>8&255,++O),A.writeUInt8(w.byteLength>>>0&255,++O)}this._totalOutgoingWireBytes+=A.byteLength+w.byteLength,this.socket.write(M.VSBuffer.concat([A,w]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(w){if(w.byteLength!==0){for(this._totalIncomingWireBytes+=w.byteLength,this._incomingData.acceptChunk(w);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const k=this._incomingData.peek(this._state.readLen),R=k.readUInt8(0),A=(R&128)>>>7,O=(R&64)>>>6,H=k.readUInt8(1),x=(H&128)>>>7,re=H&127;this._state.state=2,this._state.readLen=2+(x?4:0)+(re===126?2:0)+(re===127?8:0),this._state.fin=A,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(O)),this._state.firstFrameOfMessage=Boolean(A),this._state.mask=0}else if(this._state.state===2){const k=this._incomingData.read(this._state.readLen),R=k.readUInt8(1),A=(R&128)>>>7;let O=R&127,H=1;O===126?O=k.readUInt8(++H)*2**8+k.readUInt8(++H):O===127&&(O=k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*0+k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H));let x=0;A&&(x=k.readUInt8(++H)*2**24+k.readUInt8(++H)*2**16+k.readUInt8(++H)*2**8+k.readUInt8(++H)),this._state.state=3,this._state.readLen=O,this._state.mask=x}else if(this._state.state===3){const k=this._incomingData.read(this._state.readLen);u(k,this._state.mask),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._zlibInflate&&this._state.compressed?(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from(k.buffer)),this._zlibInflate.write(k.buffer),this._state.fin&&(this._recordInflateBytes&&this._recordedInflateBytes.push(Buffer.from([0,0,255,255])),this._zlibInflate.write(Buffer.from([0,0,255,255]))),this._zlibInflate.flush(()=>{const R=Buffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,this._totalIncomingDataBytes+=R.length,this._onData.fire(M.VSBuffer.wrap(R))})):(this._totalIncomingDataBytes+=k.byteLength,this._onData.fire(k))}}}async drain(){this._zlibDeflateFlushWaitingCount>0&&await b.Event.toPromise(this._onDidZlibFlush.event),await this.socket.drain()}}e.WebSocketNodeSocket=y;function u(f,w){if(w===0)return;let k=f.byteLength>>>2;for(let re=0;re<k;re++){const K=f.readUInt32BE(re*4);f.writeUInt32BE(K^w,re*4)}let R=k*4,A=f.byteLength-R;const O=w>>>24&255,H=w>>>16&255,x=w>>>8&255;A>=1&&f.writeUInt8(f.readUInt8(R)^O,R),A>=2&&f.writeUInt8(f.readUInt8(R+1)^H,R+1),A>=3&&f.writeUInt8(f.readUInt8(R+2)^x,R+2)}e.XDG_RUNTIME_DIR=process.env.XDG_RUNTIME_DIR;const l={[2]:107,[1]:103};function c(){const f=(0,I.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${f}-sock`;let w;return e.XDG_RUNTIME_DIR?w=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${f}.sock`):w=(0,g.join)((0,D.tmpdir)(),`vscode-ipc-${f}.sock`),o(w),w}e.createRandomIPCHandle=c;function n(f,w,k){const R=(0,p.createHash)("md5").update(f).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${R}-${k}-${w}-sock`;let A;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?A=(0,g.join)(e.XDG_RUNTIME_DIR,`vscode-${R.substr(0,8)}-${k}-${w}.sock`):A=(0,g.join)(f,`${k}-${w}.sock`),o(A),A}e.createStaticIPCHandle=n;function o(f){const w=l[i.platform];typeof w=="number"&&f.length>=w&&console.warn(`WARNING: IPC handle "${f}" is longer than ${w} chars, try a shorter --user-data-dir`)}class s extends S.IPCServer{constructor(w){super(s.toClientConnectionEvent(w));this.server=w}static toClientConnectionEvent(w){const k=b.Event.fromNodeEventEmitter(w,"connection");return b.Event.map(k,R=>({protocol:new m.Protocol(new h(R)),onDidClientDisconnect:b.Event.once(b.Event.fromNodeEventEmitter(R,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=s;function r(f){return new Promise((w,k)=>{const R=(0,L.createServer)();R.on("error",k),R.listen(f,()=>{R.removeListener("error",k),w(new s(R))})})}e.serve=r;function a(f,w){return new Promise((k,R)=>{const A=(0,L.createConnection)(f,()=>{A.removeListener("error",R),k(m.Client.fromSocket(new h(A),w))});A.once("error",R)})}e.connect=a}),define(Q[219],J([0,1,57]),function(j,e,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.WindowDriverRegistryChannel=e.DriverChannelClient=e.DriverChannel=void 0;class L{constructor(d){this.driver=d}listen(d,g){throw new Error("No event found")}call(d,g,i){switch(g){case"getWindowIds":return this.driver.getWindowIds();case"capturePage":return this.driver.capturePage(i);case"reloadWindow":return this.driver.reloadWindow(i);case"exitApplication":return this.driver.exitApplication();case"dispatchKeybinding":return this.driver.dispatchKeybinding(i[0],i[1]);case"click":return this.driver.click(i[0],i[1],i[2],i[3]);case"doubleClick":return this.driver.doubleClick(i[0],i[1]);case"setValue":return this.driver.setValue(i[0],i[1],i[2]);case"getTitle":return this.driver.getTitle(i[0]);case"isActiveElement":return this.driver.isActiveElement(i[0],i[1]);case"getElements":return this.driver.getElements(i[0],i[1],i[2]);case"getElementXY":return this.driver.getElementXY(i[0],i[1],i[2]);case"typeInEditor":return this.driver.typeInEditor(i[0],i[1],i[2]);case"getTerminalBuffer":return this.driver.getTerminalBuffer(i[0],i[1]);case"writeInTerminal":return this.driver.writeInTerminal(i[0],i[1],i[2]);case"getLocaleInfo":return this.driver.getLocaleInfo(i);case"getLocalizedStrings":return this.driver.getLocalizedStrings(i)}throw new Error(`Call not found: ${g}`)}}e.DriverChannel=L;class D{constructor(d){this.channel=d}getWindowIds(){return this.channel.call("getWindowIds")}capturePage(d){return this.channel.call("capturePage",d)}reloadWindow(d){return this.channel.call("reloadWindow",d)}exitApplication(){return this.channel.call("exitApplication")}dispatchKeybinding(d,g){return this.channel.call("dispatchKeybinding",[d,g])}click(d,g,i,I){return this.channel.call("click",[d,g,i,I])}doubleClick(d,g){return this.channel.call("doubleClick",[d,g])}setValue(d,g,i){return this.channel.call("setValue",[d,g,i])}getTitle(d){return this.channel.call("getTitle",[d])}isActiveElement(d,g){return this.channel.call("isActiveElement",[d,g])}getElements(d,g,i){return this.channel.call("getElements",[d,g,i])}getElementXY(d,g,i,I){return this.channel.call("getElementXY",[d,g,i,I])}typeInEditor(d,g,i){return this.channel.call("typeInEditor",[d,g,i])}getTerminalBuffer(d,g){return this.channel.call("getTerminalBuffer",[d,g])}writeInTerminal(d,g,i){return this.channel.call("writeInTerminal",[d,g,i])}getLocaleInfo(d){return this.channel.call("getLocaleInfo",d)}getLocalizedStrings(d){return this.channel.call("getLocalizedStrings",d)}}e.DriverChannelClient=D;class M{constructor(d){this.registry=d}listen(d,g){throw new Error(`Event not found: ${g}`)}call(d,g,i){switch(g){case"registerWindowDriver":return this.registry.registerWindowDriver(i);case"reloadWindowDriver":return this.registry.reloadWindowDriver(i)}throw new Error(`Call not found: ${g}`)}}e.WindowDriverRegistryChannel=M;async function P(b){const d=await(0,p.connect)(b,"driverClient"),g=d.getChannel("driver"),i=new D(g);return{client:d,driver:i}}e.connect=P}),define(Q[220],J([0,1,9,4,105,58,2,3,35,57,157,219,176,22,36]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.serve=e.Driver=void 0;function h(y){return y<21}let E=class{constructor(u,l,c,n){this.windowServer=u,this.options=l,this.windowsMainService=c,this.lifecycleMainService=n,this.registeredWindowIds=new Set,this.reloadingWindowIds=new Set,this.onDidReloadingChange=new L.Emitter}async registerWindowDriver(u){return this.registeredWindowIds.add(u),this.reloadingWindowIds.delete(u),this.onDidReloadingChange.fire(),this.options}async reloadWindowDriver(u){this.reloadingWindowIds.add(u)}async getWindowIds(){return this.windowsMainService.getWindows().map(u=>u.id).filter(u=>this.registeredWindowIds.has(u)&&!this.reloadingWindowIds.has(u))}async capturePage(u){await this.whenUnfrozen(u);const l=this.windowsMainService.getWindowById(u);if(!l?.win)throw new Error("Invalid window");return(await l.win.webContents.capturePage()).toPNG().toString("base64")}async reloadWindow(u){await this.whenUnfrozen(u);const l=this.windowsMainService.getWindowById(u);if(!l)throw new Error("Invalid window");this.reloadingWindowIds.add(u),this.lifecycleMainService.reload(l)}exitApplication(){return this.lifecycleMainService.quit()}async dispatchKeybinding(u,l){await this.whenUnfrozen(u);const c=D.KeybindingParser.parseUserBinding(l);for(let n of c)await this._dispatchKeybinding(u,n)}async _dispatchKeybinding(u,l){if(l instanceof M.ScanCodeBinding)throw new Error("ScanCodeBindings not supported");const c=this.windowsMainService.getWindowById(u);if(!c?.win)throw new Error("Invalid window");const n=c.win.webContents,o=new M.SimpleKeybinding(!1,!1,!1,!1,l.keyCode),r=new S.USLayoutResolvedKeybinding(o.toChord(),b.OS).getElectronAccelerator(),a=[];l.ctrlKey&&a.push("ctrl"),l.metaKey&&a.push("meta"),l.shiftKey&&a.push("shift"),l.altKey&&a.push("alt"),n.sendInputEvent({type:"keyDown",keyCode:r,modifiers:a}),h(l.keyCode)||n.sendInputEvent({type:"char",keyCode:r,modifiers:a}),n.sendInputEvent({type:"keyUp",keyCode:r,modifiers:a}),await(0,p.timeout)(100)}async click(u,l,c,n){await(await this.getWindowDriver(u)).click(l,c,n)}async doubleClick(u,l){await(await this.getWindowDriver(u)).doubleClick(l)}async setValue(u,l,c){await(await this.getWindowDriver(u)).setValue(l,c)}async getTitle(u){return await(await this.getWindowDriver(u)).getTitle()}async isActiveElement(u,l){return await(await this.getWindowDriver(u)).isActiveElement(l)}async getElements(u,l,c){return await(await this.getWindowDriver(u)).getElements(l,c)}async getElementXY(u,l,c,n){return await(await this.getWindowDriver(u)).getElementXY(l,c,n)}async typeInEditor(u,l,c){await(await this.getWindowDriver(u)).typeInEditor(l,c)}async getTerminalBuffer(u,l){return await(await this.getWindowDriver(u)).getTerminalBuffer(l)}async writeInTerminal(u,l,c){await(await this.getWindowDriver(u)).writeInTerminal(l,c)}async getLocaleInfo(u){return await(await this.getWindowDriver(u)).getLocaleInfo()}async getLocalizedStrings(u){return await(await this.getWindowDriver(u)).getLocalizedStrings()}async getWindowDriver(u){await this.whenUnfrozen(u);const l=`window:${u}`,c=new d.StaticRouter(o=>o===l),n=this.windowServer.getChannel("windowDriver",c);return new i.WindowDriverChannelClient(n)}async whenUnfrozen(u){for(;this.reloadingWindowIds.has(u);)await L.Event.toPromise(this.onDidReloadingChange.event)}};E=he([te(2,t.IWindowsMainService),te(3,m.ILifecycleMainService)],E),e.Driver=E;async function v(y,u,l,c){const n=l.driverVerbose,o=c.createInstance(E,y,{verbose:n}),s=new I.WindowDriverRegistryChannel(o);y.registerChannel("windowDriverRegistry",s);const r=await(0,g.serve)(u),a=new I.DriverChannel(o);return r.registerChannel("driver",a),(0,P.combinedDisposable)(r,y)}e.serve=v}),define(Q[24],J([0,1,47,8,57,48,161,5]),function(j,e,p,L,D,M,P,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EnvironmentMainService=e.IEnvironmentMainService=void 0,e.IEnvironmentMainService=(0,b.refineServiceDecorator)(M.IEnvironmentService);class d extends P.NativeEnvironmentService{get cachedLanguagesPath(){return(0,L.join)(this.userDataPath,"clp")}get backupHome(){return(0,L.join)(this.userDataPath,"Backups")}get backupWorkspacesPath(){return(0,L.join)(this.backupHome,"workspaces.json")}get mainIPCHandle(){return(0,D.createStaticIPCHandle)(this.userDataPath,"main",this.productService.version)}get mainLockfile(){return(0,L.join)(this.userDataPath,"code.lock")}get sandbox(){return!!this.args.__sandbox}get driverVerbose(){return!!this.args["driver-verbose"]}get disableUpdates(){return!!this.args["disable-updates"]}get disableKeytar(){return!!this.args["disable-keytar"]}get codeCachePath(){return process.env.VSCODE_CODE_CACHE_PATH||void 0}get useCodeCache(){return!!this.codeCachePath}}he([p.memoize],d.prototype,"cachedLanguagesPath",null),he([p.memoize],d.prototype,"backupHome",null),he([p.memoize],d.prototype,"backupWorkspacesPath",null),he([p.memoize],d.prototype,"mainIPCHandle",null),he([p.memoize],d.prototype,"mainLockfile",null),he([p.memoize],d.prototype,"sandbox",null),he([p.memoize],d.prototype,"driverVerbose",null),he([p.memoize],d.prototype,"disableUpdates",null),he([p.memoize],d.prototype,"disableKeytar",null),he([p.memoize],d.prototype,"codeCachePath",null),he([p.memoize],d.prototype,"useCodeCache",null),e.EnvironmentMainService=d}),define(Q[221],J([0,1,60,31,33,10,8,3,15,7,19,51,17,24,20,6,26]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BackupMainService=void 0;let v=class{constructor(u,l,c){this.configurationService=l,this.logService=c,this.workspaces=[],this.folders=[],this.emptyWindows=[],this.backupUriComparer=d.extUriBiasedIgnorePathCase,this.backupPathComparer={isEqual:(n,o)=>(0,D.isEqual)(n,o,!b.isLinux)},this.backupHome=u.backupHome,this.workspacesJsonPath=u.backupWorkspacesPath}async initialize(){let u;try{u=JSON.parse(await i.Promises.readFile(this.workspacesJsonPath,"utf8"))}catch(n){u=Object.create(null)}this.emptyWindows=await this.validateEmptyWorkspaces(u.emptyWorkspaceInfos);let l=[];try{Array.isArray(u.rootURIWorkspaces)&&(l=u.rootURIWorkspaces.map(n=>({workspace:{id:n.id,configPath:g.URI.parse(n.configURIPath)},remoteAuthority:n.remoteAuthority})))}catch(n){}this.workspaces=await this.validateWorkspaces(l);let c=[];try{Array.isArray(u.folderURIWorkspaces)&&(c=u.folderURIWorkspaces.map(n=>g.URI.parse(n)))}catch(n){}this.folders=await this.validateFolders(c),await this.save()}getWorkspaceBackups(){return this.isHotExitOnExitAndWindowClose()?[]:this.workspaces.slice(0)}getFolderBackupPaths(){return this.isHotExitOnExitAndWindowClose()?[]:this.folders.slice(0)}isHotExitEnabled(){return this.getHotExitConfig()!==t.HotExitConfiguration.OFF}isHotExitOnExitAndWindowClose(){return this.getHotExitConfig()===t.HotExitConfiguration.ON_EXIT_AND_WINDOW_CLOSE}getHotExitConfig(){return this.configurationService.getValue()?.files?.hotExit||t.HotExitConfiguration.ON_EXIT}getEmptyWindowBackupPaths(){return this.emptyWindows.slice(0)}registerWorkspaceBackupSync(u,l){this.workspaces.some(n=>u.workspace.id===n.workspace.id)||(this.workspaces.push(u),this.saveSync());const c=this.getBackupPath(u.workspace.id);return l&&this.moveBackupFolderSync(c,l),c}moveBackupFolderSync(u,l){if(L.existsSync(u)&&this.convertToEmptyWindowBackupSync(u),L.existsSync(l))try{L.renameSync(l,u)}catch(c){this.logService.error(`Backup: Could not move backup folder to new location: ${c.toString()}`)}}unregisterWorkspaceBackupSync(u){const l=u.id,c=this.workspaces.findIndex(n=>n.workspace.id===l);c!==-1&&(this.workspaces.splice(c,1),this.saveSync())}registerFolderBackupSync(u){return this.folders.some(l=>this.backupUriComparer.isEqual(u,l))||(this.folders.push(u),this.saveSync()),this.getBackupPath(this.getFolderHash(u))}unregisterFolderBackupSync(u){const l=this.folders.findIndex(c=>this.backupUriComparer.isEqual(u,c));l!==-1&&(this.folders.splice(l,1),this.saveSync())}registerEmptyWindowBackupSync(u,l){const c=u||this.getRandomEmptyWindowId();return this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,c))||(this.emptyWindows.push({backupFolder:c,remoteAuthority:l}),this.saveSync()),this.getBackupPath(c)}unregisterEmptyWindowBackupSync(u){const l=this.emptyWindows.findIndex(c=>!!c.backupFolder&&this.backupPathComparer.isEqual(c.backupFolder,u));l!==-1&&(this.emptyWindows.splice(l,1),this.saveSync())}getBackupPath(u){return(0,P.join)(this.backupHome,u)}async validateWorkspaces(u){if(!Array.isArray(u))return[];const l=new Set,c=[];for(let n of u){const o=n.workspace;if(!(0,E.isWorkspaceIdentifier)(o))return[];if(!l.has(o.id)){l.add(o.id);const s=this.getBackupPath(o.id);await this.doHasBackups(s)?o.configPath.scheme!==M.Schemas.file||await i.Promises.exists(o.configPath.fsPath)?c.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return c}async validateFolders(u){if(!Array.isArray(u))return[];const l=[],c=new Set;for(let n of u){const o=this.backupUriComparer.getComparisonKey(n);if(!c.has(o)){c.add(o);const s=this.getBackupPath(this.getFolderHash(n));await this.doHasBackups(s)?n.scheme!==M.Schemas.file||await i.Promises.exists(n.fsPath)?l.push(n):await this.convertToEmptyWindowBackup(s):await this.deleteStaleBackup(s)}}return l}async validateEmptyWorkspaces(u){if(!Array.isArray(u))return[];const l=[],c=new Set;for(let n of u){const o=n.backupFolder;if(typeof o!="string")return[];if(!c.has(o)){c.add(o);const s=this.getBackupPath(o);await this.doHasBackups(s)?l.push(n):await this.deleteStaleBackup(s)}}return l}async deleteStaleBackup(u){try{await i.Promises.exists(u)&&await i.Promises.rm(u,i.RimRafMode.MOVE)}catch(l){this.logService.error(`Backup: Could not delete stale backup: ${l.toString()}`)}}async convertToEmptyWindowBackup(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,l));)l=this.getRandomEmptyWindowId();const c=this.getBackupPath(l);try{await i.Promises.rename(u,c)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}convertToEmptyWindowBackupSync(u){let l=this.getRandomEmptyWindowId();for(;this.emptyWindows.some(n=>!!n.backupFolder&&this.backupPathComparer.isEqual(n.backupFolder,l));)l=this.getRandomEmptyWindowId();const c=this.getBackupPath(l);try{L.renameSync(u,c)}catch(n){return this.logService.error(`Backup: Could not rename backup folder: ${n.toString()}`),!1}return this.emptyWindows.push({backupFolder:l}),!0}async getDirtyWorkspaces(){const u=[];for(const l of this.workspaces)await this.hasBackups(l)&&u.push(l.workspace);for(const l of this.folders)await this.hasBackups(l)&&u.push(l);return u}hasBackups(u){let l;return g.URI.isUri(u)?l=this.getBackupPath(this.getFolderHash(u)):(0,I.isWorkspaceBackupInfo)(u)?l=this.getBackupPath(u.workspace.id):l=u.backupFolder,this.doHasBackups(l)}async doHasBackups(u){try{const l=await i.Promises.readdir(u);for(const c of l)try{if((await i.Promises.readdir((0,P.join)(u,c))).length>0)return!0}catch(n){}}catch(l){}return!1}saveSync(){try{(0,i.writeFileSync)(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}async save(){try{await i.Promises.writeFile(this.workspacesJsonPath,JSON.stringify(this.serializeBackups()))}catch(u){this.logService.error(`Backup: Could not save workspaces.json: ${u.toString()}`)}}serializeBackups(){return{rootURIWorkspaces:this.workspaces.map(u=>({id:u.workspace.id,configURIPath:u.workspace.configPath.toString(),remoteAuthority:u.remoteAuthority})),folderURIWorkspaces:this.folders.map(u=>u.toString()),emptyWorkspaceInfos:this.emptyWindows}}getRandomEmptyWindowId(){return(Date.now()+Math.round(Math.random()*1e3)).toString()}getFolderHash(u){let l;return u.scheme===M.Schemas.file?l=b.isLinux?u.fsPath:u.fsPath.toLowerCase():l=u.toString().toLowerCase(),(0,p.createHash)("md5").update(l).digest("hex")}};v=he([te(0,m.IEnvironmentMainService),te(1,S.IConfigurationService),te(2,h.ILogService)],v),e.BackupMainService=v}),define(Q[222],J([0,1,61,57]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(D,M,P,b){const d=i=>b(i,void 0),g=p.createConnection({host:D,port:M},()=>{g.removeListener("error",d);const i=Buffer.alloc(16);for(let t=0;t<16;t++)i[t]=Math.round(Math.random()*256);const I=i.toString("base64");let S=[`GET ws://${/:/.test(D)?`[${D}]`:D}:${M}/?${P}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${I}`];g.write(S.join(`\r
`)+`\r
\r
`);const m=t=>{t.toString().indexOf(`\r
\r
`)>=0&&(g.off("data",m),b(void 0,new L.NodeSocket(g)))};g.on("data",m)});g.once("error",d)}}}),define(Q[223],J([0,1,61,115,222,9,2,17,6,21,190,96,77]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TunnelService=e.BaseTunnelService=void 0;async function m(v,y,u,l,c){return new t(v,y,u,l,c).waitForReady()}class t extends P.Disposable{constructor(y,u,l,c,n){super();this.defaultTunnelHost=u,this.suggestedLocalPort=n,this.privacy=I.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=y,this._server=p.createServer(),this._barrier=new M.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=o=>this._onConnection(o),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=c,this.tunnelRemoteHost=l}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(u=>{u()})}async waitForReady(){let y=await(0,L.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),u=null;return this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address(),u||(y=0,this._server.listen(y,this.defaultTunnelHost),await this._barrier.wait(),u=this._server.address()),this.tunnelLocalPort=u.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${u.port}`,this}async _onConnection(y){y.pause();const u=(0,I.isLocalhost)(this.tunnelRemoteHost)||(0,I.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,l=await(0,i.connectRemoteAgentTunnel)(this._options,u,this.tunnelRemotePort),c=l.getSocket().socket,n=l.readEntireBuffer();l.dispose(),n.byteLength>0&&y.write(n.buffer),y.on("end",()=>{this._socketsDispose.delete(y.localAddress),c.end()}),y.on("close",()=>c.end()),y.on("error",()=>{this._socketsDispose.delete(y.localAddress),c.destroy()}),c.on("end",()=>y.end()),c.on("close",()=>y.end()),c.on("error",()=>{y.destroy()}),y.pipe(c),c.pipe(y),this._socketsDispose.set(y.localAddress,()=>{y.end(),c.end()})}}let h=class extends I.AbstractTunnelService{constructor(y,u,l,c,n){super(u);this.socketFactory=y,this.signService=l,this.productService=c,this.configurationService=n}get defaultTunnelHost(){return this.configurationService.getValue("remote.localPortHost")==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(y,u,l,c,n,o,s){const r=this.getTunnelFromMap(u,l);if(r)return++r.refcount,r.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,u,l,c,n,o,s);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${u}:${l} on local port ${c}.`);const a={commit:this.productService.commit,socketFactory:this.socketFactory,addressProvider:y,signService:this.signService,logService:this.logService,ipcLogger:null},f=m(a,this.defaultTunnelHost,u,l,c);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(u,l,f),f}}};h=he([te(1,d.ILogService),te(2,S.ISignService),te(3,g.IProductService),te(4,b.IConfigurationService)],h),e.BaseTunnelService=h;let E=class extends h{constructor(y,u,l,c){super(D.nodeSocketFactory,y,u,l,c)}};E=he([te(0,d.ILogService),te(1,S.ISignService),te(2,g.IProductService),te(3,b.IConfigurationService)],E),e.TunnelService=E}),define(Q[224],J([0,1,194,16,18,2,14,17,48,91,6,193,218]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let m=class extends M.Disposable{constructor(h,E,v){super();this.environmentService=E,this.logService=v,this.configure(h.getValue()),this._register(h.onDidChangeConfiguration(()=>this.configure(h.getValue()),this))}configure(h){this.proxyUrl=h.http&&h.http.proxy,this.strictSSL=!!(h.http&&h.http.proxyStrictSSL),this.authorization=h.http&&h.http.proxyAuthorization}async request(h,E){this.logService.trace("RequestService#request",h.url);const{proxyUrl:v,strictSSL:y}=this;let u;try{u=await(0,g.resolveShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.logService.error("RequestService#request resolving shell environment failed",n)}const l={...process.env,...u},c=h.agent?h.agent:await(0,I.getProxyAgent)(h.url||"",l,{proxyUrl:v,strictSSL:y});return h.agent=c,h.strictSSL=y,this.authorization&&(h.headers={...h.headers||{},"Proxy-Authorization":this.authorization}),this._request(h,E)}async getNodeRequest(h){return((0,p.parse)(h.url).protocol==="https:"?await new Promise((y,u)=>{j(["https"],y,u)}):await new Promise((y,u)=>{j(["http"],y,u)})).request}_request(h,E){return new Promise(async(v,y)=>{let u;const l=(0,p.parse)(h.url),c=h.getRawRequest?h.getRawRequest(h):await this.getNodeRequest(h),n={hostname:l.hostname,port:l.port?parseInt(l.port):l.protocol==="https:"?443:80,protocol:l.protocol,path:l.path,method:h.type||"GET",headers:h.headers,agent:h.agent,rejectUnauthorized:(0,P.isBoolean)(h.strictSSL)?h.strictSSL:!0};h.user&&h.password&&(n.auth=h.user+":"+h.password),u=c(n,o=>{const s=(0,P.isNumber)(h.followRedirects)?h.followRedirects:3;if(o.statusCode&&o.statusCode>=300&&o.statusCode<400&&s>0&&o.headers.location)this._request({...h,url:o.headers.location,followRedirects:s-1},E).then(v,y);else{let r=o;o.headers["content-encoding"]==="gzip"&&(r=o.pipe((0,S.createGunzip)())),v({res:o,stream:(0,L.streamToBufferReadableStream)(r)})}}),u.on("error",y),h.timeout&&u.setTimeout(h.timeout),h.data&&typeof h.data=="string"&&u.write(h.data),u.end(),E.onCancellationRequested(()=>{u.abort(),y((0,D.canceled)())})})}async resolveProxy(h){}};m=he([te(0,b.IConfigurationService),te(1,d.INativeEnvironmentService),te(2,i.ILogService)],m),e.RequestService=m}),define(Q[225],J([0,1,13,224]),function(j,e,p,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestMainService=void 0;function D(P){return p.net.request}class M extends L.RequestService{request(b,d){return super.request({...b||{},getRawRequest:D},d)}}e.RequestMainService=M}),define(Q[226],J([0,1,13,9,4,2,10,14,86,24,22,6,45,56,65]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcess=void 0;let h=class extends M.Disposable{constructor(v,y,u,l,c,n,o){super();this.machineId=v,this.userEnv=y,this.environmentMainService=u,this.lifecycleMainService=l,this.logService=c,this.themeMainService=n,this.protocolMainService=o,this.firstWindowConnectionBarrier=new L.Barrier,this.window=void 0,this.windowCloseListener=void 0,this._onDidError=this._register(new D.Emitter),this.onDidError=D.Event.buffer(this._onDidError.event),this._whenReady=void 0,this._whenIpcReady=void 0,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:createSharedProcessMessageChannel",(v,y)=>this.onWindowConnection(v,y)),p.ipcMain.on("vscode:relaySharedProcessWorkerMessageChannel",(v,y)=>this.onWorkerConnection(v,y)),this._register(this.lifecycleMainService.onWillShutdown(()=>this.onWillShutdown()))}async onWindowConnection(v,y){this.logService.trace("SharedProcess: on vscode:createSharedProcessMessageChannel"),this.firstWindowConnectionBarrier.isOpen()||this.firstWindowConnectionBarrier.open(),await this.whenReady();const u=await this.connect();if(v.sender.isDestroyed())return u.close();v.sender.postMessage("vscode:createSharedProcessMessageChannelResult",y,[u])}onWorkerConnection(v,y){this.logService.trace("SharedProcess: onWorkerConnection",y);const u=new M.DisposableStore,l=n=>{this.logService.trace(`SharedProcess: disposing worker (reason: '${n}')`,y),u.dispose(),this.send("vscode:electron-main->shared-process=disposeWorker",y)},c=p.BrowserWindow.fromId(y.reply.windowId);if(!c||c.isDestroyed()||c.webContents.isDestroyed()||!y.reply.channel){l("unavailable");return}u.add(D.Event.filter(this.lifecycleMainService.onWillLoadWindow,n=>n.window.win===c)(()=>l("load"))),u.add(D.Event.fromNodeEventEmitter(c,"closed")(()=>l("closed"))),c.webContents.postMessage(y.reply.channel,y.reply.nonce,v.ports)}onWillShutdown(){const v=this.window;!v||(this.send("vscode:electron-main->shared-process=exit"),this.windowCloseListener&&(v.removeListener("close",this.windowCloseListener),this.windowCloseListener=void 0),setTimeout(()=>{try{v.close()}catch(y){}this.window=void 0},0))}send(v,...y){const u=this.window;if(!u||u.isDestroyed()||u.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${v}' for shared process window that is destroyed`);return}u.webContents.send(v,...y)}whenReady(){return this._whenReady||(this._whenReady=new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=init-done",()=>{this.logService.trace("SharedProcess: Overall ready"),v()}))),this._whenReady}get whenIpcReady(){return this._whenIpcReady||(this._whenIpcReady=(async()=>{await this.firstWindowConnectionBarrier.wait(),this.createWindow(),this.registerWindowListeners(),await new Promise(v=>p.ipcMain.once("vscode:shared-process->electron-main=ipc-ready",()=>{this.logService.trace("SharedProcess: IPC ready"),v()}))})()),this._whenIpcReady}createWindow(){const v=this._register(this.protocolMainService.createIPCObjectUrl());this.window=new p.BrowserWindow({show:!1,backgroundColor:this.themeMainService.getBackgroundColor(),webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${v.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",nodeIntegration:!0,nodeIntegrationInWorker:!0,contextIsolation:!1,enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,images:!1,webgl:!1,disableBlinkFeatures:"Auxclick"}}),v.update({machineId:this.machineId,windowId:this.window.id,appRoot:this.environmentMainService.appRoot,codeCachePath:this.environmentMainService.codeCachePath,backupWorkspacesPath:this.environmentMainService.backupWorkspacesPath,userEnv:this.userEnv,args:this.environmentMainService.args,logLevel:this.logService.getLevel(),product:S.default}),this.window.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-browser/sharedProcess/sharedProcess.html",j).toString(!0))}registerWindowListeners(){!this.window||(this.windowCloseListener=v=>{this.logService.trace("SharedProcess#close prevented"),v.preventDefault(),this.window?.isVisible()&&this.window.hide()},this.window.on("close",this.windowCloseListener),this.window.webContents.on("render-process-gone",(v,y)=>this._onDidError.fire({type:2,details:y})),this.window.on("unresponsive",()=>this._onDidError.fire({type:1})),this.window.webContents.on("did-fail-load",(v,y,u)=>this._onDidError.fire({type:3,details:{reason:u,exitCode:y}})))}async connect(){await this.whenIpcReady;const v=(0,b.assertIsDefined)(this.window);return(0,d.connect)(v)}async toggle(){await this.whenIpcReady,!!this.window&&(this.window.isVisible()?(this.window.webContents.closeDevTools(),this.window.hide()):(this.window.show(),this.window.webContents.openDevTools()))}isVisible(){return this.window?.isVisible()??!1}};h=he([te(2,g.IEnvironmentMainService),te(3,i.ILifecycleMainService),te(4,I.ILogService),te(5,t.IThemeMainService),te(6,m.IProtocolMainService)],h),e.SharedProcess=h}),define(Q[227],J([0,1,9,16,8,14,7,24,20,6]),function(j,e,p,L,D,M,P,b,d,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StateMainService=e.FileStorage=void 0;class i{constructor(m,t,h){this.storagePath=m,this.logService=t,this.fileService=h,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new p.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(m){m.fileOperationResult!==1&&this.logService.error(m)}}getItem(m,t){const h=this.storage[m];return(0,M.isUndefinedOrNull)(h)?t:h}setItem(m,t){this.setItems([{key:m,data:t}])}setItems(m){let t=!1;for(const{key:h,data:E}of m)this.storage[h]!==E&&((0,M.isUndefinedOrNull)(E)?(0,M.isUndefined)(this.storage[h])||(this.storage[h]=void 0,t=!0):(this.storage[h]=E,t=!0));t&&this.save()}removeItem(m){(0,M.isUndefined)(this.storage[m])||(this.storage[m]=void 0,this.save())}async save(m){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),m)}async doSave(){if(!this.initializing)return;await this.initializing;const m=JSON.stringify(this.storage,null,4);if(m!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,L.VSBuffer.fromString(m)),this.lastSavedStorageContents=m}catch(t){this.logService.error(t)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}e.FileStorage=i;let I=class St{constructor(m,t,h){this.fileStorage=new i(P.URI.file((0,D.join)(m.userDataPath,St.STATE_FILE)),t,h)}async init(){return this.fileStorage.init()}getItem(m,t){return this.fileStorage.getItem(m,t)}setItem(m,t){this.fileStorage.setItem(m,t)}setItems(m){this.fileStorage.setItems(m)}removeItem(m){this.fileStorage.removeItem(m)}close(){return this.fileStorage.close()}};I.STATE_FILE="storage.json",I=he([te(0,b.IEnvironmentMainService),te(1,g.ILogService),te(2,d.IFileService)],I),e.StateMainService=I}),define(Q[78],J([0,1,9,23,4,17,24,22,6,21,50,41]),function(j,e,p,L,D,M,P,b,d,g,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractUpdateService=e.createUpdateURL=void 0;function S(t,h,E){return`${E.updateUrl}/api/update/${t}/${h}/${E.commit}`}e.createUpdateURL=S;let m=class{constructor(h,E,v,y,u,l){this.lifecycleMainService=h,this.configurationService=E,this.environmentMainService=v,this.requestService=y,this.logService=u,this.productService=l,this._state=I.State.Uninitialized,this._onStateChange=new D.Emitter,this.onStateChange=this._onStateChange.event}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}initialize(){if(!this.environmentMainService.isBuilt)return;if(this.environmentMainService.disableUpdates){this.logService.info("update#ctor - updates are disabled by the environment");return}if(!this.productService.updateUrl||!this.productService.commit){this.logService.info("update#ctor - updates are disabled as there is no update URL");return}const h=this.getUpdateMode(),E=this.getProductQuality(h);if(!E){this.logService.info("update#ctor - updates are disabled by user preference");return}if(this.url=this.buildUpdateFeedUrl(E),!this.url){this.logService.info("update#ctor - updates are disabled as the update URL is badly formed");return}if(this.setState(I.State.Idle(this.getUpdateType())),h==="manual"){this.logService.info("update#ctor - manual checks only; automatic updates are disabled by user preference");return}h==="start"?(this.logService.info("update#ctor - startup checks only; automatic updates are disabled by user preference"),setTimeout(()=>this.checkForUpdates(!1),30*1e3)):this.scheduleCheckForUpdates(30*1e3).then(void 0,v=>this.logService.error(v))}getUpdateMode(){return(0,M.getMigratedSettingValue)(this.configurationService,"update.mode","update.channel")}getProductQuality(h){return h==="none"?void 0:this.productService.quality}scheduleCheckForUpdates(h=60*60*1e3){return(0,p.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}async doDownloadUpdate(h){}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}async doApplyUpdate(){}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}async isLatestVersion(){if(this.url){if(this.getUpdateMode()==="none")return!1}else return;return(await this.requestService.request({url:this.url},L.CancellationToken.None)).res.statusCode===204}getUpdateType(){return 1}doQuitAndInstall(){}};m=he([te(0,b.ILifecycleMainService),te(1,M.IConfigurationService),te(2,P.IEnvironmentMainService),te(3,i.IRequestService),te(4,d.ILogService),te(5,g.IProductService)],m),e.AbstractUpdateService=m}),define(Q[228],J([0,1,13,47,4,2,17,24,22,6,21,50,29,41,78]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DarwinUpdateService=void 0;let h=class extends t.AbstractUpdateService{constructor(v,y,u,l,c,n,o){super(v,y,l,c,n,o);this.telemetryService=u,this.disposables=new M.DisposableStore}get onRawError(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"error",(v,y)=>y)}get onRawUpdateNotAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-not-available")}get onRawUpdateAvailable(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-available",(v,y,u)=>({url:y,version:u,productVersion:u}))}get onRawUpdateDownloaded(){return D.Event.fromNodeEventEmitter(p.autoUpdater,"update-downloaded",(v,y,u,l)=>({releaseNotes:y,version:u,productVersion:u,date:l}))}initialize(){super.initialize(),this.onRawError(this.onError,this,this.disposables),this.onRawUpdateAvailable(this.onUpdateAvailable,this,this.disposables),this.onRawUpdateDownloaded(this.onUpdateDownloaded,this,this.disposables),this.onRawUpdateNotAvailable(this.onUpdateNotAvailable,this,this.disposables)}onError(v){this.logService.error("UpdateService error:",v);const u=(this.state.type==="checking for updates"?this.state.explicit:!0)?v:void 0;this.setState(m.State.Idle(1,u))}buildUpdateFeedUrl(v){let y;this.productService.darwinUniversalAssetId?y=this.productService.darwinUniversalAssetId:y=process.arch==="x64"?"darwin":"darwin-arm64";const u=(0,t.createUpdateURL)(y,v,this.productService);try{p.autoUpdater.setFeedURL({url:u})}catch(l){this.logService.error("Failed to set update feed URL",l);return}return u}doCheckForUpdates(v){this.setState(m.State.CheckingForUpdates(v)),p.autoUpdater.checkForUpdates()}onUpdateAvailable(v){this.state.type==="checking for updates"&&this.setState(m.State.Downloading(v))}onUpdateDownloaded(v){this.state.type==="downloading"&&(this.telemetryService.publicLog2("update:downloaded",{version:v.version}),this.setState(m.State.Ready(v)))}onUpdateNotAvailable(){this.state.type==="checking for updates"&&(this.telemetryService.publicLog2("update:notAvailable",{explicit:this.state.explicit}),this.setState(m.State.Idle(1)))}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),p.autoUpdater.quitAndInstall()}dispose(){this.disposables.dispose()}};he([L.memoize],h.prototype,"onRawError",null),he([L.memoize],h.prototype,"onRawUpdateNotAvailable",null),he([L.memoize],h.prototype,"onRawUpdateAvailable",null),he([L.memoize],h.prototype,"onRawUpdateDownloaded",null),h=he([te(0,d.ILifecycleMainService),te(1,P.IConfigurationService),te(2,S.ITelemetryService),te(3,b.IEnvironmentMainService),te(4,I.IRequestService),te(5,g.ILogService),te(6,i.IProductService)],h),e.DarwinUpdateService=h}),define(Q[229],J([0,1,44,31,9,4,8,24,22,6,29,41]),function(j,e,p,L,D,M,P,b,d,g,i,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnapUpdateService=void 0;let S=class{constructor(h,E,v){if(this.lifecycleMainService=h,this.logService=v,this._state=I.State.Uninitialized,this._onStateChange=new M.Emitter,this.onStateChange=this._onStateChange.event,E.disableUpdates){this.logService.info("update#ctor - updates are disabled");return}this.setState(I.State.Idle(this.getUpdateType())),this.scheduleCheckForUpdates(30*1e3).then(void 0,y=>this.logService.error(y))}get state(){return this._state}setState(h){this.logService.info("update#setState",h.type),this._state=h,this._onStateChange.fire(h)}scheduleCheckForUpdates(h=60*60*1e3){return(0,D.timeout)(h).then(()=>this.checkForUpdates(!1)).then(()=>this.scheduleCheckForUpdates(60*60*1e3))}async checkForUpdates(h){this.logService.trace("update#checkForUpdates, state = ",this.state.type),this.state.type==="idle"&&this.doCheckForUpdates(h)}async downloadUpdate(){this.logService.trace("update#downloadUpdate, state = ",this.state.type),this.state.type==="available for download"&&await this.doDownloadUpdate(this.state)}doDownloadUpdate(h){return Promise.resolve(void 0)}async applyUpdate(){this.logService.trace("update#applyUpdate, state = ",this.state.type),this.state.type==="downloaded"&&await this.doApplyUpdate()}doApplyUpdate(){return Promise.resolve(void 0)}quitAndInstall(){return this.logService.trace("update#quitAndInstall, state = ",this.state.type),this.state.type!=="ready"||(this.logService.trace("update#quitAndInstall(): before lifecycle quit()"),this.lifecycleMainService.quit(!0).then(h=>{this.logService.trace(`update#quitAndInstall(): after lifecycle quit() with veto: ${h}`),!h&&(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.doQuitAndInstall())})),Promise.resolve(void 0)}getUpdateType(){return 2}doQuitAndInstall(){}};S=he([te(0,d.ILifecycleMainService),te(1,b.IEnvironmentMainService),te(2,g.ILogService)],S);let m=class extends S{constructor(h,E,v,y,u,l){super(v,y,u);this.snap=h,this.snapRevision=E,this.telemetryService=l;const c=(0,L.watch)(P.dirname(this.snap)),n=M.Event.fromNodeEventEmitter(c,"change",(a,f)=>f),o=M.Event.filter(n,a=>a==="current"),r=M.Event.debounce(o,(a,f)=>f,2e3)(()=>this.checkForUpdates(!1));v.onWillShutdown(()=>{r.dispose(),c.close()})}doCheckForUpdates(){this.setState(I.State.CheckingForUpdates(!1)),this.isUpdateAvailable().then(h=>{h?this.setState(I.State.Ready({version:"something",productVersion:"something"})):(this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2)))},h=>{this.logService.error(h),this.telemetryService.publicLog2("update:notAvailable",{explicit:!1}),this.setState(I.State.Idle(2,h.message||h))})}doQuitAndInstall(){this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),(0,p.spawn)("sleep 3 && "+P.basename(process.argv[0]),{shell:!0,detached:!0,stdio:"ignore"})}async isUpdateAvailable(){const h=await new Promise((v,y)=>(0,L.realpath)(`${P.dirname(this.snap)}/current`,(u,l)=>u?y(u):v(l))),E=P.basename(h);return this.snapRevision!==E}isLatestVersion(){return this.isUpdateAvailable().then(void 0,h=>{this.logService.error("update#checkForSnapUpdate(): Could not get realpath of application.")})}};m=he([te(2,d.ILifecycleMainService),te(3,b.IEnvironmentMainService),te(4,g.ILogService),te(5,i.ITelemetryService)],m),e.SnapUpdateService=m}),define(Q[46],J([0,1,13,31,4,39,34,2,10,8,3,15,14,19,155,51,52,24,5,6,21,100,26,101]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesManagementMainService=e.IWorkspacesManagementMainService=void 0,e.IWorkspacesManagementMainService=(0,y.createDecorator)("workspacesManagementMainService");let s=class extends b.Disposable{constructor(a,f,w,k,R){super();this.environmentMainService=a,this.logService=f,this.backupMainService=w,this.dialogMainService=k,this.productService=R,this.untitledWorkspacesHome=this.environmentMainService.untitledWorkspacesHome,this._onDidDeleteUntitledWorkspace=this._register(new D.Emitter),this.onDidDeleteUntitledWorkspace=this._onDidDeleteUntitledWorkspace.event,this._onDidEnterWorkspace=this._register(new D.Emitter),this.onDidEnterWorkspace=this._onDidEnterWorkspace.event}resolveLocalWorkspaceSync(a){return this.doResolveLocalWorkspace(a,f=>(0,L.readFileSync)(f,"utf8"))}resolveLocalWorkspace(a){return this.doResolveLocalWorkspace(a,f=>m.Promises.readFile(f,"utf8"))}doResolveLocalWorkspace(a,f){if(!!this.isWorkspacePath(a)&&a.scheme===d.Schemas.file)try{const w=f(a.fsPath);return w instanceof Promise?w.then(k=>this.doResolveWorkspace(a,k),k=>{}):this.doResolveWorkspace(a,w)}catch{return}}isWorkspacePath(a){return(0,n.isUntitledWorkspace)(a,this.environmentMainService)||(0,n.hasWorkspaceFileExtension)(a)}doResolveWorkspace(a,f){try{const w=this.doParseStoredWorkspace(a,f),k=(0,o.getWorkspaceIdentifier)(a);return{id:k.id,configPath:k.configPath,folders:(0,n.toWorkspaceFolders)(w.folders,k.configPath,I.extUriBiasedIgnorePathCase),remoteAuthority:w.remoteAuthority,transient:w.transient}}catch(w){this.logService.warn(w.toString())}}doParseStoredWorkspace(a,f){const w=(0,M.parse)(f);if(w&&Array.isArray(w.folders))w.folders=w.folders.filter(k=>(0,n.isStoredWorkspaceFolder)(k));else throw new Error(`${a.toString(!0)} looks like an invalid workspace file.`);return w}async createUntitledWorkspace(a,f){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(a,f),R=w.configPath.fsPath;return await m.Promises.mkdir((0,g.dirname)(R),{recursive:!0}),await m.Promises.writeFile(R,JSON.stringify(k,null,"	")),w}createUntitledWorkspaceSync(a,f){const{workspace:w,storedWorkspace:k}=this.newUntitledWorkspace(a,f),R=w.configPath.fsPath;return(0,L.mkdirSync)((0,g.dirname)(R),{recursive:!0}),(0,m.writeFileSync)(R,JSON.stringify(k,null,"	")),w}newUntitledWorkspace(a=[],f){const w=(Date.now()+Math.round(Math.random()*1e3)).toString(),k=(0,I.joinPath)(this.untitledWorkspacesHome,w),R=(0,I.joinPath)(k,n.UNTITLED_WORKSPACE_NAME),A=[];for(const O of a)A.push((0,n.getStoredWorkspaceFolder)(O.uri,!0,O.name,k,!i.isWindows,I.extUriBiasedIgnorePathCase));return{workspace:(0,o.getWorkspaceIdentifier)(R),storedWorkspace:{folders:A,remoteAuthority:f}}}async getWorkspaceIdentifier(a){return(0,o.getWorkspaceIdentifier)(a)}isUntitledWorkspace(a){return(0,n.isUntitledWorkspace)(a.configPath,this.environmentMainService)}deleteUntitledWorkspaceSync(a){!this.isUntitledWorkspace(a)||(this.doDeleteUntitledWorkspaceSync(a),this._onDidDeleteUntitledWorkspace.fire(a))}async deleteUntitledWorkspace(a){this.deleteUntitledWorkspaceSync(a)}doDeleteUntitledWorkspaceSync(a){const f=(0,I.originalFSPath)(a.configPath);try{(0,m.rimrafSync)((0,g.dirname)(f));const w=(0,g.join)(this.environmentMainService.workspaceStorageHome.fsPath,a.id);(0,L.existsSync)(w)&&(0,m.writeFileSync)((0,g.join)(w,"obsolete"),"")}catch(w){this.logService.warn(`Unable to delete untitled workspace ${f} (${w}).`)}}getUntitledWorkspacesSync(){const a=[];try{const f=(0,m.readdirSync)(this.untitledWorkspacesHome.fsPath).map(w=>(0,I.joinPath)(this.untitledWorkspacesHome,w,n.UNTITLED_WORKSPACE_NAME));for(const w of f){const k=(0,o.getWorkspaceIdentifier)(w),R=this.resolveLocalWorkspaceSync(w);R?a.push({workspace:k,remoteAuthority:R.remoteAuthority}):this.doDeleteUntitledWorkspaceSync(k)}}catch(f){f.code!=="ENOENT"&&this.logService.warn(`Unable to read folders in ${this.untitledWorkspacesHome} (${f}).`)}return a}async enterWorkspace(a,f,w){if(!a||!a.win||!a.isReady||!await this.isValidTargetWorkspacePath(a,f,w))return;const R=this.doEnterWorkspace(a,(0,o.getWorkspaceIdentifier)(w));if(!!R)return this._onDidEnterWorkspace.fire({window:a,workspace:R.workspace}),R}async isValidTargetWorkspacePath(a,f,w){if(!w)return!0;if((0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&I.extUriBiasedIgnorePathCase.isEqual(a.openedWorkspace.configPath,w))return!1;if((0,c.findWindowOnWorkspaceOrFolder)(f,w)){const k={title:this.productService.nameLong,type:"info",buttons:[(0,P.mnemonicButtonLabel)((0,t.localize)(0,null))],message:(0,t.localize)(1,null,(0,I.basename)(w)),detail:(0,t.localize)(2,null),noLink:!0,defaultId:0};return await this.dialogMainService.showMessageBox(k,(0,S.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow())),!1}return!0}doEnterWorkspace(a,f){if(!a.config)return;a.focus();let w;return a.config.extensionDevelopmentPath||(w=this.backupMainService.registerWorkspaceBackupSync({workspace:f,remoteAuthority:a.remoteAuthority},a.config.backupPath)),(0,n.isWorkspaceIdentifier)(a.openedWorkspace)&&this.isUntitledWorkspace(a.openedWorkspace)&&this.deleteUntitledWorkspaceSync(a.openedWorkspace),a.config.workspace=f,a.config.backupPath=w,{workspace:f,backupPath:w}}};s=he([te(0,v.IEnvironmentMainService),te(1,u.ILogService),te(2,h.IBackupMainService),te(3,E.IDialogMainService),te(4,l.IProductService)],s),e.WorkspacesManagementMainService=s}),define(Q[102],J([0,1,13,30,23,3,14,7,19,17,54,5,6,98,36,26,46]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LaunchMainService=e.ILaunchMainService=e.ID=void 0,e.ID="launchMainService",e.ILaunchMainService=(0,I.createDecorator)(e.ID);let v=class{constructor(u,l,c,n,o){this.logService=u,this.windowsMainService=l,this.urlService=c,this.workspacesManagementMainService=n,this.configurationService=o}async start(u,l){this.logService.trace("Received data from other instance: ",u,l),M.isMacintosh&&p.app.focus({steal:!0});const c=this.parseOpenUrl(u);if(c.length){let n=Promise.resolve();this.windowsMainService.getWindowCount()===0&&(n=this.windowsMainService.openEmptyWindow({context:4})[0].ready()),n.then(()=>{for(const{uri:o,url:s}of c)this.urlService.open(o,{originalUrl:s})})}else return this.startOpenWindow(u,l)}parseOpenUrl(u){return u["open-url"]&&u._urls&&u._urls.length>0?(0,L.coalesce)(u._urls.map(l=>{try{return{uri:b.URI.parse(l),url:l}}catch(c){return null}})):[]}async startOpenWindow(u,l){const c=(0,i.isLaunchedFromCli)(l)?0:4;let n=[];const o=u.wait&&u.waitMarkerFilePath?b.URI.file(u.waitMarkerFilePath):void 0,s=u.remote||void 0,r={context:c,cli:u,userEnv:l,waitMarkerFileURI:o,remoteAuthority:s};if(u.extensionDevelopmentPath)this.windowsMainService.openExtensionDevelopmentHostWindow(u.extensionDevelopmentPath,r);else if(!u._.length&&!u["folder-uri"]&&!u["file-uri"]){let a=!1;if(u["new-window"]||u["unity-launch"])a=!0;else if(u["reuse-window"])a=!1;else switch(this.configurationService.getValue("window")?.openWithoutArgumentsInNewWindow||"default"){case"on":a=!0;break;case"off":a=!1;break;default:a=!M.isMacintosh}if(a)n=this.windowsMainService.open({...r,forceNewWindow:!0,forceEmpty:!0});else{const f=this.windowsMainService.getLastActiveWindow();f?(this.windowsMainService.openExistingWindow(f,r),n=[f]):n=this.windowsMainService.open({...r,forceEmpty:!0})}}else n=this.windowsMainService.open({...r,forceNewWindow:u["new-window"],preferNewWindow:!u["reuse-window"]&&!u.wait,forceReuseWindow:u["reuse-window"],diffMode:u.diff,addMode:u.add,noRecentEntry:!!u["skip-add-to-recently-opened"],gotoLineMode:u.goto});if(o&&n.length===1&&n[0])return Promise.race([n[0].whenClosedOrLoaded,(0,d.whenDeleted)(o.fsPath)]).then(()=>{},()=>{})}async getMainProcessId(){return this.logService.trace("Received request for process ID from other instance."),process.pid}async getMainProcessInfo(){this.logService.trace("Received request for main process info from other instance.");const u=[];return p.BrowserWindow.getAllWindows().forEach(l=>{const c=this.windowsMainService.getWindowById(l.id);c?u.push(this.codeWindowToInfo(c)):u.push(this.browserWindowToInfo(l))}),{mainPID:process.pid,mainArguments:process.argv.slice(1),windows:u,screenReader:!!p.app.accessibilitySupportEnabled,gpuFeatureStatus:p.app.getGPUFeatureStatus()}}async getRemoteDiagnostics(u){const l=this.windowsMainService.getWindows();return(await Promise.all(l.map(n=>new Promise(o=>{const s=n.remoteAuthority;if(s){const r=`vscode:getDiagnosticInfoResponse${n.id}`,a={includeProcesses:u.includeProcesses,folders:u.includeWorkspaceMetadata?this.getFolderURIs(n):void 0};n.sendWhenReady("vscode:getDiagnosticInfo",D.CancellationToken.None,{replyChannel:r,args:a}),p.ipcMain.once(r,(f,w)=>{w||o({hostName:s,errorMessage:`Unable to resolve connection to '${s}'.`}),o(w)}),setTimeout(()=>{o({hostName:s,errorMessage:`Fetching remote diagnostics for '${s}' timed out.`})},5e3)}else o(void 0)})))).filter(n=>!!n)}getFolderURIs(u){const l=[],c=u.openedWorkspace;if((0,h.isSingleFolderWorkspaceIdentifier)(c))l.push(c.uri);else if((0,h.isWorkspaceIdentifier)(c)){const n=this.workspacesManagementMainService.resolveLocalWorkspaceSync(c.configPath);n&&n.folders.forEach(s=>{l.push(s.uri)})}return l}codeWindowToInfo(u){const l=this.getFolderURIs(u),c=(0,P.assertIsDefined)(u.win);return this.browserWindowToInfo(c,l,u.remoteAuthority)}browserWindowToInfo(u,l=[],c){return{pid:u.webContents.getOSProcessId(),title:u.getTitle(),folderURIs:l,remoteAuthority:c}}};v=he([te(0,S.ILogService),te(1,t.IWindowsMainService),te(2,m.IURLService),te(3,E.IWorkspacesManagementMainService),te(4,g.IConfigurationService)],v),e.LaunchMainService=v}),define(Q[53],J([0,1,44,13,25,114,47,4,34,2,10,8,3,7,83,70,19,147,52,24,5,22,6,21,29,65,36,26,46]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n,o,s,r,a,f,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeHostMainService=e.INativeHostMainService=void 0,e.INativeHostMainService=(0,l.createDecorator)("nativeHostMainService");let k=class ut extends g.Disposable{constructor(A,O,H,x,re,K,ee,F,V,z){super();this.sharedProcess=A,this.windowsMainService=O,this.dialogMainService=H,this.lifecycleMainService=x,this.environmentMainService=re,this.telemetryService=K,this.logService=ee,this.productService=F,this.themeMainService=V,this.workspacesManagementMainService=z,this.onDidOpenWindow=b.Event.map(this.windowsMainService.onDidOpenWindow,B=>B.id),this.onDidMaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-maximize",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidUnmaximizeWindow=b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-unmaximize",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidBlurWindow=b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-blur",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B)),this.onDidFocusWindow=b.Event.any(b.Event.map(b.Event.filter(b.Event.map(this.windowsMainService.onDidChangeWindowsCount,()=>this.windowsMainService.getLastActiveWindow()),B=>!!B),B=>B.id),b.Event.filter(b.Event.fromNodeEventEmitter(L.app,"browser-window-focus",(B,U)=>U.id),B=>!!this.windowsMainService.getWindowById(B))),this.onDidResumeOS=b.Event.fromNodeEventEmitter(L.powerMonitor,"resume"),this._onDidChangeColorScheme=this._register(new b.Emitter),this.onDidChangeColorScheme=this._onDidChangeColorScheme.event,this._onDidChangePassword=this._register(new b.Emitter),this.onDidChangePassword=this._onDidChangePassword.event,this.onDidChangeDisplay=b.Event.debounce(b.Event.any(b.Event.filter(b.Event.fromNodeEventEmitter(L.screen,"display-metrics-changed",(B,U,C)=>C),B=>!(Array.isArray(B)&&B.length===1&&B[0]==="workArea")),b.Event.fromNodeEventEmitter(L.screen,"display-added"),b.Event.fromNodeEventEmitter(L.screen,"display-removed")),()=>{},100),this.registerListeners()}registerListeners(){L.nativeTheme.on("updated",()=>{this._onDidChangeColorScheme.fire(this.osColorScheme)})}get windowId(){throw new Error("Not implemented in electron-main")}async getWindows(){return this.windowsMainService.getWindows().map(O=>({id:O.id,workspace:O.openedWorkspace,title:O.win?.getTitle()??"",filename:O.getRepresentedFilename(),dirty:O.isDocumentEdited()}))}async getWindowCount(A){return this.windowsMainService.getWindowCount()}async getActiveWindowId(A){const O=L.BrowserWindow.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(O)return O.id}openWindow(A,O,H){return Array.isArray(O)?this.doOpenWindow(A,O,H):this.doOpenEmptyWindow(A,O)}async doOpenWindow(A,O,H=Object.create(null)){O.length>0&&this.windowsMainService.open({context:5,contextWindowId:A,urisToOpen:O,cli:this.environmentMainService.args,forceNewWindow:H.forceNewWindow,forceReuseWindow:H.forceReuseWindow,preferNewWindow:H.preferNewWindow,diffMode:H.diffMode,addMode:H.addMode,gotoLineMode:H.gotoLineMode,noRecentEntry:H.noRecentEntry,waitMarkerFileURI:H.waitMarkerFileURI,remoteAuthority:H.remoteAuthority||void 0})}async doOpenEmptyWindow(A,O){this.windowsMainService.openEmptyWindow({context:5,contextWindowId:A},O)}async toggleFullScreen(A){const O=this.windowById(A);O&&O.toggleFullScreen()}async handleTitleDoubleClick(A){const O=this.windowById(A);O&&O.handleTitleDoubleClick()}async isMaximized(A){const O=this.windowById(A);return O?.win?O.win.isMaximized():!1}async maximizeWindow(A){const O=this.windowById(A);O?.win&&O.win.maximize()}async unmaximizeWindow(A){const O=this.windowById(A);O?.win&&O.win.unmaximize()}async minimizeWindow(A){const O=this.windowById(A);O?.win&&O.win.minimize()}async focusWindow(A,O){O&&typeof O.windowId=="number"&&(A=O.windowId);const H=this.windowById(A);H&&H.focus({force:O?.force??!1})}async setMinimumSize(A,O,H){const x=this.windowById(A);if(x?.win){const[re,K]=x.win.getSize(),[ee,F]=x.win.getMinimumSize(),[V,z]=[O??ee,H??F],[B,U]=[Math.max(re,V),Math.max(K,z)];(ee!==V||F!==z)&&x.win.setMinimumSize(V,z),(re!==B||K!==U)&&x.win.setSize(B,U)}}async saveWindowSplash(A,O){this.themeMainService.saveWindowSplash(A,O)}async installShellCommand(A){const{source:O,target:H}=await this.getShellCommandLink();try{const{symbolicLink:x}=await E.SymlinkSupport.stat(O);if(x&&!x.dangling){const re=await(0,t.realpath)(O);if(H===re)return}await E.Promises.unlink(O)}catch(x){if(x.code!=="ENOENT")throw x}try{await E.Promises.symlink(H,O)}catch(x){if(x.code!=="EACCES"&&x.code!=="ENOENT")throw x;const{response:re}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(0,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(1,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(2,null))],noLink:!0,defaultId:0,cancelId:1});if(re===0)try{const K=`osascript -e "do shell script \\"mkdir -p /usr/local/bin && ln -sf '${H}' '${O}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(K)}catch(K){throw new Error((0,v.localize)(3,null,O))}}}async uninstallShellCommand(A){const{source:O}=await this.getShellCommandLink();try{await E.Promises.unlink(O)}catch(H){switch(H.code){case"EACCES":const{response:x}=await this.showMessageBox(A,{title:this.productService.nameLong,type:"info",message:(0,v.localize)(4,null,this.productService.nameShort),buttons:[(0,d.mnemonicButtonLabel)((0,v.localize)(5,null)),(0,d.mnemonicButtonLabel)((0,v.localize)(6,null))],noLink:!0,defaultId:0,cancelId:1});if(x===0)try{const re=`osascript -e "do shell script \\"rm '${O}'\\" with administrator privileges"`;await(0,M.promisify)(p.exec)(re)}catch(re){throw new Error((0,v.localize)(7,null,O))}break;case"ENOENT":break;default:throw H}}}async getShellCommandLink(){const A=(0,I.resolve)(this.environmentMainService.appRoot,"bin","code"),O=`/usr/local/bin/${this.productService.applicationName}`;if(!await E.Promises.exists(A))throw new Error((0,v.localize)(8,null,A));return{source:O,target:A}}async showMessageBox(A,O){return this.dialogMainService.showMessageBox(O,this.toBrowserWindow(A))}async showSaveDialog(A,O){return this.dialogMainService.showSaveDialog(O,this.toBrowserWindow(A))}async showOpenDialog(A,O){return this.dialogMainService.showOpenDialog(O,this.toBrowserWindow(A))}toBrowserWindow(A){const O=this.windowById(A);if(O?.win)return O.win}async pickFileFolderAndOpen(A,O){const H=await this.dialogMainService.pickFileFolder(O);H&&(this.sendPickerTelemetry(H,O.telemetryEventName||"openFileFolder",O.telemetryExtraData),this.doOpenPicked(await Promise.all(H.map(async x=>await E.SymlinkSupport.existsDirectory(x)?{folderUri:m.URI.file(x)}:{fileUri:m.URI.file(x)})),O,A))}async pickFolderAndOpen(A,O){const H=await this.dialogMainService.pickFolder(O);H&&(this.sendPickerTelemetry(H,O.telemetryEventName||"openFolder",O.telemetryExtraData),this.doOpenPicked(H.map(x=>({folderUri:m.URI.file(x)})),O,A))}async pickFileAndOpen(A,O){const H=await this.dialogMainService.pickFile(O);H&&(this.sendPickerTelemetry(H,O.telemetryEventName||"openFile",O.telemetryExtraData),this.doOpenPicked(H.map(x=>({fileUri:m.URI.file(x)})),O,A))}async pickWorkspaceAndOpen(A,O){const H=await this.dialogMainService.pickWorkspace(O);H&&(this.sendPickerTelemetry(H,O.telemetryEventName||"openWorkspace",O.telemetryExtraData),this.doOpenPicked(H.map(x=>({workspaceUri:m.URI.file(x)})),O,A))}doOpenPicked(A,O,H){this.windowsMainService.open({context:3,contextWindowId:H,cli:this.environmentMainService.args,urisToOpen:A,forceNewWindow:O.forceNewWindow})}sendPickerTelemetry(A,O,H){const x=A?A.length:0;this.telemetryService.publicLog(O,{...H,outcome:x?"success":"canceled",numberOfPaths:x})}async showItemInFolder(A,O){L.shell.showItemInFolder(O)}async setRepresentedFilename(A,O){const H=this.windowById(A);H&&H.setRepresentedFilename(O)}async setDocumentEdited(A,O){const H=this.windowById(A);H&&H.setDocumentEdited(O)}async openExternal(A,O){return S.isLinuxSnap?this.safeSnapOpenExternal(O):L.shell.openExternal(O),!0}safeSnapOpenExternal(A){const O=process.env.GDK_PIXBUF_MODULE_FILE,H=process.env.GDK_PIXBUF_MODULEDIR;delete process.env.GDK_PIXBUF_MODULE_FILE,delete process.env.GDK_PIXBUF_MODULEDIR,L.shell.openExternal(A),process.env.GDK_PIXBUF_MODULE_FILE=O,process.env.GDK_PIXBUF_MODULEDIR=H}moveItemToTrash(A,O){return L.shell.trashItem(O)}async isAdmin(){let A;return S.isWindows?A=(await new Promise((O,H)=>{j(["native-is-elevated"],O,H)}))():A=process.getuid()===0,A}async writeElevated(A,O,H,x){const re=await new Promise((K,ee)=>{j(["sudo-prompt"],K,ee)});return new Promise((K,ee)=>{const F=[`"${this.cliPath}"`];x?.unlock&&F.push("--file-chmod"),F.push("--file-write",`"${O.fsPath}"`,`"${H.fsPath}"`);const V={name:this.productService.nameLong.replace("-",""),icns:S.isMacintosh&&this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(this.environmentMainService.appRoot),`${this.productService.nameShort}.icns`):void 0};re.exec(F.join(" "),V,(z,B,U)=>{B&&this.logService.trace(`[sudo-prompt] received stdout: ${B}`),U&&this.logService.trace(`[sudo-prompt] received stderr: ${U}`),z?ee(z):K(void 0)})})}get cliPath(){return S.isWindows?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}.cmd`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.bat"):S.isLinux?this.environmentMainService.isBuilt?(0,I.join)((0,I.dirname)(process.execPath),"bin",`${this.productService.applicationName}`):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh"):this.environmentMainService.isBuilt?(0,I.join)(this.environmentMainService.appRoot,"bin","code"):(0,I.join)(this.environmentMainService.appRoot,"scripts","code-cli.sh")}async getOSStatistics(){return{totalmem:(0,D.totalmem)(),freemem:(0,D.freemem)(),loadavg:(0,D.loadavg)()}}async getOSProperties(){return{arch:(0,D.arch)(),platform:(0,D.platform)(),release:(0,D.release)(),type:(0,D.type)(),cpus:(0,D.cpus)()}}async getOSVirtualMachineHint(){return h.virtualMachineHint.value()}get osColorScheme(){return{highContrast:L.nativeTheme.shouldUseInvertedColorScheme||L.nativeTheme.shouldUseHighContrastColors,dark:L.nativeTheme.shouldUseDarkColors}}async getOSColorScheme(){return this.osColorScheme}async killProcess(A,O,H){process.kill(O,H)}async readClipboardText(A,O){return L.clipboard.readText(O)}async writeClipboardText(A,O,H){return L.clipboard.writeText(O,H)}async readClipboardFindText(A){return L.clipboard.readFindText()}async writeClipboardFindText(A,O){return L.clipboard.writeFindText(O)}async writeClipboardBuffer(A,O,H,x){return L.clipboard.writeBuffer(O,Buffer.from(H),x)}async readClipboardBuffer(A,O){return L.clipboard.readBuffer(O)}async hasClipboard(A,O,H){return L.clipboard.has(O,H)}async newWindowTab(){this.windowsMainService.open({context:5,cli:this.environmentMainService.args,forceNewTabbedWindow:!0,forceEmpty:!0,remoteAuthority:this.environmentMainService.args.remote||void 0})}async showPreviousWindowTab(){L.Menu.sendActionToFirstResponder("selectPreviousTab:")}async showNextWindowTab(){L.Menu.sendActionToFirstResponder("selectNextTab:")}async moveWindowTabToNewWindow(){L.Menu.sendActionToFirstResponder("moveTabToNewWindow:")}async mergeAllWindowTabs(){L.Menu.sendActionToFirstResponder("mergeAllWindows:")}async toggleWindowTabsBar(){L.Menu.sendActionToFirstResponder("toggleTabBar:")}async updateTouchBar(A,O){const H=this.windowById(A);H&&H.updateTouchBar(O)}async notifyReady(A){const O=this.windowById(A);O&&O.setReady()}async relaunch(A,O){return this.lifecycleMainService.relaunch(O)}async reload(A,O){const H=this.windowById(A);if(H){if((0,f.isWorkspaceIdentifier)(H.openedWorkspace)){const x=H.openedWorkspace.configPath;if(x.scheme===i.Schemas.file&&(await this.workspacesManagementMainService.resolveLocalWorkspace(x))?.transient)return this.openWindow(H.id,{forceReuseWindow:!0})}return this.lifecycleMainService.reload(H,O?.disableExtensions!==void 0?{_:[],"disable-extensions":O.disableExtensions}:void 0)}}async closeWindow(A){this.closeWindowById(A,A)}async closeWindowById(A,O){const H=this.windowById(O);if(H?.win)return H.win.close()}async quit(A){const O=this.windowsMainService.getLastActiveWindow();O?.isExtensionDevelopmentHost&&this.windowsMainService.getWindowCount()>1&&O.win?O.win.close():this.lifecycleMainService.quit()}async exit(A,O){await this.lifecycleMainService.kill(O)}async resolveProxy(A,O){const x=this.windowById(A)?.win?.webContents?.session;if(x)return x.resolveProxy(O)}async openDevTools(A,O){const H=this.windowById(A);H?.win&&H.win.webContents.openDevTools(O)}async toggleDevTools(A){const O=this.windowById(A);O?.win&&O.win.webContents.toggleDevTools()}async sendInputEvent(A,O){const H=this.windowById(A);H?.win&&(O.type==="mouseDown"||O.type==="mouseUp")&&H.win.webContents.sendInputEvent(O)}async toggleSharedProcessWindow(){return this.sharedProcess.toggle()}async windowsGetStringRegKey(A,O,H,x){if(!S.isWindows)return;const re=await new Promise((K,ee)=>{j(["vscode-windows-registry"],K,ee)});try{return re.GetStringRegKey(O,H,x)}catch{return}}async getPassword(A,O,H){const x=await this.withKeytar(),re=await x.getPassword(O,H);if(re)try{let{content:K,hasNextChunk:ee}=JSON.parse(re);if(!K||!ee)return re;let F=1;for(;ee;){const V=await x.getPassword(O,`${H}-${F}`),z=JSON.parse(V);K+=z.content,ee=z.hasNextChunk,F++}return K}catch{return re}return re}async setPassword(A,O,H,x){const re=await this.withKeytar(),K=3,ee=async(F,V,z)=>{let B=0,U;for(;B<K;)try{await re.setPassword(F,V,z);return}catch(C){U=C,this.logService.warn("Error attempting to set a password: ",C),B++,await new Promise(X=>setTimeout(X,200))}throw U};if(S.isWindows&&x.length>ut.MAX_PASSWORD_LENGTH){let F=0,V=0,z=!0;for(;z;){const B=x.substring(F,F+ut.PASSWORD_CHUNK_SIZE);F+=ut.PASSWORD_CHUNK_SIZE,z=x.length-F>0;const U={content:B,hasNextChunk:z};await ee(O,V?`${H}-${V}`:H,JSON.stringify(U)),V++}}else await ee(O,H,x);this._onDidChangePassword.fire({service:O,account:H})}async deletePassword(A,O,H){const re=await(await this.withKeytar()).deletePassword(O,H);return re&&this._onDidChangePassword.fire({service:O,account:H}),re}async findPassword(A,O){return(await this.withKeytar()).findPassword(O)}async findCredentials(A,O){return(await this.withKeytar()).findCredentials(O)}async withKeytar(){if(this.environmentMainService.disableKeytar)throw new Error("keytar has been disabled via --disable-keytar option");return await new Promise((A,O)=>{j(["keytar"],A,O)})}windowById(A){if(typeof A=="number")return this.windowsMainService.getWindowById(A)}};k.MAX_PASSWORD_LENGTH=2500,k.PASSWORD_CHUNK_SIZE=k.MAX_PASSWORD_LENGTH-100,he([P.memoize],k.prototype,"cliPath",null),k=he([te(1,a.IWindowsMainService),te(2,y.IDialogMainService),te(3,c.ILifecycleMainService),te(4,u.IEnvironmentMainService),te(5,s.ITelemetryService),te(6,n.ILogService),te(7,o.IProductService),te(8,r.IThemeMainService),te(9,w.IWorkspacesManagementMainService)],k),e.NativeHostMainService=k}),define(Q[230],J([0,1,13,23,4,82,2,28,89,6,53,21,36]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ProxyAuthHandler=void 0;var m;(function(h){h[h.Initial=1]="Initial",h[h.StoredCredentialsUsed=2]="StoredCredentialsUsed",h[h.LoginDialogShown=3]="LoginDialogShown"})(m||(m={}));let t=class extends P.Disposable{constructor(E,v,y,u,l){super();this.logService=E,this.windowsMainService=v,this.nativeHostMainService=y,this.encryptionMainService=u,this.productService=l,this.PROXY_CREDENTIALS_SERVICE_KEY=`${this.productService.urlProtocol}.proxy-credentials`,this.pendingProxyResolve=void 0,this.state=m.Initial,this.sessionCredentials=void 0,this.registerListeners()}registerListeners(){const E=D.Event.fromNodeEventEmitter(p.app,"login",(v,y,u,l,c)=>({event:v,webContents:y,req:u,authInfo:l,callback:c}));this._register(E(this.onLogin,this))}async onLogin({event:E,authInfo:v,req:y,callback:u}){if(!v.isProxy)return;if(!this.pendingProxyResolve&&this.state===m.LoginDialogShown&&y.firstAuthAttempt){this.logService.trace("auth#onLogin (proxy) - exit - proxy dialog already shown");return}E.preventDefault();let l;if(this.pendingProxyResolve)this.logService.trace("auth#onLogin (proxy) - pending proxy handling found"),l=await this.pendingProxyResolve;else{this.logService.trace("auth#onLogin (proxy) - no pending proxy handling found, starting new"),this.pendingProxyResolve=this.resolveProxyCredentials(v);try{l=await this.pendingProxyResolve}finally{this.pendingProxyResolve=void 0}}u(l?.username,l?.password)}async resolveProxyCredentials(E){this.logService.trace("auth#resolveProxyCredentials (proxy) - enter");try{const v=await this.doResolveProxyCredentials(E);if(v)return this.logService.trace("auth#resolveProxyCredentials (proxy) - got credentials"),v;this.logService.trace("auth#resolveProxyCredentials (proxy) - did not get credentials")}finally{this.logService.trace("auth#resolveProxyCredentials (proxy) - exit")}}async doResolveProxyCredentials(E){this.logService.trace("auth#doResolveProxyCredentials - enter",E);const v=String((0,M.hash)({scheme:E.scheme,host:E.host,port:E.port}));let y,u;try{const o=await this.nativeHostMainService.getPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v);if(o){const s=JSON.parse(await this.encryptionMainService.decrypt(o));y=s.username,u=s.password}}catch(o){this.logService.error(o)}if(this.state!==m.StoredCredentialsUsed&&typeof y=="string"&&typeof u=="string")return this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - found stored credentials to use"),this.state=m.StoredCredentialsUsed,{username:y,password:u};const l=this.windowsMainService.getFocusedWindow()||this.windowsMainService.getLastActiveWindow();if(!l){this.logService.trace("auth#doResolveProxyCredentials (proxy) - exit - no opened window found to show dialog in");return}this.logService.trace(`auth#doResolveProxyCredentials (proxy) - asking window ${l.id} to handle proxy login`);const c={authInfo:E,username:this.sessionCredentials?.username??y,password:this.sessionCredentials?.password??u,replyChannel:`vscode:proxyAuthResponse:${(0,b.generateUuid)()}`};l.sendWhenReady("vscode:openProxyAuthenticationDialog",L.CancellationToken.None,c),this.state=m.LoginDialogShown;const n=await new Promise(o=>{const s=async(r,a,f)=>{if(a===c.replyChannel)if(this.logService.trace(`auth#doResolveProxyCredentials - exit - received credentials from window ${l.id}`),l.win?.webContents.off("ipc-message",s),f){const w={username:f.username,password:f.password};try{if(f.remember){const k=await this.encryptionMainService.encrypt(JSON.stringify(w));await this.nativeHostMainService.setPassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v,k)}else await this.nativeHostMainService.deletePassword(void 0,this.PROXY_CREDENTIALS_SERVICE_KEY,v)}catch(k){this.logService.error(k)}o({username:w.username,password:w.password})}else o(void 0)};l.win?.webContents.on("ipc-message",s)});return this.sessionCredentials=n,n}};t=he([te(0,g.ILogService),te(1,S.IWindowsMainService),te(2,i.INativeHostMainService),te(3,d.IEncryptionMainService),te(4,I.IProductService)],t),e.ProxyAuthHandler=t}),define(Q[231],J([0,1,13,25,34,2,10,3,84,145,74,52,24,5,102,6,53,45,21,56,66]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IssueMainService=e.IIssueMainService=void 0,e.IIssueMainService=(0,m.createDecorator)("issueMainService");let c=class bt{constructor(o,s,r,a,f,w,k,R,A){this.userEnv=o,this.environmentMainService=s,this.launchMainService=r,this.logService=a,this.diagnosticsService=f,this.dialogMainService=w,this.nativeHostMainService=k,this.protocolMainService=R,this.productService=A,this.issueReporterWindow=null,this.issueReporterParentWindow=null,this.processExplorerWindow=null,this.processExplorerParentWindow=null,this.registerListeners()}registerListeners(){p.ipcMain.on("vscode:issueSystemInfoRequest",async o=>{const[s,r]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]),a=await this.diagnosticsService.getSystemInfo(s,r);this.safeSend(o,"vscode:issueSystemInfoResponse",a)}),p.ipcMain.on("vscode:listProcesses",async o=>{const s=[];try{const r=await this.launchMainService.getMainProcessId();s.push({name:(0,g.localize)(0,null),rootProcess:await(0,d.listProcesses)(r)}),(await this.launchMainService.getRemoteDiagnostics({includeProcesses:!0})).forEach(f=>{(0,i.isRemoteDiagnosticError)(f)?s.push({name:f.hostName,rootProcess:f}):f.processes&&s.push({name:f.hostName,rootProcess:f.processes})})}catch(r){this.logService.error(`Listing processes failed: ${r}`)}this.safeSend(o,"vscode:listProcessesResponse",s)}),p.ipcMain.on("vscode:issueReporterClipboard",async o=>{const s={title:this.productService.nameLong,message:(0,g.localize)(1,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(2,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(3,null))],defaultId:0,cancelId:1,noLink:!0};if(this.issueReporterWindow){const r=await this.dialogMainService.showMessageBox(s,this.issueReporterWindow);this.safeSend(o,"vscode:issueReporterClipboardResponse",r.response===0)}}),p.ipcMain.on("vscode:issuePerformanceInfoRequest",async o=>{const s=await this.getPerformanceInfo();this.safeSend(o,"vscode:issuePerformanceInfoResponse",s)}),p.ipcMain.on("vscode:issueReporterConfirmClose",async()=>{const o={title:this.productService.nameLong,message:(0,g.localize)(4,null),type:"warning",buttons:[(0,D.mnemonicButtonLabel)((0,g.localize)(5,null)),(0,D.mnemonicButtonLabel)((0,g.localize)(6,null))],defaultId:0,cancelId:1,noLink:!0};this.issueReporterWindow&&(await this.dialogMainService.showMessageBox(o,this.issueReporterWindow)).response===0&&this.issueReporterWindow&&(this.issueReporterWindow.destroy(),this.issueReporterWindow=null)}),p.ipcMain.on("vscode:workbenchCommand",(o,s)=>{const{id:r,from:a,args:f}=s;let w;switch(a){case"issueReporter":w=this.issueReporterParentWindow;break;case"processExplorer":w=this.processExplorerParentWindow;break;default:throw new Error(`Unexpected command source: ${a}`)}w&&w.webContents.send("vscode:runAction",{id:r,from:a,args:f})}),p.ipcMain.on("vscode:openExternal",(o,s)=>{this.nativeHostMainService.openExternal(void 0,s)}),p.ipcMain.on("vscode:closeIssueReporter",o=>{this.issueReporterWindow&&this.issueReporterWindow.close()}),p.ipcMain.on("vscode:closeProcessExplorer",o=>{this.processExplorerWindow&&this.processExplorerWindow.close()}),p.ipcMain.on("vscode:windowsInfoRequest",async o=>{const s=await this.launchMainService.getMainProcessInfo();this.safeSend(o,"vscode:windowsInfoResponse",s.windows)})}safeSend(o,s,...r){o.sender.isDestroyed()||o.sender.send(s,...r)}async openReporter(o){if(!this.issueReporterWindow&&(this.issueReporterParentWindow=p.BrowserWindow.getFocusedWindow(),this.issueReporterParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.issueReporterParentWindow,700,800);this.issueReporterWindow=this.createBrowserWindow(a,r,{backgroundColor:o.styles.backgroundColor,title:(0,g.localize)(7,null),zoomLevel:o.zoomLevel,alwaysOnTop:!1}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.issueReporterWindow.id,userEnv:this.userEnv,data:o,disableExtensions:!!this.environmentMainService.disableExtensions,os:{type:(0,L.type)(),arch:(0,L.arch)(),release:(0,L.release)()},product:v.default}),this.issueReporterWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/issue/issueReporter.html",j).toString(!0)),this.issueReporterWindow.on("close",()=>{this.issueReporterWindow=null,s.dispose()}),this.issueReporterParentWindow.on("closed",()=>{this.issueReporterWindow&&(this.issueReporterWindow.close(),this.issueReporterWindow=null,s.dispose())})}this.issueReporterWindow?.focus()}async openProcessExplorer(o){if(!this.processExplorerWindow&&(this.processExplorerParentWindow=p.BrowserWindow.getFocusedWindow(),this.processExplorerParentWindow)){const s=new M.DisposableStore,r=s.add(this.protocolMainService.createIPCObjectUrl()),a=this.getWindowPosition(this.processExplorerParentWindow,800,500);this.processExplorerWindow=this.createBrowserWindow(a,r,{backgroundColor:o.styles.backgroundColor,title:(0,g.localize)(8,null),zoomLevel:o.zoomLevel,alwaysOnTop:!0}),r.update({appRoot:this.environmentMainService.appRoot,windowId:this.processExplorerWindow.id,userEnv:this.userEnv,data:o,product:v.default}),this.processExplorerWindow.loadURL(P.FileAccess.asBrowserUri("vs/code/electron-sandbox/processExplorer/processExplorer.html",j).toString(!0)),this.processExplorerWindow.on("close",()=>{this.processExplorerWindow=null,s.dispose()}),this.processExplorerParentWindow.on("close",()=>{this.processExplorerWindow&&(this.processExplorerWindow.close(),this.processExplorerWindow=null,s.dispose())})}this.processExplorerWindow?.focus()}createBrowserWindow(o,s,r){const a=new p.BrowserWindow({fullscreen:!1,skipTaskbar:!0,resizable:!0,width:o.width,height:o.height,minWidth:300,minHeight:200,x:o.x,y:o.y,title:r.title,backgroundColor:r.backgroundColor||bt.DEFAULT_BACKGROUND_COLOR,webPreferences:{preload:P.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${s.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,l.zoomLevelToZoomFactor)(r.zoomLevel),sandbox:!0,contextIsolation:!0},alwaysOnTop:r.alwaysOnTop});return a.setMenuBarVisibility(!1),a}async getSystemStatus(){const[o,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!1,includeWorkspaceMetadata:!1})]);return this.diagnosticsService.getDiagnostics(o,s)}getWindowPosition(o,s,r){let a;const f=p.screen.getAllDisplays();if(f.length===1)a=f[0];else{if(b.isMacintosh){const R=p.screen.getCursorScreenPoint();a=p.screen.getDisplayNearestPoint(R)}!a&&o&&(a=p.screen.getDisplayMatching(o.getBounds())),a||(a=p.screen.getPrimaryDisplay()||f[0])}const w={width:s,height:r},k=a.bounds;return w.x=k.x+k.width/2-w.width/2,w.y=k.y+k.height/2-w.height/2,k.width>0&&k.height>0&&(w.x<k.x&&(w.x=k.x),w.y<k.y&&(w.y=k.y),w.x>k.x+k.width&&(w.x=k.x),w.y>k.y+k.height&&(w.y=k.y),w.width>k.width&&(w.width=k.width),w.height>k.height&&(w.height=k.height)),w}async getPerformanceInfo(){try{const[o,s]=await Promise.all([this.launchMainService.getMainProcessInfo(),this.launchMainService.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0})]);return await this.diagnosticsService.getPerformanceInfo(o,s)}catch(o){throw this.logService.warn("issueService#getPerformanceInfo ",o.message),o}}};c.DEFAULT_BACKGROUND_COLOR="#1E1E1E",c=he([te(1,S.IEnvironmentMainService),te(2,t.ILaunchMainService),te(3,h.ILogService),te(4,i.IDiagnosticsService),te(5,I.IDialogMainService),te(6,E.INativeHostMainService),te(7,u.IProtocolMainService),te(8,y.IProductService)],c),e.IssueMainService=c}),define(Q[232],J([0,1,23,17,24,22,6,53,21,50,29,41,78]),function(j,e,p,L,D,M,P,b,d,g,i,I,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinuxUpdateService=void 0;let m=class extends S.AbstractUpdateService{constructor(h,E,v,y,u,l,c,n){super(h,E,y,u,l,n);this.telemetryService=v,this.nativeHostMainService=c}buildUpdateFeedUrl(h){return(0,S.createUpdateURL)(`linux-${process.arch}`,h,this.productService)}doCheckForUpdates(h){!this.url||(this.setState(I.State.CheckingForUpdates(h)),this.requestService.request({url:this.url},p.CancellationToken.None).then(g.asJson).then(E=>{!E||!E.url||!E.version||!E.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h}),this.setState(I.State.Idle(1))):this.setState(I.State.AvailableForDownload(E))}).then(void 0,E=>{this.logService.error(E),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!h});const v=h?E.message||E:void 0;this.setState(I.State.Idle(1,v))}))}async doDownloadUpdate(h){this.productService.downloadUrl&&this.productService.downloadUrl.length>0?this.nativeHostMainService.openExternal(void 0,this.productService.downloadUrl):h.update.url&&this.nativeHostMainService.openExternal(void 0,h.update.url),this.setState(I.State.Idle(1))}};m=he([te(0,M.ILifecycleMainService),te(1,L.IConfigurationService),te(2,i.ITelemetryService),te(3,D.IEnvironmentMainService),te(4,g.IRequestService),te(5,P.ILogService),te(6,b.INativeHostMainService),te(7,d.IProductService)],m),e.LinuxUpdateService=m}),define(Q[233],J([0,1,44,31,25,9,23,47,8,7,111,19,17,24,20,22,6,53,21,50,29,41,78]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Win32UpdateService=void 0;async function o(f,w=1e3){for(;!f();)await(0,M.timeout)(w)}let s;function r(){return typeof s=="undefined"&&(s=L.existsSync(d.join(d.dirname(process.execPath),"unins000.exe"))?0:1),s}let a=class extends n.AbstractUpdateService{constructor(w,k,R,A,O,H,x,re,K){super(w,k,A,O,H,K);this.telemetryService=R,this.fileService=x,this.nativeHostMainService=re}get cachePath(){const w=d.join((0,D.tmpdir)(),`vscode-update-${this.productService.target}-${process.arch}`);return I.Promises.mkdir(w,{recursive:!0}).then(()=>w)}initialize(){super.initialize(),r()===0&&this.telemetryService.publicLog("update:win32SetupTarget",{target:this.productService.target})}buildUpdateFeedUrl(w){let k="win32";return process.arch!=="ia32"&&(k+=`-${process.arch}`),r()===1?k+="-archive":this.productService.target==="user"&&(k+="-user"),(0,n.createUpdateURL)(k,w,this.productService)}doCheckForUpdates(w){!this.url||(this.setState(c.State.CheckingForUpdates(w)),this.requestService.request({url:this.url},P.CancellationToken.None).then(u.asJson).then(k=>{const R=r();return!k||!k.url||!k.version||!k.productVersion?(this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w}),this.setState(c.State.Idle(R)),Promise.resolve(null)):R===1?(this.setState(c.State.AvailableForDownload(k)),Promise.resolve(null)):(this.setState(c.State.Downloading(k)),this.cleanup(k.version).then(()=>this.getUpdatePackagePath(k.version).then(A=>I.Promises.exists(A).then(O=>{if(O)return Promise.resolve(A);const H=k.url,x=k.hash,re=`${A}.tmp`;return this.requestService.request({url:H},P.CancellationToken.None).then(K=>this.fileService.writeFile(g.URI.file(re),K.stream)).then(x?()=>(0,i.checksum)(re,k.hash):()=>{}).then(()=>I.Promises.rename(re,A)).then(()=>A)})).then(A=>{const O=this.configurationService.getValue("update.enableWindowsBackgroundUpdates");this.availableUpdate={packagePath:A},O&&k.supportsFastUpdate?this.productService.target==="user"?this.doApplyUpdate():this.setState(c.State.Downloaded(k)):this.setState(c.State.Ready(k))})))}).then(void 0,k=>{this.logService.error(k),this.telemetryService.publicLog2("update:notAvailable",{explicit:!!w});const R=w?k.message||k:void 0;this.setState(c.State.Idle(r(),R))}))}async doDownloadUpdate(w){w.update.url&&this.nativeHostMainService.openExternal(void 0,w.update.url),this.setState(c.State.Idle(r()))}async getUpdatePackagePath(w){const k=await this.cachePath;return d.join(k,`CodeSetup-${this.productService.quality}-${w}.exe`)}async cleanup(w=null){const k=w?H=>!new RegExp(`${this.productService.quality}-${w}\\.exe$`).test(H):()=>!0,R=await this.cachePath,O=(await I.Promises.readdir(R)).filter(k).map(async H=>{try{await I.Promises.unlink(d.join(R,H))}catch(x){}});await Promise.all(O)}async doApplyUpdate(){if(this.state.type!=="downloaded"&&this.state.type!=="downloading"||!this.availableUpdate)return Promise.resolve(void 0);const w=this.state.update;this.setState(c.State.Updating(w));const k=await this.cachePath;this.availableUpdate.updateFilePath=d.join(k,`CodeSetup-${this.productService.quality}-${w.version}.flag`),await I.Promises.writeFile(this.availableUpdate.updateFilePath,"flag"),(0,p.spawn)(this.availableUpdate.packagePath,["/verysilent",`/update="${this.availableUpdate.updateFilePath}"`,"/nocloseapplications","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"],windowsVerbatimArguments:!0}).once("exit",()=>{this.availableUpdate=void 0,this.setState(c.State.Idle(r()))});const A=`${this.productService.win32MutexName}-ready`,O=await new Promise((H,x)=>{j(["windows-mutex"],H,x)});o(()=>O.isActive(A)).then(()=>this.setState(c.State.Ready(w)))}doQuitAndInstall(){this.state.type!=="ready"||!this.availableUpdate||(this.logService.trace("update#quitAndInstall(): running raw#quitAndInstall()"),this.state.update.supportsFastUpdate&&this.availableUpdate.updateFilePath?L.unlinkSync(this.availableUpdate.updateFilePath):(0,p.spawn)(this.availableUpdate.packagePath,["/silent","/mergetasks=runcode,!desktopicon,!quicklaunchicon"],{detached:!0,stdio:["ignore","ignore","ignore"]}))}getUpdateType(){return r()}};he([b.memoize],a.prototype,"cachePath",null),a=he([te(0,h.ILifecycleMainService),te(1,S.IConfigurationService),te(2,l.ITelemetryService),te(3,m.IEnvironmentMainService),te(4,u.IRequestService),te(5,E.ILogService),te(6,t.IFileService),te(7,v.INativeHostMainService),te(8,y.IProductService)],a),e.Win32UpdateService=a}),define(Q[234],J([0,1,13,9,23,4,34,2,10,8,76,3,7,151,51,17,52,24,54,201,20,22,6,21,56,99,29,204,65,66,36,26,46]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n,o,s,r,a,f,w,k,R,A,O){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeWindow=void 0;var H;(function(re){re[re.NONE=0]="NONE",re[re.LOADING=1]="LOADING",re[re.NAVIGATING=2]="NAVIGATING",re[re.READY=3]="READY"})(H||(H={}));let x=class extends b.Disposable{constructor(K,ee,F,V,z,B,U,C,X,W,T,_,q,Y){super();this.logService=ee,this.environmentMainService=F,this.fileService=V,this.configurationService=B,this.themeMainService=U,this.workspacesManagementMainService=C,this.backupMainService=X,this.telemetryService=W,this.dialogMainService=T,this.lifecycleMainService=_,this.productService=q,this.protocolMainService=Y,this._onWillLoad=this._register(new M.Emitter),this.onWillLoad=this._onWillLoad.event,this._onDidSignalReady=this._register(new M.Emitter),this.onDidSignalReady=this._onDidSignalReady.event,this._onDidClose=this._register(new M.Emitter),this.onDidClose=this._onDidClose.event,this._onDidDestroy=this._register(new M.Emitter),this.onDidDestroy=this._onDidDestroy.event,this._lastFocusTime=-1,this.whenReadyCallbacks=[],this.touchBarGroups=[],this.currentHttpProxy=void 0,this.currentNoProxy=void 0,this.configObjectUrl=this._register(this.protocolMainService.createIPCObjectUrl()),this.wasLoaded=!1,this.readyState=0;{const[$,N]=this.restoreWindowState(K.state);this.windowState=$,this.logService.trace("window#ctor: using window state",$);const Z=this.windowState.mode===0||this.windowState.mode===3,ie=this.configurationService.getValue("window"),oe={width:this.windowState.width,height:this.windowState.height,x:this.windowState.x,y:this.windowState.y,backgroundColor:this.themeMainService.getBackgroundColor(),minWidth:k.WindowMinimumSize.WIDTH,minHeight:k.WindowMinimumSize.HEIGHT,show:!Z,title:this.productService.nameLong,webPreferences:{preload:d.FileAccess.asFileUri("vs/base/parts/sandbox/electron-browser/preload.js",j).fsPath,additionalArguments:[`--vscode-window-config=${this.configObjectUrl.resource.toString()}`],v8CacheOptions:this.environmentMainService.useCodeCache?"bypassHeatCheck":"none",enableWebSQL:!1,spellcheck:!1,nativeWindowOpen:!0,zoomFactor:(0,k.zoomLevelToZoomFactor)(ie?.zoomLevel),...this.environmentMainService.sandbox?{sandbox:!0}:{nodeIntegration:!0,contextIsolation:!1}}};I.isLinux?oe.icon=(0,g.join)(this.environmentMainService.appRoot,"resources/linux/code.png"):I.isWindows&&!this.environmentMainService.isBuilt&&(oe.icon=(0,g.join)(this.environmentMainService.appRoot,"resources/win32/code_150x150.png")),I.isMacintosh&&!this.useNativeFullScreen()&&(oe.fullscreenable=!1),I.isMacintosh&&(oe.acceptFirstMouse=!0,ie?.clickThroughInactive===!1&&(oe.acceptFirstMouse=!1));const le=I.isMacintosh&&ie?.nativeTabs===!0;le&&(oe.tabbingIdentifier=this.productService.nameShort);const ne=(0,k.getTitleBarStyle)(this.configurationService)==="custom";if(ne&&(oe.titleBarStyle="hidden",this.hiddenTitleBarStyle=!0,I.isMacintosh||(oe.frame=!1)),(0,i.mark)("code/willCreateCodeBrowserWindow"),this._win=new p.BrowserWindow(oe),(0,i.mark)("code/didCreateCodeBrowserWindow"),this._id=this._win.id,this.environmentMainService.args["open-devtools"]===!0&&this._win.webContents.openDevTools(),I.isMacintosh&&ne&&this._win.setSheetOffset(22),I.isMacintosh&&N&&(!le||p.BrowserWindow.getAllWindows().length===1)&&[this.windowState.width,this.windowState.height,this.windowState.x,this.windowState.y].every(ae=>typeof ae=="number")){const ae=this.windowState;this._win.setBounds({width:ae.width,height:ae.height,x:ae.x,y:ae.y})}Z&&((0,i.mark)("code/willMaximizeCodeWindow"),this._win.maximize(),this.windowState.mode===3&&this.setFullScreen(!0),this._win.isVisible()||this._win.show(),(0,i.mark)("code/didMaximizeCodeWindow")),this._lastFocusTime=Date.now()}this.onConfigurationUpdated(),this.createTouchBar(),this.marketplaceHeadersPromise=(0,u.resolveMarketplaceHeaders)(this.productService.version,this.productService,this.environmentMainService,this.configurationService,this.fileService,{get:$=>z.globalStorage.get($),store:($,N)=>z.globalStorage.set($,N)}),this.registerListeners()}get id(){return this._id}get win(){return this._win}get lastFocusTime(){return this._lastFocusTime}get backupPath(){return this.currentConfig?.backupPath}get openedWorkspace(){return this.currentConfig?.workspace}get remoteAuthority(){return this.currentConfig?.remoteAuthority}get config(){return this.currentConfig}get hasHiddenTitleBarStyle(){return!!this.hiddenTitleBarStyle}get isExtensionDevelopmentHost(){return!!this.currentConfig?.extensionDevelopmentPath}get isExtensionTestHost(){return!!this.currentConfig?.extensionTestsPath}get isExtensionDevelopmentTestFromCli(){return this.isExtensionDevelopmentHost&&this.isExtensionTestHost&&!this.currentConfig?.debugId}setRepresentedFilename(K){I.isMacintosh?this._win.setRepresentedFilename(K):this.representedFilename=K}getRepresentedFilename(){return I.isMacintosh?this._win.getRepresentedFilename():this.representedFilename}setDocumentEdited(K){I.isMacintosh&&this._win.setDocumentEdited(K),this.documentEdited=K}isDocumentEdited(){return I.isMacintosh?this._win.isDocumentEdited():!!this.documentEdited}focus(K){I.isMacintosh&&K?.force&&p.app.focus({steal:!0}),!!this._win&&(this._win.isMinimized()&&this._win.restore(),this._win.focus())}setReady(){for(this.readyState=3;this.whenReadyCallbacks.length;)this.whenReadyCallbacks.pop()(this);this._onDidSignalReady.fire()}ready(){return new Promise(K=>{if(this.isReady)return K(this);this.whenReadyCallbacks.push(K)})}get isReady(){return this.readyState===3}get whenClosedOrLoaded(){return new Promise(K=>{function ee(){F.dispose(),V.dispose(),K()}const F=this.onDidClose(()=>ee()),V=this.onWillLoad(()=>ee())})}registerListeners(){this._win.on("unresponsive",()=>this.onWindowError(1)),this._win.webContents.on("render-process-gone",(z,B)=>this.onWindowError(2,B)),this._win.webContents.on("did-fail-load",(z,B,U)=>this.onWindowError(3,{reason:U,exitCode:B})),this._win.webContents.on("will-prevent-unload",z=>{z.preventDefault()}),this._win.on("closed",()=>{this._onDidClose.fire(),this.dispose()});const K=new Set([d.Schemas.file,d.Schemas.vscodeFileResource,d.Schemas.vscodeRemoteResource,"devtools"]),ee=z=>{for(let B=z;B;B=B.parent)if(B.url.startsWith(`${d.Schemas.vscodeWebview}://`))return!0;return!1},F=z=>z.resourceType==="xhr"||ee(z.frame);this._win.webContents.session.webRequest.onBeforeRequest((z,B)=>{const U=S.URI.parse(z.url);return U.path.endsWith(".svg")&&!K.has(U.scheme)?B({cancel:!F(z)}):B({cancel:!1})}),this._win.webContents.session.webRequest.onHeadersReceived((z,B)=>{const U=z.responseHeaders,C=U["content-type"]||U["Content-Type"];if(C&&Array.isArray(C)){const X=S.URI.parse(z.url);if(X.path.endsWith(".svg")&&K.has(X.scheme))return U["Content-Type"]=["image/svg+xml"],B({cancel:!1,responseHeaders:U});if(!X.path.includes(d.Schemas.vscodeRemoteResource)&&C.some(W=>W.toLowerCase().includes("image/svg")))return B({cancel:!F(z)})}return B({cancel:!1})}),this._win.webContents.on("did-finish-load",()=>{this.readyState=1,this.pendingLoadConfig&&(this.currentConfig=this.pendingLoadConfig,this.pendingLoadConfig=void 0)}),this._win.on("focus",()=>{this._lastFocusTime=Date.now()}),this._win.on("maximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!0),p.app.emit("browser-window-maximize",z,this._win)}),this._win.on("unmaximize",z=>{this.currentConfig&&(this.currentConfig.maximized=!1),p.app.emit("browser-window-unmaximize",z,this._win)}),this._win.on("enter-full-screen",()=>{this.sendWhenReady("vscode:enterFullScreen",D.CancellationToken.None)}),this._win.on("leave-full-screen",()=>{this.sendWhenReady("vscode:leaveFullScreen",D.CancellationToken.None)}),this._register(this.configurationService.onDidChangeConfiguration(()=>this.onConfigurationUpdated())),this._register(this.workspacesManagementMainService.onDidDeleteUntitledWorkspace(z=>this.onDidDeleteUntitledWorkspace(z)));const V=["https://marketplace.visualstudio.com/*","https://*.vsassets.io/*"];this._win.webContents.session.webRequest.onBeforeSendHeaders({urls:V},async(z,B)=>{const U=await this.marketplaceHeadersPromise;B({cancel:!1,requestHeaders:Object.assign(z.requestHeaders,U)})})}async onWindowError(K,ee){switch(K){case 2:this.logService.error(`CodeWindow: renderer process crashed (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break;case 1:this.logService.error("CodeWindow: detected unresponsive");break;case 3:this.logService.error(`CodeWindow: failed to load (reason: ${ee?.reason||"<unknown>"}, code: ${ee?.exitCode||"<unknown>"})`);break}switch(this.telemetryService.publicLog2("windowerror",{type:K,reason:ee?.reason,code:ee?.exitCode}),K){case 1:case 2:if(this.isExtensionDevelopmentTestFromCli){this.lifecycleMainService.kill(1);return}if(K===1){if(this.isExtensionDevelopmentHost||this.isExtensionTestHost||this._win&&this._win.webContents&&this._win.webContents.isDevToolsOpened())return;const F=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,m.localize)(0,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(1,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(2,null))],message:(0,m.localize)(3,null),detail:(0,m.localize)(4,null),noLink:!0,defaultId:0,cancelId:1},this._win);if(!this._win)return;F.response===0?(this._win.webContents.forcefullyCrashRenderer(),this.reload()):F.response===2&&this.destroyWindow()}else if(K===2){let F;ee?F=(0,m.localize)(6,null,ee.reason,ee.exitCode??"<unknown>"):F=(0,m.localize)(5,null);const V=await this.dialogMainService.showMessageBox({title:this.productService.nameLong,type:"warning",buttons:[(0,P.mnemonicButtonLabel)((0,m.localize)(7,null)),(0,P.mnemonicButtonLabel)((0,m.localize)(8,null))],message:F,detail:(0,m.localize)(9,null),noLink:!0,defaultId:0},this._win);if(!this._win)return;V.response===0?this.reload():V.response===1&&this.destroyWindow()}break}}destroyWindow(){this._onDidDestroy.fire(),this._win.destroy()}onDidDeleteUntitledWorkspace(K){this.openedWorkspace?.id===K.id&&this.currentConfig&&(this.currentConfig.workspace=void 0)}onConfigurationUpdated(){const K=this.getMenuBarVisibility();K!==this.currentMenuBarVisibility&&(this.currentMenuBarVisibility=K,this.setMenuBarVisibility(K));let ee=(this.configurationService.getValue("http.proxy")||"").trim()||(process.env.https_proxy||process.env.HTTPS_PROXY||process.env.http_proxy||process.env.HTTP_PROXY||"").trim()||void 0;ee?.endsWith("/")&&(ee=ee.substr(0,ee.length-1));const F=(process.env.no_proxy||process.env.NO_PROXY||"").trim()||void 0;if((ee||"").indexOf("@")===-1&&(ee!==this.currentHttpProxy||F!==this.currentNoProxy)){this.currentHttpProxy=ee,this.currentNoProxy=F;const V=ee||"",z=F?`${F},<local>`:"<local>";this.logService.trace(`Setting proxy to '${V}', bypassing '${z}'`),this._win.webContents.session.setProxy({proxyRules:V,proxyBypassRules:z,pacScript:""})}}addTabbedWindow(K){I.isMacintosh&&K.win&&this._win.addTabbedWindow(K.win)}load(K,ee=Object.create(null)){this.isDocumentEdited()&&(!ee.isReload||!this.backupMainService.isHotExitEnabled())&&this.setDocumentEdited(!1),ee.isReload||(this.getRepresentedFilename()&&this.setRepresentedFilename(""),this._win.setTitle(this.productService.nameLong)),this.updateConfiguration(K,ee),this.readyState===0?this.currentConfig=K:(this.pendingLoadConfig=K,this.readyState=2),this._win.loadURL(d.FileAccess.asBrowserUri(this.environmentMainService.sandbox?"vs/code/electron-sandbox/workbench/workbench.html":"vs/code/electron-browser/workbench/workbench.html",j).toString(!0));const F=this.wasLoaded;this.wasLoaded=!0,!this.environmentMainService.isBuilt&&!this.environmentMainService.extensionTestsLocationURI&&this._register(new L.RunOnceScheduler(()=>{this._win&&!this._win.isVisible()&&!this._win.isMinimized()&&(this._win.show(),this.focus({force:!0}),this._win.webContents.openDevTools())},1e4)).schedule(),this._onWillLoad.fire({workspace:K.workspace,reason:ee.isReload?3:F?2:1})}updateConfiguration(K,ee){const F=(this.currentConfig??this.pendingLoadConfig)?.userEnv;if(F){const V=(0,y.isLaunchedFromCli)(F)&&!(0,y.isLaunchedFromCli)(K.userEnv),z=this.isExtensionDevelopmentHost;(V||z)&&(K.userEnv={...F,...K.userEnv})}process.env.CHROME_CRASHPAD_PIPE_NAME&&Object.assign(K.userEnv,{CHROME_CRASHPAD_PIPE_NAME:process.env.CHROME_CRASHPAD_PIPE_NAME}),ee.disableExtensions!==void 0&&(K["disable-extensions"]=ee.disableExtensions),K.fullscreen=this.isFullScreen,K.maximized=this._win.isMaximized(),K.partsSplash=this.themeMainService.getWindowSplash(),(0,i.mark)("code/willOpenNewWindow"),K.perfMarks=(0,i.getMarks)(),this.configObjectUrl.update(K)}async reload(K){const ee=Object.assign({},this.currentConfig);ee.workspace=await this.validateWorkspaceBeforeReload(ee),delete ee.filesToOpenOrCreate,delete ee.filesToDiff,delete ee.filesToWait,this.isExtensionDevelopmentHost&&K&&(ee.verbose=K.verbose,ee.debugId=K.debugId,ee.extensionEnvironment=K.extensionEnvironment,ee["inspect-extensions"]=K["inspect-extensions"],ee["inspect-brk-extensions"]=K["inspect-brk-extensions"],ee["extensions-dir"]=K["extensions-dir"]),ee.isInitialStartup=!1,this.load(ee,{isReload:!0,disableExtensions:K?.["disable-extensions"]})}async validateWorkspaceBeforeReload(K){if((0,A.isWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.configPath;if(ee.scheme===d.Schemas.file&&!await this.fileService.exists(ee))return}else if((0,A.isSingleFolderWorkspaceIdentifier)(K.workspace)){const ee=K.workspace.uri;if(ee.scheme===d.Schemas.file&&!await this.fileService.exists(ee))return}return K.workspace}serializeWindowState(){if(!this._win)return(0,R.defaultWindowState)();if(this.isFullScreen){let F;try{F=p.screen.getDisplayMatching(this.getBounds())}catch(B){}const V=(0,R.defaultWindowState)();return{mode:3,display:F?F.id:void 0,width:this.windowState.width||V.width,height:this.windowState.height||V.height,x:this.windowState.x||0,y:this.windowState.y||0}}const K=Object.create(null);let ee;if(!I.isMacintosh&&this._win.isMaximized()?ee=0:ee=1,ee===0?K.mode=0:K.mode=1,ee===1||ee===0){let F;ee===1?F=this.getBounds():F=this._win.getNormalBounds(),K.x=F.x,K.y=F.y,K.width=F.width,K.height=F.height}return K}restoreWindowState(K){(0,i.mark)("code/willRestoreCodeWindowState");let ee=!1;if(K)try{const F=p.screen.getAllDisplays();ee=F.length>1,K=this.validateWindowState(K,F)}catch(F){this.logService.warn(`Unexpected error validating window state: ${F}
${F.stack}`)}return(0,i.mark)("code/didRestoreCodeWindowState"),[K||(0,R.defaultWindowState)(),ee]}validateWindowState(K,ee){if(this.logService.trace(`window#validateWindowState: validating window state on ${ee.length} display(s)`,K),typeof K.x!="number"||typeof K.y!="number"||typeof K.width!="number"||typeof K.height!="number"){this.logService.trace("window#validateWindowState: unexpected type of state values");return}if(K.width<=0||K.height<=0){this.logService.trace("window#validateWindowState: unexpected negative values");return}if(ee.length===1){const z=this.getWorkingArea(ee[0]);if(z){let B=function(){!K||typeof K.x!="number"||typeof K.y!="number"||!z||(K.x<z.x&&(K.x=z.x),K.y<z.y&&(K.y=z.y))};this.logService.trace("window#validateWindowState: 1 monitor working area",z),B(),K.width>z.width&&(K.width=z.width),K.height>z.height&&(K.height=z.height),K.x>z.x+z.width-128&&(K.x=z.x+z.width-K.width),K.y>z.y+z.height-128&&(K.y=z.y+z.height-K.height),B()}return K}if(K.display&&K.mode===3){const z=ee.find(B=>B.id===K.display);if(z&&typeof z.bounds?.x=="number"&&typeof z.bounds?.y=="number"){this.logService.trace("window#validateWindowState: restoring fullscreen to previous display");const B=(0,R.defaultWindowState)(3);return B.x=z.bounds.x,B.y=z.bounds.y,B}}let F,V;try{F=p.screen.getDisplayMatching({x:K.x,y:K.y,width:K.width,height:K.height}),V=this.getWorkingArea(F)}catch(z){}if(F&&V&&K.x+K.width>V.x&&K.y+K.height>V.y&&K.x<V.x+V.width&&K.y<V.y+V.height)return this.logService.trace("window#validateWindowState: multi-monitor working area",V),K}getWorkingArea(K){if(K.workArea.width>0&&K.workArea.height>0)return K.workArea;if(K.bounds.width>0&&K.bounds.height>0)return K.bounds}getBounds(){const[K,ee]=this._win.getPosition(),[F,V]=this._win.getSize();return{x:K,y:ee,width:F,height:V}}toggleFullScreen(){this.setFullScreen(!this.isFullScreen)}setFullScreen(K){this.useNativeFullScreen()?this.setNativeFullScreen(K):this.setSimpleFullScreen(K),this.sendWhenReady(K?"vscode:enterFullScreen":"vscode:leaveFullScreen",D.CancellationToken.None),this.currentMenuBarVisibility&&this.setMenuBarVisibility(this.currentMenuBarVisibility,!1)}get isFullScreen(){return this._win.isFullScreen()||this._win.isSimpleFullScreen()}setNativeFullScreen(K){this._win.isSimpleFullScreen()&&this._win.setSimpleFullScreen(!1),this._win.setFullScreen(K)}setSimpleFullScreen(K){this._win.isFullScreen()&&this._win.setFullScreen(!1),this._win.setSimpleFullScreen(K),this._win.webContents.focus()}useNativeFullScreen(){const K=this.configurationService.getValue("window");return!K||typeof K.nativeFullScreen!="boolean"||K.nativeTabs?!0:K.nativeFullScreen!==!1}isMinimized(){return this._win.isMinimized()}getMenuBarVisibility(){let K=(0,k.getMenuBarVisibility)(this.configurationService);return["visible","toggle","hidden"].indexOf(K)<0&&(K="classic"),K}setMenuBarVisibility(K,ee=!0){I.isMacintosh||(K==="toggle"&&ee&&this.send("vscode:showInfoMessage",(0,m.localize)(10,null)),K==="hidden"?setTimeout(()=>{this.doSetMenuBarVisibility(K)}):this.doSetMenuBarVisibility(K))}doSetMenuBarVisibility(K){const ee=this.isFullScreen;switch(K){case"classic":this._win.setMenuBarVisibility(!ee),this._win.autoHideMenuBar=ee;break;case"visible":this._win.setMenuBarVisibility(!0),this._win.autoHideMenuBar=!1;break;case"toggle":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!0;break;case"hidden":this._win.setMenuBarVisibility(!1),this._win.autoHideMenuBar=!1;break}}handleTitleDoubleClick(){if(I.isMacintosh)switch(p.systemPreferences.getUserDefault("AppleActionOnDoubleClick","string")){case"Minimize":this._win.minimize();break;case"None":break;case"Maximize":default:this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}else this._win.isMaximized()?this._win.unmaximize():this._win.maximize()}close(){this._win&&this._win.close()}sendWhenReady(K,ee,...F){this.isReady?this.send(K,...F):this.ready().then(()=>{ee.isCancellationRequested||this.send(K,...F)})}send(K,...ee){if(this._win){if(this._win.isDestroyed()||this._win.webContents.isDestroyed()){this.logService.warn(`Sending IPC message to channel '${K}' for window that is destroyed`);return}this._win.webContents.send(K,...ee)}}updateTouchBar(K){!I.isMacintosh||this.touchBarGroups.forEach((ee,F)=>{const V=K[F];ee.segments=this.createTouchBarGroupSegments(V)})}createTouchBar(){if(!!I.isMacintosh){for(let K=0;K<10;K++){const ee=this.createTouchBarGroup();this.touchBarGroups.push(ee)}this._win.setTouchBar(new p.TouchBar({items:this.touchBarGroups}))}}createTouchBarGroup(K=[]){const ee=this.createTouchBarGroupSegments(K),F=new p.TouchBar.TouchBarSegmentedControl({segments:ee,mode:"buttons",segmentStyle:"automatic",change:V=>{this.sendWhenReady("vscode:runAction",D.CancellationToken.None,{id:F.segments[V].id,from:"touchbar"})}});return F}createTouchBarGroupSegments(K=[]){return K.map(F=>{let V;F.icon&&!f.ThemeIcon.isThemeIcon(F.icon)&&F.icon?.dark?.scheme===d.Schemas.file&&(V=p.nativeImage.createFromPath(S.URI.revive(F.icon.dark).fsPath),V.isEmpty()&&(V=void 0));let z;return typeof F.title=="string"?z=F.title:z=F.title.value,{id:F.id,label:V?void 0:z,icon:V}})}dispose(){super.dispose(),this._win=null}};x=he([te(1,n.ILogService),te(2,v.IEnvironmentMainService),te(3,l.IFileService),te(4,r.IStorageMainService),te(5,h.IConfigurationService),te(6,w.IThemeMainService),te(7,O.IWorkspacesManagementMainService),te(8,t.IBackupMainService),te(9,a.ITelemetryService),te(10,E.IDialogMainService),te(11,c.ILifecycleMainService),te(12,o.IProductService),te(13,s.IProtocolMainService)],x),e.CodeWindow=x}),define(Q[67],J([0,1,13,30,9,4,34,2,10,3,15,7,19,154,5,22,6,38,26,46]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesHistoryMainService=e.IWorkspacesHistoryMainService=void 0,e.IWorkspacesHistoryMainService=(0,t.createDecorator)("workspacesHistoryMainService");let l=class $e extends b.Disposable{constructor(f,w,k,R){super();this.stateMainService=f,this.logService=w,this.workspacesManagementMainService=k,this.lifecycleMainService=R,this._onDidChangeRecentlyOpened=this._register(new M.Emitter),this.onDidChangeRecentlyOpened=this._onDidChangeRecentlyOpened.event,this.macOSRecentDocumentsUpdater=this._register(new D.ThrottledDelayer(800)),this.registerListeners()}registerListeners(){this.lifecycleMainService.when(3).then(()=>this.handleWindowsJumpList()),this._register(this.workspacesManagementMainService.onDidEnterWorkspace(f=>this.addRecentlyOpened([{workspace:f.workspace}])))}handleWindowsJumpList(){!g.isWindows||(this.updateWindowsJumpList(),this._register(this.onDidChangeRecentlyOpened(()=>this.updateWindowsJumpList())))}addRecentlyOpened(f){const w=[],k=[];for(let R of f)if((0,y.isRecentWorkspace)(R))!this.workspacesManagementMainService.isUntitledWorkspace(R.workspace)&&o(w,R.workspace)===-1&&w.push(R);else if((0,y.isRecentFolder)(R))s(w,R.folderUri)===-1&&w.push(R);else{const A=r(k,R.fileUri)>=0,O=R.fileUri.scheme===d.Schemas.file&&$e.COMMON_FILES_FILTER.indexOf((0,i.basename)(R.fileUri))>=0;!A&&!O&&(k.push(R),g.isWindows&&R.fileUri.scheme===d.Schemas.file&&p.app.addRecentDocument(R.fileUri.fsPath))}this.addEntriesFromStorage(w,k),w.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(w.length=$e.MAX_TOTAL_RECENT_ENTRIES),k.length>$e.MAX_TOTAL_RECENT_ENTRIES&&(k.length=$e.MAX_TOTAL_RECENT_ENTRIES),this.saveRecentlyOpened({workspaces:w,files:k}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments())}removeRecentlyOpened(f){const w=O=>{const H=n(O);for(const x of f)if(i.extUriBiasedIgnorePathCase.isEqual(x,H))return!1;return!0},k=this.getRecentlyOpened(),R=k.workspaces.filter(w),A=k.files.filter(w);(R.length!==k.workspaces.length||A.length!==k.files.length)&&(this.saveRecentlyOpened({files:A,workspaces:R}),this._onDidChangeRecentlyOpened.fire(),g.isMacintosh&&this.macOSRecentDocumentsUpdater.trigger(()=>this.updateMacOSRecentDocuments()))}async updateMacOSRecentDocuments(){if(!g.isMacintosh)return;p.app.clearRecentDocuments();const f=this.getRecentlyOpened(),w=[];let k=0;for(let A=0;A<f.workspaces.length&&k<$e.MAX_MACOS_DOCK_RECENT_WORKSPACES;A++){const O=n(f.workspaces[A]);if(O.scheme===d.Schemas.file){const H=(0,i.originalFSPath)(O);await S.Promises.exists(H)&&(w.push(H),k++)}}const R=[];for(let A=0;A<f.files.length&&k<$e.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL;A++){const O=n(f.files[A]);if(O.scheme===d.Schemas.file){const H=(0,i.originalFSPath)(O);if($e.COMMON_FILES_FILTER.includes((0,i.basename)(O))||w.includes(H))continue;await S.Promises.exists(H)&&(R.push(H),k++)}}R.reverse().forEach(A=>p.app.addRecentDocument(A)),w.reverse().forEach(A=>p.app.addRecentDocument(A))}clearRecentlyOpened(){this.saveRecentlyOpened({workspaces:[],files:[]}),p.app.clearRecentDocuments(),this._onDidChangeRecentlyOpened.fire()}getRecentlyOpened(f){const w=[],k=[],R=f?.config?.workspace;(0,y.isWorkspaceIdentifier)(R)&&!this.workspacesManagementMainService.isUntitledWorkspace(R)?w.push({workspace:R}):(0,y.isSingleFolderWorkspaceIdentifier)(R)&&w.push({folderUri:R.uri});const A=f?.config?.filesToOpenOrCreate;if(A)for(let O of A){const H=O.fileUri;H&&r(k,H)===-1&&k.push({fileUri:H})}return this.addEntriesFromStorage(w,k),{workspaces:w,files:k}}addEntriesFromStorage(f,w){let k=this.getRecentlyOpenedFromStorage();for(let R of k.workspaces){let A=(0,y.isRecentFolder)(R)?s(f,R.folderUri):o(f,R.workspace);A>=0?f[A].label=f[A].label||R.label:f.push(R)}for(let R of k.files){let A=r(w,R.fileUri);A>=0?w[A].label=w[A].label||R.label:w.push(R)}}getRecentlyOpenedFromStorage(){const f=this.stateMainService.getItem($e.recentlyOpenedStorageKey);return(0,y.restoreRecentlyOpened)(f,this.logService)}saveRecentlyOpened(f){const w=(0,y.toStoreData)(f);this.stateMainService.setItem($e.recentlyOpenedStorageKey,w)}updateWindowsJumpList(){if(!g.isWindows)return;const f=[];if(f.push({type:"tasks",items:[{type:"task",title:(0,m.localize)(0,null),description:(0,m.localize)(1,null),program:process.execPath,args:"-n",iconPath:process.execPath,iconIndex:0}]}),this.getRecentlyOpened().workspaces.length>0){let w=[];for(let A of p.app.getJumpListSettings().removedItems){const O=A.args;if(O){const H=/^--(folder|file)-uri\s+"([^"]+)"$/.exec(O);H&&w.push(I.URI.parse(H[2]))}}this.removeRecentlyOpened(w);let k=!1;const R=(0,L.coalesce)(this.getRecentlyOpened().workspaces.slice(0,7).map(A=>{const O=(0,y.isRecentWorkspace)(A)?A.workspace:A.folderUri,{title:H,description:x}=this.getWindowsJumpListLabel(O,A.label);let re;return I.URI.isUri(O)?re=`--folder-uri "${O.toString()}"`:(k=!0,re=`--file-uri "${O.configPath.toString()}"`),{type:"task",title:H.substr(0,255),description:x.substr(0,255),program:process.execPath,args:re,iconPath:"explorer.exe",iconIndex:0}}));R.length>0&&f.push({type:"custom",name:k?(0,m.localize)(2,null):(0,m.localize)(3,null),items:R})}f.push({type:"recent"});try{p.app.setJumpList(f)}catch(w){this.logService.warn("updateWindowsJumpList#setJumpList",w)}}getWindowsJumpListLabel(f,w){if(w)return{title:(0,P.splitName)(w).name,description:w};if(I.URI.isUri(f))return{title:(0,i.basename)(f),description:c(f)};if(this.workspacesManagementMainService.isUntitledWorkspace(f))return{title:(0,m.localize)(4,null),description:""};let k=(0,i.basename)(f.configPath);return k.endsWith(y.WORKSPACE_EXTENSION)&&(k=k.substr(0,k.length-y.WORKSPACE_EXTENSION.length-1)),{title:(0,m.localize)(5,null,k),description:c(f.configPath)}}};l.MAX_TOTAL_RECENT_ENTRIES=100,l.MAX_MACOS_DOCK_RECENT_WORKSPACES=7,l.MAX_MACOS_DOCK_RECENT_ENTRIES_TOTAL=10,l.COMMON_FILES_FILTER=["COMMIT_EDITMSG","MERGE_MSG"],l.recentlyOpenedStorageKey="openedPathsList",l=he([te(0,v.IStateMainService),te(1,E.ILogService),te(2,u.IWorkspacesManagementMainService),te(3,h.ILifecycleMainService)],l),e.WorkspacesHistoryMainService=l;function c(a){return a.scheme==="file"?(0,P.normalizeDriveLetter)(a.fsPath):a.toString()}function n(a){return(0,y.isRecentFolder)(a)?a.folderUri:(0,y.isRecentFile)(a)?a.fileUri:a.workspace.configPath}function o(a,f){return a.findIndex(w=>(0,y.isRecentWorkspace)(w)&&w.workspace.id===f.id)}function s(a,f){return a.findIndex(w=>(0,y.isRecentFolder)(w)&&i.extUriBiasedIgnorePathCase.isEqual(w.folderUri,f))}function r(a,f){return a.findIndex(w=>i.extUriBiasedIgnorePathCase.isEqual(w.fileUri,f))}}),define(Q[235],J([0,1,13,9,23,34,3,7,146,17,24,22,6,182,53,21,38,29,41,66,36,67]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Menubar=void 0;const n="menu";let o=class pt{constructor(a,f,w,k,R,A,O,H,x,re,K){this.updateService=a,this.configurationService=f,this.windowsMainService=w,this.environmentMainService=k,this.telemetryService=R,this.workspacesHistoryMainService=A,this.stateMainService=O,this.lifecycleMainService=H,this.logService=x,this.nativeHostMainService=re,this.productService=K,this.fallbackMenuHandlers=Object.create(null),this.menuUpdater=new L.RunOnceScheduler(()=>this.doUpdateMenu(),0),this.menuGC=new L.RunOnceScheduler(()=>{this.oldMenus=[]},1e4),this.menubarMenus=Object.create(null),this.keybindings=Object.create(null),(P.isMacintosh||(0,u.getTitleBarStyle)(this.configurationService)==="native")&&this.restoreCachedMenubarData(),this.addFallbackHandlers(),this.closedLastWindow=!1,this.noActiveWindow=!1,this.oldMenus=[],this.install(),this.registerListeners()}restoreCachedMenubarData(){const a=this.stateMainService.getItem(pt.lastKnownMenubarStorageKey);a&&(a.menus&&(this.menubarMenus=a.menus),a.keybindings&&(this.keybindings=a.keybindings))}addFallbackHandlers(){this.fallbackMenuHandlers["workbench.action.files.newUntitledFile"]=(A,O,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.newWindow"]=(A,O,H)=>this.windowsMainService.openEmptyWindow({context:2,contextWindowId:O?.id}),this.fallbackMenuHandlers["workbench.action.files.openFileFolder"]=(A,O,H)=>this.nativeHostMainService.pickFileFolderAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.openWorkspace"]=(A,O,H)=>this.nativeHostMainService.pickWorkspaceAndOpen(void 0,{forceNewWindow:this.isOptionClick(H),telemetryExtraData:{from:n}}),this.fallbackMenuHandlers["workbench.action.clearRecentFiles"]=()=>this.workspacesHistoryMainService.clearRecentlyOpened();const a=this.productService.twitterUrl;a&&(this.fallbackMenuHandlers["workbench.action.openTwitterUrl"]=()=>this.openUrl(a,"openTwitterUrl"));const f=this.productService.requestFeatureUrl;f&&(this.fallbackMenuHandlers["workbench.action.openRequestFeatureUrl"]=()=>this.openUrl(f,"openUserVoiceUrl"));const w=this.productService.reportIssueUrl;w&&(this.fallbackMenuHandlers["workbench.action.openIssueReporter"]=()=>this.openUrl(w,"openReportIssues"));const k=this.productService.licenseUrl;k&&(this.fallbackMenuHandlers["workbench.action.openLicenseUrl"]=()=>{if(P.language){const A=k.indexOf("?")>0?"&":"?";this.openUrl(`${k}${A}lang=${P.language}`,"openLicenseUrl")}else this.openUrl(k,"openLicenseUrl")});const R=this.productService.privacyStatementUrl;R&&k&&(this.fallbackMenuHandlers["workbench.action.openPrivacyStatementUrl"]=()=>{this.openUrl(R,"openPrivacyStatement")})}registerListeners(){this.lifecycleMainService.onWillShutdown(()=>this.willShutdown=!0),this.windowsMainService.onDidChangeWindowsCount(a=>this.onDidChangeWindowsCount(a)),this.nativeHostMainService.onDidBlurWindow(()=>this.onDidChangeWindowFocus()),this.nativeHostMainService.onDidFocusWindow(()=>this.onDidChangeWindowFocus())}get currentEnableMenuBarMnemonics(){let a=this.configurationService.getValue("window.enableMenuBarMnemonics");return typeof a!="boolean"?!0:a}get currentEnableNativeTabs(){if(!P.isMacintosh)return!1;let a=this.configurationService.getValue("window.nativeTabs");return typeof a!="boolean"?!1:a}updateMenu(a,f){this.menubarMenus=a.menus,this.keybindings=a.keybindings,this.stateMainService.setItem(pt.lastKnownMenubarStorageKey,a),this.scheduleUpdateMenu()}scheduleUpdateMenu(){this.menuUpdater.schedule()}doUpdateMenu(){this.willShutdown||setTimeout(()=>{this.willShutdown||this.install()},10)}onDidChangeWindowsCount(a){!P.isMacintosh||(a.oldCount===0&&a.newCount>0||a.oldCount>0&&a.newCount===0)&&(this.closedLastWindow=a.newCount===0,this.scheduleUpdateMenu())}onDidChangeWindowFocus(){!P.isMacintosh||(this.noActiveWindow=!p.BrowserWindow.getFocusedWindow(),this.scheduleUpdateMenu())}install(){const a=p.Menu.getApplicationMenu();if(a&&this.oldMenus.push(a),Object.keys(this.menubarMenus).length===0){p.Menu.setApplicationMenu(P.isMacintosh?new p.Menu:null);return}const f=new p.Menu;let w;if(P.isMacintosh){const R=new p.Menu;w=new p.MenuItem({label:this.productService.nameShort,submenu:R}),this.setMacApplicationMenu(R),f.append(w)}if(P.isMacintosh&&!this.appMenuInstalled){this.appMenuInstalled=!0;const R=new p.Menu;R.append(new p.MenuItem({label:this.mnemonicLabel(d.localize(0,null)),click:()=>this.windowsMainService.openEmptyWindow({context:1})})),p.app.dock.setMenu(R)}if(this.shouldDrawMenu("File")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(1,null)),submenu:R});this.setMenuById(R,"File"),f.append(A)}if(this.shouldDrawMenu("Edit")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(2,null)),submenu:R});this.setMenuById(R,"Edit"),f.append(A)}if(this.shouldDrawMenu("Selection")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(3,null)),submenu:R});this.setMenuById(R,"Selection"),f.append(A)}if(this.shouldDrawMenu("View")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(4,null)),submenu:R});this.setMenuById(R,"View"),f.append(A)}if(this.shouldDrawMenu("Go")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(5,null)),submenu:R});this.setMenuById(R,"Go"),f.append(A)}if(this.shouldDrawMenu("Run")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(6,null)),submenu:R});this.setMenuById(R,"Run"),f.append(A)}if(this.shouldDrawMenu("Terminal")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(7,null)),submenu:R});this.setMenuById(R,"Terminal"),f.append(A)}let k;if(this.shouldDrawMenu("Window")){const R=new p.Menu;k=new p.MenuItem({label:this.mnemonicLabel(d.localize(8,null)),submenu:R,role:"window"}),this.setMacWindowMenu(R)}if(k&&f.append(k),this.shouldDrawMenu("Help")){const R=new p.Menu,A=new p.MenuItem({label:this.mnemonicLabel(d.localize(9,null)),submenu:R,role:"help"});this.setMenuById(R,"Help"),f.append(A)}f.items&&f.items.length>0?p.Menu.setApplicationMenu(f):p.Menu.setApplicationMenu(null),this.menuGC.schedule()}setMacApplicationMenu(a){const f=this.createMenuItem(d.localize(10,null,this.productService.nameLong),"workbench.action.showAboutDialog"),w=this.getUpdateMenuItems();let k;if(this.shouldDrawMenu("Preferences")){const ee=new p.Menu;this.setMenuById(ee,"Preferences"),k=new p.MenuItem({label:this.mnemonicLabel(d.localize(11,null)),submenu:ee})}const R=new p.Menu,A=new p.MenuItem({label:d.localize(12,null),role:"services",submenu:R}),O=new p.MenuItem({label:d.localize(13,null,this.productService.nameLong),role:"hide",accelerator:"Command+H"}),H=new p.MenuItem({label:d.localize(14,null),role:"hideOthers",accelerator:"Command+Alt+H"}),x=new p.MenuItem({label:d.localize(15,null),role:"unhide"}),re=new p.MenuItem(this.likeAction("workbench.action.quit",{label:d.localize(16,null,this.productService.nameLong),click:()=>{const ee=this.windowsMainService.getLastActiveWindow();(this.windowsMainService.getWindowCount()===0||!!p.BrowserWindow.getFocusedWindow()||ee?.isMinimized())&&this.nativeHostMainService.quit(void 0)}})),K=[f];K.push(...w),k&&K.push(s(),k),K.push(s(),A,s(),O,H,x,s(),re),K.forEach(ee=>a.append(ee))}shouldDrawMenu(a){if(!P.isMacintosh&&(0,u.getTitleBarStyle)(this.configurationService)==="custom")return!1;switch(a){case"File":case"Help":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus&&!!this.menubarMenus[a];case"Window":if(P.isMacintosh)return this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow||!!this.menubarMenus;default:return this.windowsMainService.getWindowCount()>0&&!!this.menubarMenus&&!!this.menubarMenus[a]}}setMenu(a,f){f.forEach(w=>{if((0,m.isMenubarMenuItemSeparator)(w))a.append(s());else if((0,m.isMenubarMenuItemSubmenu)(w)){const k=new p.Menu,R=new p.MenuItem({label:this.mnemonicLabel(w.label),submenu:k});this.setMenu(k,w.submenu.items),a.append(R)}else(0,m.isMenubarMenuItemRecentAction)(w)?a.append(this.createOpenRecentMenuItem(w)):(0,m.isMenubarMenuItemAction)(w)&&(w.id==="workbench.action.showAboutDialog"&&this.insertCheckForUpdatesItems(a),P.isMacintosh?this.windowsMainService.getWindowCount()===0&&this.closedLastWindow||this.windowsMainService.getWindowCount()>0&&this.noActiveWindow?this.fallbackMenuHandlers[w.id]?a.append(new p.MenuItem(this.likeAction(w.id,{label:this.mnemonicLabel(w.label),click:this.fallbackMenuHandlers[w.id]}))):a.append(this.createMenuItem(w.label,w.id,!1,w.checked)):a.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)):a.append(this.createMenuItem(w.label,w.id,w.enabled!==!1,!!w.checked)))})}setMenuById(a,f){this.menubarMenus&&this.menubarMenus[f]&&this.setMenu(a,this.menubarMenus[f].items)}insertCheckForUpdatesItems(a){const f=this.getUpdateMenuItems();f.length&&(f.forEach(w=>a.append(w)),a.append(s()))}createOpenRecentMenuItem(a){const f=b.URI.revive(a.uri),w=a.id,k=w==="openRecentFile"?{fileUri:f}:w==="openRecentWorkspace"?{workspaceUri:f}:{folderUri:f};return new p.MenuItem(this.likeAction(w,{label:a.label,click:(R,A,O)=>{const H=this.isOptionClick(O);this.windowsMainService.open({context:2,cli:this.environmentMainService.args,urisToOpen:[k],forceNewWindow:H,gotoLineMode:!1,remoteAuthority:a.remoteAuthority}).length>0||this.workspacesHistoryMainService.removeRecentlyOpened([f])}},!1))}isOptionClick(a){return!!(a&&(!P.isMacintosh&&(a.ctrlKey||a.shiftKey)||P.isMacintosh&&(a.metaKey||a.altKey)))}createRoleMenuItem(a,f,w){const k={label:this.mnemonicLabel(a),role:w,enabled:!0};return new p.MenuItem(this.withKeybinding(f,k))}setMacWindowMenu(a){const f=new p.MenuItem({label:d.localize(17,null),role:"minimize",accelerator:"Command+M",enabled:this.windowsMainService.getWindowCount()>0}),w=new p.MenuItem({label:d.localize(18,null),role:"zoom",enabled:this.windowsMainService.getWindowCount()>0}),k=new p.MenuItem({label:d.localize(19,null),role:"front",enabled:this.windowsMainService.getWindowCount()>0}),R=this.createMenuItem(d.localize(20,null),"workbench.action.switchWindow"),A=[];this.currentEnableNativeTabs&&(A.push(s()),A.push(this.createMenuItem(d.localize(21,null),"workbench.action.newWindowTab")),A.push(this.createRoleMenuItem(d.localize(22,null),"workbench.action.showPreviousWindowTab","selectPreviousTab")),A.push(this.createRoleMenuItem(d.localize(23,null),"workbench.action.showNextWindowTab","selectNextTab")),A.push(this.createRoleMenuItem(d.localize(24,null),"workbench.action.moveWindowTabToNewWindow","moveTabToNewWindow")),A.push(this.createRoleMenuItem(d.localize(25,null),"workbench.action.mergeAllWindowTabs","mergeAllWindows"))),[f,w,s(),R,...A,s(),k].forEach(O=>a.append(O))}getUpdateMenuItems(){switch(this.updateService.state.type){case"uninitialized":return[];case"idle":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(26,null)),click:()=>setTimeout(()=>{this.reportMenuActionTelemetry("CheckForUpdate"),this.updateService.checkForUpdates(!0)},0)})];case"checking for updates":return[new p.MenuItem({label:d.localize(27,null),enabled:!1})];case"available for download":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(28,null)),click:()=>{this.updateService.downloadUpdate()}})];case"downloading":return[new p.MenuItem({label:d.localize(29,null),enabled:!1})];case"downloaded":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(30,null)),click:()=>{this.reportMenuActionTelemetry("InstallUpdate"),this.updateService.applyUpdate()}})];case"updating":return[new p.MenuItem({label:d.localize(31,null),enabled:!1})];case"ready":return[new p.MenuItem({label:this.mnemonicLabel(d.localize(32,null)),click:()=>{this.reportMenuActionTelemetry("RestartToUpdate"),this.updateService.quitAndInstall()}})]}}createMenuItem(a,f,w,k){const R=this.mnemonicLabel(a),A=typeof f=="function"?f:(K,ee,F)=>{const V=K?K.userSettingsLabel:null;let z=f;Array.isArray(f)&&(z=this.isOptionClick(F)?f[1]:f[0]),V&&F.triggeredByAccelerator?this.runActionInRenderer({type:"keybinding",userSettingsLabel:V}):this.runActionInRenderer({type:"commandId",commandId:z})},O=typeof w=="boolean"?w:this.windowsMainService.getWindowCount()>0,H=typeof k=="boolean"?k:!1,x={label:R,click:A,enabled:O};H&&(x.type="checkbox",x.checked=H);let re;return typeof f=="string"?re=f:Array.isArray(f)&&(re=f[0]),P.isMacintosh&&(re==="editor.action.clipboardCutAction"?x.role="cut":re==="editor.action.clipboardCopyAction"?x.role="copy":re==="editor.action.clipboardPasteAction"&&(x.role="paste"),re==="undo"?x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.undo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("undo:")}):re==="redo"?x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.redo(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("redo:")}):re==="editor.action.selectAll"&&(x.click=this.makeContextAwareClickHandler(A,{inDevTools:K=>K.selectAll(),inNoWindow:()=>p.Menu.sendActionToFirstResponder("selectAll:")}))),new p.MenuItem(this.withKeybinding(re,x))}makeContextAwareClickHandler(a,f){return(w,k,R)=>{const A=p.BrowserWindow.getFocusedWindow();if(!A)return f.inNoWindow();if(A.webContents.isDevToolsFocused()&&A.webContents.devToolsWebContents)return f.inDevTools(A.webContents.devToolsWebContents);a(w,k||A,R)}}runActionInRenderer(a){let f=p.BrowserWindow.getFocusedWindow();if(!f){const k=this.windowsMainService.getLastActiveWindow();k?.isMinimized()&&(f=k.win)}const w=f?this.windowsMainService.getWindowById(f.id):void 0;if(w){if(this.logService.trace("menubar#runActionInRenderer",a),P.isMacintosh&&!this.environmentMainService.isBuilt&&!w.isReady&&(a.type==="commandId"&&a.commandId==="workbench.action.toggleDevTools"||a.type!=="commandId"&&a.userSettingsLabel==="alt+cmd+i"))return;if(a.type==="commandId"){const k={id:a.commandId,from:"menu"};w.sendWhenReady("vscode:runAction",D.CancellationToken.None,k)}else{const k={userSettingsLabel:a.userSettingsLabel};w.sendWhenReady("vscode:runKeybinding",D.CancellationToken.None,k)}}else this.logService.trace("menubar#runActionInRenderer: no active window found",a)}withKeybinding(a,f){const w=typeof a=="string"?this.keybindings[a]:void 0;if(w?.label){if(w.isNative!==!1)f.accelerator=w.label,f.userSettingsLabel=w.userSettingsLabel;else if(typeof f.label=="string"){const k=f.label.indexOf("[");k>=0?f.label=`${f.label.substr(0,k)} [${w.label}]`:f.label=`${f.label} [${w.label}]`}}else f.accelerator=void 0;return f}likeAction(a,f,w=!f.accelerator){w&&(f=this.withKeybinding(a,f));const k=f.click;return f.click=(R,A,O)=>{this.reportMenuActionTelemetry(a),k&&k(R,A,O)},f}openUrl(a,f){this.nativeHostMainService.openExternal(void 0,a),this.reportMenuActionTelemetry(f)}reportMenuActionTelemetry(a){this.telemetryService.publicLog2("workbenchActionExecuted",{id:a,from:n})}mnemonicLabel(a){return(0,M.mnemonicMenuLabel)(a,!this.currentEnableMenuBarMnemonics)}};o.lastKnownMenubarStorageKey="lastKnownMenubarData",o=he([te(0,y.IUpdateService),te(1,g.IConfigurationService),te(2,l.IWindowsMainService),te(3,i.IEnvironmentMainService),te(4,v.ITelemetryService),te(5,c.IWorkspacesHistoryMainService),te(6,E.IStateMainService),te(7,I.ILifecycleMainService),te(8,S.ILogService),te(9,t.INativeHostMainService),te(10,h.IProductService)],o),e.Menubar=o;function s(){return new p.MenuItem({type:"separator"})}}),define(Q[236],J([0,1,5,22,6,235]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MenubarMainService=e.IMenubarMainService=void 0,e.IMenubarMainService=(0,p.createDecorator)("menubarMainService");let P=class{constructor(d,g,i){this.instantiationService=d,this.lifecycleMainService=g,this.logService=i,this.menubar=this.installMenuBarAfterWindowOpen()}async installMenuBarAfterWindowOpen(){return await this.lifecycleMainService.when(3),this.instantiationService.createInstance(M.Menubar)}async updateMenubar(d,g){this.logService.trace("menubarService#updateMenubar",d),(await this.menubar).updateMenu(g,d)}};P=he([te(0,p.IInstantiationService),te(1,L.ILifecycleMainService),te(2,D.ILogService)],P),e.MenubarMainService=P}),define(Q[237],J([0,1,13,31,25,30,23,4,33,42,34,2,10,8,76,3,32,15,14,7,152,51,17,52,24,20,5,22,6,45,21,56,63,38,66,234,100,217,26,101,67,46]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n,o,s,r,a,f,w,k,R,A,O,H,x,re,K,ee,F,V,z,B){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WindowsMainService=void 0;function U(W){return(0,F.isWorkspaceIdentifier)(W?.workspace)}function C(W){return(0,F.isSingleFolderWorkspaceIdentifier)(W?.workspace)}let X=class xe extends I.Disposable{constructor(T,_,q,Y,$,N,Z,ie,oe,le,ne,ae,ue,de,ve){super();this.machineId=T,this.initialUserEnv=_,this.logService=q,this.stateMainService=Y,this.environmentMainService=$,this.lifecycleMainService=N,this.backupMainService=Z,this.configurationService=ie,this.workspacesHistoryMainService=oe,this.workspacesManagementMainService=le,this.instantiationService=ne,this.dialogMainService=ae,this.fileService=ue,this.productService=de,this.protocolMainService=ve,this._onDidOpenWindow=this._register(new b.Emitter),this.onDidOpenWindow=this._onDidOpenWindow.event,this._onDidSignalReadyWindow=this._register(new b.Emitter),this.onDidSignalReadyWindow=this._onDidSignalReadyWindow.event,this._onDidDestroyWindow=this._register(new b.Emitter),this.onDidDestroyWindow=this._onDidDestroyWindow.event,this._onDidChangeWindowsCount=this._register(new b.Emitter),this.onDidChangeWindowsCount=this._onDidChangeWindowsCount.event,this.windowsStateHandler=this._register(new ee.WindowsStateHandler(this,this.stateMainService,this.lifecycleMainService,this.logService,this.configurationService)),this.registerListeners()}registerListeners(){this._register(this.workspacesManagementMainService.onDidEnterWorkspace(T=>this._onDidSignalReadyWindow.fire(T.window))),this._register(this.onDidSignalReadyWindow(T=>{if(T.config?.extensionDevelopmentPath||T.config?.extensionTestsPath){const _=new I.DisposableStore;if(_.add(b.Event.any(T.onDidClose,T.onDidDestroy)(()=>_.dispose())),T.config.extensionDevelopmentPath)for(const q of T.config.extensionDevelopmentPath)_.add(this.protocolMainService.addValidFileRoot(u.URI.file(q)));T.config.extensionTestsPath&&_.add(this.protocolMainService.addValidFileRoot(u.URI.file(T.config.extensionTestsPath)))}}))}openEmptyWindow(T,_){let q=this.environmentMainService.args;const Y=_?.remoteAuthority||void 0,$=!0,N=_?.forceReuseWindow,Z=!N;return this.open({...T,cli:q,forceEmpty:$,forceNewWindow:Z,forceReuseWindow:N,remoteAuthority:Y})}openExistingWindow(T,_){T.focus(),this.handleWaitMarkerFile(_,[T])}open(T){this.logService.trace("windowsManager#open"),T.addMode&&(T.initialStartup||!this.getLastActiveWindow())&&(T.addMode=!1);const _=[],q=[],Y=[],$=[],N=[];let Z,ie=0;const oe=this.getPathsToOpen(T);this.logService.trace("windowsManager#open pathsToOpen",oe);for(const ue of oe)C(ue)?T.addMode?_.push(ue):q.push(ue):U(ue)?Y.push(ue):ue.fileUri?(Z||(Z={filesToOpenOrCreate:[],filesToDiff:[],remoteAuthority:ue.remoteAuthority}),Z.filesToOpenOrCreate.push(ue)):ue.backupPath?N.push({backupFolder:(0,m.basename)(ue.backupPath),remoteAuthority:ue.remoteAuthority}):ie++;T.diffMode&&Z&&Z.filesToOpenOrCreate.length>=2&&(Z.filesToDiff=Z.filesToOpenOrCreate.slice(0,2),Z.filesToOpenOrCreate=[]),Z&&T.waitMarkerFileURI&&(Z.filesToWait={paths:[...Z.filesToDiff,...Z.filesToOpenOrCreate],waitMarkerFileUri:T.waitMarkerFileURI}),T.initialStartup?($.push(...this.workspacesManagementMainService.getUntitledWorkspacesSync()),Y.push(...$),N.push(...this.backupMainService.getEmptyWindowBackupPaths())):N.length=0;const{windows:le,filesOpenedInWindow:ne}=this.doOpen(T,Y,q,N,ie,Z,_);if(this.logService.trace(`windowsManager#open used window count ${le.length} (workspacesToOpen: ${Y.length}, foldersToOpen: ${q.length}, emptyToRestore: ${N.length}, emptyToOpen: ${ie})`),le.length>1)if(ne)ne.focus();else{const ue=this.windowsStateHandler.state.lastActiveWindow&&!T.forceEmpty&&!T.cli._.length&&!T.cli["file-uri"]&&!T.cli["folder-uri"]&&!(T.urisToOpen&&T.urisToOpen.length);let de=!0,ve=!0;if(ue){const Ie=le.filter(me=>this.windowsStateHandler.state.lastActiveWindow&&me.backupPath===this.windowsStateHandler.state.lastActiveWindow.backupPath);Ie.length&&(Ie[0].focus(),de=!1,ve=!1)}if(de)for(let Ie=le.length-1;Ie>=0;Ie--){const me=le[Ie];if(!(me.openedWorkspace&&$.some(ge=>me.openedWorkspace&&ge.workspace.id===me.openedWorkspace.id)||me.backupPath&&N.some(ge=>me.backupPath&&ge.backupFolder===(0,m.basename)(me.backupPath)))){me.focus(),ve=!1;break}}ve&&le[le.length-1].focus()}const ae=Z&&Z.filesToDiff.length>0;if(!le.some(ue=>ue.isExtensionDevelopmentHost)&&!ae&&!T.noRecentEntry){const ue=[];for(const de of oe)U(de)&&!de.transient?ue.push({label:de.label,workspace:de.workspace,remoteAuthority:de.remoteAuthority}):C(de)?ue.push({label:de.label,folderUri:de.workspace.uri,remoteAuthority:de.remoteAuthority}):de.fileUri&&ue.push({label:de.label,fileUri:de.fileUri,remoteAuthority:de.remoteAuthority});this.workspacesHistoryMainService.addRecentlyOpened(ue)}return this.handleWaitMarkerFile(T,le),le}handleWaitMarkerFile(T,_){const q=T.waitMarkerFileURI;T.context===0&&q&&_.length===1&&_[0]&&(async()=>{await _[0].whenClosedOrLoaded;try{await this.fileService.del(q)}catch(Y){}})()}doOpen(T,_,q,Y,$,N,Z){const ie=[];let oe;function le(me,ge){ie.push(me),ge&&(oe=me,N=void 0)}let{openFolderInNewWindow:ne,openFilesInNewWindow:ae}=this.shouldOpenNewWindow(T);if(!T.initialStartup&&Z.length>0){const me=Z[0].remoteAuthority,ge=this.getLastActiveWindowForAuthority(me);ge&&le(this.doAddFoldersToExistingWindow(ge,Z.map(be=>be.workspace.uri)))}const ue=q.length+_.length+Y.length;if(N&&ue===0){const me=N.filesToOpenOrCreate[0]||N.filesToDiff[0],ge=this.getWindows().filter(ke=>N&&ke.remoteAuthority===N.remoteAuthority);let be;me?.fileUri&&!ae&&((T.context===4||T.context===0||T.context===1)&&(be=(0,K.findWindowOnFile)(ge,me.fileUri,ke=>ke.configPath.scheme===S.Schemas.file?this.workspacesManagementMainService.resolveLocalWorkspaceSync(ke.configPath):void 0)),be||(be=this.doGetLastActiveWindow(ge))),be?(0,F.isWorkspaceIdentifier)(be.openedWorkspace)?_.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):(0,F.isSingleFolderWorkspaceIdentifier)(be.openedWorkspace)?q.push({workspace:be.openedWorkspace,remoteAuthority:be.remoteAuthority}):le(this.doOpenFilesInExistingWindow(T,be,N),!0):le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:N,forceNewWindow:!0,remoteAuthority:N.remoteAuthority,forceNewTabbedWindow:T.forceNewTabbedWindow}),!0)}const de=(0,M.distinct)(_,me=>me.workspace.id);if(de.length>0){const me=(0,M.coalesce)(de.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.configPath)));if(me.length>0){const ge=me[0],be=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(T,ge,be),!!be),ne=!0}de.forEach(ge=>{if(me.some(Te=>Te.openedWorkspace&&Te.openedWorkspace.id===ge.workspace.id))return;const be=ge.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(T,ge,ne,ke),!!ke),ne=!0})}const ve=(0,M.distinct)(q,me=>v.extUriBiasedIgnorePathCase.getComparisonKey(me.workspace.uri));if(ve.length>0){const me=(0,M.coalesce)(ve.map(ge=>(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ge.workspace.uri)));if(me.length>0){const ge=me[0],be=N?.remoteAuthority===ge.remoteAuthority?N:void 0;le(this.doOpenFilesInExistingWindow(T,ge,be),!!be),ne=!0}ve.forEach(ge=>{if(me.some(Te=>(0,F.isSingleFolderWorkspaceIdentifier)(Te.openedWorkspace)&&v.extUriBiasedIgnorePathCase.isEqual(Te.openedWorkspace.uri,ge.workspace.uri)))return;const be=ge.remoteAuthority,ke=N?.remoteAuthority===be?N:void 0;le(this.doOpenFolderOrWorkspace(T,ge,ne,ke),!!ke),ne=!0})}const Ie=(0,M.distinct)(Y,me=>me.backupFolder);if(Ie.length>0&&Ie.forEach(me=>{const ge=me.remoteAuthority,be=N?.remoteAuthority===ge?N:void 0;le(this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,filesToOpen:be,remoteAuthority:ge,forceNewWindow:!0,forceNewTabbedWindow:T.forceNewTabbedWindow,emptyWindowBackupInfo:me}),!!be),ne=!0}),ie.length===0||N){N&&!$&&$++;const me=N?N.remoteAuthority:T.remoteAuthority;for(let ge=0;ge<$;ge++)le(this.doOpenEmpty(T,ne,me,N),!!N),ne=!0}return{windows:(0,M.distinct)(ie),filesOpenedInWindow:oe}}doOpenFilesInExistingWindow(T,_,q){this.logService.trace("windowsManager#doOpenFilesInExistingWindow"),_.focus();const Y={filesToOpenOrCreate:q?.filesToOpenOrCreate,filesToDiff:q?.filesToDiff,filesToWait:q?.filesToWait,termProgram:T?.userEnv?.TERM_PROGRAM};return _.sendWhenReady("vscode:openFiles",P.CancellationToken.None,Y),_}doAddFoldersToExistingWindow(T,_){this.logService.trace("windowsManager#doAddFoldersToExistingWindow"),T.focus();const q={foldersToAdd:_};return T.sendWhenReady("vscode:addFolders",P.CancellationToken.None,q),T}doOpenEmpty(T,_,q,Y,$){return!_&&!$&&typeof T.contextWindowId=="number"&&($=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:q,forceNewWindow:_,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:Y,windowToUse:$})}doOpenFolderOrWorkspace(T,_,q,Y,$){return!q&&!$&&typeof T.contextWindowId=="number"&&($=this.getWindowById(T.contextWindowId)),this.openInBrowserWindow({workspace:_.workspace,userEnv:T.userEnv,cli:T.cli,initialStartup:T.initialStartup,remoteAuthority:_.remoteAuthority,forceNewWindow:q,forceNewTabbedWindow:T.forceNewTabbedWindow,filesToOpen:Y,windowToUse:$})}getPathsToOpen(T){let _,q=!1,Y=!1;if(T.urisToOpen&&T.urisToOpen.length>0?(_=this.doExtractPathsFromAPI(T),q=!0):T.forceEmpty?_=[Object.create(null)]:T.cli._.length||T.cli["folder-uri"]||T.cli["file-uri"]?(_=this.doExtractPathsFromCLI(T.cli),_.length===0&&_.push(Object.create(null)),q=!0):(_=this.doGetPathsFromLastSession(),_.length===0&&_.push(Object.create(null)),Y=!0),!T.addMode&&q){const $=_.filter(N=>C(N));if($.length>1){const N=$[0].remoteAuthority;if($.every(Z=>Z.remoteAuthority===N)){const Z=this.workspacesManagementMainService.createUntitledWorkspaceSync($.map(ie=>({uri:ie.workspace.uri})));_.push({workspace:Z,remoteAuthority:N}),_=_.filter(ie=>!C(ie))}}}return T.initialStartup&&!Y&&this.configurationService.getValue("window")?.restoreWindows==="preserve"&&_.unshift(...this.doGetPathsFromLastSession().filter($=>U($)||C($)||$.backupPath)),_}doExtractPathsFromAPI(T){const _=[],q={gotoLineMode:T.gotoLineMode,remoteAuthority:T.remoteAuthority};for(const Y of(0,M.coalesce)(T.urisToOpen||[])){const $=this.resolveOpenable(Y,q);if($)$.label=Y.label,_.push($);else{const N=this.resourceFromOpenable(Y),Z={title:this.productService.nameLong,type:"info",buttons:[(0,i.mnemonicButtonLabel)((0,l.localize)(0,null))],defaultId:0,message:N.scheme===S.Schemas.file?(0,l.localize)(1,null):(0,l.localize)(2,null),detail:N.scheme===S.Schemas.file?(0,l.localize)(3,null,(0,i.getPathLabel)(N.fsPath,this.environmentMainService)):(0,l.localize)(4,null,N.toString()),noLink:!0};this.dialogMainService.showMessageBox(Z,(0,y.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))}}return _}doExtractPathsFromCLI(T){const _=[],q={ignoreFileNotFound:!0,gotoLineMode:T.goto,remoteAuthority:T.remote||void 0,forceOpenWorkspaceAsFile:!1},Y=T["folder-uri"];if(Y)for(const Z of Y){const ie=this.cliArgToUri(Z);if(ie){const oe=this.resolveOpenable({folderUri:ie},q);oe&&_.push(oe)}}const $=T["file-uri"];if($)for(const Z of $){const ie=this.cliArgToUri(Z);if(ie){const oe=this.resolveOpenable((0,F.hasWorkspaceFileExtension)(Z)?{workspaceUri:ie}:{fileUri:ie},q);oe&&_.push(oe)}}const N=T._;for(const Z of N){const ie=q.remoteAuthority?this.doResolvePathRemote(Z,q):this.doResolveFilePath(Z,q);ie&&_.push(ie)}return _}cliArgToUri(T){try{const _=u.URI.parse(T);if(!_.scheme){this.logService.error(`Invalid URI input string, scheme missing: ${T}`);return}return _}catch(_){this.logService.error(`Invalid URI input string: ${T}, ${_.message}`)}}doGetPathsFromLastSession(){const T=this.getRestoreWindowsSetting();switch(T){case"none":return[];case"one":case"all":case"preserve":case"folders":const _=[];T!=="one"&&_.push(...this.windowsStateHandler.state.openedWindows),this.windowsStateHandler.state.lastActiveWindow&&_.push(this.windowsStateHandler.state.lastActiveWindow);const q=[];for(const Y of _)if(Y.workspace){const $=this.resolveOpenable({workspaceUri:Y.workspace.configPath},{remoteAuthority:Y.remoteAuthority,rejectTransientWorkspaces:!0});U($)&&q.push($)}else if(Y.folderUri){const $=this.resolveOpenable({folderUri:Y.folderUri},{remoteAuthority:Y.remoteAuthority});C($)&&q.push($)}else T!=="folders"&&Y.backupPath&&q.push({backupPath:Y.backupPath,remoteAuthority:Y.remoteAuthority});return q}}getRestoreWindowsSetting(){let T;return this.lifecycleMainService.wasRestarted?T="all":(T=this.configurationService.getValue("window")?.restoreWindows||"all",["preserve","all","folders","one","none"].includes(T)||(T="all")),T}resolveOpenable(T,_=Object.create(null)){let q=this.resourceFromOpenable(T);return q.scheme===S.Schemas.file?((0,x.isFileToOpen)(T)&&(_={..._,forceOpenWorkspaceAsFile:!0}),this.doResolveFilePath(q.fsPath,_)):this.doResolveRemoteOpenable(T,_)}doResolveRemoteOpenable(T,_){let q=this.resourceFromOpenable(T);const Y=(0,O.getRemoteAuthority)(q)||_.remoteAuthority;if(q=(0,v.removeTrailingPathSeparator)((0,v.normalizePath)(q)),(0,x.isFileToOpen)(T)){if(_.gotoLineMode){const{path:$,line:N,column:Z}=(0,d.parseLineAndColumnAware)(q.path);return{fileUri:q.with({path:$}),selection:N?{startLineNumber:N,startColumn:Z||1}:void 0,remoteAuthority:Y}}return{fileUri:q,remoteAuthority:Y}}else if((0,x.isWorkspaceToOpen)(T))return{workspace:(0,V.getWorkspaceIdentifier)(q),remoteAuthority:Y};return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(q),remoteAuthority:Y}}resourceFromOpenable(T){return(0,x.isWorkspaceToOpen)(T)?T.workspaceUri:(0,x.isFolderToOpen)(T)?T.folderUri:T.fileUri}doResolveFilePath(T,_){let q,Y;_.gotoLineMode&&({path:T,line:q,column:Y}=(0,d.parseLineAndColumnAware)(T)),T=(0,d.sanitizeFilePath)((0,m.normalize)(T),(0,E.cwd)());try{const $=(0,L.statSync)(T);if($.isFile()){if(!_.forceOpenWorkspaceAsFile){const N=this.workspacesManagementMainService.resolveLocalWorkspaceSync(u.URI.file(T));if(N)return N.transient&&_.rejectTransientWorkspaces?void 0:{workspace:{id:N.id,configPath:N.configPath},remoteAuthority:N.remoteAuthority,exists:!0,transient:N.transient}}return{fileUri:u.URI.file(T),selection:q?{startLineNumber:q,startColumn:Y||1}:void 0,exists:!0}}else if($.isDirectory())return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(u.URI.file(T),$),exists:!0}}catch($){const N=u.URI.file(T);if(this.workspacesHistoryMainService.removeRecentlyOpened([N]),_.ignoreFileNotFound)return{fileUri:N,exists:!1}}}doResolvePathRemote(T,_){const q=T.charCodeAt(0),Y=_.remoteAuthority;let $,N;_.gotoLineMode&&({path:T,line:$,column:N}=(0,d.parseLineAndColumnAware)(T)),q!==47&&((0,d.isWindowsDriveLetter)(q)&&T.charCodeAt(T.charCodeAt(1))===58&&(T=(0,d.toSlashes)(T)),T=`/${T}`);const Z=u.URI.from({scheme:S.Schemas.vscodeRemote,authority:Y,path:T});if(T.charCodeAt(T.length-1)!==47){if((0,F.hasWorkspaceFileExtension)(T))return _.forceOpenWorkspaceAsFile?{fileUri:Z,selection:$?{startLineNumber:$,startColumn:N||1}:void 0,remoteAuthority:_.remoteAuthority}:{workspace:(0,V.getWorkspaceIdentifier)(Z),remoteAuthority:Y};if(_.gotoLineMode||m.posix.basename(T).indexOf(".")!==-1)return{fileUri:Z,selection:$?{startLineNumber:$,startColumn:N||1}:void 0,remoteAuthority:Y}}return{workspace:(0,V.getSingleFolderWorkspaceIdentifier)(Z),remoteAuthority:Y}}shouldOpenNewWindow(T){const _=this.configurationService.getValue("window"),q=_?.openFoldersInNewWindow||"default",Y=_?.openFilesInNewWindow||"off";let $=(T.preferNewWindow||T.forceNewWindow)&&!T.forceReuseWindow;!T.forceNewWindow&&!T.forceReuseWindow&&(q==="on"||q==="off")&&($=q==="on");let N=!1;return T.forceNewWindow||T.forceReuseWindow?N=!!T.forceNewWindow&&!T.forceReuseWindow:(h.isMacintosh?T.context===1&&(N=!0):T.context!==3&&T.context!==2&&!(T.userEnv&&T.userEnv.TERM_PROGRAM==="vscode")&&(N=!0),!T.cli.extensionDevelopmentPath&&(Y==="on"||Y==="off")&&(N=Y==="on")),{openFolderInNewWindow:!!$,openFilesInNewWindow:N}}openExtensionDevelopmentHostWindow(T,_){const q=(0,K.findWindowOnExtensionDevelopmentPath)(this.getWindows(),T);if(q)return this.lifecycleMainService.reload(q,_.cli),q.focus(),[q];let Y=_.cli["folder-uri"]||[],$=_.cli["file-uri"]||[],N=_.cli._;if(!N.length&&!Y.length&&!$.length&&!_.cli.extensionTestsPath){const le=this.windowsStateHandler.state.lastPluginDevelopmentHostWindow,ne=le&&(le.workspace||le.folderUri);ne&&(u.URI.isUri(ne)?ne.scheme===S.Schemas.file?N=[ne.fsPath]:Y=[ne.toString()]:ne.configPath.scheme===S.Schemas.file?N=[(0,v.originalFSPath)(ne.configPath)]:$=[ne.configPath.toString()])}let Z=_.remoteAuthority;for(const le of T)if(le.match(/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/)){const ne=u.URI.parse(le),ae=(0,O.getRemoteAuthority)(ne);ae&&(Z?ae!==Z&&this.logService.error("more than one extension development path authority"):Z=ae)}N=N.filter(le=>{const ne=u.URI.file(le);return(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:(0,O.getRemoteAuthority)(ne)===Z}),Y=Y.filter(le=>{const ne=this.cliArgToUri(le);return ne&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,O.getRemoteAuthority)(ne)===Z:!1}),$=$.filter(le=>{const ne=this.cliArgToUri(le);return ne&&!!(0,K.findWindowOnWorkspaceOrFolder)(this.getWindows(),ne)?!1:ne?(0,O.getRemoteAuthority)(ne)===Z:!1}),_.cli._=N,_.cli["folder-uri"]=Y,_.cli["file-uri"]=$;const ie=!N.length&&!Y.length&&!$.length,oe={context:_.context,cli:_.cli,forceNewWindow:!0,forceEmpty:ie,userEnv:_.userEnv,noRecentEntry:!0,waitMarkerFileURI:_.waitMarkerFileURI,remoteAuthority:Z};return this.open(oe)}openInBrowserWindow(T){const _=this.configurationService.getValue("window"),q={...this.environmentMainService.args,...T.cli,machineId:this.machineId,windowId:-1,mainPid:process.pid,appRoot:this.environmentMainService.appRoot,execPath:process.execPath,codeCachePath:this.environmentMainService.codeCachePath,backupPath:T.emptyWindowBackupInfo?(0,m.join)(this.environmentMainService.backupHome,T.emptyWindowBackupInfo.backupFolder):void 0,homeDir:this.environmentMainService.userHome.fsPath,tmpDir:this.environmentMainService.tmpDir.fsPath,userDataDir:this.environmentMainService.userDataPath,remoteAuthority:T.remoteAuthority,workspace:T.workspace,userEnv:{...this.initialUserEnv,...T.userEnv},filesToOpenOrCreate:T.filesToOpen?.filesToOpenOrCreate,filesToDiff:T.filesToOpen?.filesToDiff,filesToWait:T.filesToOpen?.filesToWait,logLevel:this.logService.getLevel(),logsPath:this.environmentMainService.logsPath,product:k.default,isInitialStartup:T.initialStartup,perfMarks:(0,t.getMarks)(),os:{release:(0,D.release)(),hostname:(0,D.hostname)()},zoomLevel:typeof _?.zoomLevel=="number"?_.zoomLevel:void 0,legacyWatcher:this.configurationService.getValue("files.legacyWatcher"),experimentalSandboxedFileService:this.configurationService.getValue("files.experimentalSandboxedFileService"),autoDetectHighContrast:_?.autoDetectHighContrast??!0,accessibilitySupport:p.app.accessibilitySupportEnabled,colorScheme:{dark:p.nativeTheme.shouldUseDarkColors,highContrast:p.nativeTheme.shouldUseInvertedColorScheme||p.nativeTheme.shouldUseHighContrastColors}};let Y;if(!T.forceNewWindow&&!T.forceNewTabbedWindow&&(Y=T.windowToUse||this.getLastActiveWindow(),Y&&Y.focus()),Y){const $=Y.config;!q.extensionDevelopmentPath&&$&&!!$.extensionDevelopmentPath&&(q.extensionDevelopmentPath=$.extensionDevelopmentPath,q.verbose=$.verbose,q["inspect-brk-extensions"]=$["inspect-brk-extensions"],q.debugId=$.debugId,q.extensionEnvironment=$.extensionEnvironment,q["inspect-extensions"]=$["inspect-extensions"],q["extensions-dir"]=$["extensions-dir"])}else{const $=this.windowsStateHandler.getNewWindowState(q);(0,t.mark)("code/willCreateCodeWindow");const N=Y=this.instantiationService.createInstance(re.CodeWindow,{state:$,extensionDevelopmentPath:q.extensionDevelopmentPath,isExtensionTestHost:!!q.extensionTestsPath});if((0,t.mark)("code/didCreateCodeWindow"),T.forceNewTabbedWindow){const ie=this.getLastActiveWindow();ie&&ie.addTabbedWindow(N)}xe.WINDOWS.push(N),this._onDidOpenWindow.fire(N),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()-1,newCount:this.getWindowCount()}),(0,g.once)(N.onDidSignalReady)(()=>this._onDidSignalReadyWindow.fire(N)),(0,g.once)(N.onDidClose)(()=>this.onWindowClosed(N)),(0,g.once)(N.onDidDestroy)(()=>this._onDidDestroyWindow.fire(N));const Z=(0,y.assertIsDefined)(N.win?.webContents);Z.removeAllListeners("devtools-reload-page"),Z.on("devtools-reload-page",()=>this.lifecycleMainService.reload(N)),this.lifecycleMainService.registerWindow(N)}return q.windowId=Y.id,Y.isReady?this.lifecycleMainService.unload(Y,4).then($=>{$||this.doOpenInBrowserWindow(Y,q,T)}):this.doOpenInBrowserWindow(Y,q,T),Y}doOpenInBrowserWindow(T,_,q){if(!_.extensionDevelopmentPath)if((0,F.isWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerWorkspaceBackupSync({workspace:_.workspace,remoteAuthority:_.remoteAuthority});else if((0,F.isSingleFolderWorkspaceIdentifier)(_.workspace))_.backupPath=this.backupMainService.registerFolderBackupSync(_.workspace.uri);else{const Y=q.emptyWindowBackupInfo&&q.emptyWindowBackupInfo.backupFolder;_.backupPath=this.backupMainService.registerEmptyWindowBackupSync(Y,_.remoteAuthority)}T.load(_)}onWindowClosed(T){const _=xe.WINDOWS.indexOf(T);xe.WINDOWS.splice(_,1),this._onDidChangeWindowsCount.fire({oldCount:this.getWindowCount()+1,newCount:this.getWindowCount()})}getFocusedWindow(){const T=p.BrowserWindow.getFocusedWindow();if(T)return this.getWindowById(T.id)}getLastActiveWindow(){return this.doGetLastActiveWindow(this.getWindows())}getLastActiveWindowForAuthority(T){return this.doGetLastActiveWindow(this.getWindows().filter(_=>_.remoteAuthority===T))}doGetLastActiveWindow(T){const _=Math.max.apply(Math,T.map(q=>q.lastFocusTime));return T.find(q=>q.lastFocusTime===_)}sendToFocused(T,..._){const q=this.getFocusedWindow()||this.getLastActiveWindow();q&&q.sendWhenReady(T,P.CancellationToken.None,..._)}sendToAll(T,_,q){for(const Y of this.getWindows())q&&q.indexOf(Y.id)>=0||Y.sendWhenReady(T,P.CancellationToken.None,_)}getWindows(){return xe.WINDOWS}getWindowCount(){return xe.WINDOWS.length}getWindowById(T){const _=this.getWindows().filter(q=>q.id===T);return(0,M.firstOrDefault)(_)}getWindowByWebContents(T){const _=p.BrowserWindow.fromWebContents(T);if(!!_)return this.getWindowById(_.id)}};X.WINDOWS=[],X=he([te(2,w.ILogService),te(3,H.IStateMainService),te(4,s.IEnvironmentMainService),te(5,f.ILifecycleMainService),te(6,c.IBackupMainService),te(7,n.IConfigurationService),te(8,z.IWorkspacesHistoryMainService),te(9,B.IWorkspacesManagementMainService),te(10,a.IInstantiationService),te(11,o.IDialogMainService),te(12,r.IFileService),te(13,R.IProductService),te(14,A.IProtocolMainService)],X),e.WindowsMainService=X}),define(Q[238],J([0,1,51,36,67,46]),function(j,e,p,L,D,M){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspacesMainService=void 0;let P=class{constructor(d,g,i,I){this.workspacesManagementMainService=d,this.windowsMainService=g,this.workspacesHistoryMainService=i,this.backupMainService=I,this.onDidChangeRecentlyOpened=this.workspacesHistoryMainService.onDidChangeRecentlyOpened}async enterWorkspace(d,g){const i=this.windowsMainService.getWindowById(d);if(i)return this.workspacesManagementMainService.enterWorkspace(i,this.windowsMainService.getWindows(),g)}createUntitledWorkspace(d,g,i){return this.workspacesManagementMainService.createUntitledWorkspace(g,i)}deleteUntitledWorkspace(d,g){return this.workspacesManagementMainService.deleteUntitledWorkspace(g)}getWorkspaceIdentifier(d,g){return this.workspacesManagementMainService.getWorkspaceIdentifier(g)}async getRecentlyOpened(d){return this.workspacesHistoryMainService.getRecentlyOpened(this.windowsMainService.getWindowById(d))}async addRecentlyOpened(d,g){return this.workspacesHistoryMainService.addRecentlyOpened(g)}async removeRecentlyOpened(d,g){return this.workspacesHistoryMainService.removeRecentlyOpened(g)}async clearRecentlyOpened(d){return this.workspacesHistoryMainService.clearRecentlyOpened()}async getDirtyWorkspaces(){return this.backupMainService.getDirtyWorkspaces()}};P=he([te(0,M.IWorkspacesManagementMainService),te(1,L.IWindowsMainService),te(2,D.IWorkspacesHistoryMainService),te(3,p.IBackupMainService)],P),e.WorkspacesMainService=P}),define(Q[239],J([0,1,13,31,25,16,62,18,33,42,39,34,2,10,8,3,15,14,7,28,70,119,35,122,86,230,131,51,221,17,178,159,74,52,220,89,24,54,91,167,184,90,168,20,164,95,73,5,75,231,197,102,22,6,180,236,53,21,63,226,77,38,215,99,198,29,200,202,64,41,206,228,232,229,233,98,207,208,209,210,212,36,237,213,26,67,238,46]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n,o,s,r,a,f,w,k,R,A,O,H,x,re,K,ee,F,V,z,B,U,C,X,W,T,_,q,Y,$,N,Z,ie,oe,le,ne,ae,ue,de,ve,Ie,me,ge,be,ke,Te,Ne,Fe,Ve,et,ot,Ge,ht,tt,G,se,ce,we,Ee,Le,Oe,Ce,Be,We,ze,It,vt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeApplication=void 0;let dt=class extends S.Disposable{constructor(fe,ye,Se,pe,Pe,De,Me,Re,Ae,je){super();this.mainProcessNodeIpcServer=fe,this.userEnv=ye,this.mainInstantiationService=Se,this.logService=pe,this.environmentMainService=Pe,this.lifecycleMainService=De,this.configurationService=Me,this.stateMainService=Re,this.fileService=Ae,this.productService=je,this.configureSession(),this.registerListeners()}configureSession(){const fe=pe=>pe?.startsWith(`${m.Schemas.vscodeWebview}://`),ye=new Set(["clipboard-read","clipboard-sanitized-write"]);p.session.defaultSession.setPermissionRequestHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?De(ye.has(Pe)):De(!1)),p.session.defaultSession.setPermissionCheckHandler((pe,Pe,De,Me)=>fe(Me.requestingUrl)?ye.has(Pe):!1);const Se=p.session.defaultSession;typeof Se.setCodeCachePath=="function"&&this.environmentMainService.codeCachePath&&Se.setCodeCachePath((0,t.join)(this.environmentMainService.codeCachePath,"chrome"))}registerListeners(){(0,b.setUnexpectedErrorHandler)(Se=>this.onUnexpectedError(Se)),process.on("uncaughtException",Se=>(0,b.onUnexpectedError)(Se)),process.on("unhandledRejection",Se=>(0,b.onUnexpectedError)(Se)),this.lifecycleMainService.onWillShutdown(()=>this.dispose()),(0,c.registerContextMenuListener)(),p.app.on("accessibility-support-changed",(Se,pe)=>{this.windowsMainService?.sendToAll("vscode:accessibilitySupportChanged",pe)}),p.app.on("activate",(Se,pe)=>{this.logService.trace("app#activate"),pe||this.windowsMainService?.openEmptyWindow({context:1})}),p.app.on("web-contents-created",(Se,pe)=>{pe.on("will-navigate",Pe=>{this.logService.error("webContents#will-navigate: Prevented webcontent navigation"),Pe.preventDefault()}),pe.setWindowOpenHandler(({url:Pe})=>(this.nativeHostMainService?.openExternal(void 0,Pe),{action:"deny"}))});let fe=[],ye;p.app.on("open-file",(Se,pe)=>{this.logService.trace("app#open-file: ",pe),Se.preventDefault(),fe.push(this.getWindowOpenableFromPathSync(pe)),ye!==void 0&&(clearTimeout(ye),ye=void 0),ye=setTimeout(()=>{this.windowsMainService?.open({context:1,cli:this.environmentMainService.args,urisToOpen:fe,gotoLineMode:!1,preferNewWindow:!0}),fe=[],ye=void 0},100)}),p.app.on("new-window-for-tab",()=>{this.windowsMainService?.openEmptyWindow({context:4})}),p.ipcMain.handle("vscode:fetchShellEnv",Se=>{const pe=this.windowsMainService?.getWindowByWebContents(Se.sender);let Pe,De;return pe?.config?(Pe=pe.config,De={...process.env,...pe.config.userEnv}):(Pe=this.environmentMainService.args,De=process.env),this.resolveShellEnvironment(Pe,De)}),p.ipcMain.handle("vscode:writeNlsFile",(Se,pe,Pe)=>{const De=this.validateNlsPath([pe]);if(!De||typeof Pe!="string")throw new Error("Invalid operation (vscode:writeNlsFile)");return this.fileService.writeFile(De,M.VSBuffer.fromString(Pe))}),p.ipcMain.handle("vscode:readNlsFile",async(Se,...pe)=>{const Pe=this.validateNlsPath(pe);if(!Pe)throw new Error("Invalid operation (vscode:readNlsFile)");return(await this.fileService.readFile(Pe)).value.toString()}),p.ipcMain.on("vscode:toggleDevTools",Se=>Se.sender.toggleDevTools()),p.ipcMain.on("vscode:openDevTools",Se=>Se.sender.openDevTools()),p.ipcMain.on("vscode:reloadWindow",Se=>Se.sender.reload())}validateNlsPath(fe){let ye;for(const Se of fe)typeof Se=="string"&&(typeof ye!="string"?ye=Se:ye=(0,t.join)(ye,Se));if(!(typeof ye!="string"||!(0,t.isAbsolute)(ye)||!(0,d.isEqualOrParent)(ye,this.environmentMainService.cachedLanguagesPath,!h.isLinux)))return y.URI.file(ye)}onUnexpectedError(fe){if(fe){const ye={message:`[uncaught exception in main]: ${fe.message}`,stack:fe.stack};this.windowsMainService?.sendToFocused("vscode:reportError",JSON.stringify(ye))}this.logService.error(`[uncaught exception in main]: ${fe}`),fe.stack&&this.logService.error(fe.stack)}async startup(){this.logService.debug("Starting VS Code"),this.logService.debug(`from: ${this.environmentMainService.appRoot}`),this.logService.debug("args:",this.environmentMainService.args);const fe=this.productService.win32AppUserModelId;h.isWindows&&fe&&p.app.setAppUserModelId(fe);try{h.isMacintosh&&this.configurationService.getValue("window.nativeTabs")===!0&&!p.systemPreferences.getUserDefault("NSUseImprovedLayoutPass","boolean")&&p.systemPreferences.setUserDefault("NSUseImprovedLayoutPass","boolean",!0)}catch(Ae){this.logService.error(Ae)}const ye=new o.Server;this.logService.trace("Resolving machine identifier...");const Se=await this.resolveMachineId();this.logService.trace(`Resolved machine identifier: ${Se}`);const{sharedProcess:pe,sharedProcessReady:Pe,sharedProcessClient:De}=this.setupSharedProcess(Se),Me=await this.initServices(Se,pe,Pe);if(this.environmentMainService.driverHandle){const Ae=await(0,x.serve)(ye,this.environmentMainService.driverHandle,this.environmentMainService,Me);this.logService.info("Driver started at:",this.environmentMainService.driverHandle),this._register(Ae)}this._register(Me.createInstance(r.ProxyAuthHandler)),Me.invokeFunction(Ae=>this.initChannels(Ae,ye,De));const Re=Me.invokeFunction(Ae=>this.openFirstWindow(Ae,ye));Me.invokeFunction(Ae=>this.afterWindowOpen(Ae,pe)),this.environmentMainService.args.trace&&Me.invokeFunction(Ae=>this.stopTracingEventually(Ae,Re))}async resolveMachineId(){let fe=this.stateMainService.getItem(ke.machineIdKey);return(!fe||h.isMacintosh&&fe==="6c9d2bc8f91b89624add29c0abeae7fb42bf539fa1cdb2e3e57cd668fa9bcead")&&(fe=await(0,l.getMachineId)(),this.stateMainService.setItem(ke.machineIdKey,fe)),fe}setupSharedProcess(fe){const ye=this._register(this.mainInstantiationService.createInstance(de.SharedProcess,fe,this.userEnv)),Se=(async()=>{this.logService.trace("Main->SharedProcess#connect");const Pe=await ye.connect();return this.logService.trace("Main->SharedProcess#connect: connection established"),new s.Client(Pe,"main")})(),pe=(async()=>(await ye.whenReady(),Se))();return{sharedProcess:ye,sharedProcessReady:pe,sharedProcessClient:Se}}async initServices(fe,ye,Se){const pe=new q.ServiceCollection;switch(process.platform){case"win32":pe.set(Ve.IUpdateService,new T.SyncDescriptor(tt.Win32UpdateService));break;case"linux":h.isLinuxSnap?pe.set(Ve.IUpdateService,new T.SyncDescriptor(ht.SnapUpdateService,[process.env.SNAP,process.env.SNAP_REVISION])):pe.set(Ve.IUpdateService,new T.SyncDescriptor(Ge.LinuxUpdateService));break;case"darwin":pe.set(Ve.IUpdateService,new T.SyncDescriptor(ot.DarwinUpdateService));break}pe.set(Oe.IWindowsMainService,new T.SyncDescriptor(Ce.WindowsMainService,[fe,this.userEnv])),pe.set(H.IDialogMainService,new T.SyncDescriptor(H.DialogMainService)),pe.set(N.ILaunchMainService,new T.SyncDescriptor(N.LaunchMainService)),pe.set(O.IDiagnosticsService,n.ProxyChannel.toService((0,n.getDelayedChannel)(Se.then(De=>De.getChannel("diagnostics"))))),pe.set(Y.IIssueMainService,new T.SyncDescriptor(Y.IssueMainService,[this.userEnv])),pe.set(re.IEncryptionMainService,new T.SyncDescriptor(re.EncryptionMainService,[fe])),pe.set($.IKeyboardLayoutMainService,new T.SyncDescriptor($.KeyboardLayoutMainService)),pe.set(ne.INativeHostMainService,new T.SyncDescriptor(ne.NativeHostMainService,[ye])),pe.set(Ee.IWebviewManagerService,new T.SyncDescriptor(Le.WebviewMainService)),pe.set(We.IWorkspacesService,new T.SyncDescriptor(It.WorkspacesMainService)),pe.set(vt.IWorkspacesManagementMainService,new T.SyncDescriptor(vt.WorkspacesManagementMainService)),pe.set(ze.IWorkspacesHistoryMainService,new T.SyncDescriptor(ze.WorkspacesHistoryMainService)),pe.set(le.IMenubarMainService,new T.SyncDescriptor(le.MenubarMainService)),pe.set(V.IExtensionUrlTrustService,new T.SyncDescriptor(z.ExtensionUrlTrustService)),pe.set(ge.IStorageMainService,new T.SyncDescriptor(ge.StorageMainService)),h.isWindows?pe.set(B.IExternalTerminalMainService,new T.SyncDescriptor(U.WindowsExternalTerminalService)):h.isMacintosh?pe.set(B.IExternalTerminalMainService,new T.SyncDescriptor(U.MacExternalTerminalService)):h.isLinux&&pe.set(B.IExternalTerminalMainService,new T.SyncDescriptor(U.LinuxExternalTerminalService));const Pe=new w.BackupMainService(this.environmentMainService,this.configurationService,this.logService);if(pe.set(f.IBackupMainService,Pe),pe.set(G.IURLService,new T.SyncDescriptor(ce.NativeURLService)),(0,Fe.supportsTelemetry)(this.productService,this.environmentMainService)){const De=(0,n.getDelayedChannel)(Se.then(Xe=>Xe.getChannel("telemetryAppender"))),Me=new Te.TelemetryAppenderClient(De),Re=(0,be.resolveCommonProperties)(this.fileService,(0,D.release)(),(0,D.hostname)(),process.arch,this.productService.commit,this.productService.version,fe,this.productService.msftInternalDomains,this.environmentMainService.installSourcePath),Ae=[this.environmentMainService.appRoot,this.environmentMainService.extensionsPath],je={appenders:[Me],commonProperties:Re,piiPaths:Ae,sendErrorTelemetry:!0};pe.set(ke.ITelemetryService,new T.SyncDescriptor(Ne.TelemetryService,[je]))}else pe.set(ke.ITelemetryService,Fe.NullTelemetryService);return await Pe.initialize(),this.mainInstantiationService.createChild(pe)}initChannels(fe,ye,Se){const pe=n.ProxyChannel.fromService(fe.get(N.ILaunchMainService),{disableMarshalling:!0});this.mainProcessNodeIpcServer.registerChannel("launch",pe);const Pe=this.fileService.getProvider(m.Schemas.file);(0,v.assertType)(Pe instanceof W.DiskFileSystemProvider);const De=new X.DiskFileSystemProviderChannel(Pe);ye.registerChannel("localFiles",De),ye.registerChannel(R.UserConfigurationFileServiceId,n.ProxyChannel.fromService(new R.UserConfigurationFileService(this.environmentMainService,this.fileService,this.logService)));const Me=new et.UpdateChannel(fe.get(Ve.IUpdateService));ye.registerChannel("update",Me);const Re=n.ProxyChannel.fromService(fe.get(Y.IIssueMainService));ye.registerChannel("issue",Re);const Ae=n.ProxyChannel.fromService(fe.get(re.IEncryptionMainService));ye.registerChannel("encryption",Ae);const je=n.ProxyChannel.fromService(fe.get(ve.ISignService));ye.registerChannel("sign",je);const Xe=n.ProxyChannel.fromService(fe.get($.IKeyboardLayoutMainService));ye.registerChannel("keyboardLayout",Xe),this.nativeHostMainService=fe.get(ne.INativeHostMainService);const Ye=n.ProxyChannel.fromService(this.nativeHostMainService);ye.registerChannel("nativeHost",Ye),Se.then(He=>He.registerChannel("nativeHost",Ye));const it=n.ProxyChannel.fromService(fe.get(We.IWorkspacesService));ye.registerChannel("workspaces",it);const ft=n.ProxyChannel.fromService(fe.get(le.IMenubarMainService));ye.registerChannel("menubar",ft);const Ue=n.ProxyChannel.fromService(fe.get(G.IURLService));ye.registerChannel("url",Ue);const at=n.ProxyChannel.fromService(fe.get(V.IExtensionUrlTrustService));ye.registerChannel("extensionUrlTrust",at);const nt=n.ProxyChannel.fromService(fe.get(Ee.IWebviewManagerService));ye.registerChannel("webview",nt);const Qe=this._register(new me.StorageDatabaseChannel(this.logService,fe.get(ge.IStorageMainService)));ye.registerChannel("storage",Qe),Se.then(He=>He.registerChannel("storage",Qe));const lt=n.ProxyChannel.fromService(fe.get(B.IExternalTerminalMainService));ye.registerChannel("externalTerminal",lt);const rt=new oe.LogLevelChannel(fe.get(ie.ILogService));ye.registerChannel("logLevel",rt),Se.then(He=>He.registerChannel("logLevel",rt));const Je=new oe.LoggerChannel(fe.get(ie.ILoggerService));ye.registerChannel("logger",Je),Se.then(He=>He.registerChannel("logger",Je));const st=new A.ElectronExtensionHostDebugBroadcastChannel(fe.get(Oe.IWindowsMainService));ye.registerChannel("extensionhostdebugservice",st)}openFirstWindow(fe,ye){const Se=this.windowsMainService=fe.get(Oe.IWindowsMainService),pe=fe.get(G.IURLService),Pe=fe.get(ne.INativeHostMainService);this.lifecycleMainService.phase=2;const De=[],Me=[...this.environmentMainService.args["open-url"]?this.environmentMainService.args._urls||[]:[],...global.getOpenUrls()||[]].map(_e=>{try{return{uri:y.URI.parse(_e),url:_e}}catch{return}}).filter(_e=>{if(!_e||this.shouldBlockURI(_e.uri))return!1;const Ze=this.getWindowOpenableFromProtocolLink(_e.uri);return Ze?(De.push(Ze),!1):!0}),Re=this,Ae=this.environmentMainService,je=this.productService;pe.registerHandler({async handleURL(_e,Ze){if(_e.scheme===je.urlProtocol&&_e.path==="workspace"&&(_e=_e.with({authority:"file",path:y.URI.parse(_e.query).path,query:""})),Re.shouldBlockURI(_e))return!0;const yt=Re.getWindowOpenableFromProtocolLink(_e);if(yt){const[gt]=Se.open({context:5,cli:{...Ae.args},urisToOpen:[yt],gotoLineMode:!0});return gt.focus(),!0}if(h.isMacintosh&&Se.getWindowCount()===0){const[gt]=Se.open({context:5,cli:{...Ae.args},forceEmpty:!0,gotoLineMode:!0,remoteAuthority:(0,ue.getRemoteAuthority)(_e)});return await gt.ready(),pe.open(_e,Ze)}return!1}});const Xe=this._register(new Be.ActiveWindowManager({onDidOpenWindow:Pe.onDidOpenWindow,onDidFocusWindow:Pe.onDidFocusWindow,getActiveWindowId:()=>Pe.getActiveWindowId(-1)})),Ye=new n.StaticRouter(_e=>Xe.getActiveClientId().then(Ze=>_e===Ze)),it=new se.URLHandlerRouter(Ye),ft=ye.getChannel("urlHandler",it);pe.registerHandler(new se.URLHandlerChannelClient(ft)),this._register(new we.ElectronURLListener(Me,pe,Se,this.environmentMainService,this.productService));const Ue=this.environmentMainService.args,at=global.macOpenFiles,nt=(0,ee.isLaunchedFromCli)(process.env)?0:4,Qe=Ue._.length,lt=!!Ue["folder-uri"],rt=!!Ue["file-uri"],Je=Ue["skip-add-to-recently-opened"]===!0,st=Ue.wait&&Ue.waitMarkerFilePath?y.URI.file(Ue.waitMarkerFilePath):void 0,He=Ue.remote||void 0;return De.length>0?Se.open({context:nt,cli:Ue,urisToOpen:De,gotoLineMode:!0,initialStartup:!0}):Ue["new-window"]&&!Qe&&!lt&&!rt?Se.open({context:nt,cli:Ue,forceNewWindow:!0,forceEmpty:!0,noRecentEntry:Je,waitMarkerFileURI:st,initialStartup:!0,remoteAuthority:He}):at.length&&!Qe&&!lt&&!rt?Se.open({context:1,cli:Ue,urisToOpen:at.map(_e=>this.getWindowOpenableFromPathSync(_e)),noRecentEntry:Je,waitMarkerFileURI:st,initialStartup:!0}):Se.open({context:nt,cli:Ue,forceNewWindow:Ue["new-window"]||!Qe&&Ue["unity-launch"],diffMode:Ue.diff,noRecentEntry:Je,waitMarkerFileURI:st,gotoLineMode:Ue.goto,initialStartup:!0,remoteAuthority:He})}shouldBlockURI(fe){return!!(fe.authority===m.Schemas.file&&h.isWindows&&p.dialog.showMessageBoxSync({title:this.productService.nameLong,type:"question",buttons:[(0,I.mnemonicButtonLabel)((0,a.localize)(0,null)),(0,I.mnemonicButtonLabel)((0,a.localize)(1,null))],defaultId:0,cancelId:1,message:(0,a.localize)(2,null,(0,I.getPathLabel)(fe.fsPath,this.environmentMainService),this.productService.nameShort),detail:(0,a.localize)(3,null),noLink:!0})===1)}getWindowOpenableFromProtocolLink(fe){if(!!fe.path){if(fe.authority===m.Schemas.file){const ye=y.URI.file(fe.fsPath);return(0,We.hasWorkspaceFileExtension)(ye)?{workspaceUri:ye}:{fileUri:ye}}else if(fe.authority===m.Schemas.vscodeRemote){const ye=fe.path.indexOf(t.posix.sep,1);if(ye!==-1){const Se=fe.path.substring(1,ye),pe=fe.path.substring(ye),Pe=y.URI.from({scheme:m.Schemas.vscodeRemote,authority:Se,path:pe,query:fe.query,fragment:fe.fragment});return(0,We.hasWorkspaceFileExtension)(pe)?{workspaceUri:Pe}:/:[\d]+$/.test(pe)?{fileUri:Pe}:{folderUri:Pe}}}}}getWindowOpenableFromPathSync(fe){try{if((0,L.statSync)(fe).isDirectory())return{folderUri:y.URI.file(fe)};if((0,We.hasWorkspaceFileExtension)(fe))return{workspaceUri:y.URI.file(fe)}}catch(ye){}return{fileUri:y.URI.file(fe)}}async afterWindowOpen(fe,ye){this.lifecycleMainService.phase=3;let Se=!1;(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Se=!0);const pe=fe.get(ke.ITelemetryService);this._register(ye.onDidError(({type:Me,details:Re})=>{let Ae;switch(Me){case 1:Ae="SharedProcess: detected unresponsive window";break;case 2:Ae=`SharedProcess: crashed (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break;case 3:Ae=`SharedProcess: failed to load (detail: ${Re?.reason??"<unknown>"}, code: ${Re?.exitCode??"<unknown>"})`;break}(0,b.onUnexpectedError)(new Error(Ae)),pe.publicLog2("sharedprocesserror",{type:Me,reason:Re?.reason,code:Re?.exitCode,visible:ye.isVisible(),shuttingdown:Se})}));const Pe=this.productService.win32MutexName;if(h.isWindows&&Pe)try{const Me=j.__$__nodeRequire("windows-mutex").Mutex,Re=new Me(Pe);(0,g.once)(this.lifecycleMainService.onWillShutdown)(()=>Re.release())}catch(Me){this.logService.error(Me)}p.protocol.registerHttpProtocol(m.Schemas.vscodeRemoteResource,(Me,Re)=>{Re({url:Me.url.replace(/^vscode-remote-resource:/,"http:"),method:Me.method})});const De=fe.get(Ve.IUpdateService);(De instanceof tt.Win32UpdateService||De instanceof Ge.LinuxUpdateService||De instanceof ot.DarwinUpdateService)&&De.initialize(),this.resolveShellEnvironment(this.environmentMainService.args,process.env);try{const Re=(await this.fileService.readFile(this.environmentMainService.argvResource)).value.toString();if(JSON.parse((0,i.stripComments)(Re))["enable-crash-reporter"]===void 0){const Xe=(0,Fe.getTelemetryLevel)(this.configurationService)>=1,Ye=["","	// Allows to disable crash reporting.","	// Should restart the app if the value is changed.",`	"enable-crash-reporter": ${Xe},`,"","	// Unique id used for correlating crash reports sent from this instance.","	// Do not edit this value.",`	"crash-reporter-id": "${(0,u.generateUuid)()}"`,"}"],it=Re.substring(0,Re.length-2).concat(`,
`,Ye.join(`
`));await this.fileService.writeFile(this.environmentMainService.argvResource,M.VSBuffer.fromString(it))}}catch(Me){this.logService.error(Me)}}async resolveShellEnvironment(fe,ye){try{return await(0,F.resolveShellEnv)(this.logService,fe,ye)}catch(Se){this.windowsMainService?.sendToFocused("vscode:showResolveShellEnvError",(0,P.toErrorMessage)(Se))}return{}}stopTracingEventually(fe,ye){this.logService.info("Tracing: waiting for windows to get ready...");const Se=fe.get(H.IDialogMainService);let pe=!1;const Pe=async Me=>{if(pe)return;pe=!0;const Re=await p.contentTracing.stopRecording((0,E.joinPath)(this.environmentMainService.userHome,`${this.productService.applicationName}-${Math.random().toString(16).slice(-4)}.trace.txt`).fsPath);Me?this.logService.info(`Tracing: data recorded (after 30s timeout) to ${Re}`):Se.showMessageBox({title:this.productService.nameLong,type:"info",message:(0,a.localize)(4,null),detail:(0,a.localize)(5,null,Re),buttons:[(0,I.mnemonicButtonLabel)((0,a.localize)(6,null))],defaultId:0,noLink:!0},(0,v.withNullAsUndefined)(p.BrowserWindow.getFocusedWindow()))},De=setTimeout(()=>Pe(!0),3e4);Promise.all(ye.map(Me=>Me.ready())).then(()=>{clearTimeout(De),Pe(!1)})}};dt=he([te(2,_.IInstantiationService),te(3,ie.ILogService),te(4,K.IEnvironmentMainService),te(5,Z.ILifecycleMainService),te(6,k.IConfigurationService),te(7,Ie.IStateMainService),te(8,C.IFileService),te(9,ae.IProductService)],dt),e.CodeApplication=dt}),define(Q[244],J([0,1,13,31,30,9,62,18,33,42,34,10,8,76,3,32,27,19,35,57,239,11,17,188,199,24,54,162,20,183,95,73,173,75,22,92,6,181,93,45,21,56,185,96,223,50,225,77,196,38,227,64,65,205]),function(j,e,p,L,D,M,P,b,d,g,i,I,S,m,t,h,E,v,y,u,l,c,n,o,s,r,a,f,w,k,R,A,O,H,x,re,K,ee,F,V,z,B,U,C,X,W,T,_,q,Y,$,N,Z){"use strict";Object.defineProperty(e,"__esModule",{value:!0});class ie{main(){try{this.startup()}catch(ne){console.error(ne.message),p.app.exit(1)}}async startup(){(0,b.setUnexpectedErrorHandler)(ge=>console.error(ge));const[ne,ae,ue,de,ve,Ie,me]=this.createServices();try{try{await this.initServices(ue,de,ve)}catch(ge){throw this.handleStartupDataDirError(ue,me.nameLong,ge),ge}await ne.invokeFunction(async ge=>{const be=ge.get(K.ILogService),ke=ge.get(x.ILifecycleMainService),Te=ge.get(w.IFileService),Ne=await this.claimInstance(be,ue,ke,ne,me,!0);return v.Promises.writeFile(ue.mainLockfile,String(process.pid)).catch(Fe=>{be.warn(`Error writing main lockfile: ${Fe.stack}`)}),Ie.logger=new F.SpdLogLogger("main",(0,S.join)(ue.logsPath,"main.log"),!0,Ie.getLevel()),(0,g.once)(ke.onWillShutdown)(Fe=>{Te.dispose(),de.dispose(),Fe.join(v.Promises.unlink(ue.mainLockfile).catch(()=>{}))}),ne.createInstance(l.CodeApplication,Ne,ae).startup()})}catch(ge){ne.invokeFunction(this.quit,ge)}}createServices(){const ne=new H.ServiceCollection,ae={_serviceBrand:void 0,...V.default};ne.set(z.IProductService,ae);const ue=new r.EnvironmentMainService(this.resolveArgs(),ae),de=this.patchEnvironment(ue);ne.set(r.IEnvironmentMainService,ue);const ve=new re.BufferLogService,Ie=new K.MultiplexLogService([new K.ConsoleMainLogger((0,K.getLogLevel)(ue)),ve]);process.once("exit",()=>Ie.dispose()),ne.set(K.ILogService,Ie);const me=new k.FileService(Ie);ne.set(w.IFileService,me);const ge=new R.DiskFileSystemProvider(Ie);me.registerProvider(I.Schemas.file,ge),ne.set(K.ILoggerService,new ee.LoggerService(Ie,me));const be=new o.ConfigurationService(ue.settingsResource,me);ne.set(n.IConfigurationService,be),ne.set(x.ILifecycleMainService,new A.SyncDescriptor(x.LifecycleMainService));const ke=new $.StateMainService(ue,Ie,me);return ne.set(Y.IStateMainService,ke),ne.set(W.IRequestService,new A.SyncDescriptor(T.RequestMainService)),ne.set(Z.IThemeMainService,new A.SyncDescriptor(Z.ThemeMainService)),ne.set(_.ISignService,new A.SyncDescriptor(q.SignService)),ne.set(C.ITunnelService,new A.SyncDescriptor(X.TunnelService)),ne.set(B.IProtocolMainService,new A.SyncDescriptor(U.ProtocolMainService)),[new O.InstantiationService(ne,!0),de,ue,be,ke,ve,ae]}patchEnvironment(ne){const ae={VSCODE_IPC_HOOK:ne.mainIPCHandle};return["VSCODE_NLS_CONFIG","VSCODE_PORTABLE"].forEach(ue=>{const de=process.env[ue];typeof de=="string"&&(ae[ue]=de)}),Object.assign(process.env,ae),ae}initServices(ne,ae,ue){return M.Promises.settled([Promise.all([ne.extensionsPath,ne.codeCachePath,ne.logsPath,ne.globalStorageHome.fsPath,ne.workspaceStorageHome.fsPath,ne.backupHome].map(de=>de?v.Promises.mkdir(de,{recursive:!0}):void 0)),ae.initialize(),ue.init()])}async claimInstance(ne,ae,ue,de,ve,Ie){let me;try{(0,m.mark)("code/willStartMainServer"),me=await(0,u.serve)(ae.mainIPCHandle),(0,m.mark)("code/didStartMainServer"),(0,g.once)(ue.onWillShutdown)(()=>me.dispose())}catch(ge){if(ge.code!=="EADDRINUSE")throw this.handleStartupDataDirError(ae,ve.nameLong,ge),ge;let be;try{be=await(0,u.connect)(ae.mainIPCHandle,"main")}catch(Ne){if(!Ie||t.isWindows||Ne.code!=="ECONNREFUSED")throw Ne.code==="EPERM"&&this.showStartupWarningDialog((0,c.localize)(0,null,ve.nameShort),(0,c.localize)(1,null),ve.nameLong),Ne;try{(0,L.unlinkSync)(ae.mainIPCHandle)}catch(Fe){throw ne.warn("Could not delete obsolete instance handle",Fe),Fe}return this.claimInstance(ne,ae,ue,de,ve,!1)}if(ae.extensionTestsLocationURI&&!ae.debugExtensionHost.break){const Ne="Running extension tests from the command line is currently only supported if no other instance of Code is running.";throw ne.error(Ne),be.dispose(),new Error(Ne)}let ke;!ae.args.wait&&!ae.args.status&&(ke=setTimeout(()=>{this.showStartupWarningDialog((0,c.localize)(2,null,ve.nameShort),(0,c.localize)(3,null),ve.nameLong)},1e4));const Te=y.ProxyChannel.toService(be.getChannel("launch"),{disableMarshalling:!0});if(ae.args.status)return de.invokeFunction(async()=>{const Ne=new s.DiagnosticsService(N.NullTelemetryService,ve),Fe=await Te.getMainProcessInfo(),Ve=await Te.getRemoteDiagnostics({includeProcesses:!0,includeWorkspaceMetadata:!0}),et=await Ne.getDiagnostics(Fe,Ve);throw console.log(et),new b.ExpectedError});throw t.isWindows&&await this.windowsAllowSetForegroundWindow(Te,ne),ne.trace("Sending env to running instance..."),await Te.start(ae.args,process.env),be.dispose(),ke&&clearTimeout(ke),new b.ExpectedError("Sent env to running instance. Terminating...")}if(ae.args.status)throw ne.warn("Warning: The --status argument can only be used if Code is already running. Please run it again after Code has started."),new b.ExpectedError("Terminating...");return process.env.VSCODE_PID=String(process.pid),me}handleStartupDataDirError(ne,ae,ue){if(ue.code==="EACCES"||ue.code==="EPERM"){const de=(0,D.coalesce)([ne.userDataPath,ne.extensionsPath,u.XDG_RUNTIME_DIR]).map(ve=>(0,i.getPathLabel)(ve,ne));this.showStartupWarningDialog((0,c.localize)(4,null),(0,c.localize)(5,null,(0,P.toErrorMessage)(ue),de.join(`
`)),ae)}}showStartupWarningDialog(ne,ae,ue){p.dialog.showMessageBoxSync({title:ue,type:"warning",buttons:[(0,i.mnemonicButtonLabel)((0,c.localize)(6,null))],message:ne,detail:ae,defaultId:0,noLink:!0})}async windowsAllowSetForegroundWindow(ne,ae){if(t.isWindows){const ue=await ne.getMainProcessId();ae.trace("Sending some foreground love to the running instance:",ue);try{(await new Promise((de,ve)=>{j(["windows-foreground-love"],de,ve)})).allowSetForegroundWindow(ue)}catch(de){ae.error(de)}}}quit(ne,ae){const ue=ne.get(K.ILogService),de=ne.get(x.ILifecycleMainService);let ve=0;ae&&(ae.isExpected?ae.message&&ue.trace(ae.message):(ve=1,ae.stack?ue.error(ae.stack):ue.error(`Startup error: ${ae.toString()}`))),de.kill(ve)}resolveArgs(){const ne=this.validatePaths((0,a.parseMainProcessArgv)(process.argv));if(ne.wait&&!ne.waitMarkerFilePath){const ae=(0,f.createWaitMarkerFile)(ne.verbose);ae&&((0,a.addArg)(process.argv,"--waitMarkerFilePath",ae),ne.waitMarkerFilePath=ae)}return ne}validatePaths(ne){if(ne["open-url"]&&(ne._urls=ne._,ne._=[]),!ne.remote){const ae=this.doValidatePaths(ne._,ne.goto);ne._=ae}return ne}doValidatePaths(ne,ae){const ue=(0,h.cwd)(),de=ne.map(me=>{let ge=String(me),be;ae&&(be=(0,d.parseLineAndColumnAware)(ge),ge=be.path),ge&&(ge=this.preparePath(ue,ge));const ke=(0,d.sanitizeFilePath)(ge,ue),Te=(0,S.basename)(ke);return Te&&!(0,d.isValidBasename)(Te)?null:ae&&be?(be.path=ke,this.toPath(be)):ke}),ve=t.isWindows||t.isMacintosh,Ie=(0,D.distinct)(de,me=>me&&ve?me.toLowerCase():me||"");return(0,D.coalesce)(Ie)}preparePath(ne,ae){return t.isWindows&&(ae=(0,E.rtrim)(ae,'"')),ae=(0,E.trim)((0,E.trim)(ae," "),"	"),t.isWindows&&(ae=(0,S.resolve)(ne,ae),ae=(0,E.rtrim)(ae,".")),ae}toPath(ne){const ae=[ne.path];return typeof ne.line=="number"&&ae.push(String(ne.line)),typeof ne.column=="number"&&ae.push(String(ne.column)),ae.join(":")}}new ie().main()})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/2ae9352ae33ced58772683b60d961c604c9576ff/core/vs/code/electron-main/main.js.map
